#ifndef __ARRAY_H__
#define __ARRAY_H__

#include "linked.h"

template<class I,class T> class Array;
template<class I,class T> class Tuple;

// Benutzung: T t; I i;
// t = array[i];
// array.Assign(i,t);
// array.Remove(i);

template<class I,class T> class Tuple
{
	I index;
	T value;
	
	friend class Array<I,T>;
	Tuple(const I& i,const T& t): index(i),value(t) {}
	~Tuple() {}

public:
	I& Index() { return index; }
	T& Value() { return value; }
	Tuple<I,T>& operator =(const T& t) { value=t; return *this; }
	bool operator ==(const T& t) const { return value==t; }
	bool operator ==(const Tuple<I,T>& t) const { return index==t.index; }
	bool operator !=(const Tuple<I,T>& t) const { return index!=t.index; }
};


template<class I,class T> class Array: public LinkedList<Tuple<I,T> >
{
	Tuple<I,T>* Get(const I& index) const;

public:
	bool Set(const I& index,const T& value);
	bool Unset(const I& index);
	void ReplaceValues(const T& before,const T& now);
	
	T* operator [](const I& index) const;
//	Array<I,T>& operator =(const Array<I,T>& a);
//	Array() {}
//	Array(const Array<I,T>& a) { *this = a; }
//	~Array();
};


template<class I,class T> class ArrayIterator: public OpaqueIterator<Tuple<I,T> >
{
public:
	ArrayIterator(const Array<I,T>& a): OpaqueIterator<Tuple<I,T> >(a) {}
};

#endif
