#ifndef __ATTRIB_H__
#define __ATTRIB_H__

#include <iostream.h>

#include "value.h"
#include "ident.h"

class Attrib;
class Attrib
{
	NetClass* netcl;
	Widget form,label;
	
	Ident name;
	Value* val;
	
public:
	Ident& Name() { return name; }
	Value* Type() { return val; }
	Value& Val() { return *val; }
	bool Hidden() { return val?val->Hidden():false; }
	
	Attrib(NetClass* nc = 0): netcl(nc),form(0),label(0),val(0) {}
	Attrib(Attrib& a);
	~Attrib() { if (val) delete val; }
	
	Widget CreateWidget(Widget parent);
	bool EvalWidget();
	void LimitPaneSize();
	
	istream& Input(istream& is);
	ostream& Output(ostream& os) const;
};

typedef Attrib* AttribP;

inline istream& operator >>(istream& is,Attrib& a) { return a.Input(is); }
inline ostream& operator <<(ostream& os,const Attrib& a)
 { return a.Output(os); }

#endif
