#ifndef __BOOL_H__
#define __BOOL_H__

#include "value.h"
#include "text.h"
#include "float.h"

// Der bool.h sollte moeglichst nach allen anderen Headern eingebunden
// werden,falls diese (wie im Fall der X-Header) Bool abermals #define-en!
#undef Bool

class Bool;
class Bool: public Value
{
protected:
	Widget rowcol,on,off;
	Text onstr,offstr; // Sollten noch Pointer werden!
	bool val;

public:
	Bool(NetClass* nc,bool hidden = false);
	Bool(bool b = false): rowcol(0),on(0),off(0),val(b) {}
	Bool(const Bool& b);
	~Bool() { UncatchDestroy(&rowcol,&on,&off); }
	Value* Copy() const { return new Bool(*this); }
	Value* Cast() const { return new Float(val?1:0); }

	Widget CreateWidget(Widget parent);
	bool EvalWidget();
	
	istream& Parse(istream& is);
	istream& Input(istream& is);
	ostream& Output(ostream& os) const;
	
	operator int() const { return val ? 1 : 0; }
	operator bool() const { return val; }
	operator char*() const { return val ? "true" : "false"; }
	
	Value& operator =(const bool b);
	Value& operator =(const Bool& b) { return *this=bool(b); }
	Value& operator =(const Value& v) { return *this=bool(v); }
};

typedef Bool* BoolP;

#endif
