#ifndef __COMPO_H__
#define __COMPO_H__

#include "shape.h"
#include "linked.h"
#include "metrics.h"

class Compo;
class Compo: public Shape
{
protected:
	Position offset;
	LinkedList<Shape*> members;

	istream& Input(istream& is,int field);
	void DoDraw(Display* dpy,Drawable d,GC gc,ShapeData& sd,ExprData&);

public:
	char* Type() { return "compo"; }

	Position Offset() { return offset; }
	int NumShapes() { return members.Length(); }
	Iterator<Shape*> Shapes() { return Iterator<Shape*>(members); }

	Compo(istream& is,Context* super): Shape(super),offset(0,0)  { is>>*this; }
	
	double Distance(ShapeData& sd,Position& ps,Position& nearest);
	int Inside(Display* dpy,Position pos,ShapeData&,ExprData&);
        Metrics GetMetrics(Display* dpy,ShapeData& sd,ExprData& ed);
  Position PointToMid(ShapeData&,Position&);
};

#endif
