#ifndef __DIALOG_H__
#define __DIALOG_H__

#include "xbefore.h"
#include <X11/Intrinsic.h>
#include "xafter.h"


#include "tool.h"
#include "ident.h"
#include "position.h"


template<class T,class U> class Dialog;
template<class T,class U> class Dialog: public Wrapper<Dialog<T,U>,bool>
{
protected:
	typedef void (T::*CB)(Dialog<T,U>& dia,U udata,Ident& btn);
	
	T* instance;
	WrapperID unmap_id;
	Widget dialog;
	CB cb;
	U udata;
		
	void Callback(Widget,bool handle,XtPointer);

	void CreateBox(char* name,Widget parent,CB callb,U udata,bool msg = true,
		char* buttons = "Ok");

public:

	// Create TemplateDialog,empty,with variable number of named buttons
	void Create(char* name,char* title,Widget parent,
		U udata,CB callb = 0,char* buttons = "Ok");

	// Open MessageDialog with user customized message,title,
	// (icon-)type and variable number of named buttons
	void OpenMsg(char* name,char* title,Widget parent,
		unsigned char type,char* msg,U udata,CB callb = 0,char* buttons = "Ok");
	
	// Open MessageDialog with resource customized message,title,
	// (icon-)type and variable number of named buttons
	void OpenMsg(char* name,Widget parent,U data,CB callb = 0,char* buttons = "Ok");

	Dialog(T* i): Wrapper<Dialog<T,U>,bool>(this),
		instance(i),unmap_id(0),dialog(0),cb(0) {}
	~Dialog() { Close(); }
	
	void Center(Position c);
	void Manage();
	void Close();
	
	operator Widget() { return dialog; }
	operator bool() { return dialog!=0; }
};

#endif

