#ifndef __ELLARC_H__
#define __ELLARC_H__

#include "shape.h"
#include "metrics.h"

class Ellarc;
class Ellarc: public Shape
{
protected:
	istream& Input(istream& is,int field);

	Position p,r;
	short angle1,angle2;

public:
	char* Type() { return "ellarc"; }

	Position Pos(ShapeData& sd) { return Absolute(sd,p); }
	Position Radius(ShapeData& sd) { return (r*sd.scale).Abs()*sd.zoom; }
	double StartAngle(ShapeData&) { return double(angle1)/64; }
	double EndAngle(ShapeData&) { return double(angle2)/64; }
	
	Ellarc(): p(0,0),r(100,100),angle1(0),angle2(360*64) {}
	Ellarc(istream& is,Context* super): Shape(super),
	 p(0,0),r(100,100),angle1(0),angle2(360*64) { is>>*this; }
	
	double Distance(ShapeData& sd,Position& ps,Position& nearest);
	int Inside(Display* dpy,Position,ShapeData&,ExprData&);
	void DoDraw(Display* dpy,Drawable d,GC gc,ShapeData&,ExprData&);
        Metrics GetMetrics(Display*,ShapeData& sd,ExprData&);
};

#endif
