#ifndef __FILESEL_H__
#define __FILESEL_H__

#include "xbefore.h"
#include <X11/Intrinsic.h>
#include "xafter.h"

#include "wrapper.h"

template<class T,class U> class FileSelector;
template<class T,class U> class FileSelector: public Wrapper<FileSelector<T,U>,bool>
{
	typedef void (T::*CB)(U udata,char* file,bool ok);
	T* instance;
	Widget parent;
	Widget shell,fsel;
	U udata;
	CB cb;
	
	void Callback(Widget,bool ok,XtPointer);
	void CreateWidget();

public:
	FileSelector(T* i);
	~FileSelector();

	void Open(Widget par,char* title,CB cb,U udata,
		char* dir = 0,char* mask = 0);
	char* GetDir();
	
	operator bool() { return fsel && XtIsManaged(fsel); }
	operator Widget() { return fsel; }
};

#endif
