#ifndef __IDENT_H__
#define __IDENT_H__

#include <iostream.h>

#include "value.h"
#include "text.h"
#include "wrapper.h"

class Ident;
class Ident: public Value, public Wrapper<Ident,int>
{
protected:
	bool csens;
	Widget text;
	char* p;
	Text* descr;
	
	bool Valid(char c,bool first);
	void Validate(Widget,int,XtPointer);

public:
	Ident(NetClass* nc,bool hidden = false);
	Ident(bool cs = true);
	Ident(const char *s,bool cs = true);
	Ident(const Ident& i);
	~Ident();
	
	Value* Copy() const { return new Ident(*this); }
	Value* Cast() const { return new Text(p); }
	
	char* Label() const { return descr?(char*)*descr:p?p:""; }
	bool Defined() const { return p!=0; }
	
	int Length() { return p?strlen(p):0; }

	Widget CreateWidget(Widget parent);
	bool EvalWidget();
	
	istream& Parse(istream& is);
	istream& Input(istream& is);
	ostream& Output(ostream& os) const;
	
	operator char*() const { return p; }
	operator bool() const { return p!=0; }
	
	bool IsOneOf(char* names);
	
	Value& operator =(const char* s);
	Value& operator =(const Ident& i);
	Value& operator =(const Value& v)  { return *this=(char*)v; }

	bool operator ==(const char *s) const;
	bool operator >(const char* s) const;
	bool operator <(const char* s) const; // alphabetischer String-Vergleich
	bool operator !=(const char *s) const { return !(*this==s); }
	bool operator ==(const Ident& i) const { return *this==i.p; }
	bool operator !=(const Ident& i) const { return *this!=i.p; }

	Ident operator +(const char* s) const; // String-Addition
	Ident& operator +=(const char* s); // String-Addition
	Ident& operator +=(const char c); // Zeichen-Addition
};

typedef Ident* IdentP;

#endif
