#ifndef __OBJBAR_H__
#define __OBJBAR_H__

#include <iostream.h>

#include "ident.h"
#include "linked.h"
#include "net.h"
#include "wrapper.h"


template<class T> class ObjectBar;
template<class T> class ObjectBar: public Wrapper<ObjectBar<T>,void*>
{
	struct Button
	{
		Ident name;
		Iterator<T*> alts;
		T* curr;
		char* curr_label;
		bool state;
		Widget button,label;
		
		Button(char* n,Iterator<T*>& a): 
			name(n),alts(a),curr(a.First()),curr_label(""),button(0) {}
		
		void Next();
		void Prev();
		void State(bool newstate);
		operator Widget() { return button; }
	};
	
	LinkedList<Button*> buttons;
	Iterator<Button*> biter;
	Button* curr;	
	Pixel sel,unsel;
	Widget bar,popup;

	void Draw(Widget,void* button,XtPointer);
	void Click(Widget,void* button,XtPointer calld);
	void Popup(Widget,void* button,XtPointer calld);
	void Popdown(Widget,void* button,XtPointer);
	
	WrapperID build_id;
	bool Build(void* udata);
	
	void Select(void* button);

public:
	ObjectBar(): Wrapper<ObjectBar<T>,void*>(this),
		biter(buttons),curr(0),bar(0),build_id(0) {}
	~ObjectBar();
	
	void AddButton(char* name,Iterator<T*> iter);
	void ButtonState(char* name,bool enable);
	void ClearButtons();
	void EnterParent(Widget parent);
	void LeaveParent();
//	void SetCurrent(T*);
	T* Current() { return curr?curr->curr:(T*)0; }
		
	operator Widget() { return bar; }	
	operator T* () { return Current(); }
};

#endif
