#ifndef __OBJCL_H__
#define __OBJCL_H__

#include "xbefore.h"
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include "xafter.h"

#include <iostream.h>

#include "linked.h"
#include "shape.h"
#include "expr.h"
#include "ident.h"
#include "struct.h"
#include "metrics.h"

class Net;
class Attrib;
class NetClass;

class ObjectClass;
class ObjectClass
{
protected:
	NetClass& netcl;
	Struct attr;
	LinkedList<Shape*> shapes;
	Ident name,gname,prefix;
	Position defscale;
	LinkedList<Position*> relatives;
	
	static void _Expose(Widget,XtPointer,XtPointer);
	static void _Switch(Widget,XtPointer,XtPointer);

	istream& Input(istream& is,Ident& id);

	friend class Object;
	friend class Connector;
	
	friend class NetClass;
	ObjectClass(NetClass& nc,char* nprefix);
	virtual ~ObjectClass();
	virtual void DrawButton(Display* dpy,Drawable d,int x,int y,int w,int h) = 0;

public:
	NetClass& NetCl() { return netcl; }
	Ident Name() { return name; }
	Ident Label() { return name.Label(); }
	Ident NamePrefix() { return prefix; }
	Ident GroupName() { return gname; }
	Position Scale() { return defscale; }
	Struct& Attribute() { return attr; }
	Iterator<Shape*> Shapes() { return Iterator<Shape*>(shapes); }
	Iterator<Position*> Relatives() { return Iterator<Position*>(relatives); }
	
	virtual bool IsNodeClass() = 0;
	virtual istream& Input(istream&) = 0;

	double Nearest(ShapeData& sd,Position& ps,Position& nearest);
	int IsUnder(Display* dpy,Position pos,ShapeData&,ExprData&);
	void Draw(Display* dpy,Drawable d,ShapeData& sd,ExprData& ed);
        Metrics GetMetrics(Display* dpy,ShapeData& sd,ExprData& ed);
};

typedef ObjectClass* ObjectClassP;

inline istream& operator >>(istream& is,ObjectClass& o) { return o.Input(is); }

#endif
