#ifndef __STRUCT_H__
#define __STRUCT_H__

#include "linked.h"
#include "value.h"
#include "attrib.h"
#include "wrapper.h"

class Ident;
class Object;

class Struct;
class Struct: public Value, public Wrapper<Struct,int>
{
protected:
	Widget scroll,clip,paned;
	bool call_hidden;
	LinkedList<Attrib*> members;

	Struct* super; // ggf. uebergeordnete Struktur (zB netAttr = >ObjAttr)
	
	WrapperID resize_id,expose_id;
	void ResizeCB(Widget w,int,XtPointer);

public:
	Struct(NetClass* nc = 0,bool hidden = false);
	Struct(const Struct& s,Struct* sup = 0);
	Struct(char* def,bool hidden = false);
	Value* Copy() const { return new Struct(*this); }
	Value* Cast() const { return (Value*)this; }
	~Struct();
	
	bool IsStruct() const { return true; }
	
	bool Composite() const { return true; }
	bool Resizable() const { return true; }
	
	Widget CreateWidget(Widget parent);
	bool EvalWidget();
	Widget EnterDialog(Widget parent,bool hidden = false);
	
	int NumMembers() { return members.Length(); }
	Iterator<Attrib*> Members() { return Iterator<Attrib*>(members); }
	Value* GetMember(char* name) const;
	
	istream& Parse(istream& is);
	istream& Input(istream& is);
	ostream& Output(ostream& os) const;
	
 	operator int() const { return members; }
	operator Widget() const { return paned; }
	Value& operator =(const Struct& s);
	Value& operator =(const Value& v);
	
private:
	friend class Operation;
	Value* Idx(Value& v) { return GetMember(v); }
};

typedef Struct *StructP;

#endif
