#ifndef __VALUE_H__
#define __VALUE_H__

#include "xbefore.h"
#include <X11/Intrinsic.h>
#include "xafter.h"

#include <iostream.h>

#include "tool.h"

class NetClass;

#define VALUE_NOTIFY(value_name,value_class) \
static ValueNotification notif (value_name,new value_class);

class Value;

struct ValueNotification {
	ValueNotification(char* name, Value* v);
};

class Value
{
protected:
	NetClass* netcl;
	bool hidden;
	
	Value* Type(istream& is) { return GetType(is,netcl); }
	
public:
        Value& Get() { return *this; } // SPNLControl braucht Referenz fuer Manipulation
	virtual bool IsStruct() const { return false; }
	virtual bool IsList() const { return false; }
	
	virtual bool Composite() const { return false; }
	virtual bool Resizable() const { return false; }
	virtual bool Defined() const { return true; }
	bool Hidden() const { return hidden; }
	
	Value(NetClass* nc = 0,bool hide = false): netcl(nc),hidden(hide) {}
	Value(const Value& v): netcl(v.netcl),hidden(v.hidden) {}
	virtual Value* Copy() const = 0;
	virtual Value* Cast() const = 0;
	virtual ~Value() {}
	
	virtual Widget CreateWidget(Widget) = 0;
	virtual bool EvalWidget() = 0;
	
	virtual istream& Parse(istream&) = 0;
	virtual istream& Input(istream&) = 0;
	virtual ostream& Output(ostream&) const = 0;
	
	virtual operator int() const { return 0; }
	virtual operator bool() const { return false; }
	virtual operator double() const { return 0; }
	virtual operator char*() const { return 0; }
	
	virtual Value& operator =(const int) { return *this; }
	virtual Value& operator =(const bool) { return *this; }
	virtual Value& operator =(const double) { return *this; }
	virtual Value& operator =(const char*) { return *this; }
	virtual Value& operator =(const Value&) { return *this; }
	
	static Value* GetType(istream&,NetClass* nt = 0);

private:
	friend class Operation;
	virtual Value* Idx(int) { return 0; }
	virtual Value* Eq(Value&) { return 0; }
	virtual Value* Gt(Value&) { return 0; }
	virtual Value* Lt(Value&) { return 0; }
	virtual Value* Neg() { return 0; }
	virtual Value* Not() { return 0; }
	virtual Value* Sub(Value&) { return 0; }
	virtual Value* Add(Value&) { return 0; }
	virtual Value* Mul(Value&) { return 0; }
	virtual Value* Div(Value&) { return 0; }
	
	virtual Value* And(Value&) { return 0; }
	virtual Value* Or(Value&) { return 0; }
};

typedef Value *ValueP;

inline istream& operator >>(istream& is,Value& v) {	return v.Input(is); }
inline ostream& operator <<(ostream& os,const Value& v) 
	{	return v.Output(os); }

#endif
