// -----------------------------------------------------------------
// Importe
// -----------------------------------------------------------------

#include "tokengam.h"
// Tokengameklasse

// -----------------------------------------------------------------
// Klassendefinitionen
// -----------------------------------------------------------------


void FireItem::Fire(int* BIndex, TokengameP game)
{
  if (game->FiredCount!=game->Fired.Length())
    {	  
      if (((*game->Fired[game->FiredCount])->node != this->node) ||
	  ((*game->Fired[game->FiredCount])->binding) != *BIndex)
	{
	  for (int i= game->Fired.Length()-1; i>=game->FiredCount; i--)
	    game->Fired.RemoveIndex(i);
	  game->Fired.Append(new FiredItem(this->node, *BIndex));
	  // die gefeuerte Transition merken
	}
    }
  else
    game->Fired.Append(new FiredItem(this->node, *BIndex));
  // die gefeuerte Transition merken
  
  game->FiredCount++;
  
  game->FireTrans(this->node, *BIndex, false);
}

// -----------------------------------------------------------------

void FiredItem::Do(DoType Type, TokengameP game)
{
  
  if (Type==BACKWARD)
    {
      game->FiredCount--;

      game->FireTrans(this->node, binding, true);
    }

  if (Type==FORWARD)
    {
      game->FiredCount++;
      
      game->FireTrans(this->node, binding, false);
    }    
}

// -----------------------------------------------------------------
// -----------------------------------------------------------------
// -----------------------------------------------------------------

Tokengame::Tokengame(Net& n): CommModule(n,"Tokengame"), 
                              Wrapper<Tokengame,bool>(this),
                              Parser(),
                              TokenGameEnable(false), TimerEnable(true), 
			      ShowHide(false),
                              FlashID(0), CallBackID(0), 
                              MenuWidget(0), ToggleWidget(0), 
                              FiredCount(0)
{ 
  this->name= new char[10];sprintf(this->name,"%s","Tokengame");
}

// -----------------------------------------------------------------

Tokengame::~Tokengame() 
{
  if (MenuWidget) this->ed->DestroyEntry(MenuWidget, CallBackID);
  // Menu-Icon zerstoeren
    
  delete[] (this->name);
  // Tokengame-Namen loeschen
    
  ReadyToFire.Clear(); Fired.Clear(); InitialMarking.Clear();
  // Listen loeschen
}

// -----------------------------------------------------------------

bool Tokengame::IsReadyToFire(NodeP node) 
{// Ist die Transition node feuerbereit?
   
  Iterator<FireItemP> FireList= ReadyToFire;
  for (FireItemP item= FireList; item; item=++FireList)
    if (*item==node) return true;
  return false;
}

// -----------------------------------------------------------------

bool Tokengame::Open(Editor& e, Page&)
{// Wird aufgerufen, wenn Init() true zurueckgeliefert hat

  this->ed= &e;
  // Den Editor merken, in dem das Tokengame laeuft

  WrapperID dummy;
  ToggleWidget= this->ed->CreateEntry(this->name,xmToggleButtonWidgetClass,
				      this->ed->Mods(),NULL, dummy);
  // Erstellt einen Menue-Eintrag unter Modules als ToggleButton

  MenuWidget= this->ed->CreateEntry("Menu",xmPushButtonWidgetClass,
				    this->ed->Box(), NULL,CallBackID);
  if (MenuWidget)
    this->ed->ButtonState("Menu", false);

  return false;
  // keinen automatischen Menueeintrag erzeugen, dies wurde schon gemacht!
}

// -----------------------------------------------------------------

bool Tokengame::Menu(Editor& editor, Page& page, Ident& name, bool before)
{// Wird aufgerufen, wenn der Menuepunkt angeklickt wurde

  if (name==this->name && before)
    {// Tokengame im Menue ausgewaehlt

      if (TokenGameEnable= !TokenGameEnable)
	{// Durch Mausklick aktivieren oder deaktivieren

	  InitTokengame();
	}
      else
 	{
	  Text DialogContense;
	  DialogContense+= (charP)Text("[Text \"\" ");
	  DialogContense+= (charP)Text("end=\"this is the end of ");
	  DialogContense+= (charP)Text("the Tokengame\"");
	  DialogContense+= (charP)Text(";]");
	  CreateDialog((charP)DialogContense);
	  OpenDialog(*this->ed, "Tokengame_Exit", "Restore Quit Cancel");
	}
      return (true);
      // keine Weiterleitung desMenueEvents an andere Module erforderlich,  
      // deshalb kein 2. Aufruf mit (before= false)
    }
  
  if (TokenGameEnable && name=="Leave" && before)
    {
      if (PageP superpage= page.SuperPage())
	{
	  net.ChangeEditor(editor,superpage);
	  net.UpdateButtonStates(editor, *superpage);
	}
      return (true);
      // Die MenueEventbehandlung nicht an weitere Module weiterleiten
      // deshalb erfolgt kein 2. Aufruf mit (before= false)
    }

  else if (name=="Menu" && before) 
    OpenOptionsMenu();
  
  if (TokenGameEnable) 
    return (true);  // fertig
  else
    return (false); // noch nicht behandelter Menuepunkt
}

// -----------------------------------------------------------------

bool Tokengame::Event(Editor& ed, Page& pg, EventInfo& ev, bool before)
{// Wird bei jeder Mausaktivitaet aufgerufen
  
  if (TokenGameEnable && ev.event==EventDouble && ev.button==ButtonUser && 
      EventEnable() && before)
    {// Doppelklick & Rechter Mausknopf

      pg.SetCurrOb(ed.Dpy(), ev.pos);
      ObjectP obj=  pg.GetCurrOb();
      // Welches Objekt befindet sich unter der Maus?

      if (obj && obj->IsNode())
	{// Ist ein Knoten unter der Maus

	  NodeP node= (NodeP)obj;
	  if (IsReadyToFire(node) && !node->SubPage())
	    OpenFireMenu(*(NodeP)obj);
	  // Feuern der elementaren Transition!
	}

      return true;
      // keine Weiterleitung desMenueEvents an andere Module erforderlich,  
      // deshalb kein 2. Aufruf mit (before= false)
    }

  if (TokenGameEnable && ev.event==EventDouble && ev.button==ButtonSelect && before)
    {// Doppelklick & Linker Mausknopf

      pg.SetCurrOb(ed.Dpy(), ev.pos);
      ObjectP obj=  pg.GetCurrOb();
      // Welches Objekt befindet sich unter der Maus?
  
      if (obj)
	{// Ist ein Knoten unter der Maus 

	  PageP subpage;
	  NodeP node= (NodeP)obj;
	  if (obj->IsNode() && (subpage= node->SubPage()))
	    {// Ist es eine SubTransition?

	      net.ChangeEditor(ed,subpage);
	      net.UpdateButtonStates(ed, *subpage);
	    }
	  else
	    {// ObjectDialog-Fenster oeffnen
	    
	      EditorSettings set= ed.Settings();
	      Widget shell= ed.Shell();
	      net.ObjectDialog(shell,obj,false,true);
	    }
	}
	  
      return true;
      // keine Weiterleitung des MenueEvents an andere Module erforderlich,  
      // deshalb kein 2. Aufruf mit (before= false)
    }

  if (TokenGameEnable) 
    return (true);  // fertig
  else
    return (false); // noch nicht behandelter Menuepunkt
}

// -----------------------------------------------------------------

void Tokengame::InitTokengame()
{
  DeselectAllTrans();

  SaveMarking();
  // Aktuelle Markierung sichern
  
  FiredCount_save= FiredCount;
  // merken, falls die initiale Konfiguration
  // wiederhergestellt werden soll

  if (MenuWidget)
    this->ed->ButtonState("Menu", true);
  
  StartTokengame();

  TimerEnable= true;
  FlashID = TimerCB(UPDATEINTERVALL,FlashTimer,false);	
}

// -----------------------------------------------------------------

void Tokengame::DeInitTokengame(bool restore)
{
  TimerEnable= false;
  TokenGameEnable= false;

  EndTokengame();

  DeselectAllTrans();
  DeselectColor();
  
  ReadyToFire.Clear();
  // Initiale Werte fuer den naechsten Start des Tokengame

  if (MenuWidget)
    this->ed->ButtonState("Menu", false);

  if (restore)
    {
      RecursiveCnt= 0;
      RestoreMarking();
      FiredCount= FiredCount_save;

      this->ed->Update();
      // Editor-Screen update
    }
      
  InitialMarking.Clear();
}

// -----------------------------------------------------------------

void Tokengame::SaveMarking(PageP pg)
{
  if (!pg) pg = net.Prime();
  // oberste Netzseite holen

  Iterator<NodeP> ListNodes = pg->Nodes();
  for (NodeP n=ListNodes; n; n=++ListNodes)
    {
      if (IsPlace(n))
	{
	  TextP marking;
	  if ((marking= GetMarking(n)))
	    InitialMarking.Append(new Text((charP)(*marking)));
	}
      else if (n->SubPage())
	SaveMarking(n->SubPage());
    }
}

// -----------------------------------------------------------------

void Tokengame::RestoreMarking(PageP pg)
{// Vor dem Aufruf: RecursiveCnt auf 0 setzen

  if (!pg) pg = net.Prime();
  // oberste Netzseite holen

  if (InitialMarking.Length())
    {
      Iterator<NodeP> ListNodes = pg->Nodes();
      for (NodeP n=ListNodes; n; n=++ListNodes)
	{
	  if (IsPlace(n))
	    {
	      TextP marking;
	      if ((marking= GetMarking(n)))
		*marking= *(*InitialMarking[RecursiveCnt++]);
	    }
	  else if (n->SubPage())
	    RestoreMarking(n->SubPage());
	}
    }
}

// -----------------------------------------------------------------

void Tokengame::SelectTrans(NodeP node)
{
  do
    {
      TextP selcol;
      if ((selcol= GetColor(node)))
	*selcol= ACTIVECOLOR;

      node->Select(true);
    }
  while ((node= node->GetPage()->Parent()));
}

// -----------------------------------------------------------------

void Tokengame::DeselectTrans(NodeP node)
{
  do
    {
      TextP selcol;
      if ((selcol= GetColor(node)))
	*selcol= ENABLECOLOR;

      node->Select(false);
    }
  while ((node= node->GetPage()->Parent()));
}

// -----------------------------------------------------------------

void Tokengame::DeselectAllTrans(PageP pg)
{
  if (!pg) pg = net.Prime();
  
  Iterator<NodeP> ListNodes = pg->Nodes();
  for (NodeP n=ListNodes; n; n=++ListNodes)
    {
      if (IsTransition(n))
	*GetColor(n)= ENABLECOLOR;
      
      n->Select(false);
      if (n->SubPage())
	DeselectAllTrans (n->SubPage());
    }
}

// -----------------------------------------------------------------

void Tokengame::DeselectColor(PageP pg)
{
  if (!pg) pg = net.Prime();
  
  Iterator<NodeP> ListNodes = pg->Nodes();
  for (NodeP n=ListNodes; n; n=++ListNodes)
    {
      if (IsTransition(n))
	*GetColor(n)= "blue";
      
      n->Select(false);
      if (n->SubPage())
	DeselectColor (n->SubPage());
    }
}

// -----------------------------------------------------------------

bool Tokengame::FlashTimer(bool)
{
  bool noerror;

  if (TimerEnable)
    {
      if(ShowHide = !ShowHide)
	noerror= SelectEnabledTrans(0);
      else
	noerror= DeselectEnabledTrans(0);

      this->ed->Update();

      if (noerror)
	{
	  RemoveCB(FlashID);
	  FlashID = TimerCB(UPDATEINTERVALL,FlashTimer,false);	
	}
      return (noerror);
    }
  else
    return (false);
}

// -----------------------------------------------------------------
