#include "array.h"


template<class I, class T> Tuple<I, T>* Array<I, T>::Get(const I& index) const
{
	Container<Tuple<I,T> >* c;

	for (c=first; c && !(c->val.Index()==index); c=c->next); 

	return c?&c->val:0;
}


template<class I, class T> void Array<I, T>::ReplaceValues(const T& before, const T& now)
{
	for (Container<Tuple<I,T> >* c=first; c; c=c->next)
		if (c->val.Value()==before)
			c->val = now;
}


template<class I, class T> bool Array<I, T>::Set(const I& index, const T& value)
{
	Tuple<I,T>* t = Get(index);

	if (t)
		*t = value;
	else
		Append(Tuple<I,T>(index,value));

	return t!=0;
}


template<class I, class T> bool Array<I, T>::Unset(const I& index)
{
	Tuple<I,T>* t = Get(index);

	if(t) Remove(*t);

	return t!=0;
}


template<class I, class T> T* Array<I, T>::operator [](const I& index) const
{
	Tuple<I,T>* t = Get(index);

	return t?&t->Value():0;
}

// for g++
#ifndef NoExplicitInstanciation
#define NoExplicitInstanciation

#include "linked.cc"

#define AINSTANCIATE(index,value) \
template class Array< index , value >;\
template class Tuple< index, value >;\
template class Container< Tuple< index , value > >;\
template class LinkedList< Tuple< index , value > >;\
template class OpaqueIterator< Tuple< index , value > >;\
template class ArrayIterator< index , value >;

class Page; class Editor;
AINSTANCIATE(Editor*,Page*)

#include "shape.h"
#include "value.h"
AINSTANCIATE(Ident,Value*)
AINSTANCIATE(Ident,ShapeInstanciator)

#endif
