#include <iostream.h>

extern "C" {
#include <string.h>
}

#include "keytable.h"


Keytable::Keytable(char* keywords[], int h_x, int h_y):
  hash_x(h_x),
  hash_y(h_y)
{
  int n;
  int dimension = hash_x*hash_y;
  key_table = new elementP[dimension];
  for (n=0; n<dimension; ++n)
      key_table[n] = NULL; // Initalisierung

  int x, y;
  for (n=0; *(keywords[n])!='\0'; ++n) {
    element* new_entry = new element;
    x = strlen(keywords[n]) % hash_x;
    y = (int(*(keywords[n]))) % hash_y;
    new_entry->keyword = keywords[n];
    new_entry->next = key_table[x+hash_x*y];
    key_table[x+hash_x*y] = new_entry;
  }
  //PrintTable();
}


bool Keytable::IsKey(char* token, int len)
{
  int x = len % hash_x;
  int y = (int(*token)) % hash_y;
  for (element* search=key_table[x+hash_x*y]; search!=NULL; search=search->next) {
    if ((unsigned(len)==strlen(search->keyword))?!strncmp(token,search->keyword,len):0)
      return true;
  }
  return false;
}


void Keytable::PrintTable()
{
  for (int x=0; x<hash_x; ++x)
    for (int y=0; y<hash_y; ++y) {
      cout << "x:" << x << " y:" << y << " keywords:";
      for (element* search=key_table[x+hash_x*y]; search!=NULL; search=search->next)
	//cout << search->keyword << " ";
      cout << '\n';
    }
}
    
char* keys[] =       {"module","end","use","process","processtype",
                      "private","processinstance","array","of",
                      "guess","parameter","port","p<-t",
                      "t<-p","p->t","t->p","p-ot","to-p",
                      "mult","markdep","dist","graphbegin",
                      "graphend","place","trans","timed","imm",
                      "arc","type","ioarc","harc","portdep",
                      "transatt","prio","weight","enabdep","scaling",
                      "policy","prd","prs","pri","concurrency",
                      "ss","is","guard","useprocess","graphplace",
                      "graphtrans","grapharc","graphprocess","graphport","center",
                      "name","orient","viapos","width",
                      "length","exp","uniform","truncnormal","erlang",
                      "weibull","phasetype","det","bernoulli","discreteuniform",
                      "geometric","modgeometric","binomial","poisson","I",
                      "R","x","e","if","then",
                      "elsif","else","not","and","or",
                      "true","false","ArithmeticMean","E",
                      "smeasure", "mmeasure", "rreward", "ireward", "creward",
                      "param", "measparam", "constant",
		      ""};
// gestrichen: "reward","measure","mod","div","cardinal","integer","posreal","real"

Keytable spnl = Keytable(keys,HASH_X,HASH_Y);

    
  
  
		 
