#include "label.h"
#include "scope.h"

SHAPE_NOTIFY("label",Label)


double Label::Distance(ShapeData&, Position&, Position&)
{
		return 1e300;
//	return (nearest = ob->Absolute(p,Position(0,0),false,context.cpos)).Distance(ps);
}

Text Label::LabelText(ExprData& ed)
{
	ed.context = &context;
	Value* v = e.Evaluate(ed);
	return v?Text((char*)*v):Text();
}


void Label::DoDraw(Display* dpy, Drawable drw, GC gc, ShapeData& sd, ExprData& ed)
{
	ed.context = &context;
	Value* v = e.Evaluate(ed);

  if (!v) return; 
	char* text = *v; 
	
	int akt_len = 0; // aktuelle Zeilenlaenge
  bool end_reached = false; // Gibt an, ob Ende des Labels erreicht ist
	int akt_line = 0; // Nummer der aktuellen Zeile;

	while (!end_reached) {
	  ++akt_line;
	  // Ende der aktuellen Zeile suchen
	  for (text+=akt_len,akt_len=0; (*(text+akt_len)!='\0')&&
		 (*(text+akt_len)!='\n'); ++akt_len);
	  if (*(text+akt_len)=='\0')
	    end_reached = true;
	  else {
	    *(text+akt_len)='\0'; // newline durch Stringende ersetzen
	    ++akt_len; // Anzahl Zeichen bis zum naechsten Zeilenanfang
	  }
	  if (text)
	  {
	    XPoint pnt = Absolute(sd,p);
	    int asc,desc,width,shadow = context.shadow;
	    context.TextExtents(dpy,text,asc,desc,width);
	       
	    pnt.y += (asc-desc)/2+(akt_line-1)*(asc+desc); // y-Position entsprechend der Zeilennummer angleichen 
	    if (align==Center)
	      pnt.x -= width/2;
	    else
	      if (align==Right) pnt.x -= width;

	    if (shadow)
	      ((context.filled && !context.draw_xor)?XDrawImageString:XDrawString)
		(dpy,drw,gc,pnt.x+shadow,pnt.y+shadow,text,strlen(text));

	    ((context.filled && !context.draw_xor)?XDrawImageString:XDrawString)
	      (dpy,drw,gc,pnt.x,pnt.y,text,strlen(text));
	  }
	}
}


int Label::Inside(Display* dpy, Position pos, ShapeData& sd,ExprData& ed)
{
	Position pnt = Absolute(sd,p);
	Value* v = e.Evaluate(ed);
	char* text = v?(char*)*v:0;
	int akt_line = 0; // Nummer der aktuellen Zeile;

	int akt_len = 0; // aktuelle Zeilenl"ange
        bool end_reached = false; // Gibt an, ob das Ende des Labels erreicht ist
	bool inside = false; // Position liegt innerhalb des Labels

	if (text) {	
	  while (!end_reached && !inside) {
	    ++akt_line;
	    // Ende der aktuellen Zeile suchen
	    for (text+=akt_len,akt_len=0; (*(text+akt_len)!='\0')&&
		   (*(text+akt_len)!='\n');++akt_len);
	    if (*(text+akt_len)=='\0')
	      end_reached = true;
	    else {
	      *(text+akt_len)='\0'; // newline durch Stringende ersetzen
	      ++akt_len; // Anzahl Zeichen bis zum n"achsten Zeilenanfang
	    }
	    if (text)
	    {
	      pnt = Absolute(sd,p);
	      int asc,desc,width;
	      context.TextExtents(dpy,text,asc,desc,width);
	      pnt.y += -(asc+desc)/2+(akt_line-1)*(asc+desc);
	      if (align==Center)
		pnt.x -= width/2;
	      else
		if (align==Right) pnt.x -= width;
		
	      //cout<<"label.inside: "<<pos<<" in ("<<pnt.x<<','<<pnt.y<<','<<width<<','<<asc+desc<<")?"<<endl;
	      if (pos.x>=pnt.x && pos.y>=pnt.y
		  && pos.x<pnt.x+width && pos.y<pnt.y+(asc+desc)) inside = true;
	    }
	  }
	  return inside?RelativePos():0;
	}			
	return pnt.Distance(pos)<5?RelativePos():0;
}


istream& Label::Input(istream& is, int field)
{
	switch (field)
	{
	case 1:	is>>p; break;
	case 2: is>>e; break;
	case 3: Ident id(false); 
		is>>id; align = (id=="center")?Center:(id=="right")?Right:Left;
	}
	return is;
}

/*
ostream& Label::Output(ostream& os)
{
	return os<<<<p<<','<<e<<endl;
}
*/



