#include "xbefore.h"
#include <Xm/Text.h>
#include <Xm/ScrolledW.h>
#include "xafter.h"

#include <iostream.h>
#include "logwin.h"
extern "C" {
#include <fcntl.h>
}

bool LogWindow::Timer(bool)
{
//	cout<<"Timer!"<<endl;
	char buf[520]; bool update = false;
	
	istr.clear();
	do
	{
		char c,* p=buf;
    while (p-buf<512 && istr.get(c)) {
      if (!OnRecieveChar(c))
        *p++=c;
      if (c=='\n') break;
    }

		*p = 0;
		if (p > buf) update = true;
		text += (p = buf);
	}
	while (istr);
	
	if (update && w && text)
		XmTextSetString(w,text);
	
	input_id = wrapper.InputCB(fd,XtInputReadMask,Input,false);
	timer_id = 0;
	return false;	// nicht fortsetzen
}

	
bool LogWindow::Input(int,bool)
{
//	cout<<"Input!"<<endl;
	
	if (timer_id) wrapper.RemoveCB(timer_id);
	timer_id = wrapper.TimerCB(input_delay,Timer,false);
	input_id = 0;
	return false; // nicht fortsetzen
}
	

LogWindow::LogWindow(int filedes): 
	Dialog<LogWindow,bool>(this),
	wrapper(this),
	input_id(0),
	timer_id(0),
	w(0),
	istr(filedes),
	fd(filedes)
{
	fcntl(fd,F_SETFL,O_NONBLOCK);
	input_id = wrapper.InputCB(fd,XtInputReadMask,Input,false);
}
	

LogWindow::LogWindow(char* filename): 
	Dialog<LogWindow,bool>(this),
	wrapper(this),
	input_id(0),
	timer_id(0),
	w(0),
	istr(filename),
	fd(istr ? istr.rdbuf()->fd() : -1)
{
	if (fd>=0)
	{
		fcntl(fd,F_SETFL,O_NONBLOCK);
		input_id = wrapper.InputCB(fd,XtInputReadMask,Input,false);
	}
	else
		text = Text("File ")+filename+" not found!\n";
}

	
LogWindow::~LogWindow()
{
	UncatchDestroy(&w);
	if (input_id) wrapper.RemoveCB(input_id);
	if (timer_id) wrapper.RemoveCB(timer_id);
}


void LogWindow::Open(char* name, char* title, Widget parent, char* buttons)
{
	if(*this) return;
	Create(name,title,parent,false, DialogCB, buttons);
	Widget scroll = XtVaCreateManagedWidget("LogWindowScroll",
		xmScrolledWindowWidgetClass,Widget(*this),NULL);

	w = XtVaCreateManagedWidget("LogWindowText",xmTextWidgetClass,scroll,
		XmNeditable,False,
		XmNeditMode,XmMULTI_LINE_EDIT,
		NULL);
	CatchDestroy(&w);
	if (text) XmTextSetString(w,text);
	Manage();
}
  

void LogWindow::SetContents(char* c) 
{ 
  text = c; 
  if (c) XmTextSetString(w, c);
  else XmTextSetString(w, "");
} 
