#include "xbefore.h"
#include <X11/Intrinsic.h>
#include "xafter.h"

#include <strstream.h>
#include <iostream.h>

extern "C" {
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
}

#include "net.h"
#include "netcl.h"
#include "editor.h"
#include "expr.h"
#include "value.h"
#include "ident.h"
#include "logwin.h"

extern char* fallbacks[]; // from fbacks.cc

XtAppContext app;
char* app_class = "Agnes";
char* app_name = "agnes";
static char** app_argv;
int app_argc = 0;
Text agnes_dir, model_dir, tnet_dir;
LogWindow* logwindow = 0;


char** Argv()
{
	char** new_argv = new char*[app_argc];
	memcpy(new_argv,app_argv,app_argc*sizeof(char*));
	return new_argv;
}


int main(int argc, char *argv[])
{	
//	Ident x = "efg",*p = x;  Bug im g++: Missbrauchter char* Cast )o:

	Text home_dir = getenv("HOME");
	if (!home_dir) 
		home_dir = ".";
	
	if (!(tnet_dir = getenv("TNETHOME")))
		tnet_dir = ".";

	if (!(agnes_dir = getenv("AGNESDIR")))
		agnes_dir = tnet_dir+"/Agnes";
  
	if (!(model_dir = getenv("MODELDIR")))
		model_dir = ".";

	Text bitmap_dir = getenv("XBMLANGPATH");
	if (!bitmap_dir)
		putenv(bitmap_dir = Text("XBMLANGPATH=")+agnes_dir+"/bitmaps/%B");
	
	XtToolkitInitialize();
	app = XtCreateApplicationContext();
	XtAppSetFallbackResources(app,fallbacks);
	
	if ((app_argc = argc))
		app_argv = argv;
	
	// Eingebaute Netzklassen instanziieren
#include "builtins.h"
	
	// ggf. Externe Netzklassen laden
  NetClass::LoadExternals("./NetClasses");
  NetClass::LoadExternals(model_dir+"/NetClasses");
  NetClass::LoadExternals(agnes_dir+"/NetClasses");
    
	// Netze aus der Commandline (rekursiv) laden, ggf. leeres Fenster auf
	Editor::NewEditor(0,NULL,1);

	// stderr ausgaben in globales Logwindow umlenken
	int err_pipe[2];
	pipe(err_pipe);
  dup2(err_pipe[1],2);
	close(err_pipe[1]);
	logwindow = new LogWindow(err_pipe[0]);
	
	Editor::MainLoop();
	return 0;
}

