#include "metrics.h"

double Metrics::epsilon=0;

void Metrics::Compare(Metrics comp)
{
  if(comp.set) {
    if(set) {
      if (y_beg > comp.y_beg) y_beg = comp.y_beg;
      if (y_end < comp.y_end) y_end = comp.y_end;
      if (x_beg > comp.x_beg) x_beg = comp.x_beg;
      if (x_end < comp.x_end) x_end = comp.x_end;
    }
    else {
      y_beg = comp.y_beg;
      y_end = comp.y_end;
      x_beg = comp.x_beg;
      x_end = comp.x_end;
      set = true;
    }
  }
}

void Metrics::Compare(Position pos)
{
  if (set) {
    if (y_beg > pos.y) y_beg = pos.y;
    if (y_end < pos.y) y_end = pos.y;
    if (x_beg > pos.x) x_beg = pos.x;
    if (x_end < pos.x) x_end = pos.x;
  }
  else {
    y_beg = pos.y;
    y_end = pos.y;
    x_beg = pos.x;
    x_end = pos.x;
    set = true;
  }
}

void Metrics::Print()
{
  cout << "Metrics\n";
      if (set) {
	cout << "y_beg:" << y_beg << " y_end:" << y_end << '\n';
	cout << "x_beg:" << x_beg << " x_end:" << x_end << '\n';
      }
      else
	cout << "Sorry, Metrics Are Undefined\n";
}

double Metrics::Overlap(Metrics met)
{
  return (y_end + MINSPACE - met.y_beg);
}

bool Metrics::Within(Position pos)
{
  if ((x_beg<pos.x)&&(pos.x<x_end)&&(y_beg<pos.y)&&(pos.y<y_end))
    return true;
  else
    return false;
}

bool Metrics::Within(Metrics met)
{
  if ((x_beg-met.x_beg<epsilon)&&(met.x_end-x_end<epsilon)
      &&(y_beg-met.y_beg<epsilon)&&(met.y_end-y_end<epsilon))
    return true;
  else
    return false;
}

bool Metrics::IsLower(Metrics met)
{
  if (met.y_end<y_beg)
    return true;
  else
    return false;
}

Position Metrics::ForceIn(Position pos)
{
  if (pos.x<=x_beg) pos.x = x_beg + 1;
  if (pos.x>=x_end) pos.x = x_end - 1;
  if (pos.y<=y_beg) pos.y = y_beg + 1;
  if (pos.y>=y_end) pos.y = y_end - 1;
  return pos;
}

Position Metrics::ForceIn(Position pos,Metrics met)
{
  if (met.x_beg<=x_beg) pos.x += x_beg-met.x_beg + 1;
  if (met.x_end>=x_end) pos.x -= met.x_end-x_end + 1;
  if (met.y_beg<=y_beg) pos.y += y_beg-met.y_beg + 1;
  if (met.y_end>=y_end) pos.y -= met.y_end-y_end + 1;
  return pos;
}

void Metrics::Move(Position rel)
{
  x_beg += rel.x;
  x_end += rel.x;
  y_beg += rel.y;
  y_end += rel.y;
}

