#include "netcl.h"
#include "nodecl.h"
#include "scope.h"
#include "node.h"


NodeClass::NodeClass(NetClass& nc): 
	ObjectClass(nc,"N"),subclass(0),align(true)
{
}


istream& NodeClass::Input(istream& is)
{
	Ident id(false);
	Scope sp(is);
	while (is && sp.GetId(id))
		if (id=="subclass")
		{
			if (!(is>>id) || (subclass = NetClass::GetNetClass(id,netcl.Path()))==0)
			{
				cerr<<"NodeClass::Input: Name of Sub-NetClass expected!"<<endl;
				is.clear(ios::badbit);
			}
		}
		else if (id=="align")
		{
			if (is>>id)
				align=id=="true";
			else
			{
				cerr<<"NodeClass::Input: true or false expected for align!"<<endl;
				is.clear(ios::badbit);
			}
		}		
		else ObjectClass::Input(is, id);

	return is;
}

Position NodeClass::PointToMid(ShapeData& sd, Position& ps)
{
  return (*shapes.First())->PointToMid(sd,ps);
}


void NodeClass::DrawButton(Display* dpy, Drawable d, int x, int y, int w, int h)
{
	Ident empty("");
	Iterator<Position*> iter(relatives);
	bool mono = DefaultDepth(dpy,XDefaultScreen(dpy))==1;
	ShapeData sd(1,Position(x,y),Position(w/200.0,h/200.0),0,
		iter,iter,true);
	ExprData ed(attr,empty,false,false,false,mono);
	ObjectClass::Draw(dpy,d,sd,ed);
}
