// Pfeilschneller *,?,, und [] Matcher aus der tcsh

static char *cclass(char *p, int sub)
{
	char c, d, negate = *p=='^', found = 0;

	if (negate) p++;
	do
	{
		if (*p=='\0')
			return 0;
		c = *p;
		if (p[1]=='-' && p[2]!=']')
		{
			d = p[2];
			p += 2;
		}
		else
			d = c;
		if (c==sub || (c <= sub && sub <= d))
			found = 1;
	}
	while (*++p!=']');

	return (found!=negate) ? p+1 : 0;
}


static bool exprmatch(char *s, char *p)
{
	char sc, pc;

	while ((pc = *p++)!=0)
	{
		sc = *s++;
		switch (pc)
		{
		case '[':
			if (sc==0 || (p = cclass(p, sc))==0)
				return false;
			break;

		case '?':
			if (sc==0)
				return false;
			break;

		case '*':
			s--;
			do
			{
				if (*p==0 || exprmatch(s, p))
					return true;
			}
			while (*s++!=0);
			return false;
		
		default:
			if (sc!=pc)
				return false;
		}
	}
	return *s==0;
}


bool Matches(char *file, char *mask)
{
	char more = 0; char *p = mask;

	do
	{
		while (*p && *p!=',') p++;
		more = *p;
		*p = 0;
		
		if (exprmatch(file, mask))
		{
			if (more) *p = ',';
			return true;
		}
		
		if (more)
		{
			*p++ = ','; mask = p;
		}
	}
	while (more);

	return false;
}
