#include "xbefore.h"
#include <Xm/ScrollBar.h>
#include "xafter.h"

#include "tool.h"


int Maxi(int a,int b)
{
	return a>b?a:b;
}


int Mini(int a,int b)
{
	return a<b?a:b;
}


char* NormalString(XmString cs)
{
	XmStringContext context;
	XmStringCharSet charset;
	XmStringDirection direction;
	Boolean	separator;
	char* selection;

	XmStringInitContext(&context,cs);
	XmStringGetNextSegment(context,&selection,&charset,&direction,&separator);
	XmStringFreeContext(context);

	return selection;
}


void SetStringValue(Widget w,char *res,char *msg)
{
	XmString str,curr;

	XtVaGetValues(w,res,&curr,NULL);
	str = XmStringCreateLtoR(msg?msg:"",XmFONTLIST_DEFAULT_TAG);
	
	if (!XmStringCompare(str,curr))
		XtVaSetValues(w,res,str,NULL);
	XmStringFree(str);
}


char* GetStringValue(Widget w,char *res)
{
	XmString str;

	XtVaGetValues(w,res,&str,NULL);
	return NormalString(str);
}


void _FixHighlight(Widget scw)
{
	Widget hsc,vsc;
	
	XtVaGetValues(scw,XmNhorizontalScrollBar,&hsc,
		XmNverticalScrollBar,&vsc,NULL);
	if (hsc) XtVaSetValues(hsc,XmNhighlightThickness,0,NULL);
	if (vsc) XtVaSetValues(vsc,XmNhighlightThickness,0,NULL);
}

void CheckLabelPixmap(Widget w)
{	
	unsigned char ltype; Pixmap lpix;
	XtVaGetValues(w,XmNlabelType,&ltype,XmNlabelPixmap,&lpix,NULL);
	if (ltype==XmPIXMAP && lpix==XmUNSPECIFIED_PIXMAP)
		XtVaSetValues(w,XmNlabelType,XmSTRING,NULL);
}

static void _Destroy(Widget,XtPointer cldata,XtPointer)
{
	*(Widget*)cldata = 0;
}


void CatchDestroy(Widget* w1,Widget* w2,Widget* w3,Widget* w4)
{
	if (w1 && *w1)
		XtAddCallback(*w1,XmNdestroyCallback,_Destroy,XtPointer(w1));
	if (w2 && *w2)
		XtAddCallback(*w2,XmNdestroyCallback,_Destroy,XtPointer(w2));
	if (w3 && *w3)
		XtAddCallback(*w3,XmNdestroyCallback,_Destroy,XtPointer(w3));
	if (w4 && *w4)
		XtAddCallback(*w4,XmNdestroyCallback,_Destroy,XtPointer(w4));
}


void UncatchDestroy(Widget* w1,Widget* w2,Widget* w3,Widget* w4)
{
	if (w1 && *w1)
		XtRemoveCallback(*w1,XmNdestroyCallback,_Destroy,XtPointer(w1));
	if (w2 && *w2)
		XtRemoveCallback(*w2,XmNdestroyCallback,_Destroy,XtPointer(w2));
	if (w3 && *w3)
		XtRemoveCallback(*w3,XmNdestroyCallback,_Destroy,XtPointer(w3));
	if (w4 && *w4)
		XtRemoveCallback(*w4,XmNdestroyCallback,_Destroy,XtPointer(w4));
}


