#include "xbefore.h"
#include <X11/Intrinsic.h>
#include <Xm/XmStrDefs.h>
#include "xafter.h"

#include "value.h"
#include "netcl.h"
#include "ident.h"
#include "array.h"
#include <iostream.h>


static Array<Ident,Value*> values;

ValueNotification::ValueNotification(char* name, Value* v)
{
	values.Set(Ident(name,false),v);
}

	
Value *Value::GetType(istream& is, NetClass* nc)
{
	Value *v = 0,** vp;
	Ident id(false);
	if (is>>id)
	{
		bool hidden = id=="hidden";
		if (hidden) is>>id;
		
		if ((vp = values[id]))
		{
			v = (*vp)->Copy();
			v->netcl = nc;
			v->hidden = hidden;
		}

		if ((v || (nc && (v = nc->GetType(id)))) && !v->Parse(is))
		{
			delete v; v = 0;	
		}
	}
	return v;
}

