/******************************************************************************
* Programm  : gensol                                                          *
* Komponente: debug.c (showXRG()) wird durch option -x bei gensol aufgerufen  *
* Parameter : filename                                                        *
* Rueckgabe :                                                                 *
* Aufgabe   : Ausgabe des expandierten Erreichbarkeitsgraphen in eine vom     *
*             Menschen lesbare Datei. Das Format ist selbsterklaerend.        *
* Projektleiter: Reinhard German, TU-Berlin                                   *
* Programmierer: Thomas Kuhlmann, TU-Berlin                                   *
* Datum:         Mon Jun 21 18:18:40 MET DST 1993                             *
******************************************************************************/
#include "expand.h"

void showXRG(xrg_fname)
char *xrg_fname;
{
	FILE *fp;

	new_mark_no_t new_mark_no;
	det_tra_no_t  det_tra_no;
	pred_cnt_t    pred_no;
	new_mark_t   *n_mark;

	if (!(fp=fopen(xrg_fname,"w"))) {
		perror(xrg_fname);
		return;
	}
	fprintf(fp,"--- Expanded new marking table: ----\n");
	for (new_mark_no=no_new_marks; new_mark_no--; ) {
		n_mark = new_mark[new_mark_no];
		/*
		 *	Zeige die Markierung new_mark_no an:
		 */
		fprintf(fp,"%02d %02d:", n_mark->new_no, n_mark->old_no );
		for (det_tra_no=no_det_trans; det_tra_no--; ) {
			fprintf(fp," %d", n_mark->phase[det_tra_no] );
		}
		/*
		 *	Kanten zu dieser Markierung von:
		 */
		fprintf(fp,"\n");
		for (pred_no = n_mark->no_preds; pred_no--; ) {
			fprintf(fp," from: %02d, with rate: %.15g\n",
				n_mark->pred[pred_no].from_mark,
				n_mark->pred[pred_no].rate );
		}
		fprintf(fp,"sum of outgoing rates: %.15g\n", n_mark->ratesum );
	}
	if (fclose(fp)) perror(xrg_fname);
}
