/******************************************************************************
* Programm  : gensol                                                          *
* Komponente: tra.c (det_tra_no())                                            *
* Parameter : Transitionsnummer aus dem reduzierten Erreichbarkeitsgraph .rrg *
* Rueckgabe : neue Transitionsnummer (nur fuer deterministische) von 0..      *
* Aufgabe   : Erzeugen von deterministischen Transitionsnummern die von Null  * 
*             an aufwaerts reichen. Diese Nummern koennen als index in eine   *
*             Liste von Phasenzaehlern verwendet werden.                      *
* Projektleiter: Reinhard German, TU-Berlin                                   *
* Programmierer: Thomas Kuhlmann, TU-Berlin                                   *
* Datum:         Mon Jun 21 18:18:40 MET DST 1993                             *
******************************************************************************/
#include "expand.h"

typedef struct {
	unsigned     tra_name;
	det_tra_no_t tra_no;
} tra_name_no_t;

bool_t TraNameNoCompare(pa,pb)
tra_name_no_t *pa, *pb;
{
	return ((int)(pa->tra_name)) - ((int)(pb->tra_name));
}

/*
 *	Uebersetzung von deterministischen Transitionsnamen(nummern) in zusammen-
 * haengende Transitionsnummern von 1..no_det_trans:
 */
det_tra_no_t det_tra_no( new_tra_name )
unsigned new_tra_name;
{
	static tra_name_no_t *name_no = (tra_name_no_t*)0;
	tra_name_no_t  new_name_no;
	tra_name_no_t *newpos;

	new_name_no.tra_name = new_tra_name;
	new_name_no.tra_no   = no_det_trans;
	(void) insert( (char*)&new_name_no, (char**)&name_no, &no_det_trans,
			sizeof(tra_name_no_t), TraNameNoCompare, (char**)&newpos );
	return newpos->tra_no;
}
