/******************************************************************************
* Programm  : gensol                                                          *
* Komponente: utils.c                                                         *
* Aufgabe   : Zusammenfassung haeufig verwendeter Codestuecke als Funktionen  *
* Projektleiter: Reinhard German, TU-Berlin                                   *
* Programmierer: Thomas Kuhlmann, TU-Berlin                                   *
* Datum:         Mon Jun 21 18:18:40 MET DST 1993                             *
******************************************************************************/
#define __utils_c__
#include <errno.h>
#include <malloc.h>
#include <ctype.h>
#include "expand.h"

void eperror(str)
char *str;
{
	extern char *sys_errlist[];

	if (str)
		perror(str);
	else
		perror(sys_errlist[errno]);
	exit(1);
}

char *erealloc(ptr,nelems,elemsize)
char     *ptr;
unsigned  nelems, elemsize;
{
	char *result;

        if (!nelems || !elemsize) return NULLPTR;
	if (result=realloc(ptr,nelems*elemsize)) return result;
	eperror(NULLPTR);
}

char *ecalloc(nelems,elemsize)
unsigned nelems, elemsize;
{
	char *result;

        if (!nelems || !elemsize) return NULLPTR;
	if (result=calloc(nelems,elemsize)) return result;
	eperror(NULLPTR);
}

char *emalloc(nelems,elemsize)
unsigned nelems, elemsize;
{
	char *result;

        if (!nelems || !elemsize) return NULLPTR;
	if (result=malloc(nelems*elemsize)) return result;
	eperror(NULLPTR);
}

/*
 *	Stringvergleich wobei Gross/Kleinschreibung nicht signifikant ist
 *   fuer die Programmoptionen 'Loesungsmethode' und 'Schaltsemantik'
 */
int optequal( s1, s2 )
char *s1, *s2;
{
	while ( tolower(*s1) == tolower(*s2) ) {
		if (!*s1++ || !*s2++) return TRUE;
	}
	return (!*s1 || !*s2);
}

int skip_comment_lines(stream)
FILE *stream; {
	int c;

	do switch (c=fgetc(stream)) {
		case EOF:
			return 1;
		case COMMENT:
			while ((c=fgetc(stream)) != NEWLINE)
				if (c == EOF) return 1;
			continue;
		default:
			ungetc(c,stream);
			return 0;
		}
	while (TRUE);
}
