/******************************************************************************
* Programm  : gensol                                                          *
* Komponente: write.c (write_result())                                        *
* Parameter : filename, globale Tabelle mit alten Markierungen                *
* Aufgabe   : Ausgabe des Loesungsvektors in das .sol file                    *
* Projektleiter: Reinhard German, TU-Berlin                                   *
* Programmierer: Thomas Kuhlmann, TU-Berlin                                   *
* Datum:         Mon Jun 21 18:18:40 MET DST 1993                             *
******************************************************************************/
#include "expand.h"

/*
 *	Voraussetzung: die alten Markierungen sind nach der Markierungsnummer
 * aufsteigend sortiert
 */
void write_result(filename)
char *filename;
{
	FILE *fp;
	char *solfile, *next;
	register old_mark_no_t old_mark_no;

	if (!(fp=fopen(filename,"w"))) eperror(filename);
	solfile = filename;
	/*
	 *	letzte Komponente des Filenames (wird im Kommentar des Files verwendet):
	 */
	for(next=filename; *next; next++) {
		if (*next == '/') solfile = next+1;
	}
	fprintf(fp,"#\n# file %s containing the probabilities of the ", solfile);
	fprintf(fp,"tangible markings\n# generated by APPROX\n#\n");
	fprintf(fp,"# Number of tangible markings #tmark:\n");
	fprintf(fp,"%ld\n", no_old_marks );
	fprintf(fp,"# probabilities of the tangible markings (from marking 0 to marking #tmark-1):\n");
	for(old_mark_no = 0; old_mark_no<no_old_marks; old_mark_no++ ) {
		fprintf(fp,"%.20g\n", old_mark[old_mark_no].time_spent);
	}
	if (fclose(fp)) eperror(filename);
}
