/*******************************************************************************
* Program:	genrrg
*
* File:		genrrg.h
*
* Purpose:	Type-definitions and constants, headers.
*
* Programmer:	Robert Zijal
*
* History:	March 1995
*
*******************************************************************************/

#ifndef _GENRRG_H
#define _GENRRG_H

#include <math.h> 
#include "netio.h"


/*-----------*/
/* CONSTANTS */
/*-----------*/
#define	MAX_BYTE_LIM  0xFF     	       /* 1 byte  = 255 */

#define	MAX_WORD_LIM  0xFFFF           /* 2 bytes = 65535 */

#define	MAX_PLACE     MAX_BYTE_LIM     /* max no of places */

#define	MAX_TRANS     MAX_BYTE_LIM     /* max no of transitions */

#define	MAX_TOKEN     (MAX_WORD_LIM-1) /* max no of tokens + 0 */

#define MAX_PHASE     (MAX_WORD_LIM-2) /* max no of phases + 0 + B_ph-entry */


/*-----------*/
/* VARIABLES */
/*-----------*/

/* initial phase, set to max_phase + 1: 0xFF or 0xFFFF */
word B_ph; 

/* global access for more efficiency (please READ ONLY !); from genrrg_main.c */
extern NetDescr *dtnet;
/* debugging accuracy; from genrrg_main.c */
extern double DEB_accuracy;
/* trigger: using embedding technique */
extern Bool Embedding;
/* trigger: for smaller state-space representation, when embedding */
extern Bool SaveSpace;
/* basic underlying time-step */
extern unsigned long int but_step;

#define _SHOWMEMUSAGE

#ifdef SHOWMEMUSAGE
 unsigned long int no_mtree_reallocs;
 unsigned long int no_phtree_reallocs;

 unsigned long int m_bnd_size;
 unsigned long int m_unbnd_size;
 unsigned long int m_unbnd_mxentries;
 unsigned long int m_unbnd_entries;
 unsigned long int m_state_size;

 unsigned long int ph_bnd_size;
 unsigned long int ph_unbnd_size;
 unsigned long int ph_unbnd_mxentries;
 unsigned long int ph_unbnd_entries;
 unsigned long int ph_state_size;
#endif


/*------------------*/
/* FUNCTION-HEADERS */
/*------------------*/
  
/* from load_net.c */
extern NetDescr *load_dtn(/* char *net_name */);
extern void    show_dtnet(/* NetDescr *net  */);
extern void test_tree();
extern void test_graph();
extern void genrrg();
extern int My_Error();
extern void geom_usage(/* NetDescr *net, Transition *t, double real_delay */);

/* from genrrg_graph.c */
extern int act_marking(/*int pla*/);

/*--------*/
/* MACROS */
/*--------*/

#define nl(w) fprintf(w,"\n"); 

#endif


