/************************************************/
/*** Strukturen fuer das Format der P-Matrix: ***/
/************************************************/
static struct P_row_header {
  unsigned row_index;	      /* Zeilennummer */
  unsigned entries_in_row;    /* Anzahl nachfolgender Eintraege in dieser Zeile
				  (Je Eintrag eine P_row_entry-Struktur) */
} P_row_header;
#define SIZEOF_P_row_header sizeof(P_row_header)

static struct P_row_entry {
  double probability;			/* Uebergangswahrscheinlichkeit */
  unsigned column_index;		/* Spaltennummer des Eintrages */
} P_row_entry;
#define SIZEOF_P_row_entry (sizeof(double) + sizeof(unsigned))


/**********************************************/
/*** Struktur fuer das Format der C-Matrix: ***/
/**********************************************/
/* im Fall Mexp: */
static struct C0_entry {
  double sojourn_time;			/* mittlere Aufenthaltszeit */
  unsigned state_number;		/* Zustandsnummer */
} C0_entry;
#define SIZEOF_C0_entry (sizeof(double) + sizeof(unsigned))

/**************************************************/
/*** Struktur fuer das Format der RATES-Matrix: ***/
/**************************************************/
static struct rates_type
{       byte    t_nr;
        double  rate;
} rate_entry;

