/******************************************************************************
 File:              showTransCurves.h
 
 Project Director:  Reinhard German
 

Programmer:         Joerg W. Mitzlaff

History:            10.94 (Dipl.Arbeit)
*******************************************************************************/

#define COMMENT     '#'
#define BUF_SIZE    1000

typedef enum {Adaptive,Absolute,Logarithmic,Equal} Scale_Type;

#ifdef STR
typedef enum {Lines, Dashes,Off} Conf_Type;
#endif

typedef struct
{
      char *name;      /* reward measure name */

      double maxX;    /* gegebene Groessen */
      double maxY;
      double minY;
      double maxY_before_stat;
      double minY_before_stat;
      double maxY_stat;
      double minY_stat;
      Scale_Type scale;
      int visible;

      int kachel_breite; /* Bildausschnittsdimension */
      int kachel_hoehe;
      int kachel_x;
      int kachel_y;
                      /* Berechnete Groessen */
      double rminY;     /* abgerundetes maxY ist aber groesser  minY-rticstepy */
      double rmaxY;

      double umaxX;     /* pixelbildgroesse / reale argumentbereichsgroesse */
      double udiffY;    /*   -||-  */
      double lrminY;    /* log10(rminY); */
      int    startx;    /* zum schnellen unrealx berechnen */
      int    starty;    /* zum schnellen unrealy berechnen */

      double *Datas;    /* numDatas Werte */
      double stat_res;  /* Loesung der stationaeren Analyse */

#ifdef STR
      double *conf_datas;    /* numDatas Konfidenz-Werte */
      int    stopped;
#endif
} Measure_Datas;

typedef struct
{
      int numDatas;
      int aktData;     /* naechstes zu lesendes datum */
      int numMeasures;
      Measure_Datas *mdata;
      double *time;
      char *buffer;
      int show_stat;
      int derived_stat;
} Drawing_Basis;

