#ifndef _ORAArcObj_h
#define _ORAArcObj_h
/*******************************************************************************
Modul   	:	ArcObj.h

Purpose		: 	"offentliches Headerfile der Klasse ArcObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/

#include <limits.h>

/* VERSUCH IN DIE KLASSEN HIERARCHI ZW OBJECT UND ARC COMPOSITE ZU INTEGRIEREN */
/*
 * ArcObj Widget public include file
 
   Class Hierarchie:
   core ->  Composite -> ArcObj
 */

/*
 * This include not needed unless the application includes Intrinsic.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include <X11/Composite.h>

/* Resources:
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
  XtNfromObj	     XtCfromObj        	XtRPointer     	NULL
  XtNtoObj	     XtCtoObj        	XtRPointer     	NULL
  XtNarcType	     XtCarcType		XtRInt		INPUTARC
  XtNmultiplicity    XtCmultiplicity	XtRPointer      NULL
  XtNdrawingDirection    XtCdrawingDirection	XtRdrawingDirection	UP
 */

#define XtNfromObj 	"fromObj"
#define XtCfromObj 	"FromObj"

#define XtNtoObj 	"toObj"
#define XtCtoObj 	"ToObj"

typedef enum {INPUTARC,OUTPUTARC,INHIBITORARC} ArcType;

#define XtEinputArc        "inputArc"
#define XtEoutputArc       "outputArc"
#define XtEinhibitorArc    "inhibitorArc"

#define XtNarcType 	"arcType"
#define XtCarcType 	"ArcType"
#define XtRarcType	"ArcType"

#define XtNmultiplicity "multiplicity"
#define XtCmultiplicity "Multiplicity"

#define XtNdrawingDirection "drawingDirection"
#define XtCdrawingDirection "DrawingDirection"
#define XtRdrawingDirection "DrawingDirection"

typedef enum {UP,DOWN} DrawingDirection;
typedef enum {ARCVALUE, MD_DEF} MultiplType;

#define arcClassName "ArcObj"

/* -------------------- */

typedef struct {
    MultiplType type;		/* arcpar or not */    
    union {
	Cardinal arcvalue;   /* either Cardinalvalue or ... */
	String md_definition;
    } values;
    Cardinal actualValue;
} Multiplicity;

#define Impossible UINT_MAX  /* max Cardinal */

#define XtNarc "arcs"
#define XtCarc "Arcs"
#define XtRarc "Arc"

/* Mode for multiplicity settings */
#define INCR 0
#define DECR 1
#define ABS  2

/* Mode vor selecting IP */
#define POINT 0
#define SECTION 1

/* possible return of recieveIP */
#define NOT_FOUND -10

/* Class record constants */

#define isArcObject(W) XtIsSubclass(W,arcObjClass)

extern WidgetClass arcObjClass;

/* Public functions */
extern void getImPCoords();
extern void createImPoint();
extern void destroyImPoint();
extern void resetImPoint();
extern int  recievePointOfArc();
extern void rescaleImPoint();
extern void setMultiplicity();

typedef struct _ArcObjClassRec *ArcObjectClass;
typedef struct _ArcObjRec      *ArcObject;

#endif /* _ORAArcObj_h */
/* DON'T ADD STUFF AFTER THIS #endif */
