/*******************************************************************************
Modul   	:	ArcObjP.h

Purpose		: 	privates Headerfile der Klasse ArcObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


/* 
 * ArcObjP.h - Private definitions for ArcObj widget

   Class Hierarchie:
   Core ->  Composite-> ArcObj
 */

#ifndef _ORAArcObjP_h
#define _ORAArcObjP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include <X11/CompositeP.h>

/*
 * This one is always needed!
 */
#include "ArcObj.h"

/* New fields for the ArcObj widget class record */

typedef struct {
	int dummy;	/* dummy field */
} ArcObjClassPart;

/* Full class record declaration */
typedef struct _ArcObjClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    ArcObjClassPart	arcObj_class;
} ArcObjClassRec;

extern ArcObjClassRec arcObjClassRec;

/* New fields for the ArcObj record */
typedef struct {

    /* resources */
    Widget fromObj,toObj;
    ArcType arcType;
    Multiplicity *multiplicity;
    DrawingDirection drawing_direction;

    /* private state */
    Cardinal insert_position;
     
} ArcObjPart;

/*
 * Full instance record declaration
 */
typedef struct _ArcObjRec {
    CorePart		core;
    CompositePart	composite;
    ArcObjPart		arcObj;
} ArcObjRec;

#endif /* _ORAArcObjP_h */
