/*******************************************************************************
Modul   	:	BaseObj.h

Purpose		: 	"offentlices Headerfile der Klasse BaseObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


#ifndef _ORABaseObj_h
#define _ORABaseObj_h

/*
 * BaseObj Widget public include file
 
   Class Hierarchie:
   Object -> BaseObj
 */

/*
 * This include not needed unless the application includes Intrinsic.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include <X11/Object.h>

/* Resources:
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
  XtNxpos	     XtCxpos	        XtRPosition     UNSPECIFIED_COORDINATE
  XtNypos	     XtCypos 	        XtRPosition     UNSPECIFIED_COORDINATE
  XtNdblX            XtCDblX            XtRFloat
  XtNdblY            XtCDblY            XtRFloat 
 */

#define XtNxpos "xpos"
#define XtNypos "ypos"

#define XtCxpos "Xpos"
#define XtCypos "Ypos"

#define XtNdblX "dblX"
#define XtCDblX "DblX"

#define XtNdblY "dblY"
#define XtCDblY "DblY"

#define baseClassName "BaseObj"

#define UNSPECIFIED_COORDINATE -12345
/* Class record constants */

#define isBaseObject(W) XtIsSubclass(W, baseObjClass)

extern WidgetClass baseObjClass;

extern Boolean isDestroyed();

typedef struct _BaseObjClassRec *BaseObjClass;
typedef struct _BaseObjRec      *BaseObj;

#endif /* _ORABaseObj_h */
/* DON'T ADD STUFF AFTER THIS #endif */


