/*******************************************************************************
Modul   	:	BaseObjP.h

Purpose		: 	privates Headerfile der Klasse BaseObj.h

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


/* 
 * BaseObjP.h - Private definitions for BaseObj widget

   Class Hierarchie:
   Object -> BaseObj
 */

#ifndef _ORABaseObjP_h
#define _ORABaseObjP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include <X11/ObjectP.h>

/*
 * This one is always needed!
 */
#include "BaseObj.h"

/* New fields for the BaseObj widget class record */

typedef struct {
	int dummy;	
} BaseObjClassPart;

/* Full class record declaration */
typedef struct _BaseObjClassRec {
    ObjectClassPart	object_class;
    BaseObjClassPart	baseObj_class;
} BaseObjClassRec;

extern BaseObjClassRec baseObjClassRec;

/* New fields for the BaseObj widget record */

typedef struct {
    /* resources */
    int x,y;
    double dblX, dblY;  /* need this for rotation of objects */

} BaseObjPart;

/*
 * Full instance record declaration
 */
typedef struct _BaseObjRec {
    ObjectPart		object;
    BaseObjPart	baseObj;
} BaseObjRec;

#endif /* _ORABaseObjP_h */
