/*******************************************************************************
Modul   	:	MarkParObjP.h

Purpose		: 	privates Headerfile der Klasse MarkParObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


/* 
 * MarkParObjP.h - Private definitions for MarkParObj widget

   Class Hierarchie:
   Object -> BaseObj -> MarkParObj
 */

#ifndef _ORAMarkParObjP_h
#define _ORAMarkParObjP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include "BaseObjP.h"

/*
 * This one is always needed!
 */
#include "MarkParObj.h"

/* New fields for the MarkParObj widget class record */

typedef struct {
	int num_created;	/* number of created objects */
} MarkParObjClassPart;

/* Full class record declaration */
typedef struct _MarkParObjClassRec {
    ObjectClassPart	object_class;
    BaseObjClassPart	baseObj_class;
    MarkParObjClassPart	markParObj_class;
} MarkParObjClassRec;

extern MarkParObjClassRec markParObjClassRec;

/* New fields for the MarkParObj widget record */
typedef struct {

    /* resources */
    String mpar_name;
    Cardinal mpar_value;

    /* private state */
     
} MarkParObjPart;

/*
 * Full instance record declaration
 */
typedef struct _MarkParObjRec {
    ObjectPart		object;
    BaseObjPart		baseObj;
    MarkParObjPart	markParObj;
} MarkParObjRec;

#endif /* _ORAMarkParObjP_h */
