/*******************************************************************************
Modul   	:	PlaceObj.h

Purpose		: 	"offentliches Headerfile der Klasse PlaceObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


#ifndef _ORAPlaceObj_h
#define _ORAPlaceObj_h

/*
 * PlaceObj Widget public include file
 
   Class Hierarchie:
   Object -> BaseObj -> TagedObj -> PlaceObj
 */

/*
 * This include not needed unless the application includes Intrinsic.h
 * after this file.   Anyway, it doesn't hurt.
 */

#include "TagedObj.h"

/* Resources:
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
  XtNinitialMarking  XtCinitialMarking  XtRinitialMarking     NULL
  XtNdistribution    XtCdistribution  	XtRdistribution       NULL
  XtNactualMarking   XtCactualMarking   XtRCardinal           0
  XtNselected        XtCSelection       XtRBoolean            False
  XtNcopy            XtCCopy            XtRWidget             NULL
 */

#define XtNinitialMarking "initialMarking"
#define XtCinitialMarking "InitialMarking"
#define XtRinitialMarking "InitialMarking"

#define XtNdistribution "distribution"
#define XtCdistribution "Distribution"
#define XtRdistribution "Distribution"

#define XtNactualMarking "actualMarking"
#define XtCActualMarking "ActualMarking"

#define XtNselected "selected"
#define XtCSelected "Selected"

#define XtNcopy "copy"
#define XtCCopy "Copy"

typedef struct _InitialMarking {
		int type;			/* type of value */
		union {
			Cardinal markingValue;	/* either int value */
			XtPointer markingParam;	/* or markingparam */
		      } values;
		} InitialMarking,*InitialMarkingPtr;

typedef struct _Distribution {
		double mean,error;
		String distribution_string;
		} Distribution;

#define MARKINGVALUE 0
#define MARKINGPARAM 1

#define placeClassName "PlaceObj"

/* Class record constants */

#define isPlaceObject(W) XtIsSubclass(W, placeObjClass)

extern WidgetClass placeObjClass;

/* public functions 
extern void DrawPlace();*/

typedef struct _PlaceObjClassRec *PlaceObjClass;
typedef struct _PlaceObjRec      *PlaceObj;

#endif /* _ORAPlaceObj_h */
/* DON'T ADD STUFF AFTER THIS #endif */
