/*  LAST EDIT: Tue Feb  9 14:26:54 1993 by Christian Luehe (merlin!chl)  */
/*******************************************************************************
Modul   	:	PlaceObjP.h

Purpose		: 	privates Headerfile der Klasse PlaceObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


/* 
 * PlaceObjP.h - Private definitions for PlaceObj widget

   Class Hierarchie:
   Object -> BaseObj ->TagedObj ->  PlaceObj
 */

#ifndef _ORAPlaceObjP_h
#define _ORAPlaceObjP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include "TagedObjP.h"

/*
 * This one is always needed!
 */
#include "PlaceObj.h"

/* New fields for the PlaceObj widget class record */

typedef struct {
	int num_created;	/* dummy field */
} PlaceObjClassPart;

/* Full class record declaration */
typedef struct _PlaceObjClassRec {
    ObjectClassPart	object_class;
    BaseObjClassPart    baseObj_class;
    TagedObjClassPart   tagedObj_class;
    PlaceObjClassPart	placeObj_class;
} PlaceObjClassRec;

extern PlaceObjClassRec placeObjClassRec;

/* New fields for the PlaceObj widget record */
typedef struct _PlaceObjPart {

    /* resources */
    InitialMarking *M0;
    Distribution *distribution;
    Cardinal actualMarking;
    Boolean selected;
    Widget copy;

    /* private state */

} PlaceObjPart;

/*
 * Full instance record declaration
 */
typedef struct _PlaceObjRec {
    ObjectPart		object;
    BaseObjPart 	baseObj;
    TagedObjPart 	tagedObj;
    PlaceObjPart	placeObj;
} PlaceObjRec;

#endif /* _ORAPlaceObjP_h */
