
#ifndef _POLYGON
#define _POLYGON

#ifndef POLYGON_C
#define EXTERN extern
#else
#define EXTERN
#endif

typedef struct _Coordinate {
    double x,y;
} Coordinate;

typedef struct _Polygon {

    unsigned maxVertexes, numVertexes;
    Coordinate *vertexes;
} Polygon;

#ifdef __STDC__
EXTERN Polygon *createPolygon(void);
EXTERN void destroyPolygon(Polygon *p);
EXTERN void createVertex (Polygon *p, double x, double y);
EXTERN Boolean polygonClosed(Polygon *p, double x, double y, double d);
EXTERN Boolean isInPolygon(Polygon *p, double x, double y);
EXTERN void computePolygonCenter (Polygon *p, double *x, double *y);
EXTERN void shiftPolygon (Polygon *p, double x, double y);
#else
EXTERN Polygon *createPolygon();
EXTERN void destroyPolygon();
EXTERN void createVertex ();
EXTERN Boolean polygonClosed();
EXTERN Boolean isInPolygon();
EXTERN void computePolygonCenter ();
EXTERN void shiftPolygon ();
#endif

#endif



