/*******************************************************************************
Modul   	:	RateParObj.h

Purpose		: 	"offentliches Headerfile der Klasse RateParObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


#ifndef _ORARateParObj_h
#define _ORARateParObj_h

/*
 * RateParObj Widget public include file
 
   Class Hierarchie:
   Object -> BaseObj -> RateParObj
 */

/*
 * This include not needed unless the application includes Intrinsic.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include "BaseObj.h"

/* Resources:
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
  XtNrateParName     XtCrateParName     XtRString       NULL
  XtNrateParValue    XtCrateParValue  	XtRrateParValue NULL
 */

#define XtNrateParName  "rateParName"
#define XtCrateParName  "RateParName"
#define XtNrateParValue "rateValue"
#define XtCrateParValue "RateValue"
#define XtRrateParValue "RateValue"

#define isRateParObject(W) XtIsSubclass(W, rateParObjClass)

typedef enum {Ratevalue, Definition} rateType;

typedef struct _RateValue {
			rateType valueType;
			union {
				double value;
				String definition;
			} values;
	} RateValue;

/* public functions
extern void DrawRatePar();*/
extern String getDisplayedRateString();

/* Class record constants */
extern WidgetClass rateParObjClass;

typedef struct _RateParObjClassRec *RateParObjClass;
typedef struct _RateParObjRec      *RateParObj;

#endif /* _ORARateParObj_h */
/* DON'T ADD STUFF AFTER THIS #endif */
