/*******************************************************************************
Modul   	:	RateParObjP.h

Purpose		: 	privates Headerfile der Klasse RateParObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


/* 
 * RateParObjP.h - Private definitions for RateParObj widget

   Class Hierarchie:
   Object -> BaseObj -> RateParObj
 */

#ifndef _ORARateParObjP_h
#define _ORARateParObjP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include "BaseObjP.h"

/*
 * This one is always needed!
 */
#include "RateParObj.h"

/* New fields for the RateParObj widget class record */

typedef struct {
	int num_created;	/* number of created objects */
} RateParObjClassPart;

/* Full class record declaration */
typedef struct _RateParObjClassRec {
    ObjectClassPart	object_class;
    BaseObjClassPart	baseObj_class;
    RateParObjClassPart	rateParObj_class;
} RateParObjClassRec;

extern RateParObjClassRec rateParObjClassRec;

/* New fields for the RateParObj widget record */
typedef struct {

    /* resources */
    String ratepar_name;
    RateValue* ratepar_value;

    /* private state */
     
} RateParObjPart;

/*
 * Full instance record declaration
 */
typedef struct _RateParObjRec {
    ObjectPart		object;
    BaseObjPart		baseObj;
    RateParObjPart	rateParObj;
} RateParObjRec;

#endif /* _ORARateParObjP_h */
