/*******************************************************************************
Modul   	:	ResultObjectP.h

Purpose		: 	privates Headerfile der Klasse ResultObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


/* 
 * ResultObjectP.h - Private definitions for ResultObject widget

   Class Hierarchie:
   Object -> ResultObject
 */

#ifndef _ORAResultObjectP_h
#define _ORAResultObjectP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include <X11/ObjectP.h>

/*
 * This one is always needed!
 */
#include "ResultObject.h"

/* New fields for the ResultObject widget class record */

typedef struct {
	int object_size;	/* predefinded objectsize */
} ResultObjectClassPart;

/* Full class record declaration */
typedef struct _ResultObjectClassRec {
    ObjectClassPart	object_class;
    ResultObjectClassPart	resultObject_class;
} ResultObjectClassRec;

extern ResultObjectClassRec resultObjectClassRec;

/* New fields for the ResultObject widget record */
typedef struct {

    /* resources */
    String result_name;
    String result_definition;

    /* private state */
     
} ResultObjectPart;

/*
 * Full instance record declaration
 */
typedef struct _ResultObjectRec {
    ObjectPart		object;
    ResultObjectPart	resultObject;
} ResultObjectRec;

#endif /* _ORAResultObjectP_h */
