/*******************************************************************************
Modul   	:	TagedObj.h

Purpose		: 	"offentliches Headerfile der Klasse TagedObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


#ifndef _ORATagedObj_h
#define _ORATagedObj_h

/*
 * TagedObj Widget public include file
 
   Class Hierarchie:
   Object -> BaseObj -> TagedObj
 */

/*
 * This include not needed unless the application includes Intrinsic.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include "BaseObj.h"

/* Resources:
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
  XtNtagName	     XtCtaName	        XtRString     	NULL
  XtNtagXPos	     XtCtagXPos	        XtRInt     	DEFAULT_TAG_POSITION
  XtNtagXPos	     XtCtagXPos	        XtRInt     	DEFAULT_TAG_POSITION
 */

#define XtNtagName "tagName"
#define XtCtagName "TagName"

#define XtNtagXPos "tagXPos"
#define XtCtagXPos "TagXPos"

#define XtNtagYPos "tagYPos"
#define XtCtagYPos "TagYPos"

#define tagedClassName "TagedObj"
/* DEFAULT_TAG_POSITION will not be used in .NET-file 
   all tag-coordinates are now in relative to object-coordinates */
#define DEFAULT_TAG_POSITION -12345 
#define DEFAULT_TAG_xPOSITION 16
#define DEFAULT_TAG_yPOSITION -8

#define TAG_ONLY 01
#define TAG_NO   02

/* Class record constants */

#define isTagedObject(W) XtIsSubclass(W, tagedObjClass)

/*extern void DrawTag();*/

extern WidgetClass tagedObjClass;

typedef struct _TagedObjClassRec *TagedObjClass;
typedef struct _TagedObjRec      *TagedObj;

#endif /* _ORATagedObj_h */
/* DON'T ADD STUFF AFTER THIS #endif */
