/*******************************************************************************
Modul   	:	TagedObjP.h

Purpose		: 	privates Headerfile der Klasse TagedObjP.h

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/


/* 
 * TagedObjP.h - Private definitions for TagedObj widget

   Class Hierarchie:
   Object -> TagedObj
 */

#ifndef _ORATagedObjP_h
#define _ORATagedObjP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include "BaseObjP.h"

/*
 * This one is always needed!
 */
#include "TagedObj.h"

/* New fields for the TagedObj widget class record */

typedef struct {
	int dummy;	
} TagedObjClassPart;

/* Full class record declaration */
typedef struct _TagedObjClassRec {
    ObjectClassPart	object_class;
    BaseObjClassPart	baseObj_class;
    TagedObjClassPart	tagedObj_class;
} TagedObjClassRec;

extern TagedObjClassRec tagedObjClassRec;

/* New fields for the TagedObj widget record */

typedef struct {

    /* resources */
    String tagName;
    int tagXPos,tagYPos;

    /* private state */
     
} TagedObjPart;

/*
 * Full instance record declaration
 */
typedef struct _TagedObjRec {
    ObjectPart		object;
    BaseObjPart		baseObj;
    TagedObjPart	tagedObj;
} TagedObjRec;

#endif /* _ORATagedObjP_h */
