/*******************************************************************************
Modul   	:	TransObjP.h

Purpose		: 	privates Headerfile der Klasse TransObject

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
-------------------------------------------------
                :       Erg"anzungen f"ur zeitdiskrete Strukturen 
*******************************************************************************/


/* 
 * TransObjP.h - Private definitions for TransObj widget

   Class Hierarchie:
   Object -> BaseObj -> TagedObj ->TransObj
 */

#ifndef _ORATransObjP_h
#define _ORATransObjP_h

/*
 * This include not needed unless the .c file includes IntrinsicP.h
 * after this file.   Anyway, it doesn't hurt.
 */
#include "TagedObjP.h"

/*
 * This one is always needed!
 */
#include "TransObj.h"

/* New fields for the TransObj widget class record */

typedef struct {
	int num_created;
} TransObjClassPart;

/* Full class record declaration */
typedef struct _TransObjClassRec {
    ObjectClassPart	object_class;
    BaseObjClassPart    baseObj_class;
    TagedObjClassPart   tagedObj_class;
    TransObjClassPart	transObj_class;
} TransObjClassRec;

extern TransObjClassRec transObjClassRec;

/* New fields for the TransObj widget record */
typedef struct {

    /* resources */
    TransType transType;
    TransOrientation transOrient;
    Cardinal priority;
    EnablingDependence enablingDependence;
    int ratePos_x;
    int ratePos_y;
    Rate *rate;
    Boolean enabled;
    Connections inpConnection, outpConnection, inhibitConnection;
    Cardinal numInputs, numOutputs, numInhibits;

    void (*addConnectionMethod)();
    void (*delConnectionMethod)();
    double throughput;
    
    Boolean selected;
    Widget copy;
    
    double startPhi;
    TransOrientation startOrient;

    /* private state */

    /*new*/
    Cardinal phase;
    int group;
    double group_weight;
    RacePolicy racePolicy;
} TransObjPart;

/*
 * Full instance record declaration
 */
typedef struct _TransObjRec {
    ObjectPart		object;
    BaseObjPart 	baseObj;
    TagedObjPart 	tagedObj;
    TransObjPart	transObj;
} TransObjRec;

#endif /* _ORATransObjP_h */


