/******************************************************************************
 File:              pmfedit.h

 Project Director:  Reinhard German

 Programmer:        Ulrich Hertlein & Joerg W. Mitzlaff

 History:           Release 1:
******************************************************************************/

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

/*
 * Constants
 */
#define MIN_WIDTH   520
#define MIN_HEIGHT  290

#define WIDTH       550
#define HEIGHT      200

#define MODE_EDIT   0
#define MODE_APPLY  1

#define MODE_PMF    	0
#define MODE_PDF  	1
#define MODE_1MPDF    	2

#define PMF_BUFLEN 255
#define DF_BUFLEN 511

#define DEFAULT_PMF_FUNCTION "UNIFORM(0.0,1.0);" /* see TransObj.h */
/* Types of Transition - Delays for general Transition => see Transobj.h */
#define PMF_FUNC 3
#define DATAFILE 4

#define SEQUENCE 0
#define SEQU_REV 1
#define RAND_UNI 2

/*
 * Function prototyping
 */
extern void set_text();
extern void get_text();

extern int editCB();
extern int cancelCB();
extern int clearCB();

extern void pmfSetup();
extern void pmfEdit();
extern int doneCB();

extern void ja_func();
extern void nein_func();

extern int buffer_apply();
extern int buffer_discard();
extern int buffer_clear();
extern int buffer_evaluate();
