/******************************************************************************
 File:              graph.h

 Project Director:  Reinhard German

 Programmer:        Ulrich Hertlein & Joerg W. Mitzlaff

 History:           Release 1:
******************************************************************************/

#include "pmfParsdfunc.h"

/*
 * Constants
 */
#define NUM_STEP    500        /* how many points in virtual space */
#define NUM_STEP_NORMAL    10
 
#define CONNECT     0x01
#define INTERVAL    0x02


/*
 * Datatypes
 */
struct g_data
{
   double x;
   double y;
   char type;
   struct g_data *next;
};


/*
 * used Global variables
 */

extern func_mode;
extern struct time_l *erg;

extern double pot();


/*
 * Function prototyping
 */

extern struct g_data *graph_build();
extern struct g_data *graph_free();
