#define  __NEW_BY_JOA__  /* alles ausser: MDF <-> TN */

#include <unistd.h>
#include <stdio.h>
#include <sys/param.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <errno.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>

#include <X11/Intrinsic.h>

#include "NetWidget.h"
#include "RateParObj.h"

#include "environment.h"
#include "inputCheck.h"
#include "fgetline.h"
#include "vlstring.h"

extern char **environ;

extern Widget getCurrentNet();

#ifdef __STDC__
       int   waitForLine(int fd, char* s, int n);
extern void  WriteNet( NetWidget nw, FILE *fp );
extern char* vlstrcat( char* dest, char* src );
extern char* vlstrcpy( char* dest, char* src );
#else
       int   waitForLine();
extern void  WriteNet();
extern char* vlstrcat();
extern char* vlstrcpy();
#endif


/******************************************************************************
  int checkSyntax()   (Extern durch proc_TN Aufruf)
  
  Return : <0 => Prozess wurde unterbrochen
            0 => ok
            1 => Fehler in Preamble, das heisst in dieser Funktion
	    2 => Definitionsname ungueltig
	   >2 => Fehler in Definition auf Zeile Return-2
	  
******************************************************************************/
  
#ifdef __STDC__
int checkSyntax(void)
#else 
int checkSyntax()
#endif
{
    int status, pid;
    char *argv[4];
    char command[MAXPATHLEN];
    FILE *errfile;
    FILE *net;
    char netname[MAXPATHLEN];

    /* tmp-Namen generieren */
    strcpy( netname, tempnam( getenv("MODELDIR"), "tmp." ) );
    strcat( netname, ".TN" );

    /* tmp-File mit akt. Model schreiben */
    if( netname ) {
      net = fopen( netname, "w" );
      if( net ) {
        WriteNet( getCurrentNet(), net );
	fclose( net );
      } /* if */
    } /* if */

#ifdef DEBUG
	fprintf (stderr, "checkSyntax()\n");
#endif

    sprintf (command,"%s/Shared/bin/proc_TN", getenv(DSPNPACKAGE_ENV));
    
    argv[0] = command;
    argv[1] = "-n";
    argv[2] = netname;
    argv[3] = NULL;

    switch (pid=fork()) {
    case -1: /* error */
	perror("ERROR in vfork() ");
	return (-1);
	break;

    case 0:  /* child */	

#ifdef DEBUG
	fprintf (stderr, "checkSyntax()-Child executes: \n%s %s %s\n", 
		 argv[0], argv[1], argv[2]);
#endif

	if (execve(command,argv,environ)) {   /* und TSCHUESS */
	    fprintf(stderr, "file %s : ", argv[0]);
	    perror("ERROR in execve() ");
	    exit(-1);
	}
	break;

    default: /* parent */
	break;
    }
    
    waitpid(pid,&status,0);
    *command = 0;

    if (WIFEXITED(status)) 
	if (status = WEXITSTATUS(status)) {

#ifdef DEBUG
	    fprintf( stderr, "proc_TN exit-status is : %d\n",
		status ); 
#endif

	    switch (status) {
	    case 0:     /* successful */
		break;
	    default:     /* Zeile/Spalte, in der der Fehler aufgetreten ist */
		if( status < 0 ) {
			sprintf( command, "Error in proc_TN.\n" );
		} else {
			sprintf( command, "Syntax error before or in line %d.\n", status );
		} /* if */
		break;
	    }
	}
    else if (WIFSTOPPED(status)) {
	sprintf(command, "Syntax-check stopped by signal %d.\n", 
		status = WSTOPSIG(status));
	status *= -1;
    }
    else if (WIFSIGNALED(status)) {
	sprintf(command, "Syntax-check terminated by signal %d.\n", 
		status = WTERMSIG(status));
	status *= -1;
    }

    if( *command ) XtWarning (command);

    if( net     ) unlink( netname );

    return status;
}



#ifdef __STDC__
int waitForLine(int fd, char* s, int n)
#else
int waitForLine(fd, s, n)
    int fd;
    char *s;
    int n;
#endif
{
    int i, r;
    char c;

    for (i = 0; i < n-1; i++) {
	
	while ((r = read(fd, &c, 1))==0) ;
	
	if (r == -1) 
	{
	    perror("read on pipe from 'proc_TN' ");
	    if (errno == EWOULDBLOCK) {
		i--;
	    }
	    else 
	    {
		fprintf(stderr, "can't catch the error!");
		return -1;
	    }
	}
	else 
	{
	    if (c == '\n')
		break;
	    else
		s[i] = c;
#ifdef DEBUG
	    write (STDERR_FILENO, &c, 1);
#endif	
	}
    }
    s[i] = '\0';
    return i;
}



#ifdef __STDC__
int getRidOf (int fd, char* s)
#else
int getRidOf (fd, s)
    int fd;
    char* s;
#endif
{
    int i, w = 1, len = strlen(s);
    
    for (i = 0; i < len && w != -1; i++) {
#ifdef DEBUG
	write (STDERR_FILENO, &(s[i]), 1);
#endif
	while (!(w=write (fd, &(s[i]), 1)));
    }
    
    if (w == -1) {
	perror ("ERROR in write() ");
	return w;
    }
    else
	return 0;
}

