/*******************************************************************************
Modul   	:	infoText.c

Purpose		: 	Anzeigen der Onlinehilfe beim Erstellen von Modellen

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
*******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <X11/Intrinsic.h>     /* Intrinsics Definitions*/
#include <X11/StringDefs.h>    /* Standard Name-String definitions*/

#include <X11/Xaw/Form.h>     /* Athena Text Widget */
#include <X11/Xaw/AsciiText.h>     /* Athena Text Widget */

#include "NetWidget.h"
#include "layout.h"

#define TEXT_BUF_SIZE 400

extern Widget getCurrentNet();
extern Widget netDisplayed;
/*new*/
extern int GetTimeMode();

void replaceInfoString();
void showInfo();

static char infoStringTokenGame[] =
"Right Button: Select a transition to fire";

static char* infoStringsPrim[] = {
    /*NOCOMMAND*/
    "Select an object and a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields",
    "Select a command in the toggle fields", 
    /*ADD*/
    "Select an object in the toggle fields",
    "Left Button: Add a place",
    "Left Button: Add an immediate transition ",
    "Left Button: Add an exponential transition ",
    "Left Button: Add a deterministic transition ",
    "Left Button: Add a gen. transition ",
    "Left Button: Add an input/output arc\nMiddle Button: Add an inhibitor arc",
    "Left Button: Add a marking parameter ",
    "Left Button: Add a delay parameter ",
    "Left Button: Add a result parameter ",
    "Tags cannot be added",
    "",
    "",
    "Groups cannot be added, but changed",
    /*Delete*/
    "Select an object in the toggle fields",
    "Left Button: Delete a place",
    "Left Button: Delete a transition",
    "Left Button: Delete a transition",
    "Left Button: Delete a transition",
    "Left Button: Delete a transition",
    "Left Button: Delete the closest intermediate point of an arc\nMiddle Button: Delete the entire arc",
    "Left Button: Delete a marking parameter",
    "Left Button: Delete a delay parameter",
    "Left Button: Delete a result parameter",
    "Tags cannot be deleted",
    "",
    "",
    "Groups cannot be deleted, but changed",
    
    /*Move*/
    "Select an object in the toggle fields",
    "Left Button: Select the place to be moved",
    "Left Button: Select the transition to be moved",
    "Left Button: Select the transition to be moved",
    "Left Button: Select the transition to be moved",
    "Left Button: Select the transition to be moved",
    "Left Button: Select the intermediate point of an arc to be moved\nMiddle Button: Add an intermediate point of an arc",
    "Left Button: Select the marking parameter to be moved",
    "Left Button: Select the delay parameter to be moved / Select the transition for which the firing delay should be moved\nMiddle Button: Select the transition for which the firing delay should be adjusted",
    "Left Button: Select the result parameter to be moved ",
    "Left Button: Select the place or transition for which the tag should be moved\nMiddle Button: Select the place or transition for which the tag should be adjusted",
    "",
    "Left Button in the selection: start moving",
    "Groups cannot be moved, but changed",
    
    /*Change*/
     "Select an object in the toggle fields",
    "Places cannot be changed",
    "Left Button: Select the transition for which the type or priority should be changed\nMiddle Button: Select the transition for which the orientation should be changed",
    "Left Button: Select the transition for which the type or priority should be changed\nMiddle Button: Select the transition for which the orientation should be changed",
    "Left Button: Select the transition for which the type or priority should be changed\nMiddle Button: Select the transition for which the orientation should be changed",
    "Left Button: Select the transition for which the type or priority should be changed\nMiddle Button: Select the transition for which the orientation should be changed",
    "Left Button: Select the arc for which the type or multiplicity or mark.-dep defintion should be changed",
    "Left Button: Select the place or marking parameter which should be changed",
    "Left Button: Select the transition or delay parameter which should be changed",
    "Left Button: Select the delay parameter which should be changed",
    "Left Button: Select the place or transition for which the tag should be changed ",
    "",
    "Left Button in the selection: start rotation",
    "Left Button: Select the transition for which the group should be changed ",

#define SHOWINFO "Left Button: Select a place to show token distribution\n\
                 Select a transition or an arc to show firing delay and arc cardinality, respectively"
    
    /* Show */
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    SHOWINFO,
    "",
    "",
    SHOWINFO,

	/*SELECT*/
#define SELECT_STRING "Left Button: Define the selection area as a polygon\n"

    SELECT_STRING,"","","","","","","","","","","","",""
};

String infoStringsSec[] = {
	/*NOOPERATION*/
	"","","","","","","","","","","","","","",
	/*ADD*/
	"","","","","","",
	"Left Button: Select endpoint / Insert new intermediate point\n\
Right Button: Cancel adding new arc\n",
	"","","","","","","",
	/*Delete*/
	"","","","","","","","","","","","","","",
	/*Move*/
	"",
	" Left Button: Define new location of the place",
	" Left Button: Define new location of the transition",
	" Left Button: Define new location of the transition",
	" Left Button: Define new location of the transition",
	" Left Button: Define new location of the transition",
	" Left Button: Define new location of the intermediate point",
	" Left Button: Define new location of the markingparamter",
	" Left Button: Define new location of the rateparameter \
or the firing delay of the transition ",
	"",
	" Left Button: Define new location of the tag",
	"","Left Button: Drop the selection\n","",
	/*Change*/
	"","","","","","","","","","","","","Left Button: Drop the selection\n","",
	/*Show*/
	"","","","","","","","","","","","","","",
	/*Select*/
	"","","","","","","","","","","",
	"Ctrl + Middle Button: set vertex point of the selection\n\
Ctrl + Right Button: close the selection",
	"",""
	};


static char textBuf[TEXT_BUF_SIZE];

Widget infoText;

/*******************************************************************************
Name:
       initInfoField
--------------------------------------------------------------------------------
Funktionstyp:
        oeffentliche funktion
--------------------------------------------------------------------------------
gebraucht in:
        main.c
--------------------------------------------------------------------------------
Parameter:
        parent: Elterwidget
--------------------------------------------------------------------------------
Zweck:
       Initialisierung des Textwidgets
*******************************************************************************/

void initInfoField(manage_it,parent)
int manage_it;
Widget parent;

{
  Dimension height;

  infoText = XtVaCreateWidget(
		"infoText",
		asciiTextWidgetClass,
		parent,
		XtNwidth,APPLICATION_WIDTH,
		XtNdisplayCaret,False,
		XtNeditType,XawtextRead,
		XtNlength,TEXT_BUF_SIZE,
		XtNstring,textBuf,
		XtNfromVert,INFOTEXT_FROM_VERT,
		XtNright,XawChainRight,
		XtNleft,XawChainLeft,
		XtNtop,XawChainTop,
		XtNbottom,XawChainTop,
		NULL);

  XtVaGetValues(infoText,
		XtNheight,&height,
		NULL);
  XtVaSetValues(infoText,
		XtNheight,3*height,
		NULL);

  if(manage_it) XtManageChild(infoText);
}

/*******************************************************************************
Name:
      showInfo  
--------------------------------------------------------------------------------
Funktionstyp:
        Callback
--------------------------------------------------------------------------------
Registriert mit:
        XtNinfoCallback der Klasse Netwidget
--------------------------------------------------------------------------------
Parameter:
       call_data: PRIMARY_ACTION oder SECONDARY_ACTION
                  welches infoString-Feld zu benutzen ist
--------------------------------------------------------------------------------
Zweck:
       Ausgabe des Infostrings
*******************************************************************************/
/* ARGSUSED */

void showInfo(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XawTextBlock textblock;
  Commands command;
  Objects object;
  char text[1024];
  Boolean tokenGame;

#ifdef debug
  printf("showInfo \n");
#endif
  XtVaGetValues(w,
		XtNCommands,&command,
		XtNObjects,&object,
		XtNtokenGame, &tokenGame,
		NULL);
  
  if (call_data==(XtPointer)SECONDARY_ACTION) {
      textblock.firstPos = 0;
      textblock.length = strlen(infoStringsSec[command*NUMOBJECTS+object]);
	
      textblock.ptr = infoStringsSec[command*NUMOBJECTS+object];
  }
  else {
    if (tokenGame && command!=NOOPERATION) {
      sprintf(text,"%s\n%s",
	      infoStringsPrim[command*NUMOBJECTS+object],
	      infoStringTokenGame);
      textblock.firstPos = 0;
      textblock.length = strlen(text);
      textblock.ptr = text;
    }
    else if (tokenGame) {
      textblock.firstPos = 0;
      textblock.length = strlen(infoStringTokenGame);
      textblock.ptr = infoStringTokenGame; 
    } 
    else if (GetTimeMode() && command == CHANGE && object == RATEPAR) { 
      /*new*/
      sprintf(text,"%s\n",
	      "Left Button: Select the transition or delay parameter for which delay,phase or group weight should be changed");
      textblock.firstPos = 0;
      textblock.length = strlen(text);
      textblock.ptr = text;
    }
    else if (GetTimeMode() && command == SHOW) { 
      /*new*/
      sprintf(text,"%s\n","Left Button: Select a place to show token distribution\n\
                 Select a transition or an arc to show firing delay/phase/group and arc cardinality, respectively");
      textblock.firstPos = 0;
      textblock.length = strlen(text);
      textblock.ptr = text;
    }    
    else if (GetTimeMode() && command == ADD && object == EXPTRANS) { 
      /*new*/
      sprintf(text,"%s\n","Left Button: Add a geometric transition ");
      textblock.firstPos = 0;
      textblock.length = strlen(text);
      textblock.ptr = text;
    }
    else
    {
      textblock.firstPos = 0;
	   textblock.length = strlen(infoStringsPrim[command*NUMOBJECTS+object]);
	   textblock.ptr = infoStringsPrim[command*NUMOBJECTS+object];
    }
  }
  XtVaSetValues(infoText,
		XtNeditType,XawtextEdit,
		NULL);
  if(XawTextReplace(infoText,0,TEXT_BUF_SIZE,&textblock)!=XawEditDone)
	    XtWarning("infoText Textedit: unable to show info");
  XtVaSetValues(infoText,
		XtNeditType,XawtextRead,
		NULL);
}

/*******************************************************************************
Name:
        replaceInfoString
--------------------------------------------------------------------------------
Funktionstyp:
        oeffentliche Funktion
--------------------------------------------------------------------------------
gebraucht in:
        commandToggles.c, objectToggles.c, manageNets.c, evalMenu.c
--------------------------------------------------------------------------------
Zweck:
        ruft mittels Parameterexpandierung direkt showInfo auf
*******************************************************************************/

void replaceInfoString()

{
    showInfo(getCurrentNet(),NULL,PRIMARY_ACTION);
}
