/*******************************************************************************
Modul   	:	inputCheck.c

Project Director:	Christoph Lindemann TU Berlin

Programmer	:	Martin M"uller

History		:	release 1: October 1992
                Entbugt July 26 1993  Kolja Koischwitz

*******************************************************************************/
#include <stdio.h>
#include <ctype.h>

#include <X11/Intrinsic.h>     /* Intrinsics Definitions*/
#include <X11/StringDefs.h>    /* Standard Name-String definitions*/

#include "inputCheck.h"

static Boolean IsIdentifier();

/*******************************************************************************
Name:
        isOfType
--------------------------------------------------------------------------------
Funktionstyp:
        "offentliche Funktion
--------------------------------------------------------------------------------
Parameter:
        string: zu analysierender String
	type:   Typangabe
--------------------------------------------------------------------------------
Rueckgabewert:
        True, falls string angegebenen Typ repr"asentiert, False sonst
--------------------------------------------------------------------------------
Zweck:
        Analysiert, ob  string angegebenen Typ repr"asentiert
*******************************************************************************/
Boolean isOfType(string,type)
String string;
int type;
{
int ret,bool;
String t_buf = (String)XtCalloc(strlen(string)+1,sizeof(char));
String s_buf = (String)XtCalloc(strlen(string)+1,sizeof(char));
double d_buf;
unsigned u_buf;

switch (type) 
  {
  case FLOAT:
    ret = sscanf(string,"%lg%s",&d_buf,t_buf);
    bool = (ret == 1 && d_buf > 0.0); break;
  case MARKING:
    ret = sscanf(string,"%u%s",&u_buf,t_buf);
    bool = (ret == 1 && u_buf < 10000); break;
  case MULTIPLICITY:
    ret = sscanf(string,"%u%s",&u_buf,t_buf);
    bool = (ret == 1 && u_buf > 0 && u_buf < 10000); break;
  case INTEGER:
    ret = sscanf(string,"%u%s",&u_buf,t_buf);
    bool = (ret == 1 && u_buf < 65355); break;
  case IDENTIFIER:
    ret = sscanf(string,"%s%s",s_buf,t_buf);
    bool = (ret == 1 && IsIdentifier(s_buf) == True); break;
  case PRIORITY:
    ret = sscanf(string,"%u%s",&u_buf,t_buf);
    bool = (ret == 1 && u_buf > 0 && u_buf <= 127); break;
  case NOINPUT:
    ret = sscanf(string,"%s",t_buf);
    bool = (ret <= 0); break;
    /*new*/
  case CARDINAL:
    ret = sscanf(string,"%u%s",&u_buf,t_buf);
    bool = (ret == 1 && u_buf > 0 && u_buf < 65355); break;
  default:
     bool=0;
  }
  XtFree(t_buf); XtFree(s_buf); return(bool?True:False);
}


/*******************************************************************************
Name:
        IsIdentifier
--------------------------------------------------------------------------------
Funktionstyp:
        private Funktion
--------------------------------------------------------------------------------
Parameter:
        String: zu analysierender String
--------------------------------------------------------------------------------
Rueckgabewert:
        True, falls identifier, False sonst
--------------------------------------------------------------------------------
Zweck:
        Analysiert, ob Identifier vroliegt
*******************************************************************************/
static Boolean IsIdentifier(string)
String string;
{

if (string == NULL || !isalpha(*string++))
  return False;

while(isalnum((int)*string) || *string=='_') string++;
return(*string==0?True:False);
}



/*******************************************************************************
Name:
       getWord 
--------------------------------------------------------------------------------
Funktionstyp:
        "offentliche Funktion
--------------------------------------------------------------------------------
Parameter:
        String: zu analysierender String
--------------------------------------------------------------------------------
Rueckgabewert:
        das erste Wort aus string
--------------------------------------------------------------------------------
Zweck:
        isolisiert aus string das erste Wort
*******************************************************************************/
String getWord(string)
String string;
{
  String word = XtCalloc((strlen(string)+1),sizeof(char));

  if (word && string)
    {
      sscanf(string,"%s",word);
      return word;
    }
  else 
    return NULL;
}
