
# line 2 "MSAnalysis/evaluater/evaluate_parser.y"
extern "C" {
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
}
#include "inc_classes.h" 
#include "inc_lex_yacc_globals.h" 

/*------------------------------------------------------*/
/*			fehler				*/
/*------------------------------------------------------*/
void 	yyerror		(char*);
void	SetError	(int);

/*------------------------------------------------------*/
/*		string/path-handling			*/
/*------------------------------------------------------*/
char* 	StripOfPath	(char*);
char* 	GetNumberString	(int);
int 	GetNumberSize	(int);

/*------------------------------------------------------*/
/*			create				*/
/*------------------------------------------------------*/
int 	MakeActPageName	(char*);
void	MakeEvalCell	(Cell*);

/*------------------------------------------------------*/
/*			save				*/
/*------------------------------------------------------*/
int	SaveToken	(char*, char*, char*); 
int 	SaveDefinition	(Definition*);



# line 38 "MSAnalysis/evaluater/evaluate_parser.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{	
	//-----------------------------------------------
	//	"elementare" typen
	//-----------------------------------------------
	double  		d_val;
	int     		i_val;
	char*   		s_val;
	Operator		_Operator;
	//-----------------------------------------------
	//	"elmentare" Klassen
	//-----------------------------------------------
	Identifier*		_IdentifierPtr;
	Cell*			_CellPtr;
	//-----------------------------------------------
	// 	Definitions Klassen
	//-----------------------------------------------
	Definition*		_DefinitionPtr;
	DefinitionList*		_DefinitionListPtr;
} YYSTYPE;
# define DEFINITION 257
# define PAGE 258
# define EVALUATE 259
# define COMMA 260
# define POINT 261
# define DOUBLEPOINT 262
# define QUESTIONMARK 263
# define OPEN_I 264
# define OPEN_II 265
# define OPEN_III 266
# define CLOSE_I 267
# define CLOSE_II 268
# define CLOSE_III 269
# define PLUS 270
# define MINUS 271
# define DIVIDE 272
# define MULTIPLY 273
# define TIMES 274
# define NOT 275
# define AND 276
# define OR 277
# define WAHR 278
# define FALSCH 279
# define EQUAL 280
# define LESS 281
# define GREATER 282
# define NOT_EQUAL 283
# define LESS_OR_EQUAL 284
# define GREATER_OR_EQUAL 285
# define E 286
# define E_MSET 287
# define P_MSET 288
# define INT_CONST 289
# define REAL_CONST 290
# define NUMERIC 291
# define LOGIC 292
# define STRING 293
# define ERROR 294

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 310 "MSAnalysis/evaluater/evaluate_parser.y"

#include "evaluate_scanner.cc"

/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*		 pfad vom gesuchten String abtrennen und string zurueckgeben					    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
char* StripOfPath(char* s)
{
	int   count = 0;
	int c_count = 0;
	char* h;

	for (h = s; *h != '\0'; h++)
		if ( *h == '\\' ) count++;

	for (h = s; count; h++,c_count++)
		if ( *h == '\\' ) count--;

	char* h1 = new char[strlen(s)-c_count+1];
	char* h2 = h1;

	for (; *h != '\0'; h++, h1++)
		*h1 = *h;
	*h1 = '\0';
	return h2;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*			int in char* umwandeln									    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
char* GetNumberString(int number)
{
	int   number_size = GetNumberSize(number);
	int   rest 	  = 0;
	char* c1   	  = new char[number_size+2](NULL);

	*c1++ = '\0';
	while (number/10 >= 1.0)
	{
		rest   = number % 10;
		number = number / 10 - rest / 10;
		*c1++  = char(rest+48);
	}
	*c1++ = char(number+48);
	*c1   ='\0';

	char* c2 = new char[sizeof(c1)+1](NULL);
	char* c3 = c2;

	for (c1--; *c1 != '\0';) *c2++ = *c1--;
	*c2 = '\0';
	return c3;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*			groesse eines int ermitteln 								    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
int GetNumberSize(int number) 
{
        int number_size=0;
	for (number_size = 0; number/10 >= 1.0; number = number/10 - (number%10)/10, number_size++);
	return number_size;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*			zu evaluierende Celle kreieren								    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
void	MakeEvalCell(Cell* eval_cell)
{
	if (eval_cell)  EvalCell = eval_cell->Copy();
	else		EvalCell = new ConstVal();
}
/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*			Seitennamen erstellen	 								    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
int	MakeActPageName(char* str)
{
	if (!str) return (PAGE_NAME_ERR);

	sprintf(actual_page = new char[(strlen(str) + 1)], str); 
	return 0; 
}
/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*			Definition in DefinitionRefList speichern 						    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
int	SaveDefinition(Definition* def)
{
        if ( DefinitionRefList.UniqueNameAppend(*def) < 0 )
		return (DEF_EXISTS_ERR);
	return 0;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*			- Token kreieren									    */
/*			- Token in TokenRefList speichern							    */
/*			- Referenz zureuckgeben									    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
int	SaveToken(char* name, char* version, char* step) 
{ 
	Token    tok(name, version, step);
	int tr = TokenRefList.UniqueAppend(tok);
	if (tr < 0) tr = -tr;
	if (tr > MAX_TREF) yyerror("too much tokens defined (max = 65536)");
	return TokenRef(tr);
}
/*------------------------------------------------------------------------------------------------------------------*/
/*														    */
/*			fehlerausgabe										    */
/*														    */
/*------------------------------------------------------------------------------------------------------------------*/
void	SetError(int err_no)
{
	if (err_set) return;
	ErrNo   = err_no;
	err_set = true;
}
/*------------------------------------------------------------------------------------------------------------------*/
void 	yyerror(char*)
{
	SetError(SYNTAX_ERR);
	return;
}
/*------------------------------------------------------------------------------------------------------------------*/
static const yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 78
# define YYLAST 308
static const yytabelem yyact[]={

    26,    45,    44,    49,    90,   115,   119,    27,    49,    92,
    49,    34,    49,   110,    32,    33,    93,     9,    17,   115,
    15,   118,    45,    41,    38,    35,    36,    23,    31,    49,
    26,    14,    44,   134,    94,    36,    23,    27,    66,   111,
    26,    34,    44,   109,    32,    33,   119,    27,    89,   132,
    49,    78,    45,    41,    38,    35,    36,    23,    31,    22,
    54,   125,    45,    41,    38,    35,    36,    23,   141,    49,
    45,    87,    84,    90,   140,   122,   139,    49,    52,    53,
    54,    51,   108,   125,    45,    64,   107,   123,    55,    56,
    57,    58,    59,    60,    62,    63,    64,    45,    66,    65,
   123,    62,    63,    64,    55,    56,    57,    58,    59,    60,
   138,    54,    51,    52,    53,    54,   125,   137,    16,   130,
    52,    53,    54,   125,   113,    13,   129,    52,    53,    54,
   125,   135,    10,   128,    52,    53,    54,   125,   113,    12,
     6,    52,    53,    54,    51,    52,    53,    54,    51,    52,
    53,    54,   125,   112,    82,    80,    62,    63,    64,     4,
    40,    76,    43,    81,    79,    70,    37,    68,    83,    69,
    86,     8,    50,     1,    11,    77,     5,    19,    46,     2,
     3,     7,    67,    39,    42,    28,    18,    29,    72,    74,
    30,    20,    47,    61,    25,    24,     0,     0,     0,     0,
    21,     0,    71,    73,     0,    88,     0,     0,     0,     0,
     0,    85,    91,    96,    97,    98,    99,    48,     0,     0,
    61,     0,     0,   101,   101,   101,   104,    95,     0,     0,
     0,     0,     0,     0,     0,    75,     0,   100,   102,   103,
     0,   114,     0,   121,     0,     0,     0,   117,     0,   116,
    61,   124,     0,   120,   126,   127,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   105,   106,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   131,     0,     0,     0,   133,     0,     0,   136,     0,     0,
     0,     0,     0,     0,     0,   114,     0,     0,     0,     0,
   143,     0,   143,     0,     0,     0,   142,   142 };
static const yytabelem yypact[]={

   -98,-10000000,  -118,  -276,  -130,  -120,  -137,  -246,-10000000,  -260,
-10000000,-10000000,  -144,  -275,  -276,  -234,  -264,-10000000,-10000000,  -192,
  -176,  -238,   -96,-10000000,-10000000,-10000000,  -224,  -224,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -264,  -223,-10000000,-10000000,-10000000,  -105,
-10000000,-10000000,  -106,-10000000,  -216,-10000000,  -192,  -176,  -178,   -96,
  -255,  -224,  -255,  -255,  -255,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,  -224,  -224,  -224,  -255,  -264,  -264,  -207,-10000000,  -250,
-10000000,  -114,  -129,  -187,  -161,-10000000,  -192,  -176,  -281,-10000000,
  -243,-10000000,  -189,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -255,
  -223,  -121,  -255,  -255,-10000000,-10000000,-10000000,  -212,  -212,-10000000,
  -169,  -125,  -187,  -187,  -190,-10000000,-10000000,-10000000,-10000000,  -135,
  -142,  -149,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -255,  -225,
-10000000,-10000000,  -255,  -241,  -136,  -255,  -143,  -212,-10000000,-10000000,
-10000000,  -150,  -290,  -157,  -267,  -197,-10000000,  -199,  -205,  -285,
  -283,  -202,-10000000,-10000000 };
static const yytabelem yypgo[]={

     0,   195,   194,   161,   172,   190,   200,   175,   187,   185,
   184,   183,   170,   168,   160,   166,   162,   182,   171,   181,
   180,   179,   176,   174,   173 };
static const yytabelem yyr1[]={

     0,    24,    21,    21,    19,    19,    18,    18,    18,    18,
    20,    22,    23,    23,    23,     6,     6,     6,     6,     6,
     6,     6,     5,     5,     4,     4,     4,     4,     4,     4,
     7,     7,     7,     7,     7,     7,     7,     7,     9,     9,
     9,     8,     8,     8,    11,    11,    11,    11,    11,    10,
    10,    10,    10,    10,    13,    12,    15,    15,    14,    14,
    16,    16,    16,    17,    17,    17,    17,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     2,     1 };
static const yytabelem yyr2[]={

     0,     7,     3,     5,     3,     7,     7,     7,     7,     7,
     5,     7,     7,     7,     7,     3,     3,     3,     3,     5,
     7,     7,     7,     7,     3,     3,     3,     3,     3,     3,
     3,     3,     7,     5,     7,     7,     7,     7,     3,     3,
     5,     3,     3,     5,     5,     5,     5,     7,     7,     5,
     5,     5,     7,     7,    11,    11,     3,     7,     3,     7,
     7,     7,     5,     7,     7,     7,     3,     3,     3,     3,
     7,     5,     7,     7,     7,     7,     3,     3 };
static const yytabelem yychk[]={

-10000000,   -24,   -21,   -20,   257,   -22,   258,   -19,   -18,   293,
   262,   -23,   259,   262,   277,   280,   262,   293,   -18,    -3,
    -7,    -6,   293,   291,    -1,    -2,   264,   271,    -9,    -8,
    -5,   292,   278,   279,   275,   289,   290,   -15,   288,   -11,
   -14,   287,   -10,   -16,   266,   286,    -3,    -7,    -6,   293,
    -4,   273,   270,   271,   272,   280,   281,   282,   283,   284,
   285,    -4,   270,   271,   272,   277,   276,   -17,   263,   265,
   261,    -7,    -3,    -7,    -3,    -6,    -3,    -7,   274,   269,
   260,   269,   260,   -13,   288,   -15,   -12,   287,   -14,   264,
   289,    -3,   264,   271,   289,    -7,    -3,    -3,    -3,    -3,
    -7,    -3,    -7,    -7,    -3,    -6,    -6,   293,   289,   293,
   263,   289,   267,   267,   -16,   286,   -13,   -15,   264,   289,
   -12,   -14,   264,   289,    -3,   273,    -3,    -3,   268,   268,
   268,    -3,   274,    -3,   274,   267,    -3,   267,   267,   273,
   273,   273,   -15,   -14 };
static const yytabelem yydef[]={

     0,    -2,     0,     2,     0,     0,     0,     3,     4,     0,
    10,     1,     0,     0,     0,     0,     0,    11,     5,     6,
     7,     8,     9,    67,    68,    69,     0,     0,    30,    31,
    15,    16,    17,    18,     0,    77,    76,    38,    39,     0,
    41,    42,     0,    56,     0,    58,    12,    13,    14,     0,
     0,     0,     0,     0,     0,    24,    25,    26,    27,    28,
    29,     0,     0,     0,     0,     0,     0,     0,    62,     0,
    66,     0,     0,    33,    71,    19,     0,     0,     0,    40,
     0,    43,     0,    44,    45,    46,    49,    50,    51,     0,
     0,    22,     0,     0,    77,    37,    75,    72,    73,    74,
    23,     0,    34,    35,    36,    20,    21,    60,    61,     0,
     0,     0,    32,    70,    57,    59,    47,    48,     0,     0,
    52,    53,     0,     0,     0,     0,     0,    71,    63,    64,
    65,     0,     0,     0,     0,     0,    75,     0,     0,     0,
     0,     0,    54,    55 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"DEFINITION",	257,
	"PAGE",	258,
	"EVALUATE",	259,
	"COMMA",	260,
	"POINT",	261,
	"DOUBLEPOINT",	262,
	"QUESTIONMARK",	263,
	"OPEN_I",	264,
	"OPEN_II",	265,
	"OPEN_III",	266,
	"CLOSE_I",	267,
	"CLOSE_II",	268,
	"CLOSE_III",	269,
	"PLUS",	270,
	"MINUS",	271,
	"DIVIDE",	272,
	"MULTIPLY",	273,
	"TIMES",	274,
	"NOT",	275,
	"AND",	276,
	"OR",	277,
	"WAHR",	278,
	"FALSCH",	279,
	"EQUAL",	280,
	"LESS",	281,
	"GREATER",	282,
	"NOT_EQUAL",	283,
	"LESS_OR_EQUAL",	284,
	"GREATER_OR_EQUAL",	285,
	"E",	286,
	"E_MSET",	287,
	"P_MSET",	288,
	"INT_CONST",	289,
	"REAL_CONST",	290,
	"NUMERIC",	291,
	"LOGIC",	292,
	"STRING",	293,
	"ERROR",	294,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"eval_entry : all_definitions page evaluate",
	"all_definitions : definition_def",
	"all_definitions : definition_def definitions",
	"definitions : definition",
	"definitions : definitions OR definition",
	"definition : STRING EQUAL real_expr",
	"definition : STRING EQUAL multiset_expr",
	"definition : STRING EQUAL logic_condition",
	"definition : STRING EQUAL STRING",
	"definition_def : DEFINITION DOUBLEPOINT",
	"page : PAGE DOUBLEPOINT STRING",
	"evaluate : EVALUATE DOUBLEPOINT real_expr",
	"evaluate : EVALUATE DOUBLEPOINT multiset_expr",
	"evaluate : EVALUATE DOUBLEPOINT logic_condition",
	"logic_condition : comparison",
	"logic_condition : LOGIC",
	"logic_condition : WAHR",
	"logic_condition : FALSCH",
	"logic_condition : NOT logic_condition",
	"logic_condition : logic_condition OR logic_condition",
	"logic_condition : logic_condition AND logic_condition",
	"comparison : real_expr comp_op real_expr",
	"comparison : multiset_expr comp_op multiset_expr",
	"comp_op : EQUAL",
	"comp_op : LESS",
	"comp_op : GREATER",
	"comp_op : NOT_EQUAL",
	"comp_op : LESS_OR_EQUAL",
	"comp_op : GREATER_OR_EQUAL",
	"multiset_expr : p_mset",
	"multiset_expr : e_mset",
	"multiset_expr : OPEN_I multiset_expr CLOSE_I",
	"multiset_expr : MINUS multiset_expr",
	"multiset_expr : multiset_expr PLUS multiset_expr",
	"multiset_expr : multiset_expr MINUS multiset_expr",
	"multiset_expr : multiset_expr DIVIDE real_expr",
	"multiset_expr : real_expr MULTIPLY multiset_expr",
	"p_mset : p_mset_const",
	"p_mset : P_MSET",
	"p_mset : p_mset_1 CLOSE_III",
	"e_mset : e_mset_const",
	"e_mset : E_MSET",
	"e_mset : e_mset_1 CLOSE_III",
	"p_mset_1 : OPEN_III p_mset_0",
	"p_mset_1 : OPEN_III P_MSET",
	"p_mset_1 : OPEN_III p_mset_const",
	"p_mset_1 : p_mset_1 COMMA p_mset_0",
	"p_mset_1 : p_mset_1 COMMA p_mset_const",
	"e_mset_1 : OPEN_III e_mset_0",
	"e_mset_1 : OPEN_III E_MSET",
	"e_mset_1 : OPEN_III e_mset_const",
	"e_mset_1 : e_mset_1 COMMA e_mset_0",
	"e_mset_1 : e_mset_1 COMMA e_mset_const",
	"p_mset_0 : OPEN_I real_expr CLOSE_I MULTIPLY p_mset_const",
	"e_mset_0 : OPEN_I real_expr CLOSE_I MULTIPLY e_mset_const",
	"p_mset_const : unit",
	"p_mset_const : INT_CONST TIMES unit",
	"e_mset_const : E",
	"e_mset_const : INT_CONST TIMES E",
	"unit : STRING part_version STRING",
	"unit : STRING part_version INT_CONST",
	"unit : STRING QUESTIONMARK",
	"part_version : OPEN_II STRING CLOSE_II",
	"part_version : OPEN_II QUESTIONMARK CLOSE_II",
	"part_version : OPEN_II INT_CONST CLOSE_II",
	"part_version : POINT",
	"real_expr : NUMERIC",
	"real_expr : int_const",
	"real_expr : real_const",
	"real_expr : OPEN_I real_expr CLOSE_I",
	"real_expr : MINUS real_expr",
	"real_expr : real_expr PLUS real_expr",
	"real_expr : real_expr MINUS real_expr",
	"real_expr : real_expr DIVIDE real_expr",
	"real_expr : real_expr MULTIPLY real_expr",
	"real_const : REAL_CONST",
	"int_const : INT_CONST",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.14	97/01/16 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register const int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 157 "MSAnalysis/evaluater/evaluate_parser.y"
{ ; 				    } break;
case 2:
# line 162 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.i_val = 0;			    } break;
case 3:
# line 163 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.i_val = 0; 	    		    } break;
case 4:
# line 166 "MSAnalysis/evaluater/evaluate_parser.y"
{ 
				if (SaveDefinition(yypvt[-0]._DefinitionPtr))
				{
					SetError(DEF_EXISTS_ERR);
					return  (DEF_EXISTS_ERR);
				}
				yyval.i_val = 0;
			} break;
case 5:
# line 175 "MSAnalysis/evaluater/evaluate_parser.y"
{ 
				if (SaveDefinition(yypvt[-0]._DefinitionPtr))
				{
					SetError(DEF_EXISTS_ERR);
					return  (DEF_EXISTS_ERR);
				}
				yyval.i_val = 0;
			} break;
case 6:
# line 184 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._DefinitionPtr = new Definition(yypvt[-2].s_val, yypvt[-0]._CellPtr);      } break;
case 7:
# line 185 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._DefinitionPtr = new Definition(yypvt[-2].s_val, yypvt[-0]._CellPtr);      } break;
case 8:
# line 186 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._DefinitionPtr = new Definition(yypvt[-2].s_val, yypvt[-0]._CellPtr);      } break;
case 9:
# line 188 "MSAnalysis/evaluater/evaluate_parser.y"
{
				if (!strcmp(yypvt[-2].s_val,yypvt[-0].s_val)) 
				{
					SetError(DEF_LOOP);
					return  (DEF_LOOP);
				}
				yyval._DefinitionPtr = new Definition(yypvt[-2].s_val,new ConstVal(yypvt[-0].s_val)); 
			} break;
case 10:
# line 197 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.i_val = 0;                           } break;
case 11:
# line 203 "MSAnalysis/evaluater/evaluate_parser.y"
{ 
				if (MakeActPageName(yypvt[-0].s_val))  
				{
					SetError(PAGE_NAME_ERR);
					return  (PAGE_NAME_ERR);	
				}
				yyval.i_val = 0;
			} break;
case 12:
# line 215 "MSAnalysis/evaluater/evaluate_parser.y"
{ MakeEvalCell(yypvt[-0]._CellPtr);	yyval.i_val = 0;	    } break;
case 13:
# line 216 "MSAnalysis/evaluater/evaluate_parser.y"
{ MakeEvalCell(yypvt[-0]._CellPtr);     yyval.i_val = 0;     } break;
case 14:
# line 217 "MSAnalysis/evaluater/evaluate_parser.y"
{ MakeEvalCell(yypvt[-0]._CellPtr);     yyval.i_val = 0;     } break;
case 15:
# line 222 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 16:
# line 223 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;			    } break;
case 17:
# line 224 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(true);  	    } break;
case 18:
# line 225 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(false); 	    } break;
case 19:
# line 226 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new UnaerOp(logic_not,yypvt[-0]._CellPtr);   } break;
case 20:
# line 227 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(logic_or,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);} break;
case 21:
# line 228 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(logic_and,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);} break;
case 22:
# line 230 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(yypvt[-1]._Operator,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);	    } break;
case 23:
# line 231 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(yypvt[-1]._Operator,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);	    } break;
case 24:
# line 233 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._Operator = equal; 		            } break;
case 25:
# line 234 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._Operator = less;  	 	            } break;
case 26:
# line 235 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._Operator = greater; 	            } break;
case 27:
# line 236 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._Operator = not_equal;	            } break;
case 28:
# line 237 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._Operator = less_or_equal; 	            } break;
case 29:
# line 238 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._Operator = greater_or_equal;    	    } break;
case 30:
# line 243 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 31:
# line 244 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 32:
# line 245 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr;                          } break;
case 33:
# line 246 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new UnaerOp (minus,   yypvt[-0]._CellPtr);   } break;
case 34:
# line 247 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(plus,    yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);} break;
case 35:
# line 248 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(minus,   yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);} break;
case 36:
# line 249 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(divide,  yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);} break;
case 37:
# line 250 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(multiply,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);} break;
case 38:
# line 252 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 39:
# line 253 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 40:
# line 254 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr;                          } break;
case 41:
# line 256 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 42:
# line 257 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 43:
# line 258 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr;                          } break;
case 44:
# line 260 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 45:
# line 261 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 46:
# line 262 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 47:
# line 263 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  } break;
case 48:
# line 264 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  } break;
case 49:
# line 266 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 50:
# line 267 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 51:
# line 268 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 52:
# line 269 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  } break;
case 53:
# line 270 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  } break;
case 54:
# line 272 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(multiply,yypvt[-3]._CellPtr,yypvt[-0]._CellPtr);} break;
case 55:
# line 273 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(multiply,yypvt[-3]._CellPtr,yypvt[-0]._CellPtr);} break;
case 56:
# line 275 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(new TokenMSVal(yypvt[-0].i_val, 1));      } break;
case 57:
# line 276 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(new TokenMSVal(yypvt[-0].i_val,yypvt[-2].i_val));      } break;
case 58:
# line 278 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(new TokenMSVal(NO_COLOR, 1));} break;
case 59:
# line 279 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(new TokenMSVal(NO_COLOR,yypvt[-2].i_val));} break;
case 60:
# line 284 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.i_val=SaveToken(StripOfPath(yypvt[-2].s_val),yypvt[-1].s_val,StripOfPath(yypvt[-0].s_val));     } break;
case 61:
# line 285 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.i_val=SaveToken(StripOfPath(yypvt[-2].s_val),yypvt[-1].s_val,GetNumberString(yypvt[-0].i_val)); } break;
case 62:
# line 286 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.i_val=SaveToken(StripOfPath(yypvt[-1].s_val),WILDCARD, WILDCARD);     } break;
case 63:
# line 288 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.s_val = StripOfPath(yypvt[-1].s_val);    	    } break;
case 64:
# line 289 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.s_val = WILDCARD;           	    } break;
case 65:
# line 290 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.s_val = GetNumberString(yypvt[-1].i_val);	    } break;
case 66:
# line 291 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval.s_val = STDVERSION;         	    } break;
case 67:
# line 296 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 68:
# line 297 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 69:
# line 298 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;                          } break;
case 70:
# line 299 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr;                          } break;
case 71:
# line 300 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new UnaerOp(minus,yypvt[-0]._CellPtr);       } break;
case 72:
# line 301 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(plus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);    } break;
case 73:
# line 302 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(minus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);   } break;
case 74:
# line 303 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(divide,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);  } break;
case 75:
# line 304 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new BinaerOp(multiply,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);} break;
case 76:
# line 306 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(yypvt[-0].d_val);            } break;
case 77:
# line 307 "MSAnalysis/evaluater/evaluate_parser.y"
{ yyval._CellPtr = new ConstVal(yypvt[-0].i_val);            } break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

