#ifndef __EVALUATER_CC__
#define __EVALUATER_CC__

extern "C" {
#include <string.h>
}
#include "inc_classes.h"

extern int yyparse();	
extern TokenList TokenRefList;
extern DefinitionList DefinitionRefList;

int	ErrNo;
Cell*	EvalCell;
char*	evaluation_string;


double evaluater(char* str)
{
	if (!str) { ErrNo = -1; return (0.0); }

  TokenRefList.Clear();
  DefinitionRefList.Clear();
  ErrNo = 0;
  EvalCell = 0;
  evaluation_string = str;

  yyparse();

	if (!EvalCell) { if (!ErrNo) ErrNo = -2; return 0; }
  if (EvalCell->GetResultType()!=numeric
      && EvalCell->GetResultType()!=logic_expr) { ErrNo = -3; return 0; }  
	return (EvalCell->Calculate()->GetFloat());
  
}	/* End of evaluater */


#endif
