# include "stdio.h"
# define U(x) ((x)&0377)
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern unsigned char yytext[];
int yymorfg;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;

#ifdef YY_INPUT
#undef YY_INPUT
#endif
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
	{ \
		int c = '*', n; \
		for ( n = 0; (n < max_size) && ((c = *evaluation_string++) != EOF) && (c != '\n'); ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		result = n; \
	} 


/*------------------------------------------------------*/
/*		path-get-and-add			*/
/*------------------------------------------------------*/
char*	GetPath			(char*);
char*	AddRoot			(char*);
char*	AddActDefPath		(char*);
char*	AddActPagePath		(char*);
/*------------------------------------------------------*/
/*		return-functions			*/
/*------------------------------------------------------*/
int	ReturnString		(char*);
int	ReturnDefString		(char*);
int     ReturnCellContents	(Cell*);
/*------------------------------------------------------*/
/*		definition-tests			*/
/*------------------------------------------------------*/
int	DefinitionOrString	(char*);
Cell*   TestIfDefinition	(char*, TextualList*);
bool    DefinitionLoop		(char*, Textual);
/*------------------------------------------------------*/
/*		copy-functions				*/
/*------------------------------------------------------*/
void    CopyCellPtr		(Cell*);
void    CopyString		(char*);

# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
			;
break;
case 2:
		;
break;
case 3:
		{ 	
			/*-------------------------------------------------------------------------------*/
			/*                              INT_CONST                                        */
			/*-------------------------------------------------------------------------------*/
				yylval.i_val = strtol(yytext, NULL, 10); 
				if (errno == ERANGE)
				{
					SetError(STR_TO_L_ERR);
					return (ERROR);
				}
				return (INT_CONST);
			}
break;
case 4:
case 5:
		{ 
			/*-------------------------------------------------------------------------------*/
			/*                              REAL_CONST                                       */
			/*-------------------------------------------------------------------------------*/
				if ( ((yylval.d_val=strtod(yytext, NULL)) == 0) || errno == ERANGE) 
				{
					SetError(STR_TO_D_ERR);
					return (ERROR);
				}
				return (REAL_CONST);
			}
break;
case 6:
		return (E);
break;
case 7:
		return (WAHR);
break;
case 8:
		return (FALSCH);
break;
case 9:
		{ section = page_sec; return (PAGE);		}
break;
case 10:
	{ section = eval_sec; return (EVALUATE);	}
break;
case 11:
	{ section = def_sec;  return (DEFINITION);	}
break;
case 12:
             { SetError(ROOT_ERR); return (ERROR);		}
break;
case 13:
                   { 
                        /*-------------------------------------------------------------------------------*/
			/*                              STRING (root-page)                               */
			/*-------------------------------------------------------------------------------*/
				if (section = page_sec) 
				{
					strcpy(yylval.s_val = new char[10],"\\__ROOT__");
					return(STRING);
				}
				else    
				{
					SetError(ROOT_SECTION_ERR);
					return (ERROR);
				}
			}
break;
case 14:
{
			/*-------------------------------------------------------------------------------*/
			/*                       STRING (absolute "Pfadangabe")				 */
			/*-------------------------------------------------------------------------------*/
				switch (section)
				{
					case page_sec	: return (ReturnString      (AddRoot(yytext))); 
					case def_sec	: return (ReturnDefString   (AddRoot(yytext)));
					case eval_sec	: return (DefinitionOrString(AddRoot(yytext)));
					default		: SetError(SECTION_ERR); return (ERROR);
				}
			}
break;
case 15:
 {
                        /*-------------------------------------------------------------------------------*/
			/*                      STRING (keine "Pfadangabe")                              */
			/*-------------------------------------------------------------------------------*/
				switch (section)
				{
					case def_sec	: return (ReturnString      (AddActDefPath (yytext)));
					case eval_sec	: return (DefinitionOrString(AddActPagePath(yytext))); 
					case page_sec	: SetError(NO_PAGE_PATH_ERR); return (ERROR);
					default		: SetError(SECTION_ERR);      return (ERROR);
				}
			}
break;
case 16:
{
			/*-------------------------------------------------------------------------------*/
			/*                      STRING (relative "Pfadangabe")                		 */
			/*-------------------------------------------------------------------------------*/
				switch (section)
				{
					case def_sec	: return (ReturnString      (AddActDefPath (yytext)));
					case eval_sec	: return (DefinitionOrString(AddActPagePath(yytext))); 
					case page_sec	: SetError(REL_PAGE_PATH_ERR); return (ERROR);
					default		: SetError(SECTION_ERR);       return (ERROR);
				}
			}
break;
case 17:
		return (TIMES);
break;
case 18:
		return (PLUS);
break;
case 19:
		return (MINUS);
break;
case 20:
		return (DIVIDE);
break;
case 21:
		return (MULTIPLY);
break;
case 22:
		return (NOT);
break;
case 23:
		return (AND);
break;
case 24:
		{
				if ((section == def_sec) && actual_def_path)
				{
					delete[] actual_def_path; 
					actual_def_path = NULL; 
				}
				return (OR);
			}
break;
case 25:
		;
break;
case 26:
		;
break;
case 27:
		return (EQUAL);
break;
case 28:
		return (LESS);
break;
case 29:
		return (GREATER);
break;
case 30:
		return (NOT_EQUAL);
break;
case 31:
		return (LESS_OR_EQUAL);
break;
case 32:
		return (GREATER_OR_EQUAL);
break;
case 33:
		return (COMMA);
break;
case 34:
		return (POINT);
break;
case 35:
		return (DOUBLEPOINT);
break;
case 36:
		return (QUESTIONMARK);
break;
case 37:
		return (CLOSE_I);
break;
case 38:
		return (OPEN_I);
break;
case 39:
		return (CLOSE_II);
break;
case 40:
		return (OPEN_II);
break;
case 41:
		return (CLOSE_III);
break;
case 42:
		return (OPEN_III);
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
//################################################################################################################
//
//	fuegt "str" "\__ROOT__" hinzu	
//
//################################################################################################################
char*	AddRoot(char* str)
{
	char*   ret_str = NULL;
	sprintf(ret_str = new char[(strlen(str)+11)], "\\__ROOT__%s", str);
	return (ret_str);
}
//################################################################################################################
//
//	fuegt "str" "actual_page" hinzu	
//
//################################################################################################################
char*	AddActPagePath(char* str)
{
	char*   ret_str = NULL;
	sprintf(ret_str = new char[(strlen(actual_page)+strlen(str)+3)], "%s\\%s", actual_page, str);
	return (ret_str);
}
//################################################################################################################
//
//	fuegt "str" "actual_def_path" hinzu	
//
//################################################################################################################
char*	AddActDefPath(char* str)
{
	char*   ret_str = NULL;
	sprintf(ret_str = new char[(strlen(actual_def_path)+strlen(str)+3)], "%s\\%s", actual_def_path, str);
	return (ret_str);
}
//################################################################################################################
//
//	kopiert "str" in die Parservariable "yylval.s_val" 
//
//################################################################################################################
int	ReturnString(char* str)
{
	sprintf(yylval.s_val  = new char[(strlen(str) + 1)], "%s", str);
        return (STRING);
}
//################################################################################################################
//
//	- sofern "actual_def_path" nicht gesetzt ist wird sie durch den Pfad von "str" gesetzt
//	- kopiert "str" in die Parservariable "yylval.s_val" 
//
//################################################################################################################
int	ReturnDefString(char* str)
{
	if (!actual_def_path)	
	{
		char* path = GetPath(str);
		if (!path) return (ERROR);
		sprintf(actual_def_path = new char[(strlen(path) + 1)], "%s", path);
	}
	return (ReturnString(str));
}
//################################################################################################################
//
//	ueberprueft ob der gefundene String einer Variablen der Definitionen entspricht
//
//################################################################################################################
int	DefinitionOrString(char* str)
{
	Cell* val = NULL;
	if ((val=TestIfDefinition(str, new TextualList())))
		return (ReturnCellContents(val));
	return (ReturnString(str));
}
//################################################################################################################
//
//	gibt den pfad eines strings zurueck 
//
//################################################################################################################
char* GetPath(char* s)
{
        if (*s != '\\') 
        { 
        	SetError(GET_PATH_ERR); 
        	return NULL; 
       	}

        int     slash_count = 0;
	int     cp_c_count  = 0;
	int     c_count     = 0;
	char*   h;

	for (h = s; *h != '\0'; h++,c_count++)
	{
		if ( *h == '\\' ) 
		{
			slash_count++;
			cp_c_count = c_count;
		}
	}

	char* path   = new char[cp_c_count+1];
	char* h_path = path;

	for (h = s; slash_count; h++,h_path++)
	{
		*h_path = *h;
		if ( *h == '\\' ) slash_count--;
	}
	*h_path = '\0';
	return path;
}

//################################################################################################################
//
//      Ueberpruefung, ob es Definitions-Schleifen gibt 
//
//################################################################################################################
bool    DefinitionLoop(char* old_val, Textual old_var)
{
	for (DefinitionListElement* h=DefinitionRefList.first; h; h=h->next)
	{
		if (h->lelement.GetVar() == old_val)
		{
			if (h->lelement.GetVal()->GetResultType() != textual) return false;

			if (old_var == h->lelement.GetVal()->Calculate()->GetText()) 
				return true;
			return (DefinitionLoop(h->lelement.GetVal()->Calculate()->GetText(),old_var));
		}
	}
	return false;
}
//################################################################################################################
//
// 	Testet, ob es zum gefundenen String einen passenden Eintrag in der Referenzliste "ExprRefList"
// 	gibt. 
// 		Ja   => Returnwert = gefundenen Eintrag
// 		Nein => Returnwert = NULL
//
//################################################################################################################
Cell*   TestIfDefinition(char* test_str, TextualList* tl)
{
	if (!DefinitionRefList.size) return NULL;

	Textual txt(test_str);
	for (DefinitionListElement* h=DefinitionRefList.first; h; h=h->next)
	{
		if (h->lelement.GetVar() == txt)
		{
			if ((tl->UniqueAppend(txt)) < 0 ) { SetError(DEF_LOOP); return NULL; }

			if (h->lelement.GetVal()->GetResultType() != textual) return (h->lelement.GetVal());

			if (DefinitionLoop(h->lelement.GetVal()->Calculate()->GetText(),txt)) 
			{
				SetError(DEF_LOOP);
				return  NULL;
			}

			Cell* r_val = NULL;
			if ((r_val=TestIfDefinition(h->lelement.GetVal()->Calculate()->GetText(),tl)))
				return (r_val);
			return (h->lelement.GetVal());
		}
	}
	return NULL;
}
//################################################################################################################
//
// 	Copier-Funktionen zur Uebergabe spezifischer Definitionswerte an den Parser
//
//################################################################################################################
void    CopyCellPtr(Cell* def_val)      { yylval._CellPtr     = def_val->Copy(); }
void    CopyString(char*  def_str)   	{ strcpy(yylval.s_val = new char[strlen(def_str)+1], def_str); }

//################################################################################################################
//
// 	Untersucht welche Art von Definition vorliegt.
//	Es wird die "rechte Seite" der Definition zurueckgegeben.
// 	Im Fall von numeric, p_multiset, e_multiset wird ein CellPtr zurueckgegeben
// 	Im Fall von textual wird ein char* zurueckgegeben.
//
//################################################################################################################
int     ReturnCellContents(Cell* def_val)
{
        switch (def_val->GetResultType())
	{
		case logic_expr		: CopyCellPtr(def_val);				return (LOGIC);
		case p_mset_expr	: CopyCellPtr(def_val);				return (P_MSET); 
		case e_mset_expr	: CopyCellPtr(def_val);				return (E_MSET);
		case numeric   		: CopyCellPtr(def_val);				return (NUMERIC); 
		case textual  		: CopyString(def_val->Calculate()->GetText());	return (STRING); 
		default      		: SetError(RESULT_TYPE_ERR);			return (ERROR);
	}
	return 0;
}
int yyvstop[] = {
0,

1,
0,

2,
0,

22,
0,

25,
0,

23,
0,

17,
0,

38,
0,

37,
0,

21,
0,

18,
0,

33,
0,

19,
0,

34,
0,

20,
0,

3,
0,

35,
0,

28,
0,

27,
0,

29,
0,

36,
0,

26,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

40,
0,

13,
0,

39,
0,

15,
16,
0,

6,
15,
16,
0,

42,
0,

24,
0,

41,
0,

30,
0,

4,
0,

31,
0,

32,
0,

16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

14,
0,

15,
16,
0,

5,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

14,
0,

15,
16,
0,

4,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

9,
15,
16,
0,

7,
15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

8,
15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

15,
16,
0,

10,
15,
16,
0,

12,
15,
16,
0,

15,
16,
0,

11,
15,
16,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,3,	1,4,	
3,3,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	1,3,	1,5,	3,3,	
1,6,	0,0,	0,0,	1,7,	
1,8,	1,9,	1,10,	1,11,	
1,12,	1,13,	1,14,	1,15,	
1,16,	1,17,	1,17,	1,17,	
1,17,	1,17,	1,17,	1,17,	
1,17,	1,17,	1,17,	1,18,	
0,0,	1,19,	1,20,	1,21,	
1,22,	1,23,	1,24,	1,24,	
1,24,	1,25,	1,26,	1,27,	
1,24,	1,24,	1,24,	1,24,	
1,24,	1,24,	1,24,	1,24,	
1,24,	1,28,	1,24,	1,24,	
1,24,	1,29,	1,24,	1,24,	
1,24,	1,24,	1,24,	1,24,	
1,30,	1,31,	1,32,	5,38,	
1,33,	19,41,	1,24,	1,24,	
1,24,	1,24,	1,34,	1,24,	
1,24,	1,24,	1,24,	1,24,	
1,24,	1,24,	1,24,	1,24,	
1,24,	1,24,	1,24,	1,24,	
1,24,	1,24,	1,24,	1,24,	
1,24,	1,24,	1,24,	1,24,	
1,35,	1,36,	1,37,	17,39,	
21,42,	17,17,	17,17,	17,17,	
17,17,	17,17,	17,17,	17,17,	
17,17,	17,17,	17,17,	25,44,	
26,45,	27,46,	28,47,	29,48,	
33,50,	44,54,	45,55,	46,56,	
47,57,	48,58,	17,40,	50,60,	
54,63,	55,64,	56,65,	57,66,	
58,67,	24,43,	60,68,	63,69,	
64,70,	65,71,	68,72,	69,73,	
70,74,	72,75,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
73,76,	74,77,	75,78,	76,79,	
77,80,	78,81,	17,40,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	79,82,	24,43,	82,83,	
0,0,	24,24,	0,0,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	24,24,	24,24,	24,24,	
24,24,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	0,0,	
0,0,	0,0,	0,0,	31,49,	
0,0,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	31,49,	
31,49,	31,49,	31,49,	39,39,	
39,39,	39,39,	39,39,	39,39,	
39,39,	39,39,	39,39,	39,39,	
39,39,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
40,52,	0,0,	40,52,	0,0,	
39,51,	40,53,	40,53,	40,53,	
40,53,	40,53,	40,53,	40,53,	
40,53,	40,53,	40,53,	0,0,	
0,0,	0,0,	0,0,	0,0,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
39,51,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	0,0,	
0,0,	0,0,	0,0,	43,43,	
0,0,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	43,43,	
43,43,	43,43,	43,43,	49,59,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	51,61,	0,0,	
51,61,	0,0,	0,0,	51,62,	
51,62,	51,62,	51,62,	51,62,	
51,62,	51,62,	51,62,	51,62,	
51,62,	52,53,	52,53,	52,53,	
52,53,	52,53,	52,53,	52,53,	
52,53,	52,53,	52,53,	0,0,	
59,59,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
49,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
0,0,	59,59,	0,0,	0,0,	
59,59,	0,0,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
59,59,	59,59,	59,59,	59,59,	
61,62,	61,62,	61,62,	61,62,	
61,62,	61,62,	61,62,	61,62,	
61,62,	61,62,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+1,	0,		0,	
yycrank+0,	yysvec+1,	0,	
yycrank+3,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+34,	0,		yyvstop+5,
yycrank+0,	0,		yyvstop+7,
yycrank+0,	0,		yyvstop+9,
yycrank+0,	0,		yyvstop+11,
yycrank+0,	0,		yyvstop+13,
yycrank+0,	0,		yyvstop+15,
yycrank+0,	0,		yyvstop+17,
yycrank+0,	0,		yyvstop+19,
yycrank+0,	0,		yyvstop+21,
yycrank+0,	0,		yyvstop+23,
yycrank+0,	0,		yyvstop+25,
yycrank+0,	0,		yyvstop+27,
yycrank+81,	0,		yyvstop+29,
yycrank+0,	0,		yyvstop+31,
yycrank+36,	0,		yyvstop+33,
yycrank+0,	0,		yyvstop+35,
yycrank+67,	0,		yyvstop+37,
yycrank+0,	0,		yyvstop+39,
yycrank+0,	0,		yyvstop+41,
yycrank+118,	0,		yyvstop+43,
yycrank+38,	yysvec+24,	yyvstop+46,
yycrank+22,	yysvec+24,	yyvstop+49,
yycrank+76,	yysvec+24,	yyvstop+52,
yycrank+45,	yysvec+24,	yyvstop+55,
yycrank+61,	yysvec+24,	yyvstop+58,
yycrank+0,	0,		yyvstop+61,
yycrank+176,	0,		yyvstop+63,
yycrank+0,	0,		yyvstop+65,
yycrank+49,	yysvec+24,	yyvstop+67,
yycrank+0,	yysvec+24,	yyvstop+70,
yycrank+0,	0,		yyvstop+74,
yycrank+0,	0,		yyvstop+76,
yycrank+0,	0,		yyvstop+78,
yycrank+0,	0,		yyvstop+80,
yycrank+251,	0,		yyvstop+82,
yycrank+273,	0,		0,	
yycrank+0,	0,		yyvstop+84,
yycrank+0,	0,		yyvstop+86,
yycrank+288,	yysvec+24,	yyvstop+88,
yycrank+43,	yysvec+24,	yyvstop+90,
yycrank+49,	yysvec+24,	yyvstop+93,
yycrank+71,	yysvec+24,	yyvstop+96,
yycrank+45,	yysvec+24,	yyvstop+99,
yycrank+64,	yysvec+24,	yyvstop+102,
yycrank+372,	yysvec+31,	yyvstop+105,
yycrank+69,	yysvec+24,	yyvstop+107,
yycrank+387,	0,		0,	
yycrank+397,	0,		0,	
yycrank+0,	yysvec+52,	yyvstop+110,
yycrank+47,	yysvec+24,	yyvstop+112,
yycrank+45,	yysvec+24,	yyvstop+115,
yycrank+71,	yysvec+24,	yyvstop+118,
yycrank+54,	yysvec+24,	yyvstop+121,
yycrank+87,	yysvec+24,	yyvstop+124,
yycrank+417,	0,		yyvstop+127,
yycrank+79,	yysvec+24,	yyvstop+129,
yycrank+492,	0,		0,	
yycrank+0,	yysvec+61,	yyvstop+132,
yycrank+49,	yysvec+24,	yyvstop+134,
yycrank+43,	yysvec+24,	yyvstop+137,
yycrank+92,	yysvec+24,	yyvstop+140,
yycrank+0,	yysvec+24,	yyvstop+143,
yycrank+0,	yysvec+24,	yyvstop+147,
yycrank+83,	yysvec+24,	yyvstop+151,
yycrank+58,	yysvec+24,	yyvstop+154,
yycrank+67,	yysvec+24,	yyvstop+157,
yycrank+0,	yysvec+24,	yyvstop+160,
yycrank+81,	yysvec+24,	yyvstop+164,
yycrank+60,	yysvec+24,	yyvstop+167,
yycrank+61,	yysvec+24,	yyvstop+170,
yycrank+83,	yysvec+24,	yyvstop+173,
yycrank+74,	yysvec+24,	yyvstop+176,
yycrank+79,	yysvec+24,	yyvstop+179,
yycrank+86,	yysvec+24,	yyvstop+182,
yycrank+98,	yysvec+24,	yyvstop+185,
yycrank+0,	yysvec+24,	yyvstop+188,
yycrank+0,	yysvec+24,	yyvstop+192,
yycrank+101,	yysvec+24,	yyvstop+196,
yycrank+0,	yysvec+24,	yyvstop+199,
0,	0,	0};
struct yywork *yytop = yycrank+549;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,01  ,01  ,01  ,01  ,047 ,
01  ,01  ,01  ,'+' ,01  ,'+' ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,047 ,01  ,01  ,'A' ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*
 * (c) Copyright 1990, OPEN SOFTWARE FOUNDATION, INC.
 * ALL RIGHTS RESERVED
 */
/*
 * OSF/1 Release 1.0
*/
/*
#
# IBM CONFIDENTIAL
# Copyright International Business Machines Corp. 1989
# Unpublished Work
# All Rights Reserved
# Licensed Material - Property of IBM
#
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
*/
/* @(#)ncform	1.3  com/lib/l,3.1,8951 9/7/89 18:48:47 */
int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
unsigned char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char yysbuf[YYLMAX];
unsigned char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	unsigned char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( yyt > yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if(yyt < yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
