#ifndef __ArcBindElement_cc__
#define __ArcBindElement_cc__

#include <iostream.h> 
#include "Identifier.h"
#include "Textual.h"
#include "TextualList.h"

#include "token_multiset.h"
#include "PlaceHeader.h"

#include "Token.h"

#include "CellVal.h"
#include "Cell.h"

#include "Place.h"

#include "ArcBindElement.h"


//#############################################################################################################
ArcBindElement::ArcBindElement()
{ 
	place   	= NULL; 
	result_tms	= NULL;
	tokenms 	= NULL; 
}
ArcBindElement::ArcBindElement(int)	
{ 
	place   	= NULL; 
	result_tms	= NULL;
	tokenms 	= NULL;
}
ArcBindElement::ArcBindElement(Place* p, Cell* c)  
{ 
	place 		= p; 
	result_tms	= NULL;
	NewCell(c);
}
ArcBindElement::ArcBindElement(const ArcBindElement& a)
{ 
	place 	   	= a.place; 
	result_tms 	= NULL;
	NewCell(a.tokenms);
}
//#############################################################################################################
char*		ArcBindElement::GetName()				{ return DEF_STRING; 		}
Place*		ArcBindElement::GetPlace()				{ return place; 		}
bool		ArcBindElement::operator!=(ArcBindElement& a) 		{ return !(*this == a); 	}
bool		ArcBindElement::LessThan(ArcBindElement&) 		{ return false;			}
//------------------------------------------------------------------------------------------------------------
Cell*		ArcBindElement::Gettoken_multisetCell()			
{ 
	if (tokenms) return tokenms; 		
	else	     return (new ConstVal(new TokenMSVal()));
}
//------------------------------------------------------------------------------------------------------------
void		ArcBindElement::NewCell(Cell* c)
{
	if (!c) tokenms = NULL;
	else
	{
		switch (c->GetResultType())
		{
			case c_function		:	tokenms = c->Copy();	break;
			case e_mset_expr	:	tokenms = c->Copy();	break;
			case p_mset_expr	:	tokenms = c->Copy();	break;
			default			:	tokenms = NULL;		break;
		}
	}
}
//------------------------------------------------------------------------------------------------------------
int	ArcBindElement::GetActColor()
{
	if (result_tms) 
	{
		if (result_tms->first) 
			return (result_tms->first->tref);
		return (EMPTY_COLOR);
	}

	CellVal*        cv  = tokenms->Calculate();
	token_multiset* ret = copy_token_multiset((cv->Gettoken_multiset()));

	cv->Clear();
	delete cv;

	if (tokenms->IsPlaceDependent())
	{
		if (ret->first) 
			return (ret->first->tref);
		return (EMPTY_COLOR);
	}

	result_tms = copy_token_multiset(ret);
	clear_tms(ret); 

	if (result_tms->first) 
		return (result_tms->first->tref);
	return (EMPTY_COLOR);
}
//------------------------------------------------------------------------------------------------------------
int	ArcBindElement::GetActCapacity()
{
	if (result_tms) return (get_quantity(result_tms));

	CellVal*        cv  = tokenms->Calculate();
	token_multiset* ret = copy_token_multiset((cv->Gettoken_multiset()));

	cv->Clear();
	delete cv;

	if (tokenms->IsPlaceDependent())
		return (get_quantity(ret));

	result_tms = copy_token_multiset(ret);
	clear_tms(ret); 

	return (get_quantity(result_tms));
}
//------------------------------------------------------------------------------------------------------------
token_multiset*	ArcBindElement::Gettoken_multiset()
{
	if (result_tms) return result_tms;

	CellVal*        cv  = tokenms->Calculate();
	token_multiset* ret = copy_token_multiset((cv->Gettoken_multiset()));

	cv->Clear();
	delete cv;

	if (tokenms->IsPlaceDependent())
		return ret;

	result_tms = copy_token_multiset(ret);
	clear_tms(ret); 

	return result_tms;
}
//------------------------------------------------------------------------------------------------------------
void		ArcBindElement::Clear()			
{ 
	if (tokenms)  	
	{ 
		tokenms->Clear();
		delete tokenms;
		tokenms = NULL; 
	}
	clear_tms(result_tms);
}
//------------------------------------------------------------------------------------------------------------
ArcBindElement&	ArcBindElement::operator =(const ArcBindElement& a) 
{
	Clear();
	place = a.place; 
	if (a.result_tms) result_tms = copy_token_multiset(a.result_tms); else result_tms = NULL;
	if (a.tokenms)    tokenms    = a.tokenms->Copy(); 		  else tokenms    = NULL; 
	return *this; 
}
//------------------------------------------------------------------------------------------------------------
bool		ArcBindElement::operator==(ArcBindElement& a) 
{ 
	if ( place   && !a.place)				return false;
	if (!place   &&  a.place)				return false;
	if ( tokenms && !a.tokenms)				return false;
	if (!tokenms &&  a.tokenms)				return false;
	if (!tokenms && !a.tokenms && !place && !a.place) 	return true; 
	if (!tokenms && !a.tokenms) 				return ( *(place)   == *(a.place)   );
	if (!place   && !a.place)				return ( *(tokenms) == *(a.tokenms) );
	return ( *(place) == *(a.place) && *(tokenms) == *(a.tokenms) );
}

//################################################################################################################
#endif
