#ifndef __BindingElement_h__
#define __BindingElement_h__

#include "Types.h"
#include "ArcBindList.h"
//#################################################################################################
class CellVal;
class Cell;
class Delay;
//#################################################################################################
class BindingElement
{
	Weight		weight;
	Cell*		localcond;
	short		lc_result;
	Delay*		delay;
	double		del_result;
	ArcBindList	inarcbind;
	ArcBindList	outarcbind;
public:
	BindingElement();
	BindingElement(int);
	BindingElement(Weight, const Cell*, const Delay*, const ArcBindList&, const ArcBindList&);
	BindingElement(Weight, const Cell*, const Delay*, const ArcBindList*, const ArcBindList*);
	BindingElement(const BindingElement&);
	~BindingElement() { Clear(); }

	//-----------------------------------------------------------------------------------------
	//	Delete	
	//-----------------------------------------------------------------------------------------
	void 	Clear();

	//-----------------------------------------------------------------------------------------
	//	"Getten"
	//-----------------------------------------------------------------------------------------
	Weight			GetWeight();
	Cell*			GetLocalCondition();
	Delay*			GetDelay();
	double			GetDelayVal();
	ArcBindList&		GetInArcBind();
	ArcBindList&		GetOutArcBind();

	//-----------------------------------------------------------------------------------------
	//	Modifizieren	
	//-----------------------------------------------------------------------------------------
	void			ChangeWeight(Weight);
	void			ChangeLocalCondition(const Cell*);
	void			ChangeDelay(const Delay*);
	void			ChangeInArcBind(const ArcBindList&);
	void			ChangeOutArcBind(const ArcBindList&);

	//-----------------------------------------------------------------------------------------
	//	Operatoren	
	//-----------------------------------------------------------------------------------------
	BindingElement&		operator =(const BindingElement&);
	bool			operator==(BindingElement&);
	bool			operator!=(BindingElement&);

	//-----------------------------------------------------------------------------------------
	//	Listen-Operatoren	
	//-----------------------------------------------------------------------------------------
	bool			LessThan(BindingElement&) ;
	static char*		GetName();

	//-----------------------------------------------------------------------------------------
	//	Calculate
	//-----------------------------------------------------------------------------------------
	bool			LocalCondTrue();
};
//#################################################################################################
#endif
