#ifndef __Definition_cc__
#define __Definition_cc__

#include <iostream.h>

#include "Identifier.h"
#include "Textual.h"
#include "TextualList.h"
#include "token_multiset.h"
#include "PlaceHeader.h"

#include "Token.h"

#include "CellVal.h"
#include "Cell.h"

#include "Definition.h"

//###############################################################################################################
Definition::Definition()				: var(DEF_VAR)	{ val = new ConstVal(); }
Definition::Definition(int)				: var(DEF_VAR)	{ val = new ConstVal(); }	
Definition::Definition(const Definition& d)		: var(d.var) 	{ val = d.val->Copy();  }
Definition::Definition(char* i, const Cell* c)		: var(i)		
{ 
	if (!c)	val = new ConstVal();
	else	val = c->Copy();
}	
//###############################################################################################################
CellVal*	Definition::Calculate()					{ return val->Calculate(); 		}
bool		Definition::operator==(Definition& d)			{ return  (var   == d.var); 		}
bool		Definition::operator!=(Definition& d) 			{ return !(*this == d ); 		}
bool		Definition::LessThan(Definition& d) 			{ return ( var < d.var ); 		}
char*           Definition::GetName()                         		{ return var.GetChar(); 		}
Textual   	Definition::GetVar() const				{ return var; 				}
Cell*		Definition::GetVal() const				{ return val; 				}
void		Definition::ChangeVar(const Textual& t)			{ var = t; 				}
//---------------------------------------------------------------------------------------------------------------
void		Definition::ChangeVal(const Cell* c)		   	
{ 
	if (c)   
	{ 
		val->Clear();
		delete val;
		val=c->Copy(); 
	} 	
}
//---------------------------------------------------------------------------------------------------------------
void		Definition::Clear() 					
{ 
	var.Clear();
	if (val) 
	{ 
		val->Clear();
		delete val; 
		val = NULL; 
	} 	
}
//---------------------------------------------------------------------------------------------------------------
Definition&	Definition::operator =(const Definition& d)
{
	Clear();
	var = d.var;
	val = d.val->Copy();
	return *this;
}
//###############################################################################################################
#endif
