#ifndef __Definition_h__
#define __Definition_h__

#include "Types.h"
//########################################################################################
class Cell;
class CellVal;
//########################################################################################
class Definition 
{
	Textual		var;
	Cell*		val;

public:
	Definition();	
	Definition(int);	
	Definition(char*, const Cell*);	
	Definition(const Definition&);	
	~Definition() { Clear(); }	

	void		Clear();
	//--------------------------------------------------------------------------------
	//	"Getten"/Calculate	
	//--------------------------------------------------------------------------------
	char*		GetName();
	Textual		GetVar() const;
	Cell*		GetVal() const;
	CellVal*	Calculate();

	//--------------------------------------------------------------------------------
	//	Modifizieren	
	//--------------------------------------------------------------------------------
	void		ChangeVar(const Textual&);
	void		ChangeVal(const Cell*);

	//--------------------------------------------------------------------------------
	//	Operatoren	
	//--------------------------------------------------------------------------------
	Definition&	operator =(const Definition&);
	bool		operator==(Definition&);
	bool		operator!=(Definition&);
	bool		LessThan(Definition&);
};
//########################################################################################
#endif
