#ifndef __Identifier_cc__
#define __Identifier_cc__

#include "Identifier.h"

//################################################################################################################
inline void 	Identifier::Check(const char* t) 
{ 
	if (t)
	{
		char* tmp; bool correct = true;
		strcpy(tmp  = new char[strlen(t)+1], t);
		if (tmp[0] == '_') correct = false;	
		for (unsigned i=0; i<strlen(tmp); i++)
		{
			if (!(isdigit(tmp[i]) || isalpha(tmp[i]) || tmp[i] == '_'))
			correct = false;
		}
		if (correct) strcpy(identifier = new char[strlen(t)+1], t); 
		else         
		{
			cout <<"Identifier : Error in Identifier : "<<t<<"\n";
			exit(IDENTIFIER_ERROR);
		}
		if (tmp) delete[] tmp;
	}
}
//################################################################################################################
Identifier::Identifier()		        : identifier(NULL) { };
Identifier::Identifier(int)		        : identifier(NULL) { };
Identifier::Identifier(const char* i)		: identifier(NULL) { Check(i);            }
Identifier::Identifier(const Identifier& i) 	: identifier(NULL) { Check(i.identifier); }
//################################################################################################################
void 		Identifier::Clear()		  
{ 
	if (identifier) 
	{ 
		delete[] identifier; 
		identifier = NULL; 
	} 
}
//---------------------------------------------------------------------------------------------------------------
Identifier& 	Identifier::operator =(const char* s)           	{ Clear(); Check(s); return *this; 	} 
Identifier& 	Identifier::operator =(const Identifier& i) 		{ return *this  = i.identifier; 	} 
bool        	Identifier::operator==(char* s)       			{ return (strcmp(identifier,s) == 0); 	}
bool        	Identifier::operator==(Identifier& i) 			{ return *this == i.identifier; 	}
bool        	Identifier::operator!=(char* s)       			{ return (strcmp(identifier,s) != 0); 	}
bool        	Identifier::operator!=(Identifier& i) 			{ return *this != i.identifier; 	}
bool        	Identifier::operator <(char* s)       			{ return (strcmp(identifier,s) < 0); 	}
bool        	Identifier::operator <(Identifier& i) 			{ return *this < i.identifier; 		}
bool        	Identifier::operator >(char* s)       			{ return (strcmp(identifier,s) > 0); 	}
bool        	Identifier::operator >(Identifier& i) 			{ return *this > i.identifier; 	}
//---------------------------------------------------------------------------------------------------------------
bool	    	Identifier::LessThan(Identifier& i)			{ return *this < i.identifier; 		}
char*           Identifier::GetName()                       		{ return DEF_STRING; 			}
char*	 	Identifier::GetChar()  const    			{ return identifier; 			}
//##############################################################################################################
#endif

