#ifndef __Marking_h__
#define __Marking_h__

#include "Types.h"
//#############################################################################################################
class Marking
{
	int			key;
	short*			active_trans_array;

	//--------------------------------------------------------------------------
	//	Create 
	//--------------------------------------------------------------------------
	void 			CreateKey();
	void			NewATA(short*);
public:
	token_multiset** 	pms;
	state_transition*	first;

	unsigned char   	status:4;
	unsigned char		mtype:4;

	Marking();
	Marking(int);
	Marking(const Marking&);
	Marking(short*);
	Marking(token_multiset**);
	Marking(token_multiset**, short*);
	~Marking() { Clear(); }

	//--------------------------------------------------------------------------
	//	Create 
	//--------------------------------------------------------------------------
	void		NewPMS(token_multiset**);

	//--------------------------------------------------------------------------
	//	Clear 
	//--------------------------------------------------------------------------
	void		Clear();
	void		ClearPMS();
	void		ClearTotal();

        //--------------------------------------------------------------------------
        //      Getten
        //--------------------------------------------------------------------------
	int            	GetKey();
	int		GetNumber();
	double		GetSumOfRates();
	double		GetDetOrGenDelay();
	int		GetDetOrGenTransRef();
	int		GetNoOfExpPaths();
	int     	GetNoOfStateTrans();
	short*		GetActiveTransArray();

	//--------------------------------------------------------------------------
	//      Modifizieren
	//--------------------------------------------------------------------------
	int		SetNumber(int);
	void		InitPlaceMultiSet();
	void		InitActiveTransArray();
	void		ModifyActiveTransArray(int, short);
	void		AppendNewMarking(Marking&, DelayVal&);
	
	//--------------------------------------------------------------------------
	//	Operatoren 
	//--------------------------------------------------------------------------
	Marking&	operator =(const Marking&);
	bool		operator==(Marking&);
	bool		operator!=(Marking&);

        //--------------------------------------------------------------------------
        //      Funktionen fuer ListenOperationen
        //--------------------------------------------------------------------------
        static char*   	GetName();
        bool    	LessThan(Marking&);

};
//#############################################################################################################
#endif



