#ifndef __MiscellaneousFuncs_cc__
#define __MiscellaneousFuncs_cc__

#include "inc_classes.h"
#include "inc_miscellaneous_funcs.h"

//##########################################################################################################
//
//	Fehlerbehandlung	
//
//##########################################################################################################
void	MErr(char* s1, char* s2, int line)
{
	if (s2)	RRGErr = new RRGError(__FILE__, s1, line, NULL, s2);
	else	RRGErr = new RRGError(__FILE__, s1, line);
	PrepareEnd();
}        
//##########################################################################################################
//
//      - Schalten eines Bindings 
//      -> entfernen (op=minus)/hinzufuegen (op=plus) von Token von/zu einem Stelleninhalt
//
//##########################################################################################################
void    FireArcBindings(Operator op, int p_no, token_multiset*& act_tms)
{
	if (!(arcs->size)) return;

	for (ArcBindListElement* able=arcs->first; able; able=able->next)
	{
		if ( (able->lelement.GetPlace()->GetPlaceNo()) == p_no)
		{
			token_multiset*  tmset = able->lelement.Gettoken_multiset();

			if (!(tmset) || !(tmset->first)) continue;

			switch (op)
			{
				case '+' : 
						for (token_referenz* tr0=tmset->first; tr0; tr0=tr0->next)
							add_token(act_tms, tr0); 
					   	break;

				case '-' : 	
						if (!act_tms) return;
						for (token_referenz* tr1=tmset->first; tr1; tr1=tr1->next)
					   		sub_token(act_tms, tr1); 
					   	break;
				default	 : break;
			}
		}
	}
}
//##########################################################################################################
//
//      Place-MultiSet mit PlaceList-Inhalt fuellen
//
//##########################################################################################################
token_multiset**         make_place_multiset()
{
	if (!PlaceHeaderPtrRefList.size)	
		MErr("can't make token_multiset*, PlaceHeaderList is empty", NULL, __LINE__);

	token_multiset** place_multiset = new token_multiset*[no_of_places];

	int i=0;
	for (PlaceHeaderPtrListElement* ph=PlaceHeaderPtrRefList.first; ph; i++, ph=ph->next) 
	{
		if (ph->plelement) place_multiset[i] = copy_token_multiset(ph->plelement->Gettoken_multiset());
		else		   place_multiset[i] = NULL;
	}
	return place_multiset;
}
//##########################################################################################################
//
//      - PlaceHeaderPtrRefList initialisieren
//	- Enable/DisableStates testen
//
//##########################################################################################################
void    clean_global_actual_objects()
{
	int i = 0;
	for (PlaceHeaderPtrListElement* ph=PlaceHeaderPtrRefList.first; i < no_of_places-1; i++, ph=ph->next)
	{
		if (!(ph->plelement)) MErr("PlaceHeader is NULL-pointer", NULL, __LINE__);
		clear_tms((ph->plelement->tms));
	}
}
//##########################################################################################################
//
//      - PlaceHeaderPtrRefList initialisieren
//	- Enable/DisableStates testen
//
//##########################################################################################################
void    init_global_actual_objects(token_multiset** pms)
{
	if (!pms) MErr("can't convert empty place-multiset to token-multisets", NULL, __LINE__);

	int i = 0;
	for (PlaceHeaderPtrListElement* ph=PlaceHeaderPtrRefList.first; i < no_of_places-1; i++, ph=ph->next)
	{
		if (!(ph->plelement)) MErr("PlaceHeader is NULL-pointer", NULL, __LINE__);
		ph->plelement->tms = pms[i]; 
	}
}
//##########################################################################################################
#endif
