#ifndef __NonPersistentMarking_h__
#define __NonPersistentMarking_h__

#include "Types.h"
//#############################################################################################################
class NonPersistentMarking
{
	Key			key;
	DelayVal		np_delay;
	short*			active_trans_array;

        //--------------------------------------------------------------------------
        //     Create 
        //--------------------------------------------------------------------------
        void			NewATA(short*);
        void			CreateKey();
public:
	token_multiset** 	pms;
	np_state_transition*	first;

	NonPersistentMarking();
	NonPersistentMarking(int);
	NonPersistentMarking(const NonPersistentMarking&);
	NonPersistentMarking(const DelayVal&);
	NonPersistentMarking(token_multiset**);
	NonPersistentMarking(token_multiset**, short*);
	NonPersistentMarking(token_multiset**, const DelayVal&);
	NonPersistentMarking(token_multiset**, const DelayVal&, short*);
	~NonPersistentMarking() { Clear(); }

        //--------------------------------------------------------------------------
        //     Create 
        //--------------------------------------------------------------------------
        void			NewPMS(token_multiset**);

        //--------------------------------------------------------------------------
        //     Delete 
        //--------------------------------------------------------------------------
        void			Clear();
        void			ClearPMS();
        void			ClearTotal();

        //--------------------------------------------------------------------------
        //      Getten
        //--------------------------------------------------------------------------
	Key            		GetKey();
	void           		SetKey(Key);
	DelayVal&		GetDelay();
	short*			GetActiveTransArray();

	//--------------------------------------------------------------------------
	//      Modifizieren
	//--------------------------------------------------------------------------
	void			InitPlaceMultiSet();
	void			InitActiveTransArray();
	void			ChangeDelay(const DelayVal&);
	void			AppendNewMarking(NonPersistentMarking&, DelayVal&);
	
	//--------------------------------------------------------------------------
	//	Operatoren 
	//--------------------------------------------------------------------------
	NonPersistentMarking&	operator =(const NonPersistentMarking&);
	bool			operator==(NonPersistentMarking&);
	bool			operator!=(NonPersistentMarking&);

        //--------------------------------------------------------------------------
        //      Funktionen fuer ListenOperationen
        //--------------------------------------------------------------------------
        static char*           	GetName();
        bool            	LessThan(NonPersistentMarking&);
};
//#############################################################################################################
#endif
