#ifndef __Page_h__
#define __Page_h__

#include "Types.h"
//#####################################################################
class Page
{
	Textual			pagename;
	DefinitionList*		parameters;
	TextualList*		sub_pages;
	TransitionList* 	trans;
	PlacePtrList*		places;
public:
	Page();
	Page(int);
	Page(char*);
	Page(const Page&);

	~Page() { Clear(); }

	//-------------------------------------------------------------
	//	Clear	
	//-------------------------------------------------------------
	void			Clear();

	//-------------------------------------------------------------
	//	"Getten"	
	//-------------------------------------------------------------
	Textual		 	GetPageName();
	TextualList*&	 	GetSubPages();
	PlacePtrList*&		GetPlaces();
	DefinitionList*& 	GetParameters();
	TransitionList*& 	GetTransitions();

	//-------------------------------------------------------------
	//	"Adden"	
	//-------------------------------------------------------------
	void			AddTransitions(TransitionList&);
	void			AddParameters(DefinitionList&);
	void			AddParameter(Definition&);
	void			AddPlaces(PlacePtrList*&);
	void			AddSubPage(char*);

	//-------------------------------------------------------------
	//	Suchen	
	//-------------------------------------------------------------
	bool			IsSubPage(char*);
	Definition* 		IsParameter(char*);

	//-------------------------------------------------------------
	//	Operatoren	
	//-------------------------------------------------------------
	Page&			operator =(const Page&);
	bool			operator==(Page&);
	bool			operator!=(Page&);

	//-------------------------------------------------------------
	//	fuer sortierende Listenoperationen	
	//-------------------------------------------------------------
	static bool		LessThan(Page&);
	char*			GetName();
};
//######################################################################
#endif
