#ifndef __Place_h__
#define __Place_h__

#include "Types.h"
//######################################################################################
class Place
{
	PlaceHeader*	p_head;			// name and tms

	PlaceType	ptype;
	KindOfCap	koc;
	Cell*		cap;			// capacity
	int		cap_result;

	//-----------------------------------------------------------------------------
	// 	Error	
	//-----------------------------------------------------------------------------
	void		PlaceError(char*);
public:
	Place();
	Place(int);
	Place(const Place&);
	Place(char*, int, PlaceType, KindOfCap, const Cell*);
	Place(char*, int,            KindOfCap, const Cell*);
	Place(char*, int, PlaceType, KindOfCap, const Cell*, token_multiset*);
	Place(char*, int,            KindOfCap, const Cell*, token_multiset*);
	~Place() { Clear(); } 

	//-----------------------------------------------------------------------------
	// 	Delete	
	//-----------------------------------------------------------------------------
	void     	Clear();

	//-----------------------------------------------------------------------------
	// 	"Getten" 
	//-----------------------------------------------------------------------------
	int		GetPlaceNo();
	Cell*&   	GetCapacity();
	KindOfCap	GetKindOfCap();
	PlaceType	GetPlaceType();
	Textual  	GetPlaceName();
	PlaceHeader*	GetPlaceHeader();
	token_multiset*	Gettoken_multiset();

	//-----------------------------------------------------------------------------
	// 	Modifizieren 
	//-----------------------------------------------------------------------------
	void		Changetoken_multiset(token_multiset*);
	void     	ChangePlaceType(PlaceType);
	void	 	ChangeKindOfCap(KindOfCap);
	void     	ChangeCapacity(const Cell*);

	//-----------------------------------------------------------------------------
	// 	Operatoren 
	//-----------------------------------------------------------------------------
	Place&	 	operator =(const Place&);
	bool	 	operator==(Place&);
	bool	 	operator!=(Place&);

	//-----------------------------------------------------------------------------
	// 	Listen-Operatoren
	//-----------------------------------------------------------------------------
	static	bool	LessThan(Place&);
	char*		GetName();

	//-----------------------------------------------------------------------------
	// 	Consistence/Cap/TMS-Checks
	//-----------------------------------------------------------------------------
	bool		TMSIsInPlace(token_multiset*);
	bool		ColorConsistent(int);
	bool		EnoughCapacity();
	bool		EnoughCapacity(int);
};
//######################################################################################
#endif
