#ifndef __PlaceHeader_CC__
#define __PlaceHeader_CC__

#include "Identifier.h"
#include "Textual.h"
#include "token_multiset.h"

#include "PlaceHeader.h"

//###############################################################################################################
PlaceHeader::PlaceHeader() 					
		: 	name(DEF_TXT_NAME), 	
			no(0)
			{ tms = NULL; }

PlaceHeader::PlaceHeader(int)					
		: 	name(DEF_TXT_NAME), 	
			no(0) 	
			{ tms = NULL; }

PlaceHeader::PlaceHeader(char* n)				
		: 	name(n), 		
			no(0) 	
			{ tms = NULL; }

PlaceHeader::PlaceHeader(char* n, int nr)			
		: 	name(n), 		
			no(nr) 	
			{ tms = NULL; }

PlaceHeader::PlaceHeader(const PlaceHeader& p)			
		: 	name(p.name), 	
			no(p.no)
			{ tms = p.tms; }

PlaceHeader::PlaceHeader(char* n, int nr, token_multiset* t)	
		: 	name(n), 		
			no(nr)  
			{ tms = t; }

PlaceHeader::PlaceHeader(char* n, int nr, token_multiset& t)	
		: 	name(n), 	   
			no(nr)  
			{ tms = &t; }

//###############################################################################################################
int		PlaceHeader::GetPlaceNo()				{ return no;		 	 	}
Textual&	PlaceHeader::GetPlaceName()				{ return name;			 	}
char*		PlaceHeader::GetName()					{ return name.GetChar(); 	 	}
bool		PlaceHeader::LessThan(PlaceHeader&)			{ return false; 	 		}
bool		PlaceHeader::operator!=(PlaceHeader& p)			{ return !(*this == p); 		}
bool		PlaceHeader::operator==(PlaceHeader& p)			{ return (no==p.no && name==p.name); 	}
void		PlaceHeader::Clear()					{ name.Clear(); tms = NULL; 		}
//---------------------------------------------------------------------------------------------------------------
void		PlaceHeader::Changetoken_multiset(token_multiset*& t) 	
{ 
	if (!t)   { tms = NULL; return; }

	tms = NULL;
	tms = t; 
}
//---------------------------------------------------------------------------------------------------------------
PlaceHeader&	PlaceHeader::operator =(const PlaceHeader& p)    	
{ 
	Clear();
	name	= p.name; 
	no	= p.no; 
	tms	= p.tms; 
	return *this; 
}
//---------------------------------------------------------------------------------------------------------------
token_multiset*	PlaceHeader::Gettoken_multiset()					
{ 
	if (tms) return tms;		 
	else	 return NULL; 
}
//###############################################################################################################
#endif
