#ifndef	__PTRLIST_H__
#define __PTRLIST_H__

extern "C" {
#include <strings.h>
}
#include "Types.h"
//#################################################################################################
template<class T> class PtrListElement
{
public:
	T*			plelement;
	PtrListElement<T>* 	next;

	PtrListElement();
	PtrListElement(T*);
	PtrListElement(T*, PtrListElement<T>*);
	PtrListElement(const PtrListElement<T>&);

	// setzt nur lelement gleich
	PtrListElement<T>& operator =(const PtrListElement<T>& le);

};

//#################################################################################################
template<class T> class PtrList
{
public:
	int	 	 	size;
	PtrListElement<T>*	first;
	PtrListElement<T>*	last;

	PtrList();
	PtrList(T*);
	PtrList(const PtrList<T>&);
	PtrList(const PtrList<T>&, const PtrList<T>&);
	~PtrList() { Clear(); }

	void     Clear();				// deletes all elements 
	//-----------------------------------------------------------------------------------------
	// 	Elemente hinzufuegen
	//-----------------------------------------------------------------------------------------
	int Append	         (T*);			// returns pos 
	int UniqueAppend         (T*);			// returns -pos if "e" already exists
	T*  UniqueRefAppend      (T*);			// returns NULL if "e" already exists
	T*  UniqueRefAppendInvers(T*);			// returns NULL if "e" doesn't exists

	//-----------------------------------------------------------------------------------------
	// 	Listen-Elemente loeschen
	//-----------------------------------------------------------------------------------------
	int DeleteElement(T*);				// returns old pos of deleted element or -1
	int DeleteElement(int pos);			// returns old pos of deleted element or -1

	//-----------------------------------------------------------------------------------------
	// 	Listen-Elemente manipulieren
	//-----------------------------------------------------------------------------------------
	int  ChangeElement(T* old_e, T* new_e);   	// returns pos or -1 
	int  ChangeElement(int pos,  T* new_e);		// returns pos or -1 

	//-----------------------------------------------------------------------------------------
	// 	Listen-Elemente ausgeben 
	//-----------------------------------------------------------------------------------------
	int      GetPos(T*);				// returns pos or -1
	T* 	 GetElement(T*);			// returns lelement or NULL 
	T* 	 GetElement(char*);			// returns lelement or NULL 
	T* 	 GetElement(int pos);			// returns lelement or NULL 

	//-----------------------------------------------------------------------------------------
	// 	Checks	
	//-----------------------------------------------------------------------------------------
	bool	IsIn(T*);				// true if "T" is in list
	bool	IsIn(char*);				// true if "T->GetName() == char*"

	//-----------------------------------------------------------------------------------------
	// 	Benoetigte Operatoren
	//-----------------------------------------------------------------------------------------
	PtrList<T>& 	operator =(const PtrList<T>& list) ; 
	bool     	operator==(PtrList<T>& list) ;
	bool     	operator!=(PtrList<T>& list) ;
}; 
//#################################################################################################
#endif
