#ifndef __ReferenzLists_cc__
#define __ReferenzLists_cc__

#include "Identifier.h"
#include "Textual.h"
#include "TextualList.h"

#include "token_multiset.h"
#include "PlaceHeader.h"
#include "PlaceHeaderPtrList.h"

#include "Token.h"
#include "TokenList.h"

#include "CellVal.h"
#include "Cell.h"

#include "Place.h"
#include "PlaceList.h"
#include "PlacePtrList.h"

#include "Delay.h"
#include "DelayVal.h"

#include "state_transition.h"

#include "Marking.h"
#include "MarkingList.h"
#include "MarkingPtrList.h"

#include "NonPersistentMarking.h"
#include "NonPersistentMarkingList.h"

#include "SMCLists.h"
#include "ListOfSMCLists.h"

#include "SocketPortPair.h"
#include "SocketPortList.h"

#include "Transition.h"
#include "TransitionList.h"
#include "TransitionPtrList.h"

#include "Definition.h"
#include "DefinitionList.h"

#include "Page.h"
#include "PageList.h"

//###########################################################################
//--------------------------------------------------------------------------
//		"feste" Referenz-Elemente
//--------------------------------------------------------------------------
TokenList		TokenRefList;

DefinitionList		DefinitionRefList;
DefinitionList		EvalRefList;

PlaceList		PlaceRefList;
PlacePtrList		PlaceCapDepRefList;
PlaceHeaderPtrList	PlaceHeaderPtrRefList;
SocketPortList		SocketPortRefList;

TextualList		TransitionNameRefList;
TransitionList		GeneralTransitionRefList;
TransitionList		InfiniteTransitionRefList;
TransitionList		ImmediateTransitionRefList;
TransitionList		ExclusiveTransitionRefList;

PageList		PageRefList;

ListOfSMCLists		DetMarkingListList;
ListOfSMCLists		GenMarkingListList;
//--------------------------------------------------------------------------
//		Hashs	
//--------------------------------------------------------------------------
MarkingList**			Hash;
NonPersistentMarkingList**	ImmHash;
//###########################################################################
#endif
