#ifndef __SMCLISTS_H__
#define __SMCLISTS_H__

#include "Types.h"
//############################################################################
class SMCLists
{
	int		transition_ref;
	int		no_states;
	int		first_state_no;
	int		no_preempting_arcs;
public:
	MarkingPtrList	det_or_gen_markings;

	SMCLists();
	SMCLists(int);
	SMCLists(const SMCLists&);
	~SMCLists() { Clear(); }

	//---------------------------------------------------------------------
	//	clear
	//---------------------------------------------------------------------
	void	Clear();

	//---------------------------------------------------------------------
	//	"getten"
	//---------------------------------------------------------------------
	int	GetTransitionRef();
	int 	GetNoOfStates();
	int	GetFirstStateNumber();
	int 	GetNoOfPreemptingArcs();
	double	GetDetOrGenDelay();

	//---------------------------------------------------------------------
	//	modifizieren
	//---------------------------------------------------------------------
	void	SetNoOfStates(int);
	void	SetFirstStateNumber(int);
	void	SetNoOfPreemptingArcs(int);
	void	ChangeTransitionRef(int);

	//---------------------------------------------------------------------
	//	operatoren
	//---------------------------------------------------------------------
	SMCLists&	operator =(const SMCLists&);
	bool		operator==(SMCLists&);
	bool		operator!=(SMCLists&);

	//---------------------------------------------------------------------
	//	"listen-operatoren"
	//---------------------------------------------------------------------
	static bool	LessThan(SMCLists&);
	static char*	GetName();

};
//#############################################################################
#endif

