#ifndef __SocketPortPair_cc__
#define __SocketPortPair_cc__

#include "Identifier.h"
#include "Textual.h"
#include "TextualList.h"

#include "token_multiset.h"
#include "PlaceHeader.h"

#include "Token.h"

#include "CellVal.h"
#include "Cell.h"

#include "Place.h"
#include "SocketPortPair.h"

//###############################################################################################################
SocketPortPair::SocketPortPair()			: port(DEF_TXT_NAME)	{ socket = NULL; 		}			
SocketPortPair::SocketPortPair(int)			: port(DEF_TXT_NAME)    { socket = NULL; 		}
SocketPortPair::SocketPortPair(Place* s, char* p)	: port(p)		{ socket = s;	 		}
SocketPortPair::SocketPortPair(const SocketPortPair& p) : port(p.port)		{ socket = p.socket;		}
//###############################################################################################################
Textual			SocketPortPair::GetPort()				{ return port;	     	  	}
char*			SocketPortPair::GetName()				{ return port.GetChar();  	}		
Place* 			SocketPortPair::GetSocket()			     	{ return socket;     	  	}
bool			SocketPortPair::LessThan(SocketPortPair&)      		{ return false;      	  	}
bool			SocketPortPair::operator!=(SocketPortPair& p)  		{ return !(*this == p);   	}
void			SocketPortPair::Clear() 				{ port.Clear();  		}
//---------------------------------------------------------------------------------------------------------------
SocketPortPair&	SocketPortPair::operator =(const SocketPortPair& p)
{
	socket = p.socket;
	port   = p.port; 
	return *this;
}
//---------------------------------------------------------------------------------------------------------------
bool		SocketPortPair::operator==(SocketPortPair& p)
{
	if (socket  && !p.socket)	return false;
	if (!socket &&  p.socket)	return false;
	return (port == p.port && *(socket) == *(p.socket));
}

//###############################################################################################################
#endif
