#ifndef __Textual_cc__
#define __Textual_cc__

#include "Textual.h"

//###############################################################################################################
inline void 	Textual::Check(const char* t) 
{ 
	if (t)
	{
		char* tmp; bool correct = true;
    		strcpy(tmp  = new char[strlen(t)+1], t);
 		for (unsigned i=0; i<strlen(tmp); i++) 
		{
    			if (!(isdigit(tmp[i]) || isalpha(tmp[i]) || tmp[i] == '_' || tmp[i] == '\\'))
    	   			correct = false;
		}
		if (correct) strcpy(text = new char[strlen(t)+1], t); 
		else         
		{
			cout <<"Textual : Error in Textual-string : "<<t<<"\n"; 
			exit(TEXTUAL_ERROR); 
		}
		if (tmp) delete[] tmp;
	}
}
//###############################################################################################################
Textual::Textual()		  	: text(NULL) { };
Textual::Textual(int)		  	: text(NULL) { };
Textual::Textual(const char* t)	  	: text(NULL) { Check(t);      }
Textual::Textual(const Textual& t) 	: text(NULL) { Check(t.text); }
//###############################################################################################################
void 		Textual::Clear()			
{ 
	if (text) 
	{ 
		delete[] text; 
		text = NULL; 
	} 
}
//----------------------------------------------------------------------------------------------------------------
Textual& 	Textual::operator =(const char* s)      	{ Clear(); Check(s); return *this; 	} 
Textual& 	Textual::operator =(const Textual& t) 		{ return *this  = t.text; 		} 
bool     	Textual::operator==(char* s)    		{ return (strcmp(text,s) == 0); 	}
bool     	Textual::operator==(Textual& t) 		{ return *this == t.text; 		}
bool     	Textual::operator!=(char* s)    		{ return (strcmp(text,s) != 0);		}
bool     	Textual::operator!=(Textual& t) 		{ return *this != t.text; 		}
bool     	Textual::operator <(char* s)    		{ return (strcmp(text,s)  < 0); 	}
bool     	Textual::operator <(Textual& t) 		{ return *this  < t.text; 		}
bool     	Textual::operator >(char* s)    		{ return (strcmp(text,s)  > 0);	 	}
bool     	Textual::operator >(Textual& t) 		{ return *this  > t.text; 		}
//----------------------------------------------------------------------------------------------------------------
bool	 	Textual::LessThan(Textual& t)			{ return *this < t.text; 		}
char*           Textual::GetName()				{ return DEF_STRING; 			}
char*	 	Textual::GetChar()  const 			{ return text; 				}
//################################################################################################################
#endif

