#ifndef	__Token_cc__
#define	__Token_cc__

#include "Textual.h"
#include "Identifier.h"

#include "Token.h"

//###################################################################################################
Token::Token()				: name(NULL),  version(NULL),     step(NULL)   { };
Token::Token(int)			: name(NULL),  version(NULL),     step(NULL)   { };
Token::Token(char* n, char* v, char* s)	: name(n),     version(v),        step(s)      { };
Token::Token(const Token& t)		: name(t.name),version(t.version),step(t.step) { };
//###################################################################################################
Textual&    Token::GetTokenName()			{ return name; }
char*       Token::GetName()				{ return name.GetChar(); }
Identifier& Token::GetVersion()				{ return version; }
Identifier& Token::GetStep()				{ return step; }
//---------------------------------------------------------------------------------------------------
void	    Token::Clear()				
{ 
	name.Clear();
	step.Clear();
	version.Clear();
}
//---------------------------------------------------------------------------------------------------
void	 Token::ChangeName(const char* n)		{ name    = n; }
void	 Token::ChangeVersion(const char* v)		{ version = v; }
void	 Token::ChangeStep(const char* s)		{ step    = s; }
//---------------------------------------------------------------------------------------------------
void	 Token::ChangeName(const Textual& n)		{ name    = n; }
void	 Token::ChangeVersion(const Identifier& v)	{ version = v; }
void	 Token::ChangeStep(const Identifier& s)		{ step    = s; }
//---------------------------------------------------------------------------------------------------
Token&	 Token::operator =(const Token& t)	
{ 
	name    = t.name; 
	version = t.version; 
	step    = t.step; 
	return *this; 
}
//---------------------------------------------------------------------------------------------------
bool	 Token::operator==(Token& t)	
{ 
	return (name==t.name && version==t.version && step==t.step);
}
//---------------------------------------------------------------------------------------------------
bool	 Token::operator!=(Token& t)	
{ 
	return !(*this==t);
}
//---------------------------------------------------------------------------------------------------
bool	 Token::LessThan(Token& t)	
{
	if (*this == t) return false;
	     if (name    < t.name)    return true;
	else if (version < t.version) return true;
	else if (step    < t.step)    return true;
	return false;
}

//###################################################################################################
#endif
