#ifndef __Transition_h__
#define __Transition_h__

//##########################################################################################
#include "Types.h"
#include "BindingList.h"
//##########################################################################################
class Transition 
{
	Textual      	name;
	ServerType	servertype;
	BindingList*	bindings;
	Cell*		globalcond;
	short		gc_result;
	int		global_ref;

	//---------------------------------------------------------------------------------
	//	Error	
	//---------------------------------------------------------------------------------
	void            TransitionError(Textual&);
public:
	Transition();
	Transition(int);
	Transition(const Transition&);
	Transition(char*, ServerType, const BindingList*, const Cell*);
	~Transition() { Clear(); }

	//---------------------------------------------------------------------------------
	//	Delete
	//---------------------------------------------------------------------------------
	void		Clear();

	//---------------------------------------------------------------------------------
	//	Getten/Calculate	
	//---------------------------------------------------------------------------------
	char*		GetName();
	Textual		GetTransitionName();
	ServerType	GetServerType();
	BindingList*	GetBindings();
	int		GetBindingSize();
	bool		GlobalCondTrue();
	Cell*		GetGlobalCondition();
	int		GetGlobalTransitionRef();

	//---------------------------------------------------------------------------------
	//	Modifizieren
	//---------------------------------------------------------------------------------
	void		SetGlobalTransitionRef(int);

	//---------------------------------------------------------------------------------
	//	Operatoren	
	//---------------------------------------------------------------------------------
	Transition&	operator =(const Transition&);
	bool		operator==(Transition&);
	bool		operator!=(Transition&);
	bool		LessThan(Transition&);
};
//#########################################################################################
#endif

