#ifndef __WritePMFFile_cc__
#define __WritePMFFile_cc__

extern "C" {
#include <stdio.h>
#include <string.h>
}
#include "inc_classes.h"
#include "inc_write_pmf_file.h"

//########################################################################################################################
//
//		Fehlerbehandlung	
//
//########################################################################################################################
void    WriteErr(char* s1, char* s2, int line)
{
	if (s2) RRGErr = new RRGError(__FILE__, s1, line, NULL, s2);
	else	RRGErr = new RRGError(__FILE__, s1, line);
	PrepareEnd();
}
//########################################################################################################################
//
//	Schreibt das fuer die "erand-Prozesse" benoetigte .pmf-file, falls es General-Transitionen gab.	
//
//########################################################################################################################
void	WritePMFFile(char* netname)
{
	if (!no_of_gen_transitions) 		return;
	if (!(GeneralTransitionRefList.size)) 	return;

	FILE* fptr  = NULL;
	char* fname = NULL;

	sprintf(fname = new char[(strlen(netname) + strlen(TmpDir) + 7)], "%s/%s.pmf", TmpDir, netname);

	if (!(fptr = fopen(fname, "w")))
		WriteErr("can't open file", fname, __LINE__);


	for (TransitionListElement* t=GeneralTransitionRefList.first; t; t=t->next)
	{
		fprintf(fptr,"TRANSITION %s\n", t->lelement.GetName());

		BindingList* bl=t->lelement.GetBindings();

		for (BindingListElement* ble=bl->first; ble; ble=ble->next)
		{
			if (ble->lelement.GetDelay()->GetDelayType() == _GENERAL)
			{
				ble->lelement.GetDelay()->PrintPMF(fptr);
				fprintf(fptr,";\n\n");
				break;
			}
		}
	}
	// fprintf(fptr,"%c",EOF);
	fclose(fptr);
}
//########################################################################################################################
#endif
