#ifndef __inc_info_h__
#define __inc_info_h__

//###########################################################################################################
//
// 	Informationen ueber die Rechner aus dem Environmentfile
//
//###########################################################################################################
typedef struct hostinfo
{       
	struct hostinfo *next;                 	/* naechster Eintrag 				           */
	char            *hostname;             	/* Rechnername 					           */
	unsigned short  running_processes;      /* Anzahl laufender Rand-Prozesse 		           */
	long            load;                   /* Auslastung des Rechners 	     		           */
	unsigned        priority;               /* Prioritaet zur Benutzung dieses Rechners 	           */
	bool            no_rusers;              /* rusers-Aufruf absetzen ? (DEC ohne rusers-daemon)       */
	bool            free;                   /* Rechner unbenutzt ? 				           */
}  hostinfo;

//###########################################################################################################
//
// 	Informationen fuer die Rand-Prozesse 
//
//###########################################################################################################
typedef struct randinfo
{       
	double          	tau;
	double          	max_qii;
	double          	effort;
	unsigned        	kb_per_sec;
	unsigned        	eta;
	SMCLists*		smcs;
	hostinfo*       	host;
	int             	connection_fd;
	FILE*           	connection_fp;
	ProcStatus		status;
} randinfo;

//###########################################################################################################
//
//	Zusammenfassung einiger Uebergabeparameter
//
//###########################################################################################################
typedef struct execinfo
{
	double		epsilon;
	int		server_fd;
	unsigned short 	portnumber;
	char*		model_name;
	hostinfo*	hostlist;
	hostinfo*	local_host;
	int		no_det_trans;
	char*		local_hostname;
	randinfo*	rand_info_array;
	double		sum_of_rusage_times;
	bool		distributed_execution;
	unsigned	max_processes_per_host;
} execinfo;

//###########################################################################################################
#endif
