#ifndef __inc_lex_yacc_globals_h__
#define __inc_lex_yacc_globals_h__

extern "C" {
#include <stdlib.h>
#include <string.h>
#include <errno.h>
}
#include "inc_classes.h"

//#############################################################

//-------------------------------------------------------------
//	extern var's and referencelists
//-------------------------------------------------------------
extern PlaceHeaderPtrList	PlaceHeaderPtrRefList;
extern SocketPortList  	 	SocketPortRefList;
extern PlacePtrList		PlaceCapDepRefList;
extern PlaceList		PlaceRefList;

extern DefinitionList   	DefinitionRefList;
extern DefinitionList		EvalRefList;

extern PageList			PageRefList;
extern TokenList		TokenRefList;

extern TextualList		TransitionNameRefList;
extern TransitionList		ExclusiveTransitionRefList;
extern TransitionList		ImmediateTransitionRefList;
extern TransitionList		InfiniteTransitionRefList;
extern TransitionList		GeneralTransitionRefList;

extern ListOfSMCLists		DetMarkingListList;
extern ListOfSMCLists		GenMarkingListList;

extern int			no_of_det_transitions;
extern int			no_of_exp_transitions;
extern int			no_of_imm_transitions;
extern int			no_of_gen_transitions;
extern int			no_of_mix_transitions;
extern int			no_of_trans;
extern int			place_no;

extern char*			yytext;
extern char*			table_string;
extern RRGError*		RRGErr;

//-------------------------------------------------------------
//	system dependencies	
//-------------------------------------------------------------
#if defined(__linux__) || defined(LINUX) || defined (Linux)
extern int yylineno;
extern "C" { int   fileno	(FILE*);		}
extern "C" { char* index	(const char*, int);     }
extern "C" { char* rindex	(const char*, int);	}
#else
int yylineno = 0;
#endif

#ifdef SOL2
extern "C" { int   fileno	(FILE*);		}
#endif

//-------------------------------------------------------------
//	extern functions 
//-------------------------------------------------------------
extern	void			PrepareEnd();

extern "C" { double	strtod(const char*, char**);	  }
extern "C" { long int	strtol(const char*, char**, int); }

//-------------------------------------------------------------
//	global  lex/yacc var's (mainly lex)
//-------------------------------------------------------------
typedef enum 
{ 
	no_sec,
	def_sec,    
	def_end,
	param_sec,  
	param_end,  
	eval_sec,
	eval_end,
	page_sec, 
	eplace_sec, 
	pplace_sec, 
	trans_sec
} Section;

Section 	section			= no_sec;
char*		actual_commend		= NULL;
char*   	actual_definition  	= NULL;
char*		actual_page_name   	= NULL;
char*		actual_subpage_name   	= NULL;
char*		master_page_name   	= NULL;
int     	lcount 			= 1;
bool		root_found   		= false;

//##############################################################
#endif
