#ifndef __marking_and_delay_list_cc__
#define __marking_and_delay_list_cc__

#include "token_multiset.h"
#include "DelayVal.h"
#include "state_transition.h"
#include "Marking.h"
#include "marking_and_delay_list.h"

//#########################################################################################
void	init_mdl(marking_and_delay_list& mpl)
{
	mpl.first = NULL;
}
//-----------------------------------------------------------------------------------------
void	clear_mdl(marking_and_delay_list& mpl)
{
	if (!(mpl.first)) return;

	if (!(mpl.first->next))
	{
		mpl.first->delay.Clear();
		mpl.first->marking->Clear();
		delete mpl.first->marking;
		mpl.first->marking = NULL;

		delete mpl.first;
		mpl.first = NULL;

		return;
	}

	for (m_element* h=mpl.first->next; h; h=h->next)
	{
		mpl.first->delay.Clear();
		mpl.first->marking->Clear();
		delete mpl.first->marking;
		mpl.first->marking = NULL;

		delete mpl.first;
		mpl.first = NULL;

		mpl.first = h;
	}
	mpl.first->delay.Clear();
	mpl.first->marking->Clear();
	delete mpl.first->marking;
	mpl.first->marking = NULL;

	delete mpl.first;
	mpl.first = NULL;
}
//-----------------------------------------------------------------------------------------
void	append(marking_and_delay_list*& mpl, Marking*& m, DelayVal& d)
{
	if (!m) return;

	if (!mpl) 
	{
		mpl        = new marking_and_delay_list;
		mpl->first = NULL; 
	}
	if (!(mpl->first)) 
	{
		mpl->first          = new m_element;
		mpl->first->marking = m;
		mpl->first->delay   = d;
		mpl->first->next    = NULL;
		return;
	}

	m_element* new_e = new m_element;
	new_e->marking   = m;
	new_e->delay     = d;
	new_e->next      = mpl->first;
	mpl->first	 = new_e;
}
//#########################################################################################
#endif
