
# line 2 "MSAnalysis/src/pars.y"
#include "inc_classes.h" 
#include "inc_lex_yacc_globals.h" 

char* 	StripOfPath	 	(char*);
//-----------------------------------------------------------------
//	Error-handling
//-----------------------------------------------------------------
void 	yyerror			(char*);
void 	YaccError		(char*, char*);
//-----------------------------------------------------------------
//	Checks und "getten"	
//-----------------------------------------------------------------
void	CheckAndCountTransition (char*, ServerType, BindingList*&);
Place*	CheckIfPortGetRef	(char*);
char*	CheckIfPortGetName	(char*);
char* 	GetNumberString		(int);
int 	GetNumberSize		(int);
Place*	GetPlaceRef		(char*);
//-----------------------------------------------------------------
//	"kreieren"	
//-----------------------------------------------------------------
char*	MakePortName	 	(char*);
void	MakeActualPageName	(char*);
void	MakeActualSubPageName	(char*);
Place*	SavePlace		(Place*&, PlaceType);
void	SaveDefinition		(Definition*&);
void	SaveTransition		(Transition*&);
void	SaveSubTransition	(char*);
Page*	CheckAndSavePage	(char*);



# line 34 "MSAnalysis/src/pars.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{	
	//-----------------------------------------------
	//	"elmentare" typen
	//-----------------------------------------------
	double  		d_val;
	int     		i_val;
	char*   		s_val;
	TokenRef		_TokenRef;	
	ServerType		_ServerType;
	Operator		_Operator;
	//-----------------------------------------------
	//	"elmentare" Klassen
	//-----------------------------------------------
	Identifier*		_IdentifierPtr;
	Textual*		_TextualPtr;
	Delay*			_DelayPtr;
	Cell*			_CellPtr;
	//-----------------------------------------------
	// 	Transitionsbestandteile
	//-----------------------------------------------
	ArcBindElement*		_ArcBindElementPtr;
	ArcBindList*		_ArcBindListPtr;
	arc_binding*		_arc_binding_ptr;
	BindingElement*		_BindingElementPtr;
	BindingList*		_BindingListPtr;
	//-----------------------------------------------
	// 	Transitions Klassen
	//-----------------------------------------------
	Transition*		_TransitionPtr;
	TransitionList*		_TransitionListPtr;
	//-----------------------------------------------
	// 	Stellen Klassen
	//-----------------------------------------------
	Place*			_PlacePtr;
	PlaceList*		_PlaceListPtr;
	PlacePtrList*		_PlacePtrListPtr;
	PlaceHeaderList*	_PlaceHeaderListPtr;
	//-----------------------------------------------
	// 	Definitions Klassen
	//-----------------------------------------------
	Definition*		_DefinitionPtr;
	DefinitionList*		_DefinitionListPtr;
	//-----------------------------------------------
	// 	"die" Seiten	
	//-----------------------------------------------
	Page*			_PagePtr;
} YYSTYPE;
# define INT_CONST 257
# define REAL_CONST 258
# define STRING 259
# define COMMA 260
# define POINT 261
# define DOUBLEPOINT 262
# define SEMICOLON 263
# define QUESTIONMARK 264
# define OPEN_I 265
# define OPEN_II 266
# define OPEN_III 267
# define CLOSE_I 268
# define CLOSE_II 269
# define CLOSE_III 270
# define PLUS 271
# define MINUS 272
# define DIVIDE 273
# define MULTIPLY 274
# define RAUTE 275
# define TIMES 276
# define AT 277
# define NOT 278
# define AND 279
# define OR 280
# define WAHR 281
# define FALSCH 282
# define EQUAL 283
# define LESS 284
# define GREATER 285
# define NOT_EQUAL 286
# define LESS_OR_EQUAL 287
# define GREATER_OR_EQUAL 288
# define EXPONENTIAL 289
# define DETERMINISTIC 290
# define GENERAL 291
# define IMMEDIATE 292
# define UNIFORM 293
# define TRANSITION 294
# define DEFINITION 295
# define ELEMENTARYPLACE 296
# define PRODUCTPLACE 297
# define PAGE 298
# define PARAMETER 299
# define EVALUATE 300
# define E 301
# define ES 302
# define IS 303
# define IF 304
# define INARC 305
# define OUTARC 306
# define ARROW 307
# define ASSIGN 308
# define SUBPAGE 309
# define LOGIC 310
# define NUMERIC 311
# define E_MSET 312
# define P_MSET 313
# define C_FUNCTION 314
# define A_FUNCTION 315
# define EXPECT_OPEN 316
# define PROB_OPEN 317
# define TP_OPEN 318

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 1039 "MSAnalysis/src/pars.y"

#include "scan.cc"

/*------------------------------------------------------------------------------------------------------------------*/
/*	 Stelle in der PlaceRefList anhand des Stellennamens ermitteln und Pointer auf diese Stelle zurueckgeben    */
/*------------------------------------------------------------------------------------------------------------------*/
Place*	GetPlaceRef(char* placename)
{
	if (!PlaceRefList.size) YaccError("can't get placeref, PlaceRefList is empty", placename);

	for (PlaceListElement* place=PlaceRefList.first; place; place=place->next)
		if (strcmp(place->lelement.GetName(), placename) == 0) 
			return &(place->lelement);

	YaccError("can't get placeref, placename not found", placename);
}
/*------------------------------------------------------------------------------------------------------------------*/
/*	Ueberpruefen ob placename eine Portstelle ist								    */
/*		ja : dazugehoerige Socketstellenamen zurueckgeben						    */
/*	      nein : PlaceRefList nach placename durchsuchen 							    */
/*------------------------------------------------------------------------------------------------------------------*/
char*	CheckIfPortGetName(char* placename)
{
	if (SocketPortRefList.size)
	{
		for (SocketPortListElement* sp=SocketPortRefList.first; sp; sp=sp->next)
			if (sp->lelement.GetPort() == placename)
				return sp->lelement.GetSocket()->GetName();
	}

	if (!PlaceRefList.size) return placename; 

	for (PlaceListElement* place=PlaceRefList.first; place; place=place->next)
		if (strcmp(place->lelement.GetName(), placename) == 0) 
			return placename;

	return placename;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*	Ueberpruefen ob placename eine Portstelle ist								    */
/*		ja : dazugehoerige Socketstelle zurueckgeben							    */
/*	      nein : placename in PlaceRefList suchen								    */
/*------------------------------------------------------------------------------------------------------------------*/
Place*	CheckIfPortGetRef(char* placename)
{
	if (SocketPortRefList.size)
	{
		for (SocketPortListElement* sp=SocketPortRefList.first; sp; sp=sp->next)
			if (sp->lelement.GetPort() == placename) 
				return sp->lelement.GetSocket();
	}
	return (GetPlaceRef(placename));
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 portnamen bauen					  				            */
/*------------------------------------------------------------------------------------------------------------------*/
char*	MakePortName(char* str)
{
	char*   local_port_name   = StripOfPath(str);
	char*   absolut_port_name = new char[strlen(actual_subpage_name)+strlen(local_port_name)+3];
	sprintf(absolut_port_name, "%s\\%s", actual_subpage_name, local_port_name);
	return absolut_port_name;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 aktuellen Seitennamen setzen				  				            */
/*------------------------------------------------------------------------------------------------------------------*/
void	MakeActualPageName(char* pagename)
{
	if (actual_page_name) 
	{
		delete[] actual_page_name;
		actual_page_name = NULL;
	}
	strcpy(actual_page_name = new char[strlen(pagename)+1],pagename);
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 aktuellen Subpagenamen kreieren			  				            */
/*------------------------------------------------------------------------------------------------------------------*/
void	MakeActualSubPageName(char* sub_page_name)
{
	if (actual_subpage_name) 
	{ 
		delete actual_subpage_name; 
		actual_subpage_name = NULL; 
	}
	strcpy(actual_subpage_name = new char[strlen(sub_page_name)+1],sub_page_name);
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 Seite ueberpruefen und ggf. speichern			  				            */
/*------------------------------------------------------------------------------------------------------------------*/
Page*	CheckAndSavePage(char* pagename)
{
	if (strcmp(pagename,"\\__ROOT__") == 0)
	{
		if (root_found)	YaccError("double definition of root-page", pagename);
		else 		 root_found = true;
	}
	else
	{
		if (!root_found)	YaccError("subpage-definition before root-page-definition", pagename);

		bool master_found = false;
		for (PageListElement* p=PageRefList.first; p; p=p->next)
		{
			if (p->lelement.IsSubPage(pagename)) 
			{ 
				master_found = true; 
				break; 
			}
		}
		if (!master_found)	YaccError("subpage is not referenced before its definition", pagename);
	}

	MakeActualPageName(pagename);
	Page* p = NULL;
	if (!(p = PageRefList.UniqueNameAppend(*(new Page(pagename))))) 
		YaccError("Page exists",pagename);
	return p;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 Stelle abspeichern			  				            		    */
/*------------------------------------------------------------------------------------------------------------------*/
Place*	SavePlace(Place*& p, PlaceType pt)
{
	Place* place = NULL;

	p->ChangePlaceType(pt);
	if (!(SocketPortRefList.GetElementPtr(p->GetName())))
	{
		if ( !(place=PlaceRefList.UniqueNameAppend(*p)) )
			YaccError("Place exists : ",p->GetName());

		if ( (place->GetCapacity()->IsPlaceDependent()) )
			PlaceCapDepRefList.Append(place);

		PlaceHeaderPtrRefList.Append(place->GetPlaceHeader());
	}
	p->Clear();
	delete p;

	return place;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 Definition abspeichern		  				            		    	    */
/*------------------------------------------------------------------------------------------------------------------*/
void	SaveDefinition(Definition*& d)
{
	if (!(DefinitionRefList.UniqueNameAppend(*d)))
		YaccError("Definition allready exists : ", d->GetVar().GetChar());
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 SubTransition abspeichern		  				            		    */
/*------------------------------------------------------------------------------------------------------------------*/
void	SaveSubTransition(char* sub_t_name)
{
	Textual	txt_sub_t_name(sub_t_name);

	if ((TransitionNameRefList.UniqueAppend(txt_sub_t_name)) < 0)
		YaccError("SubTransitionName exists", sub_t_name);
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 Transition abspeichern			  				            		    */
/*------------------------------------------------------------------------------------------------------------------*/
void	SaveTransition(Transition*& t)
{ 
	bool 	t_saved = false;
	char* 	t_name  = t->GetName();
	Textual txt_t_name(t_name);

	/*----------------------------------------------------------------------------------*/
	/*      Transition bekommt globale Referenz zugeordnet                              */
	/*----------------------------------------------------------------------------------*/
	no_of_trans++;
	t->SetGlobalTransitionRef(no_of_trans);

	/*----------------------------------------------------------------------------------*/
	/*      Gab's den Namen schon (Vorsicht auch Subtransitionen beachten)              */
	/*----------------------------------------------------------------------------------*/
	if ((TransitionNameRefList.UniqueAppend(txt_t_name)) < 0)
		YaccError("TransitionName allready exists in this net ", t_name);

	/*----------------------------------------------------------------------------------*/
	/*      Transition in bestimmte Liste einordnen und                                 */
	/*      eine neue Liste fuer die Markierungen dieser Transition reservieren         */
	/*----------------------------------------------------------------------------------*/
	if (t->GetBindings()->first->lelement.GetDelay()->GetDelayType() == _IMMEDIATE)
	{
		ImmediateTransitionRefList.Append(*t); 
		t_saved = true;
	}
	else
	{
		bool one_det_found = false;
		bool one_gen_found = false;

		for (BindingListElement* ble=t->GetBindings()->first; ble; ble=ble->next)
		{
			if (ble->lelement.GetDelay()->GetDelayType() == _DETERMINISTIC)
			{
				if (one_det_found)
					YaccError("more than one det-statetransition in transition",t_name);
				DetMarkingListList.UniqueAppend(*(new SMCLists(no_of_trans)));
				one_det_found = true;
				continue;
			}

			if (ble->lelement.GetDelay()->GetDelayType() == _GENERAL)
			{
				if (one_gen_found)
					YaccError("more than one gen-statetransition in transition",t_name);
				GenMarkingListList.UniqueAppend(*(new SMCLists(no_of_trans)));
				GeneralTransitionRefList.Append(*t);
				one_gen_found = true;
				continue;
			}
		}
	}
	if (!t_saved)
	{
		switch (t->GetServerType())
		{
			case Exclusive : ExclusiveTransitionRefList.Append(*t);  	break;
			case Infinite  : InfiniteTransitionRefList.Append(*t);   	break;
			default        : YaccError("can't save transition",t_name); 	break;
		}
	}
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 Transition ueberpruefen und Typ zaehlen							    */
/*------------------------------------------------------------------------------------------------------------------*/
void	CheckAndCountTransition(char* t_name, ServerType st, BindingList*& bl)
{
	if (bl && bl->first)
	{
		int dt = bl->first->lelement.GetDelay()->GetDelayType(); 

		if (st == Infinite && ( dt == _DETERMINISTIC ) )
			YaccError("IS-transition with det-delay", t_name);

		if (st == Infinite && ( dt == _GENERAL) )
			YaccError("IS-transition with gen-delay", t_name);

		for (BindingListElement* ble=bl->first; ble; ble=ble->next)
		{
			switch (ble->lelement.GetDelay()->GetDelayType())
			{
				case _GENERAL	   : 
					if (st == Infinite) 	  YaccError("IS-transition with gen-delay", t_name);
					if (dt == _IMMEDIATE) 	  YaccError("delay-type mixture (gen/imm)", t_name); 
					if (dt == _DETERMINISTIC) YaccError("delay-type mixture (gen/det)", t_name); 
					if (dt != _GENERAL) 	  dt = _MIXED;
					break;
				case _DETERMINISTIC : 	
					if (st == Infinite)  	  YaccError("IS-transition with det-delay", t_name);
				      	if (dt == _GENERAL) 	  YaccError("delay-type mixture (det/gen)", t_name); 
				      	if (dt == _IMMEDIATE) 	  YaccError("delay-type mixture (det/imm)", t_name); 
					if (dt != _DETERMINISTIC) dt = _MIXED;
					break;
				case _EXPONENTIAL   :
					if (dt == _IMMEDIATE) 	  YaccError("delay-type mixture (exp/imm)", t_name); 
					if (dt != _EXPONENTIAL)   dt = _EXPONENTIAL;
					break;
				case _IMMEDIATE     : 
					if (dt != _IMMEDIATE) 	  YaccError("delay-type mixture (xxx/imm)", t_name); 
					break;
				default		    : 		  YaccError("unknown delay", t_name);
			}
		}
		switch (dt)
		{
			case _GENERAL       : no_of_gen_transitions++; break;
			case _EXPONENTIAL   : no_of_exp_transitions++; break;
			case _DETERMINISTIC : no_of_det_transitions++; break;
			case _IMMEDIATE     : no_of_imm_transitions++; break;
			case _MIXED	    : no_of_mix_transitions++; break;
			default             : YaccError("unknown delay", t_name);
		}
	}
}
/*------------------------------------------------------------------------------------------------------------------*/
/*		 pfad vom gesuchten String abtrennen und string zurueckgeben					    */
/*------------------------------------------------------------------------------------------------------------------*/
char* 	StripOfPath(char* str)
{
	if (!str)		yyerror  ("can't strip of path");
	if (*str != '\\')	YaccError("can't strip of path; path does not begin with \\", str);

	char* tmp_str = NULL;
	char* ret_str = NULL;

	if (!(tmp_str = rindex(str, '\\'))) YaccError("can't strip of path; rindex()", str);
	tmp_str++;
	strcpy (ret_str = new char[(strlen(tmp_str) + 2)], tmp_str);
	return (ret_str);
}
/*------------------------------------------------------------------------------------------------------------------*/
/*			int in char* umwandeln					    				    */
/*------------------------------------------------------------------------------------------------------------------*/
char* 	GetNumberString(int number)
{
	int   number_size = GetNumberSize(number);
	int   rest 	  = 0;
	char* c1   	  = new char[number_size+2](NULL);

	*c1++ = '\0';
	while (number/10 >= 1.0)
	{
		rest   = number % 10;
		number = number / 10 - rest / 10;
		*c1++  = char(rest+48);
	}
	*c1++ = char(number+48);
	*c1   ='\0';

	char* c2 = new char[sizeof(c1)+1](NULL);
	char* c3 = c2;

	for (c1--; *c1 != '\0';) *c2++ = *c1--;
	*c2 = '\0';
	return c3;
}
/*------------------------------------------------------------------------------------------------------------------*/
/*			groesse eines int ermitteln 					    			    */
/*------------------------------------------------------------------------------------------------------------------*/
int 	GetNumberSize(int number) 
{
        int number_size=0;
	for (number_size = 0; number/10 >= 1.0; number = number/10 - (number%10)/10, number_size++);
	return number_size;
}

/*------------------------------------------------------------------------------------------------------------------*/
/*			fehlerausgabe						    				    */
/*------------------------------------------------------------------------------------------------------------------*/
void 	yyerror(char* s)
{
	YaccError(s, NULL);
}
/*------------------------------------------------------------------------------------------------------------------*/
void 	YaccError(char* s1, char* s2)
{
  switch (section)
  {
	case eplace_sec : RRGErr=new RRGError(PARS,s1,lcount,"ElementaryPlace",actual_commend,s2,yytext); break;
	case pplace_sec : RRGErr=new RRGError(PARS,s1,lcount,"ProductPlace",   actual_commend,s2,yytext); break; 
	case def_sec    : RRGErr=new RRGError(PARS,s1,lcount,"Definition",     actual_commend,s2,yytext); break;
	case trans_sec  : RRGErr=new RRGError(PARS,s1,lcount,"Transition",     actual_commend,s2,yytext); break;
	case def_end    : RRGErr=new RRGError(PARS,s1,lcount,"Parameter",      actual_commend,s2,yytext); break;
	case param_sec  : RRGErr=new RRGError(PARS,s1,lcount,"Parameter",      actual_commend,s2,yytext); break;
	case eval_end   : RRGErr=new RRGError(PARS,s1,lcount,"Parameter",      actual_commend,s2,yytext); break;
	case eval_sec   : RRGErr=new RRGError(PARS,s1,lcount,"Evaluate",       actual_commend,s2,yytext); break;
	case param_end  : RRGErr=new RRGError(PARS,s1,lcount,"Page",           actual_commend,s2,yytext); break;
	case page_sec   : RRGErr=new RRGError(PARS,s1,lcount,"Page",           actual_commend,s2,yytext); break;
	default         : RRGErr=new RRGError(PARS,s1,lcount,"unknown",        actual_commend,s2,yytext); break;
  }
  PrepareEnd();
}
/*------------------------------------------------------------------------------------------------------------------*/
static const yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 204
# define YYLAST 1076
static const yytabelem yyact[]={

   129,   374,   303,   308,   311,   350,    68,   310,   305,   251,
    61,    62,   120,   304,   301,   251,   247,   345,   124,   312,
    78,   313,   312,   307,   212,   125,   236,    37,    76,    83,
    80,   130,   154,   226,   120,    65,   102,   103,   238,   120,
   153,   225,   226,    30,   141,    62,    10,   119,   123,   313,
   312,     4,   139,   304,    79,   313,   312,    22,    39,   140,
    20,   235,    76,   306,    42,    69,    66,    71,    63,    73,
    74,    75,    28,   237,   138,   386,    79,    79,   118,   122,
   385,   212,   251,   341,    26,   152,    79,   151,   148,   154,
    25,   120,   167,   169,   173,   175,   176,   240,    42,   218,
    19,    20,    63,    30,   131,   182,   182,   182,   185,   187,
   189,   191,   193,   231,   149,   208,   209,   210,   232,   252,
   253,    32,   154,   166,   120,   204,   123,   102,   205,   206,
   280,   278,   239,    79,   141,    62,   179,   183,   184,   214,
   233,   234,   170,   224,   228,   131,   251,   248,   230,   171,
   359,    32,    76,   339,   242,   338,   203,   122,   334,   122,
   118,   102,   103,   102,   103,   255,    79,    19,   213,   335,
   220,   258,   259,   227,   378,   379,   380,   377,   381,   102,
   103,   260,   205,   252,   253,   375,   376,    77,    42,   105,
   106,   107,    63,    73,    74,    75,   399,   364,   322,   210,
   232,    96,    97,    98,    99,   100,   101,   347,   264,   265,
   266,   267,   203,   122,   102,   103,   337,   378,   379,   380,
   377,   381,   277,   131,   331,   276,   279,   249,   363,   388,
   340,   336,   232,   287,   102,   103,   328,   387,   131,   166,
   347,    61,    62,   120,    92,   257,   102,   103,   347,    46,
   107,    78,   318,   283,   275,   182,    47,   200,   323,    76,
   346,    80,    52,   333,   332,    50,    51,   330,   102,   103,
   131,   347,   360,   282,   131,   208,   209,   210,   207,   201,
   281,   325,   105,   106,   107,    79,   320,    96,    97,    98,
    99,   100,   101,   329,    49,    42,    69,    66,    71,    63,
    73,    74,    75,   105,   106,   107,   410,   270,   324,   208,
   209,   210,   232,   263,   316,   210,   207,   356,   357,   211,
   109,   108,   182,   182,    61,    62,    41,    92,    91,   262,
   349,   274,    46,   272,    78,   208,   209,   210,   207,    47,
   136,   273,    76,   271,    80,    52,   261,   366,    50,    51,
   135,   241,   408,   361,   362,   372,   369,   383,   384,   367,
   382,   389,   249,   208,   209,   210,   232,   269,    79,   268,
   358,   366,   342,   390,   314,   392,   365,    49,    42,    69,
    66,    71,    63,    73,    74,    75,   182,   182,   251,   315,
    61,    62,   120,   400,   401,   402,   403,   404,   128,   365,
    78,   319,   134,   396,   344,   127,   395,   157,    76,   409,
    80,    52,   133,   343,    50,    51,   321,   397,   398,   208,
   209,   210,   232,   394,   208,   209,   210,   207,   111,   110,
   109,   108,   393,   137,    79,   132,    96,    97,    98,    99,
   100,   101,   391,    49,    42,    69,    66,    71,    63,    61,
    62,   120,   222,   373,   120,   254,   371,   128,   115,    78,
   221,   113,   370,   114,   127,   351,   211,    76,   164,    80,
    52,    84,    35,    50,    51,    34,   294,    62,   120,    33,
   198,   368,   196,    24,   128,   352,    78,   197,    14,   353,
   222,   127,   120,    79,    76,   302,    80,    52,   355,   158,
    50,    51,    49,    42,    69,    66,    71,    63,   202,   354,
   348,   208,   209,   210,   207,   195,   120,   194,   299,   298,
    79,   163,    13,    96,    97,    98,    99,   100,   101,    49,
   295,    69,    66,    71,    63,   293,    62,   120,   155,   146,
   145,    90,    86,   128,     1,    78,   215,    11,   150,    12,
   127,   161,   147,    76,   159,    80,    52,    23,    18,    50,
    51,     6,   290,    62,   120,    17,     5,    15,    85,     7,
   128,    21,    78,    82,    60,    36,    29,   127,    59,    79,
    76,    58,    80,    52,    31,    57,    50,    51,    49,   291,
    69,    66,    71,    63,   202,    56,    81,    94,    93,    92,
    91,    87,    88,    89,     2,     8,    79,     9,     3,    96,
    97,    98,    99,   100,   101,    49,   289,    69,    66,    71,
    63,   286,    62,   120,    16,    27,   162,    95,   300,   128,
   156,    78,   309,   250,    53,   160,   127,    54,    67,    76,
    70,    80,    52,    45,    55,    50,    51,    64,    61,    62,
   120,    72,   216,   217,   112,    48,   128,    44,    78,   245,
    43,     0,     0,   127,     0,    79,    76,   104,    80,    52,
     0,     0,    50,    51,    49,   285,    69,    66,    71,    63,
    61,    62,   120,     0,   229,   223,     0,   219,   180,     0,
    78,     0,    79,     0,     0,   181,     0,     0,    76,     0,
    80,    49,    42,    69,    66,    71,    63,   144,    62,   120,
     0,   246,     0,   243,     0,   128,     0,    78,     0,     0,
     0,     0,   127,     0,    79,    76,     0,    80,    52,     0,
     0,    50,    51,     0,    42,    69,    66,    71,    63,     0,
   208,   209,   210,   207,   407,     0,   104,   208,   209,   210,
   232,    79,    96,    97,    98,    99,   100,   101,   104,     0,
    49,   143,    69,    66,    71,    63,   201,     0,     0,   105,
   106,   107,     0,     0,   116,    94,    93,    92,    91,     0,
     0,    96,    97,    98,    99,   100,   101,    96,    97,    98,
    99,   100,   101,   406,   244,   246,   208,   209,   210,   232,
   405,    40,     0,   208,   209,   210,   232,   327,     0,     0,
   208,   209,   210,   232,   326,     0,     0,   208,   209,   210,
   232,   202,   121,   117,   208,   209,   210,   207,   202,     0,
     0,    94,    93,    92,   257,   297,     0,     0,   208,   209,
   210,   232,   202,     0,     0,   208,   209,   210,   232,   202,
    38,     0,    94,    93,    92,    91,   199,     0,     0,   111,
   110,   109,   108,     0,     0,     0,   165,   168,   172,   174,
     0,     0,     0,     0,     0,     0,   126,     0,     0,     0,
     0,   244,     0,   186,   188,   190,   192,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   142,     0,
   121,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   177,   178,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   121,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   256,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   165,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   284,     0,     0,     0,     0,   288,
     0,   292,     0,   296,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   317 };
static const yytabelem yypact[]={

  -244,-10000000,  -253,   263,   226,  -253,-10000000,  -196,  -241,   263,
   221,  -190,-10000000,  -199,-10000000,-10000000,  -222,  -237,  -129,   217,
   213,-10000000,   210,  -190,-10000000,   263,    67,  -271,   209,  -159,
   283,  -177,   283,   283,   283,   282,-10000000,   504,  -152,   -82,
   157,   197,-10000000,-10000000,-10000000,-10000000,   -16,  -247,-10000000,-10000000,
-10000000,-10000000,   391,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,  -131,-10000000,-10000000,   170,-10000000,-10000000,   142,-10000000,-10000000,
    80,-10000000,   168,  -213,   450,   281,   280,-10000000,  -225,-10000000,
   279,-10000000,   263,   145,   262,-10000000,   205,-10000000,-10000000,-10000000,
-10000000,  -247,  -123,  -123,  -123,  -213,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,   391,   391,   423,   423,   423,  -213,  -123,  -123,
  -123,  -123,   258,-10000000,   223,-10000000,   588,   -11,   498,   326,
   197,    47,   -23,    54,  -247,  -247,-10000000,   423,   391,   469,
   -82,  -220,  -168,-10000000,   195,-10000000,  -224,  -168,  -156,  -213,
  -213,-10000000,  -243,  -231,  -172,    82,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,  -213,  -131,-10000000,  -190,-10000000,   262,   262,
-10000000,-10000000,  -292,  -119,   192,-10000000,-10000000,-10000000,-10000000,-10000000,
  -123,  -123,    47,   -29,    47,   -29,   148,-10000000,-10000000,    32,
   423,   423,    64,   -23,   -23,   -42,-10000000,-10000000,-10000000,-10000000,
    47,   -29,    47,   -29,-10000000,-10000000,    77,    60,    44,-10000000,
-10000000,-10000000,-10000000,    11,   581,    42,   240,   423,  -213,  -213,
  -213,-10000000,-10000000,   101,    99,    39,    73,    71,  -135,-10000000,
-10000000,  -213,  -145,-10000000,-10000000,  -213,  -146,    12,     5,   -15,
   364,-10000000,  -213,   574,   -74,   305,-10000000,   278,-10000000,   219,
-10000000,-10000000,   567,   260,-10000000,   259,-10000000,   236,  -256,   108,
   123,   133,-10000000,-10000000,   423,   153,   -65,  -123,   560,   -29,
   553,-10000000,-10000000,-10000000,-10000000,   -74,   -74,-10000000,-10000000,-10000000,
-10000000,-10000000,   233,-10000000,  -215,-10000000,-10000000,   546,   257,   539,
  -277,-10000000,-10000000,-10000000,   -33,    24,    -2,-10000000,   -45,    -5,
    -6,  -111,  -100,   -38,   -53,  -114,  -116,   -44,  -183,   106,
   144,-10000000,  -290,    -9,   251,-10000000,  -284,   202,   225,   229,
-10000000,-10000000,   250,   239,  -250,  -250,   104,  -118,     4,-10000000,
    32,   423,   423,-10000000,-10000000,-10000000,   -46,   -77,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
  -135,  -250,  -296,-10000000,   236,   222,-10000000,  -250,   199,   193,
   190,   -72,  -287,  -284,  -203,  -208,   -32,   -40,  -250,-10000000,
-10000000,    32,    32,   233,  -215,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,   -72,   179,  -115,-10000000,-10000000,-10000000,   167,   158,   141,
-10000000,   138,-10000000,   225,-10000000,   423,   423,-10000000,-10000000,   -73,
-10000000,  -115,-10000000,  -213,  -213,  -213,  -213,    32,    32,-10000000,
-10000000,   532,   525,   476,    92,-10000000,-10000000,-10000000,  -213,    38,
-10000000 };
static const yytabelem yypgo[]={

     0,   627,   660,   657,     0,   655,   823,   187,   654,     6,
    35,   653,   652,   546,   651,   647,   644,   643,   548,   552,
   640,   638,   637,   634,    31,     5,   633,     1,    63,     4,
     7,   632,     3,    23,     8,     2,   551,   554,    14,   628,
   626,   635,   499,   625,   568,   558,   565,   624,   608,   607,
   549,   547,   605,   604,   596,   595,   585,   581,   578,   574,
   774,   573,   571,   569,   561,   566,   544 };
static const yytabelem yyr1[]={

     0,    66,    65,    65,    64,    63,    62,    53,    53,    52,
    52,    54,    54,    51,    51,    50,    50,    50,    50,    50,
    49,    48,    61,    47,    47,    46,    46,    46,    45,    45,
    45,    44,    44,    44,    44,    44,    44,    43,    43,    43,
    43,    43,    37,    37,    36,    36,    36,    36,    42,    42,
    41,    39,    39,    38,    40,    60,    60,    60,    60,    60,
    60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
    60,    60,    60,    60,    58,    58,    58,    57,    57,    57,
    57,    57,    57,    57,    57,    57,    55,    56,    56,    56,
    59,    35,    35,    34,    34,    34,    34,    28,    28,    28,
    25,    25,    26,    26,    27,    27,    27,    27,    27,    27,
    33,    33,    33,    32,    32,    31,    31,    29,    30,     6,
     6,     6,     6,     6,     6,     6,     6,     6,     5,     5,
     1,     1,     1,     1,     1,     1,    24,    24,    24,    24,
    24,    24,    24,    24,    24,    23,    23,    23,    22,    22,
    22,    21,    21,    21,    21,    21,    20,    20,    20,    20,
    20,    19,    18,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     3,     2,    17,    17,    17,    17,    17,
    15,    16,    16,    16,    16,    16,    14,    13,    13,    12,
    12,    11,    11,    10,    10,     9,     9,     7,     7,     7,
     8,     8,     8,     8 };
static const yytabelem yyr2[]={

     0,     5,     3,     5,     9,     5,     7,     3,     5,     3,
     5,     3,     5,     3,     7,     7,     7,     7,     7,     7,
     5,     5,     5,     5,     5,     5,     7,     7,     5,     7,
     7,     7,     9,     9,    11,    11,     9,     5,     7,     7,
     9,     9,     3,     5,     9,    11,    11,    13,     3,     5,
     9,     3,     7,     7,    11,     3,     3,     3,     3,     3,
     7,     5,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,    11,    11,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,     7,     7,     7,     7,
     7,     3,     7,     9,    11,     9,     7,     7,     7,     5,
     5,     5,     3,     3,     3,     9,     9,     9,     3,    13,
     3,     3,     7,     3,     7,     3,     7,     9,     9,     3,
     3,     3,     3,     3,     7,     5,     7,     7,     7,     7,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     7,
     5,     7,     7,     7,     7,     3,     3,     5,     3,     3,
     5,     5,     5,     5,     7,     7,     5,     5,     5,     7,
     7,    11,    11,     3,     3,     3,     3,     7,     5,     7,
     7,     7,     7,     3,     3,     3,     3,     9,     9,     9,
     5,     3,     3,     9,     9,     9,     5,     5,     5,     5,
     7,     5,     7,     3,     7,     3,     7,     7,     7,     5,
     7,     7,     7,     3 };
static const yytabelem yychk[]={

-10000000,   -66,   -53,   -48,   295,   -65,   -64,   -63,   -52,   -49,
   299,   -51,   -50,   259,   262,   -64,   -47,   -46,   -45,   296,
   297,   -62,   298,   -51,   262,   280,   283,   -43,   294,   -45,
   280,   -46,   280,   262,   262,   262,   -50,    -4,    -6,   -24,
   -60,   259,   311,    -2,    -3,   -17,   265,   272,    -5,   310,
   281,   282,   278,   -23,   -22,   -16,   -55,   -56,   -57,   -58,
   -59,   257,   258,   315,   -15,   -10,   313,   -21,    -9,   312,
   -20,   314,   -14,   316,   317,   318,   275,    -7,   267,   301,
   277,   -54,   -61,   300,   262,   -44,   259,   -44,   -44,   -44,
   259,   274,   273,   272,   271,    -1,   283,   284,   285,   286,
   287,   288,   279,   280,    -1,   271,   272,   273,   274,   273,
   272,   271,    -8,   264,   266,   261,   -60,    -6,   -24,    -4,
   259,   -60,   -24,    -4,   265,   272,    -6,   272,   265,    -4,
   -24,   276,   265,   270,   260,   270,   260,   265,    -4,   265,
   272,   257,    -6,   311,   257,   259,   259,   -19,   313,   -10,
   -18,   312,    -9,   265,   257,   259,   -51,   262,   -42,   -37,
   -41,   -36,   -40,   259,   263,   -60,   -24,    -4,   -60,    -4,
   265,   272,   -60,    -4,   -60,    -4,    -4,    -6,    -6,   -24,
   265,   272,    -4,   -24,   -24,    -4,   -60,    -4,   -60,    -4,
   -60,    -4,   -60,    -4,   259,   257,   259,   264,   257,   268,
   268,   268,   268,   -24,    -4,    -4,    -4,   274,   271,   272,
   273,    -7,   301,   -10,    -9,   -13,   -12,   -11,   267,   -19,
   -10,   265,   257,   -18,    -9,   265,   257,   -10,    -9,   -13,
   304,   269,   274,    -4,    -4,   304,   269,   304,   269,   304,
   269,   269,    -4,   -37,   -41,   -42,   -36,   308,   266,   -28,
   -26,   265,   302,   303,   263,    -4,    -6,   274,    -4,    -4,
    -4,   269,   269,   269,    -4,    -4,    -4,    -4,   268,   268,
   268,   270,   260,   270,   260,   -10,    -9,    -4,   276,    -4,
   276,   268,   268,   268,    -6,   311,   257,    -4,    -6,   311,
   257,   311,    -6,   257,   257,   311,    -6,   268,   259,   259,
   -39,   -38,   259,   -35,   309,   -34,   -28,   -33,   -32,   -31,
   -30,   -29,   306,   305,   266,   266,   -28,    -6,    -4,   268,
   -24,   263,   263,    -4,   -10,    -9,   268,   268,   269,   269,
   269,   269,   269,   269,   269,   269,   269,   269,   269,   269,
   274,   266,   266,   269,   260,   307,   269,   280,   259,   -33,
   -25,   263,   260,   260,   259,   259,   -35,   -35,   266,   268,
   268,   -24,   -24,   274,   274,   -10,    -9,   -38,   259,   -34,
   263,   263,   -25,   263,   -27,   257,   258,   292,   289,   290,
   291,   293,   -30,   -32,   -29,   283,   283,   269,   269,   -35,
   -27,   263,   -27,   265,   265,   265,   265,   -24,   -24,   269,
   -27,    -4,    -4,    -4,    -4,   268,   268,   268,   260,    -4,
   268 };
static const yytabelem yydef[]={

     0,    -2,     0,     7,     0,     1,     2,     0,     0,     9,
     0,     8,    13,     0,    21,     3,     0,     0,     0,     0,
     0,     5,     0,    10,    20,     0,     0,     0,     0,    23,
     0,    24,     0,    25,    28,     0,    14,    15,    16,    17,
    18,    19,   163,   164,   165,   166,     0,   123,   119,   120,
   121,   122,     0,   136,   137,   138,    55,    56,    57,    58,
    59,   174,   173,   175,   176,   145,   146,     0,   148,   149,
     0,   181,   182,     0,     0,     0,     0,   193,     0,   195,
     0,     4,    11,     0,    37,    27,     0,    30,    26,    29,
     6,     0,     0,     0,     0,     0,   130,   131,   132,   133,
   134,   135,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   199,     0,   203,     0,     0,     0,     0,
     0,    61,   140,   168,     0,     0,   125,   123,     0,     0,
     0,     0,     0,   147,     0,   150,     0,     0,     0,     0,
     0,   174,     0,   163,   174,     0,   180,   151,   152,   153,
   156,   157,   158,     0,     0,   186,    12,    22,    38,    39,
    48,    42,     0,     0,     0,    66,   143,   172,    67,   171,
     0,     0,    68,   170,    69,   169,   128,   126,   127,   129,
     0,     0,     0,   141,   142,   144,    62,    70,    63,    71,
    64,    72,    65,    73,   197,   198,     0,     0,     0,    60,
   124,   139,   167,     0,     0,   168,     0,     0,     0,     0,
     0,   194,   196,     0,     0,     0,     0,     0,     0,   154,
   155,     0,     0,   159,   160,     0,     0,     0,     0,     0,
     0,    86,     0,     0,   168,     0,    87,     0,    88,     0,
    89,    90,     0,    41,    49,    40,    43,     0,     0,     0,
     0,     0,   102,   103,    31,     0,     0,     0,     0,   168,
     0,   200,   201,   202,   172,   169,   170,   171,   177,   178,
   179,   187,     0,   188,     0,   189,   191,     0,     0,     0,
     0,   183,   184,   185,     0,   163,   174,   172,     0,   163,
   174,   163,     0,   174,   174,   163,     0,     0,     0,     0,
     0,    51,     0,     0,     0,    91,     0,     0,   110,   111,
   113,   115,     0,     0,     0,     0,     0,     0,     0,    99,
    36,    32,    33,   172,   190,   192,     0,     0,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
     0,     0,     0,    50,     0,     0,    44,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    97,
    98,    34,    35,     0,     0,   161,   162,    52,    53,    92,
    54,     0,     0,     0,    96,   100,   101,   104,     0,     0,
   108,     0,   114,   112,   116,     0,     0,    45,    46,     0,
    93,     0,    95,     0,     0,     0,     0,   118,   117,    47,
    94,     0,     0,     0,     0,   105,   106,   107,     0,     0,
   109 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"INT_CONST",	257,
	"REAL_CONST",	258,
	"STRING",	259,
	"COMMA",	260,
	"POINT",	261,
	"DOUBLEPOINT",	262,
	"SEMICOLON",	263,
	"QUESTIONMARK",	264,
	"OPEN_I",	265,
	"OPEN_II",	266,
	"OPEN_III",	267,
	"CLOSE_I",	268,
	"CLOSE_II",	269,
	"CLOSE_III",	270,
	"PLUS",	271,
	"MINUS",	272,
	"DIVIDE",	273,
	"MULTIPLY",	274,
	"RAUTE",	275,
	"TIMES",	276,
	"AT",	277,
	"NOT",	278,
	"AND",	279,
	"OR",	280,
	"WAHR",	281,
	"FALSCH",	282,
	"EQUAL",	283,
	"LESS",	284,
	"GREATER",	285,
	"NOT_EQUAL",	286,
	"LESS_OR_EQUAL",	287,
	"GREATER_OR_EQUAL",	288,
	"EXPONENTIAL",	289,
	"DETERMINISTIC",	290,
	"GENERAL",	291,
	"IMMEDIATE",	292,
	"UNIFORM",	293,
	"TRANSITION",	294,
	"DEFINITION",	295,
	"ELEMENTARYPLACE",	296,
	"PRODUCTPLACE",	297,
	"PAGE",	298,
	"PARAMETER",	299,
	"EVALUATE",	300,
	"E",	301,
	"ES",	302,
	"IS",	303,
	"IF",	304,
	"INARC",	305,
	"OUTARC",	306,
	"ARROW",	307,
	"ASSIGN",	308,
	"SUBPAGE",	309,
	"LOGIC",	310,
	"NUMERIC",	311,
	"E_MSET",	312,
	"P_MSET",	313,
	"C_FUNCTION",	314,
	"A_FUNCTION",	315,
	"EXPECT_OPEN",	316,
	"PROB_OPEN",	317,
	"TP_OPEN",	318,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"page_table : all_definitions pages",
	"pages : page",
	"pages : pages page",
	"page : page_param all_places all_transitions all_evaluations",
	"page_param : all_parameters page_def",
	"page_def : PAGE DOUBLEPOINT STRING",
	"all_definitions : definition_def",
	"all_definitions : definition_def definitions",
	"all_parameters : parameter_def",
	"all_parameters : parameter_def definitions",
	"all_evaluations : eval_def",
	"all_evaluations : eval_def definitions",
	"definitions : definition",
	"definitions : definitions OR definition",
	"definition : STRING EQUAL real_expr",
	"definition : STRING EQUAL logic_condition",
	"definition : STRING EQUAL multiset_expr",
	"definition : STRING EQUAL eval_expr",
	"definition : STRING EQUAL STRING",
	"parameter_def : PARAMETER DOUBLEPOINT",
	"definition_def : DEFINITION DOUBLEPOINT",
	"eval_def : EVALUATE DOUBLEPOINT",
	"all_places : elementary_places product_places",
	"all_places : product_places elementary_places",
	"elementary_places : ELEMENTARYPLACE DOUBLEPOINT",
	"elementary_places : ELEMENTARYPLACE DOUBLEPOINT place",
	"elementary_places : elementary_places OR place",
	"product_places : PRODUCTPLACE DOUBLEPOINT",
	"product_places : PRODUCTPLACE DOUBLEPOINT place",
	"product_places : product_places OR place",
	"place : STRING SEMICOLON SEMICOLON",
	"place : STRING SEMICOLON real_expr SEMICOLON",
	"place : STRING SEMICOLON logic_condition SEMICOLON",
	"place : STRING SEMICOLON real_expr SEMICOLON multiset_expr",
	"place : STRING SEMICOLON logic_condition SEMICOLON multiset_expr",
	"place : STRING SEMICOLON SEMICOLON multiset_expr",
	"all_transitions : TRANSITION DOUBLEPOINT",
	"all_transitions : TRANSITION DOUBLEPOINT sub_transitions",
	"all_transitions : TRANSITION DOUBLEPOINT transitions",
	"all_transitions : TRANSITION DOUBLEPOINT transitions sub_transitions",
	"all_transitions : TRANSITION DOUBLEPOINT sub_transitions transitions",
	"transitions : transition",
	"transitions : transitions transition",
	"transition : STRING OPEN_II binding_list CLOSE_II",
	"transition : STRING guard OPEN_II binding_list CLOSE_II",
	"transition : STRING server_type OPEN_II binding_list CLOSE_II",
	"transition : STRING server_type guard OPEN_II binding_list CLOSE_II",
	"sub_transitions : sub_transition",
	"sub_transitions : sub_transitions sub_transition",
	"sub_transition : sub_trans_definition ASSIGN port_assignment_list CLOSE_II",
	"port_assignment_list : port_assignment",
	"port_assignment_list : port_assignment_list COMMA port_assignment",
	"port_assignment : STRING ARROW STRING",
	"sub_trans_definition : STRING OPEN_II SUBPAGE STRING SEMICOLON",
	"eval_expr : expectation_value",
	"eval_expr : probability",
	"eval_expr : bayes_rule_prob",
	"eval_expr : bayes_rule_expect",
	"eval_expr : through_put",
	"eval_expr : OPEN_I eval_expr CLOSE_I",
	"eval_expr : MINUS eval_expr",
	"eval_expr : eval_expr MULTIPLY eval_expr",
	"eval_expr : eval_expr DIVIDE eval_expr",
	"eval_expr : eval_expr MINUS eval_expr",
	"eval_expr : eval_expr PLUS eval_expr",
	"eval_expr : real_expr MULTIPLY eval_expr",
	"eval_expr : real_expr DIVIDE eval_expr",
	"eval_expr : real_expr MINUS eval_expr",
	"eval_expr : real_expr PLUS eval_expr",
	"eval_expr : eval_expr MULTIPLY real_expr",
	"eval_expr : eval_expr DIVIDE real_expr",
	"eval_expr : eval_expr MINUS real_expr",
	"eval_expr : eval_expr PLUS real_expr",
	"bayes_rule_expect : EXPECT_OPEN real_expr IF logic_condition CLOSE_II",
	"bayes_rule_expect : EXPECT_OPEN real_expr IF NUMERIC CLOSE_II",
	"bayes_rule_expect : EXPECT_OPEN real_expr IF INT_CONST CLOSE_II",
	"bayes_rule_prob : PROB_OPEN logic_condition IF logic_condition CLOSE_II",
	"bayes_rule_prob : PROB_OPEN logic_condition IF NUMERIC CLOSE_II",
	"bayes_rule_prob : PROB_OPEN logic_condition IF INT_CONST CLOSE_II",
	"bayes_rule_prob : PROB_OPEN NUMERIC IF NUMERIC CLOSE_II",
	"bayes_rule_prob : PROB_OPEN NUMERIC IF logic_condition CLOSE_II",
	"bayes_rule_prob : PROB_OPEN NUMERIC IF INT_CONST CLOSE_II",
	"bayes_rule_prob : PROB_OPEN INT_CONST IF INT_CONST CLOSE_II",
	"bayes_rule_prob : PROB_OPEN INT_CONST IF NUMERIC CLOSE_II",
	"bayes_rule_prob : PROB_OPEN INT_CONST IF logic_condition CLOSE_II",
	"expectation_value : EXPECT_OPEN real_expr CLOSE_II",
	"probability : PROB_OPEN logic_condition CLOSE_II",
	"probability : PROB_OPEN NUMERIC CLOSE_II",
	"probability : PROB_OPEN INT_CONST CLOSE_II",
	"through_put : TP_OPEN STRING CLOSE_II",
	"binding_list : binding",
	"binding_list : binding_list OR binding",
	"binding : guard arc_bindings SEMICOLON delay",
	"binding : guard arc_bindings weight SEMICOLON delay",
	"binding : arc_bindings weight SEMICOLON delay",
	"binding : arc_bindings SEMICOLON delay",
	"guard : OPEN_I logic_condition CLOSE_I",
	"guard : OPEN_I real_expr CLOSE_I",
	"guard : OPEN_I CLOSE_I",
	"weight : SEMICOLON INT_CONST",
	"weight : SEMICOLON REAL_CONST",
	"server_type : ES",
	"server_type : IS",
	"delay : IMMEDIATE",
	"delay : IMMEDIATE OPEN_I real_expr CLOSE_I",
	"delay : EXPONENTIAL OPEN_I real_expr CLOSE_I",
	"delay : DETERMINISTIC OPEN_I real_expr CLOSE_I",
	"delay : GENERAL",
	"delay : UNIFORM OPEN_I real_expr COMMA real_expr CLOSE_I",
	"arc_bindings : out_arc_bind_list",
	"arc_bindings : in_arc_bind_list",
	"arc_bindings : in_arc_bind_list COMMA out_arc_bind_list",
	"out_arc_bind_list : out_arc_bind",
	"out_arc_bind_list : out_arc_bind_list COMMA out_arc_bind",
	"in_arc_bind_list : in_arc_bind",
	"in_arc_bind_list : in_arc_bind_list COMMA in_arc_bind",
	"in_arc_bind : INARC STRING EQUAL multiset_expr",
	"out_arc_bind : OUTARC STRING EQUAL multiset_expr",
	"logic_condition : comparison",
	"logic_condition : LOGIC",
	"logic_condition : WAHR",
	"logic_condition : FALSCH",
	"logic_condition : MINUS",
	"logic_condition : OPEN_I logic_condition CLOSE_I",
	"logic_condition : NOT logic_condition",
	"logic_condition : logic_condition AND logic_condition",
	"logic_condition : logic_condition OR logic_condition",
	"comparison : real_expr comp_op real_expr",
	"comparison : multiset_expr comp_op multiset_expr",
	"comp_op : EQUAL",
	"comp_op : LESS",
	"comp_op : GREATER",
	"comp_op : NOT_EQUAL",
	"comp_op : LESS_OR_EQUAL",
	"comp_op : GREATER_OR_EQUAL",
	"multiset_expr : p_mset",
	"multiset_expr : e_mset",
	"multiset_expr : contents_function",
	"multiset_expr : OPEN_I multiset_expr CLOSE_I",
	"multiset_expr : MINUS multiset_expr",
	"multiset_expr : multiset_expr PLUS multiset_expr",
	"multiset_expr : multiset_expr MINUS multiset_expr",
	"multiset_expr : real_expr MULTIPLY multiset_expr",
	"multiset_expr : multiset_expr DIVIDE real_expr",
	"p_mset : p_mset_const",
	"p_mset : P_MSET",
	"p_mset : p_mset_1 CLOSE_III",
	"e_mset : e_mset_const",
	"e_mset : E_MSET",
	"e_mset : e_mset_1 CLOSE_III",
	"p_mset_1 : OPEN_III p_mset_0",
	"p_mset_1 : OPEN_III P_MSET",
	"p_mset_1 : OPEN_III p_mset_const",
	"p_mset_1 : p_mset_1 COMMA p_mset_0",
	"p_mset_1 : p_mset_1 COMMA p_mset_const",
	"e_mset_1 : OPEN_III e_mset_0",
	"e_mset_1 : OPEN_III E_MSET",
	"e_mset_1 : OPEN_III e_mset_const",
	"e_mset_1 : e_mset_1 COMMA e_mset_0",
	"e_mset_1 : e_mset_1 COMMA e_mset_const",
	"p_mset_0 : OPEN_I real_expr CLOSE_I MULTIPLY p_mset_const",
	"e_mset_0 : OPEN_I real_expr CLOSE_I MULTIPLY e_mset_const",
	"real_expr : NUMERIC",
	"real_expr : int_const",
	"real_expr : real_const",
	"real_expr : absolut_function",
	"real_expr : OPEN_I real_expr CLOSE_I",
	"real_expr : MINUS real_expr",
	"real_expr : real_expr PLUS real_expr",
	"real_expr : real_expr MINUS real_expr",
	"real_expr : real_expr DIVIDE real_expr",
	"real_expr : real_expr MULTIPLY real_expr",
	"real_const : REAL_CONST",
	"int_const : INT_CONST",
	"absolut_function : A_FUNCTION",
	"absolut_function : a_function_def",
	"absolut_function : a_function_def OPEN_I p_mset_const CLOSE_I",
	"absolut_function : a_function_def OPEN_I e_mset_const CLOSE_I",
	"absolut_function : a_function_def OPEN_I mset_const_expr CLOSE_I",
	"a_function_def : RAUTE STRING",
	"contents_function : C_FUNCTION",
	"contents_function : c_function_def",
	"contents_function : c_function_def OPEN_I p_mset_const CLOSE_I",
	"contents_function : c_function_def OPEN_I e_mset_const CLOSE_I",
	"contents_function : c_function_def OPEN_I mset_const_expr CLOSE_I",
	"c_function_def : AT STRING",
	"mset_const_expr : p_mset_const_expr CLOSE_III",
	"mset_const_expr : e_mset_const_expr CLOSE_III",
	"p_mset_const_expr : OPEN_III p_mset_const",
	"p_mset_const_expr : p_mset_const_expr COMMA p_mset_const",
	"e_mset_const_expr : OPEN_III e_mset_const",
	"e_mset_const_expr : e_mset_const_expr COMMA e_mset_const",
	"p_mset_const : unit",
	"p_mset_const : INT_CONST TIMES unit",
	"e_mset_const : E",
	"e_mset_const : INT_CONST TIMES E",
	"unit : STRING part_version STRING",
	"unit : STRING part_version INT_CONST",
	"unit : STRING QUESTIONMARK",
	"part_version : OPEN_II STRING CLOSE_II",
	"part_version : OPEN_II QUESTIONMARK CLOSE_II",
	"part_version : OPEN_II INT_CONST CLOSE_II",
	"part_version : POINT",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.14	97/01/16 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register const int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 207 "MSAnalysis/src/pars.y"
{ ; } break;
case 2:
# line 211 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0;  		    	    } break;
case 3:
# line 212 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0;  		    	    } break;
case 4:
# line 215 "MSAnalysis/src/pars.y"
{ 
				if (yypvt[-2]._PlacePtrListPtr) { yypvt[-3]._PagePtr->AddPlaces(yypvt[-2]._PlacePtrListPtr); }
				if (yypvt[-1]._TransitionListPtr) { yypvt[-3]._PagePtr->AddTransitions(*yypvt[-1]._TransitionListPtr); yypvt[-1]._TransitionListPtr->Clear(); delete yypvt[-1]._TransitionListPtr; }
				yyval.i_val = 0;
			} break;
case 5:
# line 222 "MSAnalysis/src/pars.y"
{ 
				if (yypvt[-1]._DefinitionListPtr) yypvt[-0]._PagePtr->AddParameters(*yypvt[-1]._DefinitionListPtr); 
				yyval._PagePtr = yypvt[-0]._PagePtr;  
			} break;
case 6:
# line 227 "MSAnalysis/src/pars.y"
{ yyval._PagePtr = CheckAndSavePage(yypvt[-0].s_val); 	    } break;
case 7:
# line 232 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0; 	    	    	    } break;
case 8:
# line 233 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0; 	    	    	    } break;
case 9:
# line 235 "MSAnalysis/src/pars.y"
{ yyval._DefinitionListPtr = NULL; 	    	    	    } break;
case 10:
# line 236 "MSAnalysis/src/pars.y"
{ yyval._DefinitionListPtr = yypvt[-0]._DefinitionListPtr;			    } break;
case 11:
# line 238 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0; 	    	    	    } break;
case 12:
# line 239 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0;			    } break;
case 13:
# line 242 "MSAnalysis/src/pars.y"
{ 
				switch (section)
				{
					case	def_sec	  :	SaveDefinition(yypvt[-0]._DefinitionPtr);         yyval._DefinitionListPtr = NULL; break;
					case	def_end	  :	SaveDefinition(yypvt[-0]._DefinitionPtr);         yyval._DefinitionListPtr = NULL; break;
					case	eval_sec  :	EvalRefList.Append(*yypvt[-0]._DefinitionPtr);    yyval._DefinitionListPtr = NULL; break;
					case	eval_end  :	EvalRefList.Append(*yypvt[-0]._DefinitionPtr);    yyval._DefinitionListPtr = NULL; break;
					case	param_sec :	yyval._DefinitionListPtr = new DefinitionList(*yypvt[-0]._DefinitionPtr);          break;
					case	param_end :	yyval._DefinitionListPtr = new DefinitionList(*yypvt[-0]._DefinitionPtr);          break;
					default	 	  :	yyerror("definition in wrong section");	
				}
				yypvt[-0]._DefinitionPtr->Clear(); delete yypvt[-0]._DefinitionPtr;
			} break;
case 14:
# line 256 "MSAnalysis/src/pars.y"
{ 
				switch (section)
				{
					case	def_sec	  :	SaveDefinition(yypvt[-0]._DefinitionPtr);      yyval._DefinitionListPtr = NULL; break;
					case	def_end	  :	SaveDefinition(yypvt[-0]._DefinitionPtr);      yyval._DefinitionListPtr = NULL; break;
					case	eval_sec  :	EvalRefList.Append(*yypvt[-0]._DefinitionPtr); yyval._DefinitionListPtr = NULL; break;
					case	eval_end  :	EvalRefList.Append(*yypvt[-0]._DefinitionPtr); yyval._DefinitionListPtr = NULL; break;
					case	param_sec :	yypvt[-2]._DefinitionListPtr->Append(*yypvt[-0]._DefinitionPtr);         yyval._DefinitionListPtr = yypvt[-2]._DefinitionListPtr;   break;	
					case	param_end :	yypvt[-2]._DefinitionListPtr->Append(*yypvt[-0]._DefinitionPtr);         yyval._DefinitionListPtr = yypvt[-2]._DefinitionListPtr;   break;	
					default	 	  :	yyerror("definition in wrong section");	
				}
				yypvt[-0]._DefinitionPtr->Clear(); delete yypvt[-0]._DefinitionPtr;
			} break;
case 15:
# line 271 "MSAnalysis/src/pars.y"
{ 
				yyval._DefinitionPtr = new Definition(yypvt[-2].s_val, yypvt[-0]._CellPtr); 	    
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 16:
# line 276 "MSAnalysis/src/pars.y"
{ 
				yyval._DefinitionPtr = new Definition(yypvt[-2].s_val, yypvt[-0]._CellPtr); 	    
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 17:
# line 281 "MSAnalysis/src/pars.y"
{ 
				if (section==eval_sec || section==eval_end) 
					YaccError("mset definition in eval section", yypvt[-2].s_val);
				yyval._DefinitionPtr = new Definition(yypvt[-2].s_val, yypvt[-0]._CellPtr); 	    
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 18:
# line 288 "MSAnalysis/src/pars.y"
{ 
				if (section!=eval_sec && section!=eval_end) 
					YaccError("eval definition in wrong section", yypvt[-2].s_val);
				yyval._DefinitionPtr = new Definition(yypvt[-2].s_val, yypvt[-0]._CellPtr); 	    
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 19:
# line 295 "MSAnalysis/src/pars.y"
{
				if (!strcmp(yypvt[-2].s_val,yypvt[-0].s_val)) 
					YaccError("definition loop", yypvt[-2].s_val);
				yyval._DefinitionPtr = new Definition(yypvt[-2].s_val,new ConstVal(yypvt[-0].s_val)); 
			} break;
case 20:
# line 301 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0;			    } break;
case 21:
# line 302 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0;                           } break;
case 22:
# line 303 "MSAnalysis/src/pars.y"
{ yyval.i_val = 0;                           } break;
case 23:
# line 309 "MSAnalysis/src/pars.y"
{ 
				if (!yypvt[-1]._PlacePtrListPtr && !yypvt[-0]._PlacePtrListPtr) yyval._PlacePtrListPtr = NULL;
				if ( yypvt[-1]._PlacePtrListPtr &&  yypvt[-0]._PlacePtrListPtr) yyval._PlacePtrListPtr = new PlacePtrList(*yypvt[-1]._PlacePtrListPtr,*yypvt[-0]._PlacePtrListPtr);
				else
				{
					if (yypvt[-1]._PlacePtrListPtr) yyval._PlacePtrListPtr = yypvt[-1]._PlacePtrListPtr;
					else    yyval._PlacePtrListPtr = yypvt[-0]._PlacePtrListPtr;
				}
			} break;
case 24:
# line 319 "MSAnalysis/src/pars.y"
{ 
				if (!yypvt[-1]._PlacePtrListPtr && !yypvt[-0]._PlacePtrListPtr) yyval._PlacePtrListPtr = NULL;
				if ( yypvt[-1]._PlacePtrListPtr &&  yypvt[-0]._PlacePtrListPtr) yyval._PlacePtrListPtr = new PlacePtrList(*yypvt[-1]._PlacePtrListPtr,*yypvt[-0]._PlacePtrListPtr);
				else
				{
					if (yypvt[-1]._PlacePtrListPtr) yyval._PlacePtrListPtr = yypvt[-1]._PlacePtrListPtr;
					else    yyval._PlacePtrListPtr = yypvt[-0]._PlacePtrListPtr;
				}
			} break;
case 25:
# line 329 "MSAnalysis/src/pars.y"
{ yyval._PlacePtrListPtr = NULL; 			    } break;
case 26:
# line 331 "MSAnalysis/src/pars.y"
{ 
				Place* p=SavePlace(yypvt[-0]._PlacePtr, elementary); 
				if (p) yyval._PlacePtrListPtr = new PlacePtrList(p); 
				else   yyval._PlacePtrListPtr = new PlacePtrList();
			} break;
case 27:
# line 337 "MSAnalysis/src/pars.y"
{ 
				Place* p=SavePlace(yypvt[-0]._PlacePtr, elementary); 
				if (p) yypvt[-2]._PlacePtrListPtr->Append(p);
				yyval._PlacePtrListPtr = yypvt[-2]._PlacePtrListPtr;
			} break;
case 28:
# line 343 "MSAnalysis/src/pars.y"
{ yyval._PlacePtrListPtr = NULL; 		    	    } break;
case 29:
# line 345 "MSAnalysis/src/pars.y"
{ 
				Place* p=SavePlace(yypvt[-0]._PlacePtr, object);
				if (p) yyval._PlacePtrListPtr = new PlacePtrList(p); 
				else   yyval._PlacePtrListPtr = new PlacePtrList();
			} break;
case 30:
# line 351 "MSAnalysis/src/pars.y"
{ 
				Place* p=SavePlace(yypvt[-0]._PlacePtr, object); 
				if (p) yypvt[-2]._PlacePtrListPtr->Append(p);
				yyval._PlacePtrListPtr = yypvt[-2]._PlacePtrListPtr;
			} break;
case 31:
# line 358 "MSAnalysis/src/pars.y"
{ 
				yyval._PlacePtr = new Place(yypvt[-2].s_val, place_no++, quantitativ, new ConstVal(UNFINITE)); 
			} break;
case 32:
# line 362 "MSAnalysis/src/pars.y"
{ 
				yyval._PlacePtr = new Place(yypvt[-3].s_val, place_no++, quantitativ, yypvt[-1]._CellPtr); 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 33:
# line 367 "MSAnalysis/src/pars.y"
{ 
				yyval._PlacePtr = new Place(yypvt[-3].s_val, place_no++, logic, yypvt[-1]._CellPtr); 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 34:
# line 372 "MSAnalysis/src/pars.y"
{
				CellVal* cv = yypvt[-0]._CellPtr->Calculate();
				yyval._PlacePtr = new Place(yypvt[-4].s_val, place_no++, quantitativ, yypvt[-2]._CellPtr, 
					       copy_token_multiset(cv->Gettoken_multiset()));
				cv->Clear(); delete cv;
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 35:
# line 381 "MSAnalysis/src/pars.y"
{
				CellVal* cv = yypvt[-0]._CellPtr->Calculate();
				yyval._PlacePtr = new Place(yypvt[-4].s_val, place_no++, logic, yypvt[-2]._CellPtr, 
					       copy_token_multiset(cv->Gettoken_multiset()));
				cv->Clear(); delete cv;
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 36:
# line 390 "MSAnalysis/src/pars.y"
{ 
				CellVal* cv = yypvt[-0]._CellPtr->Calculate();
				yyval._PlacePtr = new Place(yypvt[-3].s_val, place_no++, quantitativ, new ConstVal(UNFINITE), 
					       copy_token_multiset(cv->Gettoken_multiset()));
				cv->Clear(); delete cv;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 37:
# line 400 "MSAnalysis/src/pars.y"
{ yyval._TransitionListPtr = NULL;		    } break;
case 38:
# line 401 "MSAnalysis/src/pars.y"
{ yyval._TransitionListPtr = NULL;  		    } break;
case 39:
# line 402 "MSAnalysis/src/pars.y"
{ yyval._TransitionListPtr = yypvt[-0]._TransitionListPtr;  		    } break;
case 40:
# line 403 "MSAnalysis/src/pars.y"
{ yyval._TransitionListPtr = yypvt[-1]._TransitionListPtr;  		    } break;
case 41:
# line 404 "MSAnalysis/src/pars.y"
{ yyval._TransitionListPtr = yypvt[-0]._TransitionListPtr;  		    } break;
case 42:
# line 407 "MSAnalysis/src/pars.y"
{ 
				SaveTransition(yypvt[-0]._TransitionPtr);
				yyval._TransitionListPtr = new TransitionList(*yypvt[-0]._TransitionPtr);
				yypvt[-0]._TransitionPtr->Clear(); delete yypvt[-0]._TransitionPtr;
			} break;
case 43:
# line 413 "MSAnalysis/src/pars.y"
{ 
				SaveTransition(yypvt[-0]._TransitionPtr); 
				yypvt[-1]._TransitionListPtr->Append(*yypvt[-0]._TransitionPtr);
				yyval._TransitionListPtr = yypvt[-1]._TransitionListPtr; 
				yypvt[-0]._TransitionPtr->Clear(); delete yypvt[-0]._TransitionPtr;
			} break;
case 44:
# line 421 "MSAnalysis/src/pars.y"
{
				CheckAndCountTransition(yypvt[-3].s_val,Exclusive,yypvt[-1]._BindingListPtr);
				yyval._TransitionPtr =     new Transition(yypvt[-3].s_val,Exclusive,yypvt[-1]._BindingListPtr,new ConstVal(true));
				yypvt[-1]._BindingListPtr->Clear(); delete yypvt[-1]._BindingListPtr;
			} break;
case 45:
# line 427 "MSAnalysis/src/pars.y"
{
				CheckAndCountTransition(yypvt[-4].s_val,Exclusive,yypvt[-1]._BindingListPtr);
				yyval._TransitionPtr =     new Transition(yypvt[-4].s_val,Exclusive,yypvt[-1]._BindingListPtr,yypvt[-3]._CellPtr);
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;
				yypvt[-1]._BindingListPtr->Clear(); delete yypvt[-1]._BindingListPtr;
			} break;
case 46:
# line 434 "MSAnalysis/src/pars.y"
{
				CheckAndCountTransition(yypvt[-4].s_val,yypvt[-3]._ServerType,yypvt[-1]._BindingListPtr);
				yyval._TransitionPtr =     new Transition(yypvt[-4].s_val,yypvt[-3]._ServerType,yypvt[-1]._BindingListPtr,new ConstVal(true));
				yypvt[-1]._BindingListPtr->Clear(); delete yypvt[-1]._BindingListPtr;
			} break;
case 47:
# line 440 "MSAnalysis/src/pars.y"
{
				CheckAndCountTransition(yypvt[-5].s_val,yypvt[-4]._ServerType,yypvt[-1]._BindingListPtr);
				yyval._TransitionPtr =     new Transition(yypvt[-5].s_val,yypvt[-4]._ServerType,yypvt[-1]._BindingListPtr,yypvt[-3]._CellPtr);
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr; 
				yypvt[-1]._BindingListPtr->Clear(); delete yypvt[-1]._BindingListPtr;
			} break;
case 48:
# line 449 "MSAnalysis/src/pars.y"
{ SaveSubTransition(yypvt[-0].s_val); yyval.i_val = 0;  } break;
case 49:
# line 450 "MSAnalysis/src/pars.y"
{ SaveSubTransition(yypvt[-0].s_val); yyval.i_val = 0;  } break;
case 50:
# line 452 "MSAnalysis/src/pars.y"
{ yyval.s_val = yypvt[-3].s_val; } break;
case 51:
# line 454 "MSAnalysis/src/pars.y"
{ yyval.i_val = yypvt[-0].i_val; } break;
case 52:
# line 455 "MSAnalysis/src/pars.y"
{ yyval.i_val = yypvt[-0].i_val; } break;
case 53:
# line 458 "MSAnalysis/src/pars.y"
{ 
				SocketPortPair* spp = new SocketPortPair(GetPlaceRef(yypvt[-2].s_val), MakePortName(yypvt[-0].s_val));
			  	if (SocketPortRefList.UniqueAppend(*spp) < 0)
			  		YaccError("socket-port-pair exists", yypvt[-2].s_val);
			  	spp->Clear(); delete spp;
			  	yyval.i_val = 0; 
			} break;
case 54:
# line 467 "MSAnalysis/src/pars.y"
{
				if (PageRefList.GetPos(yypvt[-1].s_val) > 0) 
					YaccError("page-loop in subtransition", yypvt[-1].s_val); 

				Page* p;
				if (!(p = PageRefList.GetElementPtr(actual_page_name)))
					YaccError("master-page of subtransition is not defined", yypvt[-1].s_val);
				p->AddSubPage(yypvt[-1].s_val);
				MakeActualSubPageName(yypvt[-1].s_val);
				yyval.s_val = yypvt[-4].s_val;
			} break;
case 55:
# line 481 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=yypvt[-0]._CellPtr;			    } break;
case 56:
# line 482 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=yypvt[-0]._CellPtr;			    } break;
case 57:
# line 483 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=yypvt[-0]._CellPtr;			    } break;
case 58:
# line 484 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=yypvt[-0]._CellPtr;			    } break;
case 59:
# line 485 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=yypvt[-0]._CellPtr;			    } break;
case 60:
# line 486 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=yypvt[-1]._CellPtr;			    } break;
case 61:
# line 488 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new UnaerOp (minus ,yypvt[-0]._CellPtr);
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 62:
# line 493 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(multiply,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 63:
# line 499 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(divide,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 64:
# line 505 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(minus,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 65:
# line 511 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(plus,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 66:
# line 517 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(multiply,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 67:
# line 523 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(divide,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 68:
# line 529 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(minus,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 69:
# line 535 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(plus,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 70:
# line 541 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(multiply,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 71:
# line 547 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(divide,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 72:
# line 553 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(minus,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 73:
# line 559 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new BinaerOp(plus,yypvt[-2]._CellPtr, yypvt[-0]._CellPtr); 
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr; 
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 74:
# line 566 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_e,yypvt[-3]._CellPtr,yypvt[-1]._CellPtr); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr; 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 75:
# line 572 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_e,yypvt[-3]._CellPtr,yypvt[-1]._CellPtr); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr; 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 76:
# line 578 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_e,yypvt[-3]._CellPtr,yypvt[-1].i_val); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;  
			} break;
case 77:
# line 584 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3]._CellPtr,yypvt[-1]._CellPtr); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr; 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 78:
# line 590 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3]._CellPtr,yypvt[-1]._CellPtr); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr; 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 79:
# line 596 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3]._CellPtr,yypvt[-1].i_val); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;
			} break;
case 80:
# line 601 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3]._CellPtr,yypvt[-1]._CellPtr); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr; 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 81:
# line 607 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3]._CellPtr,yypvt[-1]._CellPtr); 
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr; 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 82:
# line 613 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3]._CellPtr,yypvt[-1].i_val);
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;
			} break;
case 83:
# line 618 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3].i_val,yypvt[-1].i_val); 
			} break;
case 84:
# line 622 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3].i_val,yypvt[-1]._CellPtr); 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 85:
# line 627 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr=new RatingCell(bayes_p,yypvt[-3].i_val,yypvt[-1]._CellPtr); 
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;
			} break;
case 86:
# line 632 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=new RatingCell(expect,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 87:
# line 634 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=new RatingCell(prob,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 88:
# line 635 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=new RatingCell(prob,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 89:
# line 636 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=new RatingCell(prob,yypvt[-1].i_val);      		    } break;
case 90:
# line 638 "MSAnalysis/src/pars.y"
{ yyval._CellPtr=new RatingCell(through_p,yypvt[-1].s_val); 		    } break;
case 91:
# line 643 "MSAnalysis/src/pars.y"
{ yyval._BindingListPtr = new BindingList(*yypvt[-0]._BindingElementPtr);        yypvt[-0]._BindingElementPtr->Clear(); delete yypvt[-0]._BindingElementPtr; } break;
case 92:
# line 644 "MSAnalysis/src/pars.y"
{ yypvt[-2]._BindingListPtr->Append(*yypvt[-0]._BindingElementPtr); yyval._BindingListPtr = yypvt[-2]._BindingListPtr;         yypvt[-0]._BindingElementPtr->Clear(); delete yypvt[-0]._BindingElementPtr; } break;
case 93:
# line 647 "MSAnalysis/src/pars.y"
{
				yyval._BindingElementPtr = new BindingElement(DEF_ES_WEIGHT,yypvt[-3]._CellPtr,yypvt[-0]._DelayPtr,yypvt[-2]._arc_binding_ptr->in,yypvt[-2]._arc_binding_ptr->out);
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;
				yypvt[-0]._DelayPtr->Clear(); delete yypvt[-0]._DelayPtr;
				delete yypvt[-2]._arc_binding_ptr; 
			} break;
case 94:
# line 654 "MSAnalysis/src/pars.y"
{
				if (yypvt[-2].d_val <= 0) yyerror("unallowed weight");
				yyval._BindingElementPtr = new BindingElement(yypvt[-2].d_val,yypvt[-4]._CellPtr,yypvt[-0]._DelayPtr,yypvt[-3]._arc_binding_ptr->in,yypvt[-3]._arc_binding_ptr->out);
				yypvt[-4]._CellPtr->Clear(); delete yypvt[-4]._CellPtr;
				yypvt[-0]._DelayPtr->Clear(); delete yypvt[-0]._DelayPtr;
				delete yypvt[-3]._arc_binding_ptr; 
			} break;
case 95:
# line 662 "MSAnalysis/src/pars.y"
{
				if (yypvt[-2].d_val <= 0) yyerror("unallowed weight");
				yyval._BindingElementPtr = new BindingElement(yypvt[-2].d_val,new ConstVal(true),yypvt[-0]._DelayPtr,yypvt[-3]._arc_binding_ptr->in,yypvt[-3]._arc_binding_ptr->out);
				yypvt[-0]._DelayPtr->Clear(); delete yypvt[-0]._DelayPtr;
				delete yypvt[-3]._arc_binding_ptr;
			} break;
case 96:
# line 669 "MSAnalysis/src/pars.y"
{
				yyval._BindingElementPtr = new BindingElement(DEF_ES_WEIGHT,new ConstVal(true),yypvt[-0]._DelayPtr,yypvt[-2]._arc_binding_ptr->in,yypvt[-2]._arc_binding_ptr->out);
				yypvt[-0]._DelayPtr->Clear(); delete yypvt[-0]._DelayPtr; 
				delete yypvt[-2]._arc_binding_ptr;
			} break;
case 97:
# line 675 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr;		    } break;
case 98:
# line 676 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr;		    } break;
case 99:
# line 677 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(true);  } break;
case 100:
# line 679 "MSAnalysis/src/pars.y"
{ yyval.d_val = double(yypvt[-0].i_val);	    } break;
case 101:
# line 680 "MSAnalysis/src/pars.y"
{ yyval.d_val = yypvt[-0].d_val;		    } break;
case 102:
# line 682 "MSAnalysis/src/pars.y"
{ yyval._ServerType = Exclusive;	    } break;
case 103:
# line 683 "MSAnalysis/src/pars.y"
{ yyval._ServerType = Infinite;	    } break;
case 104:
# line 685 "MSAnalysis/src/pars.y"
{ yyval._DelayPtr=new Immediate();	    			    } break;
case 105:
# line 686 "MSAnalysis/src/pars.y"
{ yyval._DelayPtr=new Immediate(yypvt[-1]._CellPtr);     yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;} break;
case 106:
# line 687 "MSAnalysis/src/pars.y"
{ yyval._DelayPtr=new Exponential(yypvt[-1]._CellPtr);   yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;} break;
case 107:
# line 688 "MSAnalysis/src/pars.y"
{ yyval._DelayPtr=new Deterministic(yypvt[-1]._CellPtr); yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;} break;
case 108:
# line 689 "MSAnalysis/src/pars.y"
{ yyval._DelayPtr=new General(yypvt[-0].s_val);                              } break;
case 109:
# line 691 "MSAnalysis/src/pars.y"
{ 
				if (yypvt[-3]._CellPtr->IsPlaceDependent() || yypvt[-1]._CellPtr->IsPlaceDependent())
					YaccError("placedependent uniform delay is not allowed", NULL);

				double beg = yypvt[-3]._CellPtr->CalculateFloat();
				double end = yypvt[-1]._CellPtr->CalculateFloat();
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;
				yypvt[-1]._CellPtr->Clear(); delete yypvt[-1]._CellPtr;

				if (beg > end) 
					YaccError("timeinterval for uniform delay is not correct", NULL);

				yyval._DelayPtr=new UniForm(beg,end);    
			} break;
case 110:
# line 707 "MSAnalysis/src/pars.y"
{
				arc_binding* arc_b = new arc_binding;
				arc_b->in	   = NULL;
				arc_b->out	   = yypvt[-0]._ArcBindListPtr;
				yyval._arc_binding_ptr = arc_b;
			} break;
case 111:
# line 714 "MSAnalysis/src/pars.y"
{
				arc_binding* arc_b = new arc_binding;
				arc_b->in	   = yypvt[-0]._ArcBindListPtr;
				arc_b->out	   = NULL;
				yyval._arc_binding_ptr = arc_b;
			} break;
case 112:
# line 721 "MSAnalysis/src/pars.y"
{
				arc_binding* arc_b = new arc_binding;
				arc_b->in	   = yypvt[-2]._ArcBindListPtr;
				arc_b->out	   = yypvt[-0]._ArcBindListPtr;
				yyval._arc_binding_ptr = arc_b;
			} break;
case 113:
# line 729 "MSAnalysis/src/pars.y"
{ 
				yyval._ArcBindListPtr = new ArcBindList(*yypvt[-0]._ArcBindElementPtr);   	    
				yypvt[-0]._ArcBindElementPtr->Clear(); delete yypvt[-0]._ArcBindElementPtr;
			} break;
case 114:
# line 734 "MSAnalysis/src/pars.y"
{ 
				yypvt[-2]._ArcBindListPtr->Append(*yypvt[-0]._ArcBindElementPtr); 
				yyval._ArcBindListPtr = yypvt[-2]._ArcBindListPtr; 	    
				yypvt[-0]._ArcBindElementPtr->Clear(); delete yypvt[-0]._ArcBindElementPtr;
			} break;
case 115:
# line 741 "MSAnalysis/src/pars.y"
{ 
				yyval._ArcBindListPtr = new ArcBindList(*yypvt[-0]._ArcBindElementPtr);   	    
				yypvt[-0]._ArcBindElementPtr->Clear(); delete yypvt[-0]._ArcBindElementPtr;
			} break;
case 116:
# line 746 "MSAnalysis/src/pars.y"
{ 
				yypvt[-2]._ArcBindListPtr->Append(*yypvt[-0]._ArcBindElementPtr); 
				yyval._ArcBindListPtr = yypvt[-2]._ArcBindListPtr; 	    
				yypvt[-0]._ArcBindElementPtr->Clear(); delete yypvt[-0]._ArcBindElementPtr;
			} break;
case 117:
# line 753 "MSAnalysis/src/pars.y"
{ 
				if (strncmp(actual_page_name, yypvt[-2].s_val, strlen(actual_page_name)) != 0)
					YaccError("arc-bind-place is not from this page", yypvt[-2].s_val);
				yyval._ArcBindElementPtr = new ArcBindElement(CheckIfPortGetRef(yypvt[-2].s_val),yypvt[-0]._CellPtr);
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 118:
# line 760 "MSAnalysis/src/pars.y"
{ 
				if (strncmp(actual_page_name, yypvt[-2].s_val, strlen(actual_page_name)) != 0)
					YaccError("arc-bind-place is not from this page", yypvt[-2].s_val);
				yyval._ArcBindElementPtr = new ArcBindElement(CheckIfPortGetRef(yypvt[-2].s_val),yypvt[-0]._CellPtr);
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 119:
# line 770 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 120:
# line 771 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr;			    } break;
case 121:
# line 772 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(true);  	    } break;
case 122:
# line 773 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(false); 	    } break;
case 123:
# line 774 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(true);  	    } break;
case 124:
# line 775 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr;        		    } break;
case 125:
# line 777 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new UnaerOp(logic_not,yypvt[-0]._CellPtr);   
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr; 
			} break;
case 126:
# line 782 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(logic_and,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);
				yypvt[-2]._CellPtr->Clear(); yypvt[-0]._CellPtr->Clear();
				delete yypvt[-2]._CellPtr; delete yypvt[-0]._CellPtr;
			} break;
case 127:
# line 788 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(logic_or,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);
				yypvt[-2]._CellPtr->Clear(); yypvt[-0]._CellPtr->Clear();
				delete yypvt[-2]._CellPtr; delete yypvt[-0]._CellPtr;
			} break;
case 128:
# line 795 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(yypvt[-1]._Operator,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);      
				yypvt[-2]._CellPtr->Clear(); yypvt[-0]._CellPtr->Clear();
				delete yypvt[-2]._CellPtr; delete yypvt[-0]._CellPtr;
			} break;
case 129:
# line 801 "MSAnalysis/src/pars.y"
{ 	
				yyval._CellPtr = new BinaerOp(yypvt[-1]._Operator,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);      
				yypvt[-2]._CellPtr->Clear(); yypvt[-0]._CellPtr->Clear();
				delete yypvt[-2]._CellPtr; delete yypvt[-0]._CellPtr;
			} break;
case 130:
# line 807 "MSAnalysis/src/pars.y"
{ yyval._Operator = equal; 		            } break;
case 131:
# line 808 "MSAnalysis/src/pars.y"
{ yyval._Operator = less;  	 	            } break;
case 132:
# line 809 "MSAnalysis/src/pars.y"
{ yyval._Operator = greater; 		    } break;
case 133:
# line 810 "MSAnalysis/src/pars.y"
{ yyval._Operator = not_equal;		    } break;
case 134:
# line 811 "MSAnalysis/src/pars.y"
{ yyval._Operator = less_or_equal; 	            } break;
case 135:
# line 812 "MSAnalysis/src/pars.y"
{ yyval._Operator = greater_or_equal; 	    } break;
case 136:
# line 817 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 137:
# line 818 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 138:
# line 819 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 139:
# line 820 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr; 			    } break;
case 140:
# line 822 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new UnaerOp(minus,yypvt[-0]._CellPtr);       
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 141:
# line 827 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(plus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);    
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 142:
# line 833 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(minus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);   
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 143:
# line 839 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(multiply,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 144:
# line 845 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(divide,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);  
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 145:
# line 851 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 146:
# line 852 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 147:
# line 853 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr; 			    } break;
case 148:
# line 855 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 149:
# line 856 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 150:
# line 857 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr; 			    } break;
case 151:
# line 859 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 152:
# line 860 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 153:
# line 861 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 154:
# line 863 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 155:
# line 869 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 156:
# line 875 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 157:
# line 876 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 158:
# line 877 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 159:
# line 879 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 160:
# line 885 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(plus, yypvt[-2]._CellPtr, yypvt[-0]._CellPtr);  
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 161:
# line 892 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(multiply,yypvt[-3]._CellPtr,yypvt[-0]._CellPtr);
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 162:
# line 898 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(multiply,yypvt[-3]._CellPtr,yypvt[-0]._CellPtr);
				yypvt[-3]._CellPtr->Clear(); delete yypvt[-3]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 163:
# line 907 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 164:
# line 908 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 165:
# line 909 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 	    		    } break;
case 166:
# line 910 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 			    } break;
case 167:
# line 911 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr; 			    } break;
case 168:
# line 913 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new UnaerOp(minus,yypvt[-0]._CellPtr);       
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 169:
# line 918 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(plus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);    
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 170:
# line 924 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(minus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);   
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 171:
# line 930 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(divide,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);  
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 172:
# line 936 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(multiply,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr);
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 173:
# line 942 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(yypvt[-0].d_val); 	    } break;
case 174:
# line 943 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(yypvt[-0].i_val); 	    } break;
case 175:
# line 948 "MSAnalysis/src/pars.y"
{yyval._CellPtr=yypvt[-0]._CellPtr; 			    	    } break;
case 176:
# line 949 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(absolut,yypvt[-0].s_val);    	    } break;
case 177:
# line 950 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(absolut,yypvt[-3].s_val,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 178:
# line 951 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(absolut,yypvt[-3].s_val,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 179:
# line 952 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(absolut,yypvt[-3].s_val,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 180:
# line 955 "MSAnalysis/src/pars.y"
{ 
				if (section == def_sec) yyval.s_val = yypvt[-0].s_val;
				else			yyval.s_val = CheckIfPortGetName(yypvt[-0].s_val);
			} break;
case 181:
# line 960 "MSAnalysis/src/pars.y"
{yyval._CellPtr=yypvt[-0]._CellPtr; 			    	    } break;
case 182:
# line 961 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(contents,yypvt[-0].s_val);   	    } break;
case 183:
# line 962 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(contents,yypvt[-3].s_val,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 184:
# line 963 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(contents,yypvt[-3].s_val,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 185:
# line 964 "MSAnalysis/src/pars.y"
{yyval._CellPtr=new Function(contents,yypvt[-3].s_val,yypvt[-1]._CellPtr);yypvt[-1]._CellPtr->Clear();delete yypvt[-1]._CellPtr;} break;
case 186:
# line 967 "MSAnalysis/src/pars.y"
{ 
				if (section == def_sec) yyval.s_val = yypvt[-0].s_val;
				else			yyval.s_val = CheckIfPortGetName(yypvt[-0].s_val);
			} break;
case 187:
# line 974 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr; 					    } break;
case 188:
# line 975 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-1]._CellPtr; 					    } break;
case 189:
# line 977 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 		    			    } break;
case 190:
# line 979 "MSAnalysis/src/pars.y"
{ 
                        	yyval._CellPtr = new BinaerOp(plus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr); 		    
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
                        } break;
case 191:
# line 985 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = yypvt[-0]._CellPtr; 		    			    } break;
case 192:
# line 987 "MSAnalysis/src/pars.y"
{ 
				yyval._CellPtr = new BinaerOp(plus,yypvt[-2]._CellPtr,yypvt[-0]._CellPtr); 		    
				yypvt[-2]._CellPtr->Clear(); delete yypvt[-2]._CellPtr;
				yypvt[-0]._CellPtr->Clear(); delete yypvt[-0]._CellPtr;
			} break;
case 193:
# line 993 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(new TokenMSVal(yypvt[-0]._TokenRef, 1)); 	    } break;
case 194:
# line 995 "MSAnalysis/src/pars.y"
{ 
                        	if (yypvt[-2].i_val > MAX_QUANT) yypvt[-2].i_val = MAX_QUANT;
                        	yyval._CellPtr = new ConstVal(new TokenMSVal(yypvt[-0]._TokenRef,Quant(yypvt[-2].i_val))); 	    
                        } break;
case 195:
# line 1000 "MSAnalysis/src/pars.y"
{ yyval._CellPtr = new ConstVal(new TokenMSVal(NO_COLOR, 1));} break;
case 196:
# line 1002 "MSAnalysis/src/pars.y"
{ 
                        	if (yypvt[-2].i_val > MAX_QUANT) yypvt[-2].i_val = MAX_QUANT;
				yyval._CellPtr = new ConstVal(new TokenMSVal(NO_COLOR,Quant(yypvt[-2].i_val)));
			} break;
case 197:
# line 1011 "MSAnalysis/src/pars.y"
{ 
			  	Token    tok(StripOfPath(yypvt[-2].s_val),yypvt[-1].s_val,StripOfPath(yypvt[-0].s_val));
			  	int tr = TokenRefList.UniqueAppend(tok);
			  	if (tr < 0) tr = -tr;
			  	if (tr > MAX_TREF) yyerror("too much tokens defined (max = 65536)");
			  	yyval._TokenRef = TokenRef(tr);
			} break;
case 198:
# line 1019 "MSAnalysis/src/pars.y"
{
			  	Token    tok(StripOfPath(yypvt[-2].s_val),yypvt[-1].s_val, GetNumberString(yypvt[-0].i_val));
			  	int tr = TokenRefList.UniqueAppend(tok);
			  	if (tr < 0) tr = -tr;
			  	if (tr > MAX_TREF) yyerror("too much tokens defined (max = 65536)");
			  	yyval._TokenRef = TokenRef(tr);
			} break;
case 199:
# line 1027 "MSAnalysis/src/pars.y"
{ 
			  	Token    tok(StripOfPath(yypvt[-1].s_val), WILDCARD, WILDCARD);
			  	int tr = TokenRefList.UniqueAppend(tok);
			  	if (tr < 0) tr = -tr;
			  	if (tr > MAX_TREF) yyerror("too much tokens defined (max = 65536)");
			  	yyval._TokenRef = TokenRef(tr);
			} break;
case 200:
# line 1035 "MSAnalysis/src/pars.y"
{ yyval.s_val = StripOfPath(yypvt[-1].s_val);    } break;
case 201:
# line 1036 "MSAnalysis/src/pars.y"
{ yyval.s_val = WILDCARD;   	    } break;
case 202:
# line 1037 "MSAnalysis/src/pars.y"
{ yyval.s_val = GetNumberString(yypvt[-1].i_val);} break;
case 203:
# line 1038 "MSAnalysis/src/pars.y"
{ yyval.s_val = STDVERSION; 	    } break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

