%C
%{
/* ************************************************************************
*                                                                          
*  Programm       :     scandfunc.x  (LEX-Quellprogramm)                     
*                                                                          
*  Aufgabe        :     Scannen fuer "parsdfunc.y" realisierten Parser.     
*                                                                          
*  Programmierer  :     Joerg W. Mitzlaff
*                                                                          
*  Datum          :     Juni 1993                                        
*                                                                          
*************************************************************************/


#include <stdio.h>
#include <unistd.h>
#include "y.tab.h"

/********************************************************/
/*              changed for agnes                       */
/********************************************************/
#ifdef __linux__
extern int fileno(FILE*);
#endif
/********************************************************/


%}

/*----------------------------------------------------------------*/

D    [0-9]
E    [DEde][-+]?{D}+

/*----------------------------------------------------------------*/

%%
[ \t\n]+   	{ ; }
"*"        	{ ; }
"TRANSITION"    { return(TRANSITION); }
"DETERMINISTIC" { return(DETERMINISTIC); }
"UNIFORM"       { return(UNIFORM); }
"x^"            { return(XPOT); }
"e^"            { return(EPOT); }

"R"     	{ return(R); }
"I"     	{ return(I); }
"x"     	{ return(X); }
"("     	{ return(ROPA); }
")"     	{ return(RCPA); }
"["     	{ return(EOPA); }
"]"     	{ return(ECPA); }
","     	{ return(COM); }
";"     	{ return(SEM); }
"+"     	{ return(PLUS); }
"-"     	{ return(MINUS); }

{D}+     	   {
			sscanf(yytext,"%i",&yylval.uval);
           		return(POS_INT);
         	   }

{D}+"."{D}*({E})?  |
{D}*"."{D}+({E})?  |
{D}+{E}            {
			sscanf(yytext,"%le",&yylval.dval);
                     	return(POS_REAL);
                   }

"-"{D}+"."{D}*({E})?  |
"-"{D}*"."{D}+({E})?  |
"-"{D}+{E}            {
			sscanf(yytext,"%le",&yylval.dval);
                        return(NEG_REAL);
                      }         

%%

/*----------------------------------------------------------------*/
