#ifndef __token_multiset_cc__
#define __token_multiset_cc__

#include <iostream.h>
#include "token_multiset.h"

//###################################################################################################
void		add_token(token_multiset*& tms, token_referenz* tr)
{
	if (!tr)    	 return;
	if (!tms) 	 { tms = new token_multiset; tms->first = NULL; tms->quant = 0; tms->key = 0; }
	if (!tms->first) 
	{
		tms->first 	  = new token_referenz;
		tms->first->tref  = tr->tref;
		tms->first->quant = tr->quant;
		tms->first->next  = NULL;
		tms->quant   	  = tr->quant;
		tms->key   	  = int(tr->quant + tr->tref);
		return;
	}
	for (token_referenz* tmp=tms->first; tmp; tmp=tmp->next)
	{
		if (tmp->tref == tr->tref) 
		{
			tmp->quant += tr->quant; 
			tms->quant += tr->quant;
			tms->key   += int(tr->quant);
			return;
		}
	}
	token_referenz* new_tr = new token_referenz;
	new_tr->tref           = tr->tref;
	new_tr->quant          = tr->quant;
	new_tr->next           = tms->first;
	tms->first             = new_tr;
	tms->quant            += tr->quant;
	tms->key              += int(tr->quant + tr->tref);
}
//---------------------------------------------------------------------------------------------------
void		sub_token(token_multiset*& tms, token_referenz* tr)
{
	if (!tr || !tms || !(tms->first)) return;

        if (!(tms->first->next))
	{
		if (tms->first->tref == tr->tref)
		{
			if (tr->quant >= tms->first->quant)
			{
				delete tms->first; tms->first = NULL;
				delete tms       ; tms        = NULL;
			}
			else
			{
				tms->first->quant -= tr->quant;
				tms->quant        -= tr->quant;
				tms->key          -= int(tr->quant);
			}
		}
		return;
	}
	else
	{
		if (tms->first->tref == tr->tref)
		{
			if (tr->quant >= tms->first->quant)
			{
				token_referenz* tmp = tms->first; 
				tms->quant -= tms->first->quant;
				tms->key   -= int(tms->first->quant);
				tms->key   -= int(tms->first->tref); 
				tms->first  = tms->first->next;
				delete tmp;
			}
			else
			{
				tms->first->quant -= tr->quant;
				tms->quant        -= tr->quant;
				tms->key          -= int(tr->quant);
			}
			return;
		}
	}

	for (token_referenz* tmp1=tms->first, *tmp2=tms->first->next; tmp2; tmp1=tmp1->next, tmp2=tmp2->next)
	{
		if (tr->tref == tmp2->tref)
		{
			if (tr->quant >= tmp2->quant)
			{
				tmp1->next  = tmp2->next;
				tms->quant -= tmp2->quant;
				tms->key   -= int(tmp2->quant);
				tms->key   -= int(tmp2->tref); 
				delete tmp2;
			}
			else
			{
				tmp2->quant -= tr->quant;
				tms->quant  -= tr->quant;
				tms->key    -= int(tr->quant);
			}
			return;
		}
	}
}
//---------------------------------------------------------------------------------------------------
//
//	returns true, if tms1 < tms2
//
//---------------------------------------------------------------------------------------------------
bool	tms_is_less(token_multiset* tms1, token_multiset* tms2)
{
	if (!tms1 && !tms2) 	return false;
	if (!tms1)		return true;
	if (!tms2)		return false;

	int no_tr1 = 0;
	int no_tr2 = 0;
	bool found = false;

	for (token_referenz* tr1=tms1->first; tr1; tr1=tr1->next)
	{
		no_tr1++;
		found = false;
		for (token_referenz* tr2=tms2->first; tr2; tr2=tr2->next)
		{
			if (tr1->tref == tr2->tref)
			{
				found = true;
				if (tr1->quant >= tr2->quant) 
					return false;
			}
		}
		if (!found) return false;
	}
	for (token_referenz* t2=tms2->first; t2; t2=t2->next)
		no_tr2++;

	if (no_tr1 > no_tr2) return false;

	return true;
}
//---------------------------------------------------------------------------------------------------
//
//	returns true, if tms1 > tms2
//
//---------------------------------------------------------------------------------------------------
bool	tms_is_more(token_multiset* tms1, token_multiset* tms2)
{
	if (!tms1 && !tms2) 	return false;
	if (!tms1)		return false;
	if (!tms2)		return true;

	int no_tr1 = 0;
	int no_tr2 = 0;

	for (token_referenz* tr1=tms1->first; tr1; tr1=tr1->next)
	{
		no_tr1++;
		for (token_referenz* tr2=tms2->first; tr2; tr2=tr2->next)
			if (tr1->tref == tr2->tref)
				if (tr1->quant <= tr2->quant) 
					return false;
	}
	for (token_referenz* t2=tms2->first; t2; t2=t2->next)
		no_tr2++;

	if (no_tr1 < no_tr2) return false;

	return true;
}
//---------------------------------------------------------------------------------------------------
//
//	returns true, if tms1 <= tms2
//
//---------------------------------------------------------------------------------------------------
bool	tms_is_less_or_equal(token_multiset* tms1, token_multiset* tms2)
{
	if (!tms1 && !tms2) 	return true;
	if (!tms1)		return true;
	if (!tms2)		return false;

	int no_tr1 = 0;
	int no_tr2 = 0;
	bool found = false;

	for (token_referenz* tr1=tms1->first; tr1; tr1=tr1->next)
	{
		no_tr1++;
		found = false;
		for (token_referenz* tr2=tms2->first; tr2; tr2=tr2->next)
		{
			if (tr1->tref == tr2->tref)
			{
				found = true;
				if (tr1->quant > tr2->quant) 
					return false;
			}
		}
		if (!found) return false;
	}
	for (token_referenz* t2=tms2->first; t2; t2=t2->next)
		no_tr2++;

	if (no_tr1 > no_tr2) return false;
	return true;
}
//---------------------------------------------------------------------------------------------------
//
//	returns true, if tms1 >= tms2
//
//---------------------------------------------------------------------------------------------------
bool	tms_is_more_or_equal(token_multiset* tms1, token_multiset* tms2)
{
	if (!tms1 && !tms2) 	return true;
	if (!tms1)		return false;
	if (!tms2)		return true;

	int no_tr1 = 0;
	int no_tr2 = 0;

	for (token_referenz* tr1=tms1->first; tr1; tr1=tr1->next)
	{
		no_tr1++;
		for (token_referenz* tr2=tms2->first; tr2; tr2=tr2->next)
			if (tr1->tref == tr2->tref)
				if (tr1->quant < tr2->quant) 
					return false;
	}
	for (token_referenz* t2=tms2->first; t2; t2=t2->next)
		no_tr2++;

	if (no_tr1 < no_tr2) return false;

	return true;
}
//---------------------------------------------------------------------------------------------------
bool	tms_are_equal(token_multiset* tms1, token_multiset* tms2)
{
	if (!tms1 && !tms2) return true;
	if (!tms1 || !tms2) return false;

	if (tms1->quant != tms2->quant) return false;
	if (tms1->key   != tms2->key)   return false;

	if (!(tms1->first) && !(tms2->first)) return true;
	if (!(tms1->first) || !(tms2->first)) return false;

	int no_tr1 = 1;
	int no_tr2 = 1;

	for (token_referenz* tr1=tms1->first; tr1; tr1=tr1->next)
	{
		for (token_referenz* tr2=tms2->first; tr2; tr2=tr2->next)
			if (tr1->tref == tr2->tref)
				if (tr1->quant != tr2->quant) return false;
		no_tr1++;
	}
	for (token_referenz* t2=tms2->first; t2; t2=t2->next)
		no_tr2++;

	if (no_tr1 != no_tr2) return false;
	return true;
}
//---------------------------------------------------------------------------------------------------
void		clear_pms(token_multiset**& pms, int sz)
{
	for (int i=0; i<sz; i++)
		clear_tms(pms[i]);
	delete[] pms;
}
//---------------------------------------------------------------------------------------------------
void		clear_tms(token_multiset*& tms)
{
	if (!tms) return;
	if (!(tms->first))     	   
	{ 
		delete tms; 
		tms = NULL; 
		return; 
	}
	if (!(tms->first->next))   
	{ 
		delete tms->first; 
		tms->first = NULL; 
		delete tms; 
		tms = NULL; 
		return; 
	}

	for (token_referenz* tmp=tms->first->next; tmp; tmp=tmp->next)
	{
		delete tms->first;
		tms->first = tmp;
	}
	delete tms->first;
	tms->first = NULL;
	tms->quant = 0;
	tms->key   = 0;
	delete tms; 
	tms 	   = NULL; 
}
//---------------------------------------------------------------------------------------------------
int		get_quantity(token_multiset* tms)
{
	if (!tms) return 0;
	return int(tms->quant); 
}
//---------------------------------------------------------------------------------------------------
int		get_tref_quantity(token_multiset* tms, int tr)
{
	if (!tms || !(tms->first)) return 0;
	for (token_referenz* tmp=tms->first; tmp; tmp=tmp->next)
		if (tmp->tref == tr) return int(tmp->quant);
	return 0;
}
//---------------------------------------------------------------------------------------------------
token_multiset*	copy_token_multiset(token_multiset* tms)
{
	if (!tms || !(tms->first)) return NULL;

	token_multiset* ret_tms 	     = new token_multiset;
			ret_tms->first	     = new token_referenz;
			ret_tms->quant	     = tms->quant;
			ret_tms->key	     = tms->key;
			ret_tms->first->next = NULL; 

	for (token_referenz* tok=tms->first, *tmp=ret_tms->first; tok; tok=tok->next, tmp=tmp->next)
	{
		tmp->tref  = tok->tref;
		tmp->quant = tok->quant;
		if (tok->next)  tmp->next = new token_referenz;
		else            tmp->next = NULL;
	}
	return ret_tms;
}
//---------------------------------------------------------------------------------------------------
token_multiset*	make_empty_tms()
{
	token_multiset*	ret = new token_multiset;

	ret->first = NULL;
	ret->quant = 0;
	ret->key   = 0;

	return ret;
}
//###################################################################################################
#endif
