#ifndef __token_multiset_h__
#define __token_multiset_h__

#include "Types.h"

typedef struct token_referenz
{
	TokenRef	tref;
	Quant 		quant;
	token_referenz*	next;
} token_referenz;

typedef struct token_multiset
{
	Quant		quant;
	int		key;
	token_referenz*	first;
} token_multiset;

void		clear_tms		(token_multiset*&);
void		clear_pms		(token_multiset**&, int);

void		add_token		(token_multiset*&, token_referenz*);
void		sub_token		(token_multiset*&, token_referenz*);
bool		tms_is_less  		(token_multiset*,  token_multiset*);
bool		tms_is_more  		(token_multiset*,  token_multiset*);
bool		tms_are_equal		(token_multiset*,  token_multiset*);
bool		tms_is_less_or_equal  	(token_multiset*,  token_multiset*);
bool		tms_is_more_or_equal  	(token_multiset*,  token_multiset*);

int		get_quantity		(token_multiset*);
int		get_tref_quantity	(token_multiset*,int);

token_multiset*	copy_token_multiset	(token_multiset*);
token_multiset*	make_empty_tms		();

#endif
