#include <iomanip.h>
#include "M_Measure.h"

bool M_Measure::conf_warning = false;

M_Measure::M_Measure (char *n, double *v) : Measure(n,v) {

  // Nach dem Parsen muss geprueft werden, ob das Measure "volatile" ist,
  // d.h. mehr als eine Primitive hat. Dann stimmen die Konfidenzintervalle
  // fuer das zusammengesetzte Mass nicht und der Benutzer muss gewarnt werden.

  if (prims.Size() > 1)
    M_Measure::conf_warning = true;
}


double M_Measure::GetPrimVal(int index) {

  return (PrimList[index]->GetMean());
}


void M_Measure::Result() {

  double epsilon, prim_value, value = Calc();
  int index;

  cout.precision(3);
  cout.setf(ios::fixed);
  cout.setf(ios::left);

  // Datenuebergabe an Agnes
  cout << "!setattribute " << name+9 <<" val \""<< value <<"\"\n"; 

  // Datenausgabe fuer Benutzer
  cout << setfill('.') << setw (20) << name+9 << "  " << setfill(' ');
  cout.setf(ios::internal);

  if (prims.Size() == 1) {
    // Das Measure hat nur eine Primitive
    double epsilon = PrimList[prims[0]]->GetEpsilon();
    cout << setw(7) << value << "  [";
    cout << setw(7) << value * (1-epsilon) << ";";
    cout << setw(7) << value * (1+epsilon) << "]    ";
    cout << setw(5) << epsilon;  
    if (PrimList[prims[0]]->GetStatus() != COMPLETE) 
      cout << "     unpraezise!!";
    cout << '\n';
  }
  else {
    // Das Measure besteht aus mehreren Primitiven
    cout << setw(7) << value << "   * (siehe unten)\n";
    for (index = 0; index < prims.Size(); ++index) {
      prim_value = PrimList[prims[index]]->GetMean();
      epsilon = PrimList[prims[index]]->GetEpsilon();
      cout << "                      " << setw(7) << prim_value;
      cout << "  [" << setw(7) << prim_value * (1-epsilon) << ";";
      cout << setw(7) << prim_value * (1+epsilon) << "]    ";
      cout << setw(5) << epsilon;  
      if (PrimList[prims[index]]->GetStatus() != COMPLETE) 
	cout << "     unpraezise!!";
      cout << '\n';
    }
  }
}



