#ifndef __STATISTIC_H__
#define __STATISTIC_H__

#include "Sample.h"

#define M0 100

typedef enum { DATA_TO_PROCESS,         // das Measure ist noch nicht fertig berechnet
	       COMPLETE                 // Berechnung ist erfolgt
} StatisticStatus;


class Statistic {

  StatisticStatus Status;
  int             SampleCount;          // Zahl der bisherigen Samples
  double          Sequence[2*M0];       // Liste der Batch-Means zur Varianzanalyse
  Sample          SampleSequence[2*M0]; // Liste der kumulierten Samples
  Sample          Sum;                  // Summe fuer den aktuellen Batch
  int             BatchSize;            // Groesse der Batch-Gruppen
  int             BatchIndex;           // aktueller Index in der Sequence
  int             CheckNumber;          // Zahl der bisherigen Varianzschaetzungen
  int             CheckLocNext;         // naechster Zeitpunkt fuer Varianzschaetzung
  Sample          MeanValue;            // aktueller Wert des Measures
  double          DeltaX;               // halbe Breite des Konfidenzintervalls
  double          Epsilon;              // aktueller rel. Fehler
  double          TotalTransientTime;   // Die Summe der Transienten Laengen aller Slaves
  ComfVector<double> Times;             // Die Zeiten der letzten Samples

  void            Add2Batch();          // Neuen Mittelwert zu Sequence hinzufuegen
  void            Calculate();          // Die Schaetzungen neu bestimmen

public:

  Statistic();

  void             AddSamples(Sample *, int, int, double);
  StatisticStatus  GetStatus();
  double           GetMean();
  double           GetEpsilon();
  //  double           Result();
  void             AddTransientTime(double);
};

#endif
