typedef enum { WAIT_FOR_CONNECT, // Der Slave initialisiert sich gerade
	       RECEIVING,        // Simulationsdaten werden laufend empfangen
	       DEAD              // Der Slave meldet sich nicht mehr :-(
} SlaveStatus;

//****************************************************
//
//  Der Komplize verwaltet je einen Simulationslauf
//  auf einem anderen Rechner.
//  Fuer die Simulation wird ein Prozess abgespalten,
//  der eine Remoteshell erzeugt und per Socket eine
//  Verbindung zum Slave gehalten.
//  Die empfangenen Daten werden gespeichert und die
//  Laenge der transienten Phase ermittelt.
//  Alle weiteren Daten werden im globalen Store-Objekt
//  gespeichert.
//  Bei Beendigung des Masters werden die Kind-Prozesse
//  noch schnell getoetet.

class Accomplice {
  char         *hostname;   // Name des Slave-Rechners
  SlaveStatus  status;      // aktueller Status
  int          pid;         // Prozess-ID des lokalen 'rsh'-Prozesses
  double       modeltime;   // aktuelle Zeit der Simulation
  int          socket;      // Der Socket zum Slave-Prozess

public:
  Accomplice (char *host);
  ~Accomplice();

  bool         CheckIfMySlave(unsigned short iaddress, int socket);
  SlaveStatus  GetStatus();
  void         Kill();
  ReadData();
  
