#ifndef __COMFVECTOR_H__
#define __COMFVECTOR_H__
//*****************************************************************************
//
// Class Name :  ComfVector
// Purpose    :  a comfortable vector class
// Derived    :  
// Description:  This class provides a java-like class vector.
//               Elements are stored in an array. Adding arrays may result
//               in automatic resizing the array.
//               Access to array elements via operator []. If index is
//               out of bounds, an error occurs.
//
//*****************************************************************************

// Vordefinierte Faltungs-Operatoren
typedef enum {VECTOR_PLUS, VECTOR_ARGMIN} VOperator;


template <class T> class ComfVector {

protected:
  T   *element_data;
  int element_count;
  int capacity_increment;
  int capacity;

public:
  ComfVector(int initialCapacity, int capacityIncrement);
  ComfVector(int initialCapacity);
  ComfVector();

  ~ComfVector();

  void Append(const ComfVector<T>& aVector);
  void Append(T anArray[], int length);
  void Append(T element);
  void Resize(int size);
  void CutDown(int size);
  void Replace(int index, T element);
  void Clear();
  int  Capacity();
  int  Size();
  int  IsEmpty();
  T&   operator[] (int index);
  T    Fold(VOperator operation);
  void print(char *);

};

#endif





