#ifndef _MEASURE_H
#define _MEASURE_H

#include "ComfVector.h"

#define M_CONST       -1
#define M_UNAER_MINUS -2
#define M_UNAER_NOT   -3
#define M_PLUS        -4
#define M_MINUS       -5
#define M_TIMES       -6
#define M_DIV         -7
#define M_EQUAL       -8
#define M_GREATER     -9
#define M_LOWER      -10
#define M_NOTEQUAL   -11
#define M_GREATEQ    -12
#define M_LOWEQ      -13
#define M_AND        -14
#define M_OR         -15
#define M_PRIMITIVE  -16

typedef enum{CONSTRUCTING, PARSED} MeasureStatus;

class Measure {

protected:
  char                *name;
  ComfVector<double>  expression;
  MeasureStatus       status;
  ComfVector<int>     prims;

  int Check(int index);              // rekursive Routine zum Parsen
  double Calc();                     // Berechnet den Wert
  int ParseCalc(int, double &);      // Die Auswerteroutine
  virtual double GetPrimVal(int)=0;  // Holt den Wert der Primitiven fuer Calc()

public:

  Measure(char *, double *);         // Parsiert den Ausdruck im Double-Array
  Measure(char *);                   // Legt den Namen fest. Append muss folgen
  void Append(double x);             // Erzeugt den Ausdruck
  void Parse();                      // Prueft den Ausdruck und setzt Status
  char *GetName() {return name;};
  double *Export();                  // Konvertierung in Double-Array
  virtual void Result() = 0;         // Ausgabe der Ergebnisse
  bool operator == (Measure& m);
};


#endif

