#ifndef __SAMPLE_H__
#define __SAMPLE_H__
//*****************************************************************************
//
// Class Name :  Sample
// Purpose    :  Organizing Sample-Data (Value and Time)
// Derived    :  
// Description:  This class provides a container for sample-data.
//               A samples consists of a value and a time period.
//               The estimated value of the measure ist (value / time).
//               An operator + is also provided.
//               
//
//*****************************************************************************

class Sample {

public:

  double value;
  double time;

  Sample() {value = 0.0; time = 0.0;};
  Sample(double v, double t) {value = v; time = t;};

  operator double() {return (value/time);};
  Sample& operator +(Sample s) {value += s.value; time +=s.time; return *this;};
  Sample& operator = (Sample s) {value = s.value; time = s.time; return *this;};
};

#endif





