#ifndef __PORTAB_H__
#define __PORTAB_H__

// Dieses File ist voll mit Anpassungen an die verschiedenen 
// Plattformen. Unix und C++ sind naemlich so wunderbar
// portabel ;-)
//
// Die Makros muessen im Makefile ermittelt und beim g++-Aufruf gesetzt werden
// (Option -ansi verhindert die Standard-Makros
//
// Die Makros sind
//
// OSF     fuer lemming (DEC)   (Standard __osf__)
//
// LINUX   fuer LinuX auf Intel (Standard __linux)
//
// SOL2    fuer Sun Solaris 2   (sun && __svr4__)
//
// SUNOS4  fuer SunOS4          (sun && !__svr4__)


#if defined (OSF)
#include <sys/fcntl.h>
const mode_t OPENFLAGS = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH ;


#elif defined (LINUX)
const int OPENFLAGS = 420;
#define P_PID 1
#define sigsend(c,p,s) (kill((p),(s)))
#define getpagesize() 4096

// Solaris 2
#elif defined(SOL2)
#include <sys/types.h>
#include <signal.h>
const int OPENFLAGS = 0;
//extern int gethostname(char *, int);
extern int sigsend(idtype_t, id_t, int);
//extern int kill(pid_t, int);

// SunOS 4
#elif defined(SUNOS4)
const int OPENFLAGS = 0;
#define P_PID 1
#define sigsend(c,p,s) (kill((p),(s)))
extern "C" {
// Ohne Prototyp gibt es aber Warnings im Compiler. Leider in den Standard-Headers nicht drin
struct timeval;
struct fd_set;
struct sockaddr;
int select(int, struct fd_set *, struct fd_set *, struct fd_set *, struct timeval *);
int bzero(char *, int);
int accept(int, struct sockaddr *, int *);
int socket(int, int, int);
int bind(int, struct sockaddr *, int);
int getsockname(int, struct sockaddr *, int *);
int listen(int, int);
int gethostname(char *, int);
int connect(int, struct sockaddr *, int);
}

#endif

#endif
