#ifndef __ARCBINDELEMENT_H__
#define __ARCBINDELEMENT_H__

#include "Types.h"
//###########################################################################
class Cell;
//###########################################################################
class ArcBindElement
{
	Place*		place;
	Cell*		tokenms;
	TokenMultiSet*	result_tms;

	void		NewCell(Cell*);
public:
	ArcBindElement();
	ArcBindElement(int);
	ArcBindElement(Place*, Cell*);
	ArcBindElement(const ArcBindElement&);
	~ArcBindElement() { Clear(); }

	//------------------------------------------------------------------
	//	Clear	
	//------------------------------------------------------------------
	void		Clear();

	//------------------------------------------------------------------
	//	"Getten"
	//------------------------------------------------------------------
	Place*		GetPlace();
	const Place*&	GetPlaceRef();
	TokenMultiSet*	GetArcTokenMultiSet();
	Cell*		GetTokenMultiSetCell();
	int		GetActColor();
	int		GetActCapacity();

	//------------------------------------------------------------------
	//	Operatoren
	//------------------------------------------------------------------
	ArcBindElement&	operator =(const ArcBindElement&) ;
	bool		operator==(ArcBindElement&);
	bool		operator!=(ArcBindElement&);

	//------------------------------------------------------------------
	//	Listen-Operator
	//------------------------------------------------------------------
	bool		LessThan(ArcBindElement&) ;
	static char*	GetName();
};
//##########################################################################
#endif
