#ifndef __DELAYVAL_CC__
#define __DELAYVAL_CC__

#include "DelayVal.h"

extern	unsigned char	bits[];

//################################################################################################################
DelayVal::DelayVal()				
	: 	delay_val(DEF_DELAY_VAL), 	      
		trans_ref(DEF_TRANS_REF),
		delay_typ(0)			{};	

DelayVal::DelayVal(int)				
	: 	delay_val(DEF_DELAY_VAL), 	      
		trans_ref(DEF_TRANS_REF),
		delay_typ(0)			{};	

DelayVal::DelayVal(const DelayVal& d)		
	: 	delay_val(d.delay_val),   	      
		trans_ref(d.trans_ref),
		delay_typ(d.delay_typ)		{};	

DelayVal::DelayVal(double dv, int dt)	
	: 	delay_val((dv>0?dv:DEF_DELAY_VAL)), 
		trans_ref(DEF_TRANS_REF),
		delay_typ(0)			{ delay_typ = (0 | bits[dt]); }	

DelayVal::DelayVal(double dv, int dt, int tref)	
	: 	delay_val((dv>0?dv:DEF_DELAY_VAL)), 
		trans_ref(tref),
		delay_typ(0)			{ delay_typ = (0 | bits[dt]); }	

//###############################################################################################################
void		DelayVal::Clear()					{ ;					}
double		DelayVal::GetDelayVal()					{ return delay_val; 			}
int		DelayVal::GetTransitionRef()				{ return trans_ref; 			}
void		DelayVal::ChangeDelayVal(double d)			{ delay_val = (d>0?d:DEF_DELAY_VAL); 	}
void		DelayVal::ChangeTransitionRef(int tr)			{ trans_ref = tr; 			}
bool		DelayVal::LessThan(DelayVal& dv)			{ return (delay_val < dv.delay_val); 	}
char*		DelayVal::GetName()					{ return DEF_STRING; 			}
bool		DelayVal::operator!=(DelayVal& d)			{ return !(*this == d);  		}
//---------------------------------------------------------------------------------------------------------------
bool		DelayVal::operator==(DelayVal& d)   
{ 
	return ( delay_val == d.delay_val && delay_typ == d.delay_typ); 
}
//---------------------------------------------------------------------------------------------------------------
DelayVal&	DelayVal::operator =(const DelayVal& d)	
{ 
	delay_val = (d.delay_val>0?d.delay_val:DEF_DELAY_VAL);
	delay_typ = d.delay_typ;
	trans_ref = d.trans_ref;
	return *this;
}
//###############################################################################################################
#endif
