#ifndef	__LIST_H__
#define __LIST_H__

#include "Types.h"
//#################################################################################################
template<class T> class ListElement
{
public:
	T		lelement;
	ListElement<T>* next;

	ListElement();
	ListElement(const T& le, ListElement<T>* n);
	ListElement(const ListElement<T>& le);

	// setzt nur lelement gleich
	ListElement<T>& operator =(const ListElement<T>& le);

};

//#################################################################################################
template<class T> class List
{
public:
	int	 	 size;
	ListElement<T>*	 first;
	ListElement<T>*	 last;

	List();
	List(const T& le);
	List(const T* le);
	List(const List<T>& l);
	List(const T& le1, const T& le2);
	List(const List<T>& l1, const List<T>& l2);
	~List() { Clear(); }

	//-----------------------------------------------------------------------------------------
	// 	Liste leeren	
	//-----------------------------------------------------------------------------------------
	void     Clear();				// deletes all elements 

	//-----------------------------------------------------------------------------------------
	// 	Elemente anhaengen
	//-----------------------------------------------------------------------------------------
	int 	Append(const T& e);			// returns pos of "e"
	int 	UniqueAppend(const T& e);		// returns -pos if "e" already exists
	T*  	UniqueNameAppend(const T& e);		// returns NULL if name of "e" already exists

	//-----------------------------------------------------------------------------------------
	// 	Elemente einsortieren
	//-----------------------------------------------------------------------------------------
	T*  	Insert(const T& e, bool& exists);	// returns e (exists=false => e allready exists)

	//-----------------------------------------------------------------------------------------
	// 	Suchen	
	//-----------------------------------------------------------------------------------------
	bool	 IsIn(T);				// returns true if e is in List, else false 

	//-----------------------------------------------------------------------------------------
	// 	Elemente loeschen
	//-----------------------------------------------------------------------------------------
	int 	DeleteElement(T);			// returns old pos of deleted element or -1
	int 	DeleteElement(int);			// returns old pos of deleted element or -1

	//-----------------------------------------------------------------------------------------
	// 	Klassen-Parameter manipulieren
	//-----------------------------------------------------------------------------------------
	int  	ChangeElement(T old_e, const T& new_e); // returns pos or -1 
	int  	ChangeElement(int pos, const T& new_e);	// returns pos or -1 

	//-----------------------------------------------------------------------------------------
	// 	Klassen-Parameter/Positionen ausgeben 
	//-----------------------------------------------------------------------------------------
	int      GetPos(T);				// returns pos or -1
	int      GetPos(char*);				// returns pos or -1

	T& 	 GetElement(T);				// returns lelement or faultelement 
	T& 	 GetElement(int);			// returns lelement or faultelement 
	T&	 GetElement(char*);			// returns lelement or faultelement

	T*	 GetElementPtr(T);			// returns lelement or NULL
	T*	 GetElementPtr(int);			// returns lelement or NULL
	T*	 GetElementPtr(char*);			// returns lelement or NULL

	//-----------------------------------------------------------------------------------------
	// 	Benoetigte Operatoren
	//-----------------------------------------------------------------------------------------
	List<T>& operator =(const List<T>&); 
	bool     operator==(List<T>&);
	bool     operator!=(List<T>&);
}; 
//#################################################################################################
#endif
