#ifndef _MINFIRING_H
#define _MINFIRING_H

#include "Output.h"
#include "BindingElement.h"
#include "ComfVector.h"

typedef enum { SOME_ARE_MISSING,             // Einige Bindings haben noch nicht oft genug geschaltet
               MISSION_FULFILLED             // Alle Bindings haben oft genug gefeuert
	       } MinFiringStatus;


class MinFiring {

  MinFiringStatus status;                 // Stand der Pruefung
  int wait;                               // Zahl der Schritte, die noch bis zur 
                                          // naechsten Pruefung gewartet wird
  int min_fire;                           // Mindest-Schaltzahl je Binding
  ComfVector <BindingElement *> bindings; // Liste aller Bindings des Netzes
  ComfVector <char *> transitions;        // Liste der Transitionsnamen zu den Bindings
  Output *master;                         // Ausgabeobjekt fuer die Erfolgsmeldung
  void TestBindings();                    // Testet alle Bindings durch uns setzt wait neu

public:

  MinFiring(int, Output *);
  ~MinFiring();
  void Check();                           // Zaehlt wait mit und testet ggf. die Bindings

};

#endif
