#ifndef __PAGE_H__
#define __PAGE_H__

#include "Types.h"
//#####################################################################
class Page
{
	Textual		pagename;
	DefinitionList*	parameters;
	TextualList*	sub_pages;
public:
	Page();
	Page(int);
	Page(char*);
	Page(const Page&);

	~Page() { Clear(); }

	//-------------------------------------------------------------
	//	Clear	
	//-------------------------------------------------------------
	void		Clear();

	//-------------------------------------------------------------
	//	"Getten"	
	//-------------------------------------------------------------
	Textual		 GetPageName();
	TextualList*&	 GetSubPages();
	DefinitionList*& GetParameters();

	//-------------------------------------------------------------
	//	Modifizieren	
	//-------------------------------------------------------------
	void		AddParameters(const DefinitionList&);
	void		AddParameter(const Definition&);
	void		AddSubPage(char*);

	//-------------------------------------------------------------
	//	Suchen	
	//-------------------------------------------------------------
	bool		IsSubPage(char*);
	Definition* 	IsParameter(char*);

	//-------------------------------------------------------------
	//	Operatoren	
	//-------------------------------------------------------------
	Page&		operator =(const Page&);
	bool		operator==(Page&);
	bool		operator!=(Page&);

	//-------------------------------------------------------------
	//	fuer sortierende Listenoperationen	
	//-------------------------------------------------------------
	static bool	LessThan(Page&);
	char*		GetName();
};
//######################################################################
#endif
