#ifndef __PlaceHeader_CC__
#define __PlaceHeader_CC__

#include "Identifier.h"
#include "Textual.h"

#include "token_multiset.h"
#include "TokenMultiSet.h"

#include "PlaceHeader.h"

//###############################################################################################################
PlaceHeader::PlaceHeader() 					
		: 	name(DEF_TXT_NAME), 	
			no(0)
			{ tms = new TokenMultiSet(); }

PlaceHeader::PlaceHeader(int)					
		: 	name(DEF_TXT_NAME), 	
			no(0) 	
			{ tms = new TokenMultiSet(); }

PlaceHeader::PlaceHeader(char* n)				
		: 	name(n), 		
			no(0) 	
			{ tms = new TokenMultiSet(); }

PlaceHeader::PlaceHeader(char* n, int nr)			
		: 	name(n), 		
			no(nr) 	
			{ tms = new TokenMultiSet(); }

PlaceHeader::PlaceHeader(const PlaceHeader& p)			
		: 	name(p.name), 	
			no(p.no)
			{ tms = new TokenMultiSet(p.tms->tmset); }

PlaceHeader::PlaceHeader(char* n, int nr, TokenMultiSet* t)	
		: 	name(n), 		
			no(nr)  
			{ tms = new TokenMultiSet(t->tmset); }

PlaceHeader::PlaceHeader(char* n, int nr, TokenMultiSet& t)	
		: 	name(n), 	   
			no(nr)  
			{ tms = new TokenMultiSet(t.tmset); }

//###############################################################################################################
int		PlaceHeader::GetPlaceNo()				{ return no;		 	 	}
Textual&	PlaceHeader::GetPlaceName()				{ return name;			 	}
char*		PlaceHeader::GetName()					{ return name.GetChar(); 	 	}
bool		PlaceHeader::LessThan(PlaceHeader&)			{ return false; 	 		}
bool		PlaceHeader::operator!=(PlaceHeader& p)			{ return !(*this == p); 		}
bool		PlaceHeader::operator==(PlaceHeader& p)			{ return (no==p.no && name==p.name); 	}
//---------------------------------------------------------------------------------------------------------------
void		PlaceHeader::Clear()					
{ 
	name.Clear();
	if (tms)
	{
		tms->Clear();
		delete tms;
		tms = NULL;
	}
}
//---------------------------------------------------------------------------------------------------------------
void		PlaceHeader::ChangeTokenMultiSet(token_multiset*& t) 	
{ 
	if (!t)   { 
	        delete tms;
	        tms = new TokenMultiSet();
		return; 
	      }

	if (tms)
	{
		tms->Clear();
		delete tms;
		tms = NULL;
	}
	tms = new TokenMultiSet(t);
}
//---------------------------------------------------------------------------------------------------------------
PlaceHeader&	PlaceHeader::operator =(const PlaceHeader& p)    	
{ 
	Clear();
	name	= p.name; 
	no	= p.no; 
	tms	= new TokenMultiSet(p.tms->tmset); 
	return *this; 
}
//---------------------------------------------------------------------------------------------------------------
TokenMultiSet*	PlaceHeader::GetTokenMultiSet()					
{ 
	if (tms) return tms;		 
	else	{cout<<"gefunden2\n"; return new TokenMultiSet();}
}
//---------------------------------------------------------------------------------------------------------------
TokenMultiSet*	PlaceHeader::GetCopyOfTMS()					
{ 
	if (tms) return (tms->Copy());
	else 	 return new TokenMultiSet();
}
//###############################################################################################################
#endif
