#ifndef __RRGERROR_CC__
#define __RRGERROR_CC__

#include <iostream.h>
extern "C" {
#include <string.h>
}
#include "RRGError.h"
//##################################################################################################################
RRGError::RRGError() 						  
	: line_no(0)  		
	{ InitChar(NULL,NULL,NULL,NULL,NULL,NULL); }

RRGError::RRGError(char* f, char* es, int li) 			  
	: line_no(li)		
	{ InitChar(f,   es,  NULL,NULL,NULL,NULL); }

RRGError::RRGError(char* f, char* es, int li, char* se)		  
	: line_no(li)		
	{ InitChar(f,   es,  se,  NULL,NULL,NULL); }

RRGError::RRGError(char* f, char* es, int li, char* se, char* ei) 
	: line_no(li)		
	{ InitChar(f,   es,  se,  ei  ,NULL,NULL); }

RRGError::RRGError(char* f, char* es, int li, char* se, char* ei, char* ls) 
	: line_no(li)		
	{ InitChar(f,   es,  se,  ei  ,ls,  NULL); }

RRGError::RRGError(char* f, char* es, int li, char* se, char* e1, char* e2, char* ls) 
	: line_no(li)		
	{ InitChar(f,   es,  se,  e1  ,e2,  ls); }

RRGError::RRGError(const RRGError& e) 		 
	: line_no(e.line_no)	
	{ InitChar(e.file, e.err_str, e.section, e.ext_inf1, e.ext_inf2, e.last_str); }

//##################################################################################################################
void 	RRGError::Clear()
{
	if (file)	{ delete[] file;     file     = NULL; }
	if (section)	{ delete[] section;  section  = NULL; }
	if (err_str) 	{ delete[] err_str;  err_str  = NULL; }
	if (ext_inf1)  	{ delete[] ext_inf1; ext_inf1 = NULL; }
	if (ext_inf2)  	{ delete[] ext_inf2; ext_inf2 = NULL; }
	if (last_str)  	{ delete[] last_str; last_str = NULL; }
	line_no = 0;
}
//-----------------------------------------------------------------------------------------------------------------
void 	RRGError::InitChar(char* fi, char* es, char* se, char* e1, char* e2, char* ls)
{
	if (fi) strcpy(file	= new char[strlen(fi)+1], fi); else file    = NULL;
	if (es) strcpy(err_str	= new char[strlen(es)+1], es); else err_str = NULL;
	if (se) strcpy(section	= new char[strlen(se)+1], se); else section = NULL;
	if (e1) strcpy(ext_inf1	= new char[strlen(e1)+1], e1); else ext_inf1= NULL;
	if (e2) strcpy(ext_inf2	= new char[strlen(e2)+1], e2); else ext_inf2= NULL;
	if (ls) strcpy(last_str	= new char[strlen(ls)+1], ls); else last_str= NULL;
}
//-----------------------------------------------------------------------------------------------------------------
void	RRGError::PrintError()
{
	cout <<"\n";
	cout <<"ERROR occured\n";

	if (file && (!(strcmp(file, PARS)) || !(strcmp(file, SCAN))))
		if (ext_inf1) cout <<"\n"<< ext_inf1 <<"\n";
		else          cout <<"\n/* unknown */\n";

	cout <<"\n";
	if (file)	cout <<"file		: "<< file     <<"\n";
	if (line_no)	cout <<"line		: "<< line_no  <<"\n";
	if (section)	cout <<"section 	: "<< section  <<"\n";
	if (err_str)	cout <<"error-string	: "<< err_str  <<"\n";
	if (ext_inf1)	cout <<"extra-info	: "<< ext_inf1 <<"\n";
	if (ext_inf2)	cout <<"extra-info	: "<< ext_inf2 <<"\n";
	if (last_str) 	cout <<"last string	: "<< last_str <<"\n";
	cout <<"\n";
}
//#################################################################################################################
#endif

