#ifndef __TOKEN_H__
#define __TOKEN_H__

#include "Types.h"
//################################################################################
class Textual;
class Identifier;
//################################################################################
class Token
{
	Textual		name;
	Identifier	version;
	Identifier	step;
public:
	Token();
	Token(int);
	Token(char*, char*, char*);
	Token(const Token&);
	~Token() { Clear(); }

	void	    Clear();
	//-----------------------------------------------------------------------
	//	"Getten"
	//-----------------------------------------------------------------------
	Textual&    GetTokenName();
	char*	    GetName();
	Identifier& GetVersion();
	Identifier& GetStep();

	//-----------------------------------------------------------------------
	//	Modifizieren	
	//-----------------------------------------------------------------------
	void	ChangeName(const char*);
	void	ChangeName(const Textual&);

	void	ChangeVersion(const char*);
	void	ChangeVersion(const Identifier&);

	void	ChangeStep(const char*);
	void	ChangeStep(const Identifier&);

	//-----------------------------------------------------------------------
	//	Benoetigte Operatoren	
	//-----------------------------------------------------------------------
	Token&	operator =(const Token&);
	bool	operator==(Token&);
	bool	operator!=(Token&);
	bool    LessThan(Token& t);
};
//################################################################################
#endif
