#ifndef __INC_SLAVE_GLOBALS_H__
#define __INC_SLAVE_GLOBALS_H__

#include "sim_slave_types.h"

//extern "C" {
//#include <stdlib.h>
//#include <time.h>
//#include <unistd.h>
//#include <errno.h>
//#include "portab.h" 
//}

//###########################################################################################################
//	externe globale ReferenzListen und Variablen 
//###########################################################################################################
extern TransitionList		InfiniteTransitionRefList;   // alle Infinite-Server Transitionen des Netzes
extern TransitionList		ImmediateTransitionRefList;  // alle Immediate-Transitionen des Netzes
extern TransitionList		ExclusiveTransitionRefList;  // alle Exclusive-Server Transitionen des Netzes
extern TextualList		TransitionNameRefList;	     // alle Transitionen des Netzes
extern PlaceHeaderPtrList	PlaceHeaderPtrRefList;	     // alle Stellen-header des Netzes
extern TokenList		TokenRefList;		     // alle Token des Netzes
extern PlaceList		PlaceRefList;		     // alle Stellen des Netzes
extern PageList			PageRefList;		     // alle Seiten des Netzes
extern DefinitionList   	DefinitionRefList;	     // alle Ausdruecke des Netzes
extern DefinitionList		EvalRefList;		     // alle zu berecheneneden Bewertungsgroessen des 
							     // Netzes 

//-----------------------------------------------------------------------------------------------------------
//	Variablen fuer die Funktion getopt_long()
//-----------------------------------------------------------------------------------------------------------
//extern char*     	optarg;
//extern int       	optind; 
//extern int		opterr; 
//extern int		optopt;

//###########################################################################################################
//	globale Variablen
//###########################################################################################################
char*		table_string;			 // eingelesene oder uebergebene Uebergangstabelle
char*    	netname        = "default";	 // Defaultwert des Netz/Modellnamens
#define         ENV_MODELDIR_NAME "MODELDIR"     // Name der Environment-Variablen
Uniform         rnd(0,1,new ACG);                // Generator fuer gleichverteilte Zufallszahlen
RRGError*       RRGErr         = new RRGError(); // Fehlervariable aller Funktionen

// Nur fuer Statistik und Erstellung der SMC-Listen! Sollte eigentlich lieber raus!
int	no_of_det_transitions = 0;
int	no_of_exp_transitions = 0;
int	no_of_gen_transitions = 0;
int	no_of_imm_transitions = 0;
int	no_of_exc_transitions = 0;
int	no_of_mix_transitions = 0;
int	no_of_places	      = 0;
int	no_of_trans 	      = 0;
int	place_no	      = 1;


unsigned char	bits[8]	       = {1, 2, 3, 4, 6, 8, 10, 15}; // bits fuer die Markierungszustaende/typen


//###########################################################################################################
//      externe Funktionen
//###########################################################################################################
extern int      yyparse();
extern void     TxtToRef();


// ------------------------------------------------------------
// Globale Variablen zur Anbindung an TimeNETs det_init_trans.c (und andere)
// ------------------------------------------------------------

double  current_time;             // Wird beim Aufruf von Prim.Eval() initialisiert
int	conf_level = 95;          // Konfidenzlevel fuer die Variabzschaetzung init_trans_detect
double	eps_max;                  // Nie benutzt. Wird aber in det_init_trans importiert
int     StatSema;                 // Benutzt TimeNET-Slave als Zaehler (Simulation endet,
                                  // wenn StatSema (-phore) == 0 ist. Der farbige Slave
                                  // laeuft aber bis zum SIGTERM
long	maxsamples      = MAXINT; // Aufruf-Parameter. Verhindert eine ewige Simulation
T_bool	trans_detection = true;   // Wird per Parameter '-t' auf false gesetzt und schaltet 
                                  // dann die Erkennung der initialen transienten Phase aus
int     portnumber = 0;           // Port zum Master der Simulation; wenn 0, dann cout statt Socket
char    *hostname;                // Name des Hosts vom Master; wenn NULL, dann localhost

int     min_firings = 30;         // Mindest-Schatzahl je Binding

#endif



