#ifndef __ERROR_H__
#define __ERROR_H__

#include "dialog.h"
#include "node.h"
#include "page.h"
#include "editor.h"

//-----------------------------------------------------------------------------

class Error
{
  Dialog<Error, bool> dialog;
  Editor* editor;
  void* context;
  bool occured;

  void ShowMessage(char* msg, bool center=false);
  void DialogCB(Dialog<Error, bool>&, bool, Ident&);

public:
  enum ErrorType { TooManyStructures, NoStructure, NoStructRef,
                   IllegalStructRef, DefExists,
                   NoMatchingArc, ArcWithoutWeight,

                   CantLoadTemplate, NotATemplate,
                   IllegalParamType, DifferentParamTypes,
                   NoSubtransName, NameExists, ParamSyntaxError,
                   AmbigousInstConditions, Nothing2Insert,
                   AmbigousExistConditions, ErrorInShape,
                   EmptyParam, ConstraintHurt,
                   
                   AmbigousConnConditons, ArcNotInTemplate,
                   MeltConflict, IllegalArc, NoStructRef2,
                   IllegalStructRef2,

                   VarSyntax, ExprSyntax
                 };

  Error(Editor& e): dialog(this), editor(&e), context(0), occured(false) {}
  Error(): dialog(0), editor(0), context(0), occured(false) {} 

  void operator() () { ShowMessage("Unknown Error"); }
  void operator() (char* text) { ShowMessage(text); }
  void operator() (ErrorType, void* first = NULL, void* second = NULL);
  operator bool() { return occured; }
  void SetContext(void* c) { context = c; }
  Editor* GetEditor() { return editor; }
};

//-----------------------------------------------------------------------------

#endif

