#ifndef __ANAINTERFACE_H__
#define __ANAINTERFACE_H__

#include "net.h"
#include "error.h"
#include "relation.h"
#include "node.h"
#include "value.h"
#include "string.h"
#include "struct.h"
#include "logwin.h"

typedef ComplexValueMap<Ident, Text> Ident2Text;
typedef MapIterator<Ident, Text> Ident2TextIter;

//-----------------------------------------------------------------------------
// Die Klasse AnalyserInterface bietet ein Interface zu dem herangelinkten 
// Evaluater und der Analysekomponente.
//
class AnalyserInterface
{
  static void AddComment(ostream& s, Text where, Object* ob);

public:
  static void DescribePage(Page* page, ostream& s, Error& error);
  static void DescribeSymbols(Page* page, ostream& s);

  static Text PoppName(Object* ob);
  static Text PoppName(Page* page);
  static void GetAllNodes(Page* page, LinkedList<Node*>& l);
  static void AnalyseHCPN(Net*, Editor*, Error&); 

  static bool EvaluateCondition(char* expr, Ident2Text& context, Node* where,
                                Error& error);
};

#endif
