#ifndef __NODESEL_H__
#define __NODESEL_H__

#include "module.h"
#include "editor.h"
#include "net.h"
#include "page.h"
#include "node.h"
#include "netcl.h"

//-----------------------------------------------------------------------------

typedef void (*NodeSelCB)(void* caller, Node* node);
typedef bool (*NodeSelTestFn)(void* caller, Node* node);


class NodeSelector: public Module
{
  bool active;
  void* caller;
  NodeSelTestFn test;
  NodeSelCB callback;

  static NodeSelector* FindSelf(Net* net);
  
public:
  NodeSelector(Net& n) : Module(n, "NodeSelector"), active(false) {}
  bool Init() { return net.Prime()->Class()->Name() == "Template_Lib"; }
  bool DoubleClick(Editor& editor, Page& page, Object* object);
  void Close(Editor& editor, Page& page); 
  ~NodeSelector();

  static bool Activate(Net* net, void* caller, NodeSelTestFn t, NodeSelCB cb);
  static bool Deactivate(Net* net);
  static bool IsActive(Net* net);
};

#endif
