
#include "relation.h"

//-----------------------------------------------------------------------------

template <class T1, class T2> bool Map<T1, T2>::Add(T1* a, T2* b)
{
  defs.Append(a);
  vals.Append(b);
  return (defs.Length() == vals.Length());
}

//-----------------------------------------------------------------------------

template <class T1, class T2> T2* Map<T1, T2>::operator [] (T1* key)
{
  MapIterator<T1, T2> iter = *this;
  T1* d; T2* v;
  for (iter.Start(d,v); d; iter.Step(d,v))
    if (Compare(d, key)) return v;
  return 0;
}

//-----------------------------------------------------------------------------

template <class T1, class T2> ComplexMap<T1, T2>::~ComplexMap()
{
  Iterator<T2*> iter = Vals();

  for (T2* v=iter; v; v=++iter)
    delete v;
}

//-----------------------------------------------------------------------------

// for g++

#define MAPINSTANCIATE(T1,T2) \
template class Map < T1, T2 >; \
template class MapIterator < T1, T2 >;

#define CMAPINSTANCIATE(T1,T2) \
template class Map < T1, T2 >; \
template class MapIterator < T1, T2 >; \
template class ComplexMap < T1, T2 >;

#define VMAPINSTANCIATE(T1,T2) \
template class Map < T1, T2 >; \
template class MapIterator < T1, T2 >; \
template class ValueMap < T1, T2 >;

#define CVMAPINSTANCIATE(T1,T2) \
template class Map < T1, T2 >; \
template class MapIterator < T1, T2 >; \
template class ComplexMap < T1, T2 >; \
template class ComplexValueMap < T1, T2 >;


#include "ident.h"
#include "node.h"

#define NoExplicitInstanciation

#include "linked.cc"

CINSTANCIATE(LinkedList<Node*>)

typedef ValueMap<Ident, Ident> Ident2Ident;
CINSTANCIATE(Ident2Ident)

VMAPINSTANCIATE(Ident, Node)
VMAPINSTANCIATE(Ident, Ident)
CVMAPINSTANCIATE(Ident, LinkedList<Node*>)
CVMAPINSTANCIATE(Ident, Text)
CMAPINSTANCIATE(Page, Ident2Ident)
MAPINSTANCIATE(Node, Node)
