/*$Header: /home/pdv/timenet/CVS/TimeNET/Print/src/PaintPlace.c,v 1.3 1995/03/06 15:13:40 kkk Exp $*/
/*******************************************************************************
Modul           :       PaintPlace

Purpose         :       Erzeugen der PostScript-Befehle zum Drucken 
                        einer Stelle

Project Director:       Christoph Lindemann TU Berlin

Programmer      :       Christian L"uhe

History         :       release 1: November 1992
			release 2: July     1994
			Joachim Schneider: Anpassung an .TN-Format
*******************************************************************************/

#define PAINTPLACE

#include <string.h>
#include <math.h>
#include "netio.h"
#include "Paint.h"
#define DELTA       PixToInch (DEFAULT_SIZE/5)



#ifdef __STDC__
  void PaintPlace(Place p)
#else
  void PaintPlace(p)
    Place p;
#endif
{
  int  flag = 0;

  if (marks && p.is_value)

    switch (p.marking.value) {
      case 0:
        break;
      case 1: 
        printf("\t%f %f marking\n", p.pos.x, p.pos.y);
        break;
      case 2: 
        printf("\t%f %f marking\n", p.pos.x-DELTA, p.pos.y);
        printf("\t%f %f marking\n", p.pos.x+DELTA, p.pos.y);
        break;
      case 3:
        {
          double  dx   = DELTA;
          double  dy_u = (double)(double)DELTA/cos(M_PI/6.0);
          double  dy_d = (double)(double)DELTA*tan(M_PI/6.0);
          /* the center of an equal sided triangle */
          printf("\t%f %f marking\n", p.pos.x-dx, p.pos.y-dy_d);
          printf("\t%f %f marking\n", p.pos.x+dx, p.pos.y-dy_d);
          printf("\t%f %f marking\n", p.pos.x,    p.pos.y+dy_u);
          break;
        }
      case 4:
        printf("\t%f %f marking\n", p.pos.x-DELTA, p.pos.y-DELTA);
        printf("\t%f %f marking\n", p.pos.x+DELTA, p.pos.y-DELTA);
        printf("\t%f %f marking\n", p.pos.x-DELTA, p.pos.y+DELTA);
        printf("\t%f %f marking\n", p.pos.x+DELTA, p.pos.y+DELTA);
        break;
      case 5:
        printf("\t%f %f marking\n", p.pos.x-DELTA, p.pos.y-DELTA);
        printf("\t%f %f marking\n", p.pos.x+DELTA, p.pos.y-DELTA);
        printf("\t%f %f marking\n", p.pos.x-DELTA, p.pos.y+DELTA);
        printf("\t%f %f marking\n", p.pos.x+DELTA, p.pos.y+DELTA);
        printf("\t%f %f marking\n", p.pos.x,       p.pos.y);
        break;
      default: 
	flag = 1;
        break;
    } /* switch */



  printf ("\t(%s) %f %f tag\n",
    p.name, p.name_pos.x, p.name_pos.y);

  if (marks && ! p.is_value)
    printf("(%s) %f %f place\n",
      p.marking.markpar->name,
      p.pos.x, p.pos.y); 
  else
    if (p.is_value && flag)
      printf("(%u) %f %f place\n",
        p.marking.value,
        p.pos.x, p.pos.y); 
    else
      printf("() %f %f place\n",
        p.pos.x, p.pos.y); 

} /* PaintPlace */
    
