#ifndef EXPRCALCCC
#define EXPRCALCCC

#include <stdlib.h>  // system
#include <math.h>    // modf
#include <fstream.h> // open
#include "spnlprocess.cc"
#include "spnlbasics.cc"
#include "vektor.cc"
#include "exprcalc.h"



ExprCalc::ExprCalc (ProcessTypeDecl *processtd) {
  newprocess= processtd;
  exprlist= newstring ("echo '");
}


ExprCalc::~ExprCalc () {
  delete (exprlist);
  infile.close ();
  remove ("expr_calc.tmp");
}


char *ExprCalc::removeVariables (char *expr) {
// liefert NULL zurueck, wenn mind. eine Variable nicht umgewandelt werden
//  konnte
  char *newexpr= NULL, *zwerg= NULL;
  char *id= NULL, *idexpr= NULL;
  bool noexpression= true;
  Parameter *param;
  Reward *reward;

//cout << "\n***removeVariables vorher>  " << expr << flush;
  newexpr= mark_names (expr, REW_NUMRESWORDS, rew_reserved);
  id= get_first_name (newexpr);
  while (id) {
//cout << "\n***removeVariables during>  " << newexpr << flush;

    // zu id passende Expression aus rewards und parametern suchen:
    param= newprocess->searchParameter (id);
    if (param) {
      idexpr= mark_names (param->getParameterExpression (),
			  REW_NUMRESWORDS, rew_reserved);
      noexpression= false;
    }
    else {
      reward= newprocess->searchReward (id);
      if (reward) {
	idexpr= mark_names (reward->getRewardExpression (),
			    REW_NUMRESWORDS, rew_reserved);
	noexpression= false;
      }
    }

    if (noexpression) {
      delete (newexpr);
      return (NULL);
    }
    zwerg= newexpr;
    newexpr= replace_first_name (zwerg, idexpr, true);
    delete (zwerg);
    zwerg= NULL;
    delete (idexpr);
    idexpr= NULL;
    delete (id);
    id= get_first_name (newexpr);
  }
//cout << "\n***removeVariables nachher> " << newexpr << flush;
  return (newexpr);
}


/*** public ***/

/*
char *ExprCalc::calculateExpression (char *expr, bool *intvalpt) {
// liefert NULL zurueck, wenn mind. eine Variable nicht umgewandelt werden konnte
  *intvalpt= true;
  char *newexpr= NULL;
  if (!expr)
    return (NULL);

//cout << "\n***calculateExpr vorher>    " << expr;
  newexpr= removeVariables (expr);
//cout << "\n***calculateExpr nachher>   " << newexpr << '\n';

  if (newexpr) {
    char *zwerg= concat ("echo '", newexpr);
    char *zwerg2= concat (zwerg,
          ";' | $AGNESDIR/../SPNL/compiler/bin/expr_calc > expr_calc.tmp");
//cout << "\n***AUFRUF: " << zwerg2 << '\n';
    system (zwerg2);
    delete (zwerg);
    delete (zwerg2);
    char ergebnis[MAX_ERGEBNIS_LEN];
    ifstream infile ("expr_calc.tmp");
    infile >> ergebnis;
    remove ("expr_calc.tmp");

    double value;
    sscanf (ergebnis, "%lf", &value);
//cout << "\n***ausgerechnet: " << value;
    double vorkomma;
    double nachkomma;
    nachkomma= modf (value, &vorkomma);
//cout << ", vorkomma: " << vorkomma << ", nachkomma: " << nachkomma;
    if (nachkomma > 0.5) {
      if (vorkomma > 0)
	vorkomma+= 1.0;
      else
	vorkomma-= 1.0;
      nachkomma= fabs (nachkomma - 1.0);
    }
//cout << ", vorkomma2: " << vorkomma << ", nachkomma2: " << nachkomma;

    if ((nachkomma < EPSILON) && (value+EPSILON > 0)) {
      delete (newexpr);
      if (value < EPSILON)
	vorkomma= 0.0;  // sonst wird seltsamerweise -0 ausgegeben...
      sprintf (ergebnis, "%1.0lf", vorkomma);
      char *ergebnis2= newstring (ergebnis);
//cout << "\n***calculateExpr fertig>    " << ergebnis2 << '\n';
      return (ergebnis2);
    }
    else {
      *intvalpt= false;
      return (newexpr);
    }
  }
  return (NULL);
}
*/

void ExprCalc::pushExpression (char *expr) {
//cout << "\npush: " << expr;
  char *newexpr= NULL;
  char *zwerg= exprlist;
  if (!expr)
    exprlist= concat (zwerg, "errorcall;");  // Name darf nicht beliebig
  else {                                     //  lang sein (sonst error)
    newexpr= removeVariables (expr);
    if (newexpr) {
      exprlist= new char[strlen(zwerg)+strlen(newexpr)+2];
      strcpy (exprlist, zwerg);
      strcat (exprlist, newexpr);
      strcat (exprlist, ";");
      delete (newexpr);
    }
    else
      exprlist= concat (zwerg, "errorcalc;");  // Laenge begrenzt (s.o.)
  }
  delete (zwerg);
}


void ExprCalc::calculateExpressions () {
  char *zwerg= exprlist;
  exprlist= concat (zwerg,
	    "' | $AGNESDIR/../SPNL/compiler/bin/expr_calc > expr_calc.tmp");
  delete (zwerg);
//cout << "\n***call: " << exprlist << flush;
  system (exprlist);
  delete (exprlist);
  exprlist= newstring ("echo '");
  infile.open ("expr_calc.tmp");
}


char *ExprCalc::popValue (bool *intvalpt) {
  *intvalpt= true;
  char ergebnis[MAX_ERGEBNIS_LEN];
  infile >> ergebnis;

  if (!strcmp (ergebnis, "error")) // error wird zurueckgeliefert, wenn der
    return (NULL);                 //  Parser als Eingabe einen String erhielt
  double value;
  sscanf (ergebnis, "%lf", &value);
  double vorkomma;
  double nachkomma;
  nachkomma= modf (value, &vorkomma);
  if (nachkomma > 0.5) {
    if (vorkomma > 0)
      vorkomma+= 1.0;
    else
      vorkomma-= 1.0;
    nachkomma= fabs (nachkomma - 1.0);
  }

  if ((nachkomma < EPSILON) && (value+EPSILON > 0)) {
    if (value < EPSILON)
      vorkomma= 0.0;  // sonst wird seltsamerweise -0 ausgegeben...
    sprintf (ergebnis, "%1.0lf", vorkomma);
    return (newstring (ergebnis));
  }
  else {
    *intvalpt= false;
    return (newstring (ergebnis));
  }
}


#endif
