#ifndef EXPRCALCH
#define EXPRCALCH

#include "spnlprocess.h"


#define MAX_ERGEBNIS_LEN 64  // laenger darf die Realzahl nicht sein
#define EPSILON .0001        // fuer Rechenungenauigkeiten


class ExprCalc {
  private:
    ProcessTypeDecl *newprocess;
    char *exprlist;  // zu berechnende Expressions
    ifstream infile;  // Datei zum Einlesen der Ergebnisse

    char *removeVariables (char *expression);
    // Ersetzt alle in expression vorkommenden Variablen durch deren
    //  Expression - solange, bis alle Variablen ersetzt wurden oder bis die
    //  Prozedur auf einen Port stoesst (in diesem Fall liefert sie NULL
    //  zurueck - der Ausdruck kann erst zur Laufzeit berechnet werden).

  public:
    ExprCalc (ProcessTypeDecl *processtd);
    ~ExprCalc ();

/*
    char *calculateExpression (char *expression, bool *intvalpt);
    // Berechnet den Ausdruck expression mittels removeVariables und
    //  expr_calc (extern) und liefert das Ergebnis (oder NULL im Fehlerfall)
    //  zurueck. Unter intvalpt wird zurueckgeliefert, ob es sich um einen
    //  Integerwert handelt, oder nicht.
*/

    void pushExpression (char *expression);
    // Fuegt den Ausdruck expression den anderen hinzu. Dieser Ausdruck wird
    //  noch nicht berechnet, nur gespeichert.

    void calculateExpressions ();
    // Berechnet alle gespeicherten Ausdruecke mittels eines system-Aufrufs
    //  von expr_calc und stellt die Ergebnisse bereit.

    char *popValue (bool *intvalpt);
    // Liefert die Ergebnisse (oder NULL im Fehlerfall) nach dem Stack-
    //  Prinzip zurueck. Unter intvalpt wird zurueckgeliefert, ob es sich um
    //  einen Integerwert handelt, oder nicht.

};


#endif
