#include <stream.h>
#include "parser.cc"
#include "foutput.h"

// Wenn stdio.h importiert wird, gibt es Fehler bein file-oeffnen.
//  Abhilfe durch wegnehmen des file-initialisierens mit NULL.


// *********** haerte spaeter herausnehmen



// mit "g++ spnl_compile.cc -static -o ../bin/spnl_compile" linken!
// cp spnl_compile ~/TimeNET/Agnes


void openfnetfile (char *filename) {
  char *fbasename= substring2lastpoint (filename);
  char *newfilename= concat (fbasename, SPNLCOMP_ENDING);
  fnet.open (newfilename);
  if (!fnet) {
    cout << "\nerror opening output file " << newfilename << '\n';
    exit (1);
  }
  delete (newfilename);
  delete (fbasename);
}


void main (int argc, char **argv) {
  ParserT test;
  CompilerT compiler;
  ProcessTypeDecl *procpt;   // Fertig compilierter Prozess
  char *filename;
  bool haerte= false, verify= false;

  if ((argc < 2) || (argc > 3)) {  // falsche Argument-Anzahl
    if (argc == 1)
      cout << "spnl_compile: Insufficient arguments (0)\n";
    else
      cout << "spnl_compile: Too many arguments (" << argc-1 << ")\n";
    cout << "Usage: spnl_compile [- (d|v|i|c)+] name\n";
    cout << "with -d: dots during compilation\n";
    cout << "     -v: verify scanned net\n";
    cout << "     -i: ignore errors\n";
    cout << "     -c: don't calculate arc multiplicities\n";
    cout << "     -h: HAERTE-TEST\n";
    cout << "     name: filename (" << SPNL_ENDING << ")\n";
    exit (1);
  }
  else if (argc == 2)  // nur File-name
    filename= argv[1];
  else if (argc == 3) {  // Filename + Optionen
    filename= argv[2];
    for (int i=1; i<strlen (argv[1]); i++)
      switch (argv[1][i]) {
      case 'd': dots= true;
		break;
      case 'v': verify= true;
	        break;
      case 'i': errornetdisplay= true;
	        break;
      case 'c': calcarcmult= false;
	        break;
      case 'h': haerte= true;
	        break;
      default : cout << "spnl_compile: illegal option -"<< argv[1][i] << '\n';
      }
  }

  if (haerte || verify)
    cout << ".init finished\n";

  if (!test.parse (filename)) {  // Fehler, wenn nicht geparst werden konnte.
    if (verify && errornetdisplay) {
      if (!fnet)
	openfnetfile (filename);
      fnet << "\ndisplay original net:\n\n";
      test.display ();
      fnet << "\n\ndisplay finished";
    }
    cout << "\nerror during parsing\n";
    exit (1);
  }
  if (dots)
    cout << "parsing finished\n";

  if (!haerte) {
    if (verify) {
      if (!fnet)
	openfnetfile (filename);
      fnet << "\noriginal net:\n\n";
      test.display ();
      if (dots)
	cout << ".display finished\n";
    }
    procpt= compiler.compile (&(test.modules));
    if (verify)
      cout << ".compile finished\n";
    if (procpt) {
      if (!fnet)
	openfnetfile (filename);
      if (verify)
	fnet << "\n\n(* -=- compiled net: -=- *)\n\n";
      procpt->display_comp (compiler.getSectionCount ());
      if (verify)
	fnet << "\n\n(* -=-=-=-= end =-=-=-=- *)";
      fnet << '\n';
      delete (procpt);
      cout << "compilation finished successfully\n";
      // successfully-string hat Laenge ERRORFILE_LENGTH aus spnlstructure.h
    }
    else
      cout << "\nfile " << filename << " has not been compiled\n";
  }
  else {
    // Haertetest:
    if (!fnet)
      openfnetfile (filename);
    fnet << "==vor display==\n";
    test.display ();
    test.display ();
    fnet << "==fertig display==\n";

    procpt= compiler.compile (&(test.modules));
    fnet << "==fertig compile==\n";
    delete (procpt);
    procpt= compiler.compile (&(test.modules));
    fnet << "==fertig compile==\n";
    delete (procpt);
    procpt= compiler.compile (&(test.modules));
    fnet << "==fertig compile==\n";
    test.display ();
    if (procpt) {
      procpt->display_comp (compiler.getSectionCount ());
      procpt->display_comp (compiler.getSectionCount ());
    }
    delete (procpt);
    procpt= compiler.compile (&(test.modules));
    fnet << "==fertig compile==\n";
    if (procpt) {
      fnet << "\n(* -=- compiled net: -=- *)\n";
      procpt->display_comp (compiler.getSectionCount ());
      procpt->display_comp (compiler.getSectionCount ());
      procpt->display_comp (compiler.getSectionCount ());
      fnet << "\n(* -=-=-=-= end =-=-=-=- *)\n";
      delete (procpt);
    }
    else
      cout << "\ntoo many errors. Cannot compile "
	<< ((test.modules).readElementAt (0))->getid() << SPNL_ENDING << ".\n";
    fnet << "==fertig==";
  }
  fnet << "\n";
  fnet.close ();
}
