#include <stdio.h>      // remove
#include <stream.h>     // cout
#include <string.h>	// strcpy, strlen
#include <fcntl.h>      // open
#include <sys/types.h>
#include <sys/stat.h>
#include "scanner.cc"
#include "stdfun.cc"
#include "vektor.cc"
#include "spnltypes.cc"

// mit "g++ spnl_make.cc -static -o ../bin/spnl_make" linken!
// cp spnl_make ~/TimeNET/Agnes


ScannerT *scanner;
int lookahead;
char *buffer;


bool valid (int t) {
  return ((lookahead == t)
	  || ((t == NUM) && ((lookahead == REAL) || (lookahead == INT))));
}


bool validString (char *s) {
  return (!strcmp (buffer,s));
}

/*
bool cryptvalidString (char *str, int lastlookahead) {
  return (validString (str) || ((lastlookahead == '\\') &&
	 (!strcmp ((char *)buffer+1, str)) && (buffer[0] == 'n')));
}
*/

void scannBehind (char a) {
  while (!(valid (a) || valid (DONE)))
    lookahead= scanner->lexan ();
  if (valid(DONE)) {
    scanner->error ("Make error: file end reached.\n");
    exit (1);
  }
  else
    lookahead= scanner->lexan ();
}


void entryImports (Vektor <String> *modlist) {
  String *string;
//  int lastlookahead= ';';
  // Nach 'module', 'id', ';' suchen
  //  Jetzt muss als naechstes 'use' kommen, dann Id's einlesen, bis ';'
  scannBehind (';');  // Jetzt ist die erste Zeile zuende (module id;)
  while (!(valid (ID) && (validString ("use") ||
	   validString ("parameter") || validString ("processinst") ||
       	   validString ("processtype") || validString ("process")))) {
    // Solange suchen, bis 'use' gefunden, oder aufhoeren bei process... & Co.
    lookahead= scanner->lexan ();
  }
  if (validString ("use")) {
    // Jetzt steht der buffer genau auf 'use'
    // Namen eintragen, aufhoeren bei process... & Co.
    lookahead= scanner->lexan ();
    while (!(valid (';') || (valid (ID) && (validString ("parameter") ||
             validString ("processinst") || validString ("processtype") ||
             validString ("process"))))) {
      if (valid (ID)) {
	string= new String (buffer);
        if (!modlist->searchId (buffer))
          modlist->addElement (string);
      }
/*
      if (valid (ID) && ((lastlookahead != '\\') ||
                         ((buffer[0] == 'n') && (strlen (buffer) > 1)))) {
        if ((lastlookahead == '\\') && (buffer[0] == 'n'))
          string= new String ((char *)buffer+1);
        else
          string= new String (buffer);
        if (!modlist->searchId (buffer))
          modlist->addElement (string);
      }
*/
      lookahead= scanner->lexan ();
    }
  }
}


bool file_exist (char *fname) {
/*
  ifstream filevorhanden;
  filevorhanden.open (fname, ios::in);
  if (filevorhanden)
    filevorhanden.close ();
  return (filevorhanden);
*/
  int fd= open (fname, O_RDONLY);
  return (fd != -1);
}


bool file_newer (char *f1, char *f2) {
// f1 wurde 100-prozentig spaeter erstellt als f2 (ist neuer)
  time_t *time1, *time2;
  struct stat file_stat1, file_stat2;

  if ((lstat (f1, &file_stat1)) || (lstat (f2, &file_stat2)))
    return (false);  // File konnte nicht korrekt eingelesen werden
  time1= &(file_stat1.st_mtime);
  time2= &(file_stat2.st_mtime);
/*
  if (*time1 < *time2) cout << "\nf1 "<<f1<<" ("<<(unsigned long int)*time1<<") is newer than f2 "<<f2<<" ("<<(unsigned long int)*time2<<")";
  if (*time1 > *time2) cout << "\nf2 "<<f2<<" ("<<(unsigned long int)*time2<<") is newer than f1 "<<f1<<" ("<<(unsigned long int)*time1<<")";
  if (*time1 == *time2) cout << "\n"<<f1<<" ("<<*time1<<") is same as "<<f2;
*/
  return (*time1 > *time2);
}


void main (int argc, char **argv) {
  int i= 0;
  char *filename, *path, *modname;
  char *modfname, *outfname, *fname, *fname2, *zwerg;
  Vektor <String> modlist;
  String *string;
  bool buildall= false;

  if ((argc < 2) || (argc > 3)) {  // falsche Argument-Anzahl
    if (argc == 1)
      cout << "spnl_make: Insufficient arguments (0)\n";
    else
      cout << "spnl_make: Too many arguments (" << argc-1 << ")\n";
    cout << "Usage: spnl_make [-b] name\n";
    cout << "with -b:   build all (including not altered files)\n";
    cout << "     name: filename (" << SPNL_ENDING << ")\n";
    exit (1);
  }
  else if (argc == 2)  // nur File-name
    filename= argv[1];
  else if (argc == 3) {  // Filename + Optionen
    filename= argv[2];
    for (i=1; i<strlen (argv[1]); i++)
      switch (argv[1][i]) {
      case 'b': buildall= true;
		break;
      default : cout << "spnl_make: illegal option -"<< argv[1][i] << '\n';
      }
  }

  path= getPath (filename);
  fname= getFile (filename);
  modname= substring2point (fname);

  // ersten Filename in die Liste eintragen (ohne Pfad):
  if (modname && file_exist (filename)) {
    string= new String (modname);
    modlist.addElement (string);
  }
  else
    cerr << "wrong filename: " << filename << '\n';
  delete (fname);

  // Liste durchgehen und jeweils entsprechendes File oeffnen um dessen
  //  importierte Files einzutragen (wenn noch nicht vorhanden)
  for (i= 0; i < modlist.size(); i++) {
    zwerg= concat (path, (modlist.readElementAt (i))->getid ());
    fname= concat (zwerg, SPNL_ENDING);
    fname2= concat (zwerg, NET_ENDING);
//    if (!file_exist (fname) && !file_exist (fname2))
      // Nicht vorhandene Files immer entfernen.
//      delete (modlist.removeElementAt (i--));  // aus Liste austragen
//    else
    if (file_exist (fname)) {
      scanner= new ScannerT (fname);
      buffer= scanner->lexbuf;
      lookahead= scanner->lexan ();

      // Importe aus aktuellem Modul auslesen und in die Liste eintragen
      entryImports (&modlist);
      delete (scanner);
    }
    delete (zwerg);
    delete (fname);
    delete (fname2);
    lookahead= 0;    
  }

  // Wenn Liste fertig, evtl (wenn !buildall) schon compilierte Files
  //  aus der Liste entfernen.
  if (!buildall)
    for (i= 0; i < modlist.size(); i++) {
      zwerg= concat (path, (modlist.readElementAt (i))->getid ());
      fname= concat (zwerg, NET_ENDING);
      outfname= concat (zwerg, OUT_ENDING);
      modfname= concat (zwerg, SPNL_ENDING);

      if (file_exist (modfname) && file_exist (fname) &&
	  file_newer (modfname, fname) && !file_exist (outfname))
	delete (modlist.removeElementAt (i--));  // aus Liste austragen

      delete (zwerg);
      delete (fname);
      delete (outfname);
      delete (modfname);
    }

  // Verbleibende Liste mit Endung 'SPNLPRJ_ENDING' speichern
  zwerg= concat (path, modname);
  fname= concat (zwerg, SPNLPRJ_ENDING);
  ofstream fprj;
  fprj.open (fname);
  if (!fprj) {
    cerr << "\nerror opening outputfile " << fname << '\n';
    exit (1);
  }
  if (!modlist.size())
    remove (fname);
  else
    for (i= 0; i < modlist.size(); i++) {
      zwerg= concat (path, (modlist.readElementAt (i))->getid ());
      modfname= concat (zwerg, SPNL_ENDING);
      fname= concat (zwerg, NET_ENDING);
      fprj << zwerg << ' ';
      if (file_exist (modfname))
	fprj << 0;
      else
	if (file_exist (fname))
	  fprj << 1;
	else
	  fprj << 2;
      fprj << '\n';
      delete (zwerg);
      delete (modfname);
      delete (fname);
    }
  delete (zwerg);
  delete (fname);

//  delete (filename);  // nicht freigeben, ist Argument!
  delete (path);
  delete (modname);
}
