#ifndef SPNLBASICSCC
#define SPNLBASICSCC


#include <string.h>
#include <iostream.h>
#include "spnlbasics.h"



/*********************** Hilfsfunktionen zur Ausgabe **********************/

char *DistributionType2String (DistributionType enumval) {
  switch (enumval) {
  case NODISTR:
    return (NULL);
    break;
  case EXP:
    return ("exp");
    break;
  case UNIFORM:
    return ("uniform");
    break;
  case TRUNCNORMAL:
    return ("truncnormal");
    break;
  case ERLANG:
    return ("erlang");
    break;
  case WEIBULL:
    return ("weibull");
    break;
  case PHASETYPE:
    return ("phasetype");
    break;
  case DET:
    return ("det");
    break;
  case BERNOULLI:
    return ("bernoulli");
    break;
  case DISCRETEUNIFORM:
    return ("discreteuniform");
    break;
  case GEOMETRIC:
    return ("geometric");
    break;
  case MODGEOMETRIC:
    return ("modgeometric");
    break;
  case BINOMIAL:
    return ("binomial");
    break;
  case POISSON:
    return ("poisson");
    break;
  case EXPOLY:
    return ("expoly");
    break;
  default:
    return ("error");
    break;
  }
} 

DistributionType String2DistributionType (char *s) {
  if (s) {
    if (!strcmp (s, "exp"))
      return (EXP);
    else if (!strcmp (s, "uniform"))
      return (UNIFORM);
    else if (!strcmp (s, "truncnormal"))
      return (TRUNCNORMAL);
    else if (!strcmp (s, "erlang"))
      return (ERLANG);
    else if (!strcmp (s, "weibull"))
      return (WEIBULL);
    else if (!strcmp (s, "phasetype"))
      return (PHASETYPE);
    else if (!strcmp (s, "det"))
      return (DET);
    else if (!strcmp (s, "bernoulli"))
      return (BERNOULLI);
    else if (!strcmp (s, "discreteuniform"))
      return (DISCRETEUNIFORM);
    else if (!strcmp (s, "geometric"))
      return (GEOMETRIC);
    else if (!strcmp (s, "modgeometric"))
      return (MODGEOMETRIC);
    else if (!strcmp (s, "binomial"))
      return (BINOMIAL);
    else if (!strcmp (s, "poisson"))
      return (POISSON);
    else if (!strcmp (s, "expoly"))
      return (EXPOLY);
    else
      return (NODISTR);
  }
  else
    return (NODISTR);
} 

char *MarkingDependencyType2String (MarkingDependencyType enumval) {
  switch (enumval) {
  case NOMARKDEP:
    return (NULL);
    break;
  case ENABDEP:
    return ("enabdep");
    break;
  case SCALING:
    return ("scaling");
    break;
  case CONSTANT:
    return ("constant");
    break;
  default:
    return ("error");
    break;
  }
} 

MarkingDependencyType String2MarkingDependencyType (char *s) {
  if (s) {
    if (!strcmp (s, "enabdep"))
      return (ENABDEP);
    else if (!strcmp (s, "scaling"))
      return (SCALING);
    else if (!strcmp (s, "constant"))
      return (CONSTANT);
    else
      return (NOMARKDEP);
  }
  else
    return (NOMARKDEP);
} 

char *PolicyType2String (PolicyType enumval) {
  switch (enumval) {
  case NOPOLICY:
    return (NULL);
    break;
  case PRD:
    return ("prd");
    break;
  case PRS:
    return ("prs");
    break;
  case PRI:
    return ("pri");
    break;
  default:
    return ("error");
    break;
  }
}

PolicyType String2PolicyType (char *s) {
  if (s) {
    if (!strcmp (s, "prd"))
      return (PRD);
    if (!strcmp (s, "prs"))
      return (PRS);
    else if (!strcmp (s, "pri"))
      return (PRI);
    else
      return (NOPOLICY);
  }
  else
    return (NOPOLICY);
}

char *ConcurrencyDegree2String (ConcurrencyDegree enumval) {
  switch (enumval) {
  case NOCONC:
    return (NULL);
    break;
  case IS:
    return ("is");
    break;
  case SS:
    return ("ss");
    break;
  default:
    return ("error");
    break;
  }
} 

ConcurrencyDegree String2ConcurrencyDegree (char *s) {
  if (s) {
    if (!strcmp (s, "is"))
      return (IS);
    else if (!strcmp (s, "ss"))
      return (SS);
    else
      return (NOCONC);
  }
  else
    return (NOCONC);
}

char *TransitionType2String (TransitionType enumval) {
  switch (enumval) {
  case NOTRTYPE:
    return (NULL);
    break;
  case TIMED:
    return ("timed");
    break;
  case IMM:
    return ("imm");
    break;
  default:
    return ("error");
    break;
  }
} 

TransitionType String2TransitionType (char *s) {
  if (s) {
    if (!strcmp (s, "timed"))
      return (TIMED);
    else if (!strcmp (s, "imm"))
      return (IMM);
    else
      return (NOTRTYPE);
  }
  else
    return (NOTRTYPE);
}

char *PortType2String (PortType enumval) {
  switch (enumval) {
  case NOPORTTYPE:
    return (NULL);
    break;
  case PinT:
    return ("p<-t");
    break;
  case USEDPORT:
    return ("usedport");
    break;
  case TinP:
    return ("t<-p");
    break;
  case PoutT:
    return ("p->t");
    break;
  case ToutP:
    return ("t->p");
    break;
  case PinhiboutT:
    return ("p-ot");
    break;
  case TinhibinP:
    return ("to-p");
    break;
  default:
    return ("error");
    break;
  }
} 

PortType String2PortType (char *s) {
  if (s) {
    if (!strcmp (s, "usedport"))
      return (USEDPORT);
    if (!strcmp (s, "p<-t"))
      return (PinT);
    if (!strcmp (s, "t<-p"))
      return (TinP);
    if (!strcmp (s, "p->t"))
      return (PoutT);
    if (!strcmp (s, "t->p"))
    return (ToutP);
    if (!strcmp (s, "p-ot"))
      return (PinhiboutT);
    else if (!strcmp (s, "to-p"))
      return (TinhibinP);
    else
      return (NOPORTTYPE);
  }
  else
    return (NOPORTTYPE);
}

char *ArcType2String (ArcType enumval) {
  switch (enumval) {
//  case NOARCTYPE:
//    return (NULL);
//    break;
  case IOARC:
    return ("ioarc");
    break;
  case HARC:
    return ("harc");
    break;
  default:
    return ("error");
    break;
  }
} 

ArcType String2ArcType (char *s) {
  if (s && !strcmp (s, "harc"))
    return (HARC);
  else
    return (IOARC);
//  if (s) {
//    if (!strcmp (s, "ioarc"))
//      return (IOARC);
//    else if (!strcmp (s, "harc"))
//      return (HARC);
//    else
//      return (NOARCTYPE);
//  }
//  else
//    return (NOARCTYPE);
}

char *VisibleType2String (VisibleType enumval) {
  switch (enumval) {
  case PRIVATE:
    return ("private");
    break;
  case PUBLIC:
    return ("public");
    break;
  default:
    return ("error");
    break;
  }
}

VisibleType String2VisibleType (char *s) {
  if (s) {
    if (!strcmp (s, "private"))
      return (PRIVATE);
    else
      return (PUBLIC);
  }
  else
    return (PUBLIC);
}

char *ProcessTypeDeclType2String (ProcessTypeDeclType enumval) {
  switch (enumval) {
  case TYPE:
    return ("processtype");
    break;
  case DECL:
    return ("process");
    break;
  default:
    return ("error");
    break;
  }
}

ProcessTypeDeclType String2ProcessTypeDeclType (char *s) {
  if (s) {
    if (!strcmp (s, "processtype"))
      return (TYPE);
    else
      return (DECL);
  }
  else
    return (TYPE);
}

char *FormalParameterType2String (FormalParameterType enumval) {
  switch (enumval) {
  case PARAM:
    return ("param");
    break;
  case RREWARD:
    return ("rreward");
    break;
  case MEASPARAM:
    return ("measparam");
    break;
  case IREWARD:
    return ("ireward");
    break;
  case CREWARD:
    return ("creward");
    break;
  case SMEASURE:
    return ("smeasure");
    break;
  case MMEASURE:
    return ("mmeasure");
    break;
  default:
    return ("error");
    break;
  }
}

FormalParameterType String2FormalParameterType (char *s) {
  if (s) {
    if (!strcmp (s, "rreward"))
      return (RREWARD);
    else if (!strcmp (s, "measparam"))
      return (MEASPARAM);
    else if (!strcmp (s, "ireward"))
      return (IREWARD);
    else if (!strcmp (s, "creward"))
      return (CREWARD);
    else if (!strcmp (s, "smeasure"))
      return (SMEASURE);
    else if (!strcmp (s, "mmeasure"))
      return (MMEASURE);
    else
      return (PARAM);
  }
  else
    return (PARAM);
}


 
/************************ Funktionen zum SPNL-check ***********************/


bool isValidName (char *id) {
  for (int i=0; i<ALL_NUMRESWORDS; i++)
    if (!strcmp (all_reserved[i], id))
      return (false);
  return (true);
}


#endif

