#ifndef SPNLMODULEH
#define SPNLMODULEH



class Module {

  private:
    char *id;
    bool errorfree;

    Vektor <String> ImportList;			// use ...
    Vektor <Parameter> ParameterList;		// parameter ...
    Vektor <ProcessInst> ProcessInstList;	// processinst ...
    Vektor <ProcessTypeDecl> ProcessList;	// process/processtype ...
      
    void error_cannotdeclare (char *idtype, char *idname);
    // Gibt Fehlermeldung aus: idname schon vergeben, kann nicht neuen idtype
    //  mit Namen idname deklarieren.

    void error_notdefined (char *nichtdatyp, char *nichtdaid,
	       char hinzufuegkuerzel, char *hinzufuegtyp, char *hinzufuegid);
    // Gibt Fehlermeldung aus: nichtdatyp mit Namen nichtdaid ist nicht
    //  vorhanden, kann hinzufuegtyp mit Namen hinzufuegid nicht hinzufuegen.

  public:
    Module (char *name);
    ~Module ();
    void display ();
    char *getid ();

    bool isErrorfree ();

    String *addImport (char *importmodule);
    char *getImport (int i);

    Parameter *addParameter (char *id, char *expr);
    Parameter *getParameter (int i);
    Parameter *searchParameter (char *id);

    ProcessInst *addProcessInst (char *id, char *array, char *processtype);
    ProcessInst *addProcessInstFormPar (char *processinst, char *paramexpr,
					char *guessexpr);
    ProcessInst *getProcessInst (int i);
    ProcessInst *searchProcInst (char *id);

    ProcessTypeDecl *addProcess (char *id, ProcessTypeDeclType type);
    ProcessTypeDecl *addProcessFormPar (char *process,
					char *param, char *paramtype);
    ProcessTypeDecl *getProcess (int i);

    ProcessTypeDecl *addProcessPort (char *process,
				     char *port, char *type, char *mult);
    ProcessTypeDecl *addProcessReward (char *process, char *reward,
				       char typ, VisibleType visible);
    ProcessTypeDecl *addProcessMeasure (char *process, char *measure,
					char typ, VisibleType visible);
    ProcessTypeDecl *addProcessParameter (char *process, char *param,
					  char *expr);

    ProcessTypeDecl *addProcessProcInst (char *process,
			char *processinst, char *array, char *processtype);
    ProcessTypeDecl *addProcessProcInstFormPar (char *process,
			char *processinst, char *paramexpr, char *guessexpr);

    ProcessTypeDecl *addProcessProcUsage (char *process,
			char *newid, char *useproc);

    ProcessTypeDecl *addProcessPlace (char *process,
			char *place, char *marking);
    ProcessTypeDecl *addProcessTrans (char *process,
			char *trans, char *type);
    ProcessTypeDecl *addProcessArc (char *process,
			char *arc, char *from, char *to, char *type,
			char *mult);

    ProcessTypeDecl *addProcessTransAttr (char *process, char *trans, 
	                char *prioexpr, char *distribution, char *distexpr,
			char *weight, char *markdep, char *policy,
                        char *concurrency, char *guard);
    ProcessTypeDecl *addProcessRewardExpr (char *process,
			char *reward, char *expr);
    ProcessTypeDecl *addProcessMeasureExpr (char *process,
			char *measure, char *expr);

    bool checkIntern ();
    // Ueberprueft die globalen Parameter und ProzessInstanzen (sofern sie
    //  lokal in diesem Modul ueberprueft werden koennen). Ruft dann fuer
    //  alle Prozesse und Prozesstypen deren Methode checkIntern auf.

};



#endif
