#ifndef STDFUNCC
#define STDFUNCC

#include <string.h>
#include <ctype.h>      // isalpha, isalnum
#include "stdfun.h"
//#include <iostream.h>   // wieder rausnehmen!!!


char *getPath (char *a) {
  char *b= NULL;
  if (a) {
    int i= strlen(a);
    while (--i>=0 && a[i] != '/');  // letztes '/' suchen
    if (i < 0)
      return (NULL);
    b= new char[i+2];  // Pfad incl. '/' nach b kopieren
    memcpy (b, a, i+1);
    b[i+1]= '\0';
  }
  return (b);
}


char *getFile (char *a) {
  char *b= NULL;
  if (a) {
    int i= strlen(a);
    while (--i>=0 && a[i] != '/');  // letztes '/' suchen
    if (i < 0)
      return (newstring (a));
    b= new char[strlen(a)-i];  // File ohne '/' nach b kopieren
    memcpy (b, a+i+1, strlen(a)-i);
  }
  return (b);
}


char *concat (char *a, char *b) {
  char *c= NULL;
  if (a && b) {
    c= new char[strlen(a)+strlen(b)+1];
    strcpy (c,a);
    strcat (c,b);
  }
  else if (b) {
    c= new char[strlen(b)+1];
    strcpy (c,b);
  }
  else if (a) {
    c= new char[strlen(a)+1];
    strcpy (c,a);
  }
  return (c);
}


char *pointed_concat (char *a, char *b) {
  char *c= NULL;
  if (a && b) {
    c= new char[strlen(a)+strlen(b)+3];
    strcpy (c,a);
    strcat (c,".");
    strcat (c,b);
  }
  else if (b) {
    c= new char[strlen(b)+2];
    strcpy (c,b);
  }
  else if (a) {
    c= new char[strlen(a)+2];
    strcpy (c,a);
  }
  strcat (c,".");
  return (c);
}


char *pointed_concat2 (char *a, char *b) {
  char *c= NULL;
  if (a && b) {
    c= new char[strlen(a)+strlen(b)+2];
    strcpy (c,a);
    strcat (c,".");
    strcat (c,b);
  }
  else if (b) {
    c= new char[strlen(b)+1];
    strcpy (c,b);
  }
  else if (a) {
    c= new char[strlen(a)+1];
    strcpy (c,a);
  }
  return (c);
}


char *newstring (char *a) {
  if (a) {
    char *b= new char[strlen(a)+1];
    strcpy (b, a);
    return (b);
  }
  else
    return (NULL);
}


char *substring2point (char *a) {
/*
  char *zwerg= newstring (a);
  return (strtok (zwerg, "."));
*/
  char *b= NULL;
  if (a) {
    int i= 0;
    while (a[i++] != '.' && a[i-1] != '\0');
    if (a[i-1] == '\0')
      return (NULL);
    b= new char[i];
    memcpy (b, a, i-1);
    b[i-1]= '\0';
  }
  return (b);
}


char *substring2lastpoint (char *a) {
  char *b= NULL;
  if (a) {
    int i= strlen(a);
    while (--i>=0 && a[i] != '.');
    if (i < 0)
      return (newstring (a));
    b= new char[i+1];
    memcpy (b, a, i);
    b[i]= '\0';
  }
  return (b);
}


char *lastsubstring (char *a) {
  char *b= NULL;
  if (a) {
    int i= strlen(a);
    while (--i>=0 && a[i] != '.');
    if (i < 0)
      return (NULL);
    b= new char[strlen(a)-i];
    memcpy (b, a+i+1, strlen(a)-i);
  }
  return (b);
}


char *mark_names (char *a, int resc, char **resv) {
  if (!a)
    return (NULL);

  char *neu= newstring (a);
  char *zwerg= NULL;
  char *name= NULL;
  int i= 0, j= 0, anfang= 0, laenge= 0, notfound;
  char t;
  // Durchsuche neu nach Namen und wenn ein Name gefunden wird, der
  //  nicht in resv als reservierter Name steht, erzeuge in neu
  //  neuen String mit $Name:  $ und loesche altes neu mittels zwerg
  //  zum pointer-zwischenspeichern.
  while (i<strlen(neu)) {
    t=  neu[i];
    if (((i == 0) || !isdigit (neu[i-1])) &&
	(isalpha (t) || t == '_')) {  // Beginn Name
      // Die erste Zeile der Abfrage dient dazu, Zahlen wie 4E7 richtig
      //  zu erkennen.
      anfang= i;  // Position des erstes Zeichen des Namens merken
      while (isalnum (t) || t == '_' ||
	     (t == '.' && (isalpha (neu[i+1]) || neu[i+1] == '_')))
	t= neu[++i];
      laenge= i - anfang;
      
      name= new char[laenge+1];
      memcpy (name, neu+anfang, laenge);  // Name reinkopieren
      name[laenge]= '\0';                 // und String beenden
      notfound= true;
      for (j=0; j<resc; j++)
	if (!strcmp (resv[j], name))
	  notfound= false;

      delete (name);
      name= NULL;
      if (notfound) {
//cout << "\n1 neu=>"<<neu<<"<, zwerg=>"<<zwerg<<"<<"<<flush;
	// Wenn name nicht gefunden wird in Uebergabeliste, dann markieren
	zwerg= neu;
	neu= new char[strlen(zwerg)+3];  // 1x'\0' + 2x'$'
//cout << "\n2"<<flush;
	memcpy (neu, zwerg, anfang);  // alles vor Name reinkopieren
	neu[anfang]= '$';             // $ einfuegen
	memcpy (neu+anfang+1, zwerg+anfang, laenge);  // Name reinkopieren
	neu[anfang+laenge+1]= '$';    // $ anfuegen
	memcpy (neu+i+2, zwerg+i, (strlen(zwerg)-i)+1);
                                      // alles nach Name reinkopieren
	delete (zwerg);
	zwerg= NULL;
	i+= 2;
      }
    }
    i++;
  }
  return (neu);
}


char *globalize_names (char *a, char *pfad) {
  if (!a)
    return (NULL);
  if (!pfad)
    return (newstring (a));

  char *neu= newstring (a);
  char *zwerg= NULL;
  int i= 0, einfuegepos= 0, restlaenge= 0;
  int pfadlaenge= strlen(pfad);
  char t;
  // Durchsuche neu nach $Name:  $ und ersetze es durch $pfadName$.
  //  Mittels zwerg wird der alte pointer, der geloescht werden muss,
  //  zwischengespeichert.

  while (i<strlen(neu)) {
    if (neu[i] == '$') {  // Beginn Name
      zwerg= neu;
      neu= new char[strlen(zwerg)+pfadlaenge+1];  // 1x'\0' + pfadlaenge
      memcpy (neu, zwerg, i+1);  // alles vor Name reinkopieren
      memcpy (neu+i+1, pfad, pfadlaenge);  // Pfad reinkopieren
      memcpy (neu+i+1+pfadlaenge, zwerg+i+1, strlen(zwerg)-i);
                                      // Rest reinkopieren incl. '\0'
      delete (zwerg);
      zwerg= NULL;
      while (neu[++i] != '$');
    }
    i++;
  }
  return (neu);
}


bool exist_name (char *a) {
  if (!a)
    return (NULL);
  return (strchr (a,'$') != NULL);
}


char *get_first_name (char *a) {
  if (!a)
    return (NULL);
  int i=0;
  char *name= NULL;
  while (i<strlen(a)) {
    if (a[i] == '$') {  // Beginn Name gefunden
      // Jetzt Ende des Strings suchen, zeichen zaehlen und uebertragen
      int anfang= i;  // Position des ersten $-Zeichens
      while (a[++i] != '$');
      name= new char[i-anfang];   // 1x'\0' + namen
      memcpy (name, a+anfang+1, i-anfang-1);  // alles vor Name reinkopieren
      name[i-anfang-1]= '\0';
      return (name);
    }
    i++;
  }
  return (NULL);
}


char *replace_first_name (char *a, char *newname, bool einklammern= false) {
  if (!a)
    return (NULL);
  int i=0;
  char *neu= NULL;
  char *newnametmp= NULL;

  if (einklammern && newname) {
    newnametmp= new char[strlen(newname)+3];
    newnametmp[0]= '(';
    newnametmp[1]= '\0';
    strcat (newnametmp, newname);
    strcat (newnametmp, ")");
    newname= newnametmp;
  }
  if (newname) {
    while (i<strlen(a)) {
      if (a[i] == '$') {  // Beginn Name gefunden
	// Jetzt Ende des Strings suchen, zeichen zaehlen und austauschen
	int anfang= i;  // Position des ersten $-Zeichens
	while (a[++i] != '$');
	neu= new char[strlen(a)-i+anfang+strlen(newname)];
	memcpy (neu, a, anfang);  // alles vor Name reinkopieren
	memcpy (neu+anfang, newname, strlen(newname)); // newname reinkopieren
	memcpy (neu+anfang+strlen(newname), a+i+1, strlen(a)-i);
                                  // alles nach Name reinkopieren
	delete (newnametmp);
	return (neu);
      }
      i++;
    }
  }
  else {
    while (i<strlen(a)) {
      if (a[i] == '$') {  // Beginn Name gefunden
	// Jetzt Ende des Strings suchen, zeichen zaehlen und austauschen
	int anfang= i;  // Position des ersten $-Zeichens
	while (a[++i] != '$');
	neu= new char[strlen(a)-i+anfang];
	memcpy (neu, a, anfang);  // alles vor Name reinkopieren
	memcpy (neu+anfang, a+i+1, strlen(a)-i);
                                  // alles nach Name reinkopieren
	delete (newnametmp);
	return (neu);
      }
      i++;
    }
  }
  delete (newnametmp);
  return (NULL);
}


bool name_during_if (char *a) {
// 1.) $-Zeichen finden
// 2.) von dort aus rueckwaerts if oder elsif suchen
// 3.) nun, bis Klammern abgeschlossen, vorwaerts laufen
// 4.) wenn nun aktueller pointer hinter $-Pointer => true
  int klammeranz= 1;
  char *namept= strchr (a, '$');
  while (!(  (!strncmp (namept,    "if(", 3) && (!isalnum(*(namept-1))))
	   ||(!strncmp (namept, "elsif(", 6) && (!isalnum(*(namept-1)))))
	 && (namept >= a))
    namept--;
  if (namept < a)
    return (false); // kein if
  namept= strchr (namept, '(');
  while (klammeranz && (namept < a+strlen(a))) {
    namept++;
    if (*namept == '(')
      klammeranz++;
    else if (*namept == ')')
      klammeranz--;
  }
  return (namept > strchr (a, '$'));
}


bool name_after_dcross (char *a) {
  char *pt= strchr (a,'$')-1;
  return ((pt >= a) && (*pt == '#'));
}


bool search_substring (char *string, char *substring) {
  if (!string || !substring)
    return (false);
  return (strstr (string, substring) != NULL);
/*
  int i=0, j=0;
  while (string[i] != '\0') {
    if (string[i] == substring[0]) {
      j= 0;
      while ((string[i+j] == substring[j]) && (substring[j] != '\0'))
	j++;
      if (substring[j] == '\0')
	return (true);  // String gefunden
    }
    i++;
  }
  return (false);
*/
}


char *replace_substring (char *str, char *oldsubstr, char *newsubstr) {
  if (!str)
    return (NULL);
  if (!oldsubstr)
    return (newstring (str));

  char *neu= newstring (str);
  // testen, ob oldsubstr in neu enthalten ist:
  int i=0, j=0;

  while (neu[i] != '\0') {
    if (neu[i] == oldsubstr[0]) {
      j= 0;
      while ((neu[i+j] == oldsubstr[j]) && (oldsubstr[j] != '\0'))
	j++;
      if (oldsubstr[j] == '\0') {
	// String gefunden von [i] anfangend j Zeichen lang
	char *zwerg= neu;
	if (newsubstr) {
	  neu= new char[strlen(zwerg)-j+strlen(newsubstr)+1];
	  if (i)
	    memcpy (neu, zwerg, i);
	  memcpy (neu+i, newsubstr, strlen(newsubstr));
	  memcpy (neu+i+strlen(newsubstr), zwerg+i+j, strlen(zwerg)-i-j+1);
	  i+= strlen (newsubstr)-1;
	}
	else {  // newsubstr == NULL
	  neu= new char[strlen(zwerg)-j+1];
	  if (i)
	    memcpy (neu, zwerg, i);
	  memcpy (neu+i, zwerg+i+j, strlen(zwerg)-i-j+1);
	  i--;
	}
	delete (zwerg);
	zwerg= NULL;
      }
    }
    i++;
  }
  return (neu);
}


void display_dollarexpr (char *expression) {
  char *p;
  p= strtok (expression, "$");
  cout << p;
  do {
    p= strtok ('\0', "$");
    if (p)
      cout << p;
  } while (p);
}





/*
bool isin (char *a, char b) {
  if (a)
    for (int i=0; i<strlen(a); i++)
      if (a[i] == b)
	return (true);
  return (false);
}
*/


#endif






/*
const int NUMRESWORDS= 17;

char* reserved[NUMRESWORDS]= {  // includes meas, dist und rew (s.o.)
  "if", "then", "else", "elseif",
  "and", "or", "not", "true", "false",
  "dist", "ArithmeticMean", "E",
  "portdep", "I", "R", "x", "e"
};

#include <iostream.h>
void main () {
  char *a= NULL;
  char *b= NULL; 
  char *c= NULL;
  char *d= NULL;

  a= new char[5];
  b= new char[5];
  a[0]= 'a';
  a[1]= 'b';
  a[2]= 'c';
  a[3]= 'd';
  a[4]= '\0';
  b[0]= '1';
  b[1]= '2';
  b[2]= '3';
  b[3]= '4';
  b[4]= '\0';
  c= concat (a,b);
  cout << c;
  delete (a);
  delete (b);
  delete (c);
  cout << "================\n";
  c= substring2point ("protocol_layers.spnl");
  cout << c << '\n';
  delete (c);
  c= substring2point ("protocol_layersspnl");
  cout << c << '\n';
  delete (c);

  c= mark_names ("2.0+U x S.w5", NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,"hallo.test1.m.");
  cout << d << "\n";
  delete (d);
  delete (c);
  c= mark_names ("ArithmeticMean(test.values)", NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,"hallo.test1.m.");
  cout << d << "\n";
  delete (d);
  delete (c);
  c= mark_names ("hiername+5.01", NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,"hallo.");
  cout << d << "\n";
  delete (d);
  delete (c);
  c= mark_names ("43.478E-4-(klamm*2)^neun.zehn a", NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,"hallo.test1.");
  cout << d << "\n";
  delete (d);
  delete (c);
  c= mark_names ("43.4+ if a then 7 else c", NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,"p.");
  cout << d << "\n";
  delete (d);
  delete (c);
  c= mark_names ("1997", NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,".");
  cout << d << "\n";
  delete (d);
  delete (c);
  c= mark_names ("u", NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,NULL);
  cout << d << "\n";
  delete (d);
  delete (c);
  c= mark_names (NULL, NUMRESWORDS, reserved);
  cout << c << "\n";
  d= globalize_names (c,"dk.");
  cout << d << "\n";
  delete (d);
  delete (c);

  c= replace_substring ("HCH.DU","H.D","hd");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("hallo, du hallhallohallo","hallo","bistdubloed");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("hallo, du hallhallohallo","hallo","hi");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("hallo, du hallhallohallo","hallo",NULL);
  cout << c << "\n";
  delete (c);
  c= replace_substring ("hi there",NULL,"hi");
  cout << c << "\n";
  delete (c);
  c= replace_substring (NULL,"sd","sd");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("ICH","ICH","I");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("ICH","ICH",NULL);
  cout << c << "\n";
  delete (c);
  c= replace_substring ("von dir will","von ","Vla");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("ich bin doof","doof","recht nett");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("i am you","am","was");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("heutige heuer heuheu heutig","heute","gestern");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("die dummen daemel duerfen","d","t");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("hhhihihihhhi","hi","von hier bis da hihi");
  cout << c << "\n";
  delete (c);
  c= replace_substring ("krummkrummkrummkrumm","rummkr","krumm");
  cout << c << "\n";
  delete (c);

  c= get_first_name ("this ist $dollar$ zeichen");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("$dollar$ zeichen");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("this ist $dollar$");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("$dollar$");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("this ist $$ zeichen");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("this ist zeichen");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("this $dollar1$ ist $dollar2$ zeichen");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("thisist$d$zeichen");
  cout << c << "\n";
  delete (c);
  c= get_first_name ("t");
  cout << c << "\n";
  delete (c);
  c= get_first_name (NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $dollar$ zeichen", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("$dollar$ zeichen", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $dollar$", "p");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("$dollar$", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $$ zeichen", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist zeichen", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $dollar1$ $dollar2$ zeichen", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $d$ zeichen", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name (NULL, "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("t", "pfund");
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $dollar$ zeichen", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("$dollar$ zeichen", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $dollar$", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("$dollar$", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $$ zeichen", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist zeichen", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $dollar1$ $dollar2$ zeichen", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("this ist $d$ zeichen", NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name (NULL, NULL);
  cout << c << "\n";
  delete (c);
  c= replace_first_name ("t", NULL);
  cout << c << "\n";
  delete (c);

  cout << "----------------------------\n";
  if (name_during_if ("if((hj) ($g")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("if((hj) )(()(($g")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("if(hj) ($g")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("alh if($hj$)")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("if(#$hj$ (shfh 45) sdk) fee else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("$jdh$if(hj (shfh 45) sdk) fee else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if($hj$ (shfh 45) sdk) fee else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if(hj ($shfh$ 45) sdk) fee else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if(hj (shfh 45) $sdk$) fee else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if(hj (shfh 45) sdk) $fee$ else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if(hj (shfh 45) sdk) fee else (hgjfd) () (()()) elsif(shg$ (hgsdj(fjs)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if(hj (shfh 45) sdk) fee else (hgjfd) () (()()) elsif(shg (hgsdj($fjs$)m,ks)sk) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if(hj (shfh 45) sdk) fee else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)$sk$) halh")) cout << "yupp\n"; else cout << "nop\n";
  if (name_during_if ("jdh if(hj (shfh 45) sdk) fee else (hgjfd) () (()()) elsif(shg (hgsdj(fjs)m,ks)sk) $halh$")) cout << "yupp\n"; else cout << "nop\n";

  cout << "----------------------------\n";
  if (name_after_doppelkreuz ("gjkm#$jbjk$")) cout << "yupp\n"; else cout << "nop\n";
  if (name_after_doppelkreuz ("#$r$")) cout << "yupp\n"; else cout << "nop\n";
  if (name_after_doppelkreuz ("$r$")) cout << "yupp\n"; else cout << "nop\n";
  if (name_after_doppelkreuz ("#3$#5")) cout << "yupp\n"; else cout << "nop\n";
}
// ynnyynyyynyyyn | yynn
*/
