#ifndef STDFUNH
#define STDFUNH

char *getPath (char *completefilename);
// Liefert den kompletten Pfad von completefilename zurueck
// Liefert Substring bis zum letzten Backslash (incl.) zurueck. Wenn kein
//  Backslash existiert, wird NULL zurueckgeliefert.

char *getFile (char *completefilename);
// Liefert den Filename von completefilename zurueck (ohne Pfad)
// Liefert Substring nach dem letzten Backslash (excl.) zurueck. Wenn kein 
//  Backslash existiert, wird ein neuer String zurueckgeliefert.

char *concat (char *a, char *b);
// Concadiniert die beiden Strings direkt aneinander.

char *pointed_concat (char *a, char *b);
// Zusammenfuegen zweier Strings durch Punkt getrennt und Punkt am Ende
//  z.B.: a="hi", b="there" returns "hi.there.".

char *pointed_concat2 (char *a, char *b);
// Zusammenfuegen zweier Strings durch Punkt getrennt ohne Punkt am Ende
//  z.B.: a="hi", b="there" returns "hi.there".

char *newstring (char *a);
// Erzeugt einen neuen String mit demselben Inhalt von a

char *substring2point (char *a);
// Liefert Substring bis zum ersten Punkt zurueck. Wenn kein Punkt
//  existiert, wird ein neuer String mit a zurueckgeliefert.

char *substring2lastpoint (char *a);
// Liefert Substring bis zum letzten Punkt zurueck. Wenn kein Punkt
//  existiert, wird ein neuer String mit a zurueckgeliefert.

char *lastsubstring (char *a);
// Liefert Substring nach dem letzten Punkt zurueck. Wenn kein Punkt
//  existiert, wird NULL zurueckgeliefert.

char *mark_names (char *a, int resc, char **resv);
// Alle Namen in a werden, nachdem sie erkannt wurden, in $-Zeichen gesetzt.
//  In resv stehen resc reservierte Namen, die nicht umgewandelt werden.
//  z.B.: a="a+5.0e-7*b.zeit" liefert "$a$+5.0e-7*$b.zeit$".
// ACHTUNG: Funktion funktioniert nur auf einfache Namen!!!
// NUR AUF KOMPILIERTE NETZE ANWENDEN. KANN FEHLER ERZEUGEN BEI Z.B.:
// ERDE3 (VERWECHSLUNG MIT 5E3) ODER E5E6. ALSO: VORSICHT IST GEBOTEN!!!

char *globalize_names (char *a, char *pfad);
// Wandelt alle Einzelstrings in $a$ in globale Strings um, d.h. zu
//  jedem gefundenem String wird der pfad angefuegt.
//  z.B.: a="$a$+5.0e-7*$b.zeit$" und pfad="mod.proc." liefern
//        "$mod.proc.a$+5.0e-7*$mod.proc.b.zeit$".

bool exist_name (char *a);
// Liefert zurueck, ob ein mit $-Zeichen markierter Name in dem String a
//  vorhanden ist.

char *get_first_name (char *a);
// Liefert einen neuen String mit dem ersten durch $-Zeichen in a markierten
//  Namen zurueck. Ist kein Name vorhanden, wird eine NULL zurueckgeliefert.

char *replace_first_name (char *a, char *newname, bool einklammern= false);
// Ersetzt den ersten durch $-Zeichen in a markierten Namen durch newname
//  und loescht dabei die $-Zeichen und liefert diesen String zurueck.
//  Wenn einklammern gesetzt ist, wird newname noch in a eingeklammert.

bool name_during_if (char *a);
// Liefert zurueck, ob sich der erste $name$ in einem if- oder elsif-
//  Praedikat befindet (eingeklammertes Praedikat).

bool name_after_dcross (char *a);
// Liefert zurueck, ob sich der erste $name$ direkt nach einem # befindet.

bool search_substring (char *string, char *substring);
// Testet das Vorkommen des Substrings innerhalb des Strings. Liefert true
//  zurueck, falls substring mindestens ein mal in string vorkommt.
//  Search_substring ist eine sinnvolle Abfrage bevor mit replace_substring
//  etwas ersetzt wird, ist aber nicht noetig.

char *replace_substring (char *str, char *oldsubstr, char *newsubstr);
// Ersetzt in str jedes Vorkommen von oldsubstr durch newsubstr und
//  liefert diesen String zurueck. Kann auch zum loeschen bestimmter
//  Namen benutzt werden, indem als newsubstr NULL uebergeben wird.

void display_dollarexpr (char *expression);
// Gibt den Ausdruck expression ohne evtl. vorkommende Dollar-Zeichen aus.
//  Die Dollar-Zeichen werden beim Scannen der Expression um die Variablen-
//  namen gelegt, um diese schneller wiederzuerkennen.


#endif
