%{
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#define YYSTYPE double /* double-Typ fuer den Stack */

/* double globalval= 0; */

void yyerror (char *t) {
  printf (t);
}

%}

%token IDENT
%token REALNUM
%token INTNUM
%left '+' '-'
%left '*' '/'
%left '^'
%right UMINUS

%%


line  : line expr ';'             { printf ("%g\n", $2); }
      | line IDENT ';'            { printf ("error\n"); }
      | /* leer */
      | error ';'                 { printf ("error\n");
				    yyerror ("expression couldn't be parsed");
				    yyerrok; }
      ;

expr  : expr '+' expr             { $$ = $1 + $3; }
      | expr '-' expr             { $$ = $1 - $3; }
      | expr '*' expr             { $$ = $1 * $3; }
      | expr '/' expr             { $$ = $1 / $3; }
      | expr '^' expr             { $$ = pow ($1, $3); }
      | '(' expr ')'              { $$ = $2; }
      | '-' expr %prec UMINUS     { $$ = - $2; }
      | REALNUM
      | INTNUM
      ;

%%

#include "lex.yy.c"

/* Aufruf: echo 16/-4^2 | a.out > ergebnisfile */

void main () {
  yyparse ();
/*
  if (yyparse())
    printf ("%g", globalval);
  else
    printf ("0");
*/
}

