#ifndef IDN_H
#define IDN_H
/* $Id: idn.h,v 1.1 1998/01/14 12:04:11 indy Exp $ */
/* Copyright 1989, The Regents of the University of Colorado */

/* This file is part of the Eli Module Library.

The Eli Module Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The Eli Module Library is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the Eli Module Library; see the file COPYING.LIB.
If not, write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Eli into the
   directory resulting from a :source derivation, you may use that
   created file as a part of that directory without restriction. */

	/* Type exported by the Identifier Table Module */

typedef int INTERNIDN;
#define NoIdn 0


#ifndef NOFOLD
	/* Variable exported by the Identifier Table Module */

extern int dofold;
#endif


	/* Routines exported by the Identifier Table Module */

#if defined(__cplusplus) || defined(__STDC__)
#include <stdio.h>
#endif

#if defined(__cplusplus) || defined(__STDC__)
extern void prtidnv(FILE *d, int i);
#else
extern void prtidnv(/* FILE *d; int i; */);
#endif
/* Print an identifier
 *    On exit-
 *       The identifier encoded by i has been added to the current
 *          line of d.
 ***/


#if defined(__cplusplus) || defined(__STDC__)
extern void saveidn(FILE *d);
#else
extern void saveidn(/* FILE *d; */);
#endif
/* Save the current identifier table state
 *    On exit-
 *       File d is a symbolic encoding of the current state, suitable
 *          for inclusion in the identifier table module
 ***/


#if defined(__cplusplus) || defined(__STDC__)
extern void dmpidn(FILE *d);
#else
extern void dmpidn(/* FILE *d; */);
#endif
/* Dump the identifier table
 *    On exit-
 *       The entire identifier table has been written to d
 ***/


#if defined(__cplusplus) || defined(__STDC__)
extern void mkidn(char *c, int l, int *t, int *s);
#else
extern void mkidn(/* char *c; int l, *t; int *s; */);
#endif
/* Obtain the internal coding of an identifier or keyword
 *    On entry-
 *       c points to the identifier or keyword
 *       l=length of the identifier or keyword
 *       t points to a location containing the initial terminal code
 *    If the identifier or keyword has appeared previously then on exit-
 *       t has been set to the terminal code given on its first appearance
 *       s has been set to the internal coding set on its first appearance
 *    Otherwise on exit-
 *       t remains unchanged
 *       s has been set to a new internal coding
 ***/

#endif
