
/* interface of tree construction functions */

#ifndef TREECON_H
#define TREECON_H
#include "err.h"

#ifdef _P
#undef _P
#endif

#if defined(__STDC__) || defined(__cplusplus)
#define _P(args) args
#else
#define _P(args) ()
#endif


#ifdef MONITOR
#define _NODECOMMON int _prod; POSITION _coord;
#else
#define _NODECOMMON int _prod;
#endif

typedef struct NODEPTR_struct {
	_NODECOMMON
#ifdef __cplusplus
	void* operator new(size_t size);
#endif
}* NODEPTR;
#undef _NODECOMMON
#define NULLNODEPTR ((NODEPTR)0)
#include "HEAD.h"
extern void InitTree _P((void));

extern void FreeTree _P((void));

extern NODEPTR MkSPNL_Module _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG1 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkImport _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkIdList _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParameterDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessTypeDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessInstantiation _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessBody _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkFormalParameters _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG4 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG2 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG3 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkFormalParameterItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkFormalParameterType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG5 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessInstantiationItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkActualParameters _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkEnumeration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG6 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG9 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG7 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG8 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkActualParameterExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArrayId _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParameterExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkActParameterExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSign _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkActParameterSum _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAddOp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkActParameterTerm _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMulOp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkActParameterFactor _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpOp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkActParameterPrimary _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkNumber _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkIdOrArrayId _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG10 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG11 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkGraphicalPart _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG12 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPublicDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPrivateDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPrivateDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG13 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortDeclarationItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortMultAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortMulExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessUsage _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionAttributeDef _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG14 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionAttributeDefItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG17 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG15 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG16 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPriorityAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDistributionAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkWeightAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMarkingDependencyAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPolicyAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConcurrencyAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkGuardAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDistributionExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMarkingDependencyType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPolicyType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConcurrencyDegree _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPredicate _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExponentialDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkUniformDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTruncNormalDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkErlangDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkWeibullDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPhaseTypeDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDeterministicDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkBernoulliDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDiscreteUniDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkGeometricDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkModGeometricDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkBinomialDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPoissonDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpolyDistribution _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMatrix _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkVektor _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG20 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG18 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG19 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG23 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG21 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG22 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpolyDistributionSum _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpolyDistributionPrimary _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkImpulseExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkContinuousExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpolynomial _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpolinomialSum _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpolinomialPrimary _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG24 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG25 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkGraphicalDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkGraphicalDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPlaceDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcDeclaration _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG26 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPlaceDeclarationItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG27 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionDeclarationItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG28 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcDeclarationItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkIdOrQualId _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG30 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG29 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcTypeAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMultiplicityAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMultiplicityType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPlaceGraphicalDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionGraphicalDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcGraphicalDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortGraphicalDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessGraphicalDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArrayGraphicalDefinition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG31 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPlaceGraphicalDefItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG34 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG32 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG33 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPlaceGraphicalAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG35 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionGraphicalDefItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG38 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG36 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG37 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionGraphicalAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG39 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcGraphicalDefItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG42 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG40 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG41 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArcGraphicalAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG43 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortGraphicalDefItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG46 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG44 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG45 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPortGraphicalAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG47 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessGraphicalDefItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG50 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG48 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG49 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProcessGraphicalAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG51 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArrayGraphicalDefItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG54 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG52 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG53 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkArrayGraphicalAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkCenterPosition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkNamePosition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkOrientation _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkViaPositionAttribute _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMultiplicityPosition _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkWidth _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkLength _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG58 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG55 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG56 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG57 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG59 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParameterDeclarationItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParameterSum _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParameterTerm _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParameterFactor _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParameterPrimary _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG60 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardDefinitionItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardSign _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG62 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG61 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardSum _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardTerm _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardFactor _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRewardPrimary _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPredicateSum _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkOrOp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPredicateTerm _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAndOp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPredicateFactor _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkNotOp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPredicatePrimary _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkPredicateComp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkCompOp _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureType _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG63 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureDefinitionItem _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureExpression _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSingleMeasureExpr _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMultipleMeasureExpr _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureSum _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureTerm _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasureFactor _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMeasurePrimary _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkQualifiedId _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG64 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG65 _P((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR Mkrule_000 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1, int _TERM2));
extern NODEPTR Mkrule_001 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, int _TERM2));
extern NODEPTR Mkrule_002 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_003 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_004 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_005 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_006 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_007 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_008 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_009 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_010 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_011 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_012 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_013 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_014 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_015 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_016 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_017 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_018 _P((POSITION *_coordref));
extern NODEPTR Mkrule_019 _P((POSITION *_coordref));
extern NODEPTR Mkrule_020 _P((POSITION *_coordref));
extern NODEPTR Mkrule_021 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_022 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_023 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_024 _P((POSITION *_coordref, NODEPTR _desc1, int _TERM1));
extern NODEPTR Mkrule_025 _P((POSITION *_coordref, NODEPTR _desc1, int _TERM1, NODEPTR _desc2));
extern NODEPTR Mkrule_026 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, int _TERM1));
extern NODEPTR Mkrule_027 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, int _TERM1, NODEPTR _desc3));
extern NODEPTR Mkrule_028 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_029 _P((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_030 _P((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_031 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_032 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_033 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_034 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_035 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_036 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_037 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_038 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_039 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_040 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_041 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_042 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_043 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_044 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_045 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_046 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_047 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_048 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_049 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4, NODEPTR _desc5));
extern NODEPTR Mkrule_050 _P((POSITION *_coordref));
extern NODEPTR Mkrule_051 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_052 _P((POSITION *_coordref));
extern NODEPTR Mkrule_053 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_054 _P((POSITION *_coordref));
extern NODEPTR Mkrule_055 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_056 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_057 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_058 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_059 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_060 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_061 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_062 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_063 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_064 _P((POSITION *_coordref));
extern NODEPTR Mkrule_065 _P((POSITION *_coordref));
extern NODEPTR Mkrule_066 _P((POSITION *_coordref));
extern NODEPTR Mkrule_067 _P((POSITION *_coordref));
extern NODEPTR Mkrule_068 _P((POSITION *_coordref));
extern NODEPTR Mkrule_069 _P((POSITION *_coordref));
extern NODEPTR Mkrule_070 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_071 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_072 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_073 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_074 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_075 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_076 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_077 _P((POSITION *_coordref, NODEPTR _desc1, int _TERM1));
extern NODEPTR Mkrule_078 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_079 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_080 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_081 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_082 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_083 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_084 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_085 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_086 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_087 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_088 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_089 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_090 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_091 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_092 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_093 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_094 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_095 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_096 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_097 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_098 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_099 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_100 _P((POSITION *_coordref));
extern NODEPTR Mkrule_101 _P((POSITION *_coordref));
extern NODEPTR Mkrule_102 _P((POSITION *_coordref));
extern NODEPTR Mkrule_103 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_104 _P((POSITION *_coordref));
extern NODEPTR Mkrule_105 _P((POSITION *_coordref));
extern NODEPTR Mkrule_106 _P((POSITION *_coordref));
extern NODEPTR Mkrule_107 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_108 _P((POSITION *_coordref));
extern NODEPTR Mkrule_109 _P((POSITION *_coordref));
extern NODEPTR Mkrule_110 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_111 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_112 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_113 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_114 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_115 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_116 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_117 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_118 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_119 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_120 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_121 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_122 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_123 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_124 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_125 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_126 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_127 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_128 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_129 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_130 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_131 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_132 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_133 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_134 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_135 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_136 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_137 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_138 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_139 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_140 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_141 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_142 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_143 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_144 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_145 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_146 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_147 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_148 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_149 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_150 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_151 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_152 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_153 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_154 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_155 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_156 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_157 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_158 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_159 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_160 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_161 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_162 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_163 _P((POSITION *_coordref));
extern NODEPTR Mkrule_164 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_165 _P((POSITION *_coordref));
extern NODEPTR Mkrule_166 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_167 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_168 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_169 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_170 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_171 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_172 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_173 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_174 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_175 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_176 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_177 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_178 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_179 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_180 _P((POSITION *_coordref));
extern NODEPTR Mkrule_181 _P((POSITION *_coordref));
extern NODEPTR Mkrule_182 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_183 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_184 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_185 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_186 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_187 _P((POSITION *_coordref));
extern NODEPTR Mkrule_188 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_189 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_190 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_191 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_192 _P((POSITION *_coordref));
extern NODEPTR Mkrule_193 _P((POSITION *_coordref));
extern NODEPTR Mkrule_194 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_195 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_196 _P((POSITION *_coordref));
extern NODEPTR Mkrule_197 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_198 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_199 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_200 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_201 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_202 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_203 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_204 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_205 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_206 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR Mkrule_207 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_208 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_209 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_210 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_211 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_212 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_213 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_214 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR Mkrule_215 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_216 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_217 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_218 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_219 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_220 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_221 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_222 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR Mkrule_223 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_224 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_225 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_226 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_227 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_228 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_229 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_230 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_231 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_232 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_233 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_234 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_235 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_236 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_237 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_238 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR Mkrule_239 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_240 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_241 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_242 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_243 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_244 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_245 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_246 _P((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR Mkrule_247 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_248 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_249 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_250 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_251 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_252 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_253 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_254 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_255 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_256 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_257 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_258 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_259 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_260 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_261 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_262 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_263 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_264 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_265 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_266 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_267 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_268 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_269 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_270 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_271 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_272 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_273 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_274 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_275 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_276 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_277 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_278 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_279 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_280 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_281 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_282 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_283 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_284 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_285 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_286 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_287 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_288 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_289 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_290 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_291 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_292 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_293 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_294 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_295 _P((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_296 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_297 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_298 _P((POSITION *_coordref));
extern NODEPTR Mkrule_299 _P((POSITION *_coordref));
extern NODEPTR Mkrule_300 _P((POSITION *_coordref));
extern NODEPTR Mkrule_301 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_302 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_303 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_304 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_305 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_306 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4));
extern NODEPTR Mkrule_307 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_308 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_309 _P((POSITION *_coordref));
extern NODEPTR Mkrule_310 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_311 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_312 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_313 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_314 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_315 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_316 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_317 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_318 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_319 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_320 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_321 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_322 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_323 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_324 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_325 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_326 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_327 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_328 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_329 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_330 _P((POSITION *_coordref));
extern NODEPTR Mkrule_331 _P((POSITION *_coordref));
extern NODEPTR Mkrule_332 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_333 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_334 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_335 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_336 _P((POSITION *_coordref));
extern NODEPTR Mkrule_337 _P((POSITION *_coordref));
extern NODEPTR Mkrule_338 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_339 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_340 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_341 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_342 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_343 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_344 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_345 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_346 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_347 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_348 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_349 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_350 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_351 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_352 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_353 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_354 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_355 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_356 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_357 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_358 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_359 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_360 _P((POSITION *_coordref));
extern NODEPTR Mkrule_361 _P((POSITION *_coordref));
extern NODEPTR Mkrule_362 _P((POSITION *_coordref));
extern NODEPTR Mkrule_363 _P((POSITION *_coordref));
extern NODEPTR Mkrule_364 _P((POSITION *_coordref));
extern NODEPTR Mkrule_365 _P((POSITION *_coordref));
extern NODEPTR Mkrule_366 _P((POSITION *_coordref));
extern NODEPTR Mkrule_367 _P((POSITION *_coordref));
extern NODEPTR Mkrule_368 _P((POSITION *_coordref));
extern NODEPTR Mkrule_369 _P((POSITION *_coordref));
extern NODEPTR Mkrule_370 _P((POSITION *_coordref));
extern NODEPTR Mkrule_371 _P((POSITION *_coordref));
extern NODEPTR Mkrule_372 _P((POSITION *_coordref));
extern NODEPTR Mkrule_373 _P((POSITION *_coordref));
extern NODEPTR Mkrule_374 _P((POSITION *_coordref));
extern NODEPTR Mkrule_375 _P((POSITION *_coordref));
extern NODEPTR Mkrule_376 _P((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_377 _P((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_378 _P((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_379 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_380 _P((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_381 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_382 _P((POSITION *_coordref, int _TERM1, int _TERM2));
extern NODEPTR Mkrule_383 _P((POSITION *_coordref, int _TERM1, int _TERM2));
extern NODEPTR Mkrule_384 _P((POSITION *_coordref, int _TERM1, int _TERM2, int _TERM3));
extern NODEPTR Mkrule_385 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_386 _P((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_387 _P((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_388 _P((POSITION *_coordref, int _TERM1));
#define MkReal(pos,val) (val)
#define MkInteger(pos,val) (val)
#define MkId(pos,val) (val)
#endif
