
/* definition of tree node structure */

#ifndef NODE_H
#define NODE_H
#include "err.h"
#include "treecon.h" /* defines NODEPTR */
#include "nodecode.h"
extern int LHSMAP[];


#ifdef MONITOR
#define _NODECOMMON int _prod; POSITION _coord;
#else
#define _NODECOMMON int _prod;
#endif

typedef struct _TSCompiledSPNL* _TSPCompiledSPNL;
typedef struct _TSG1* _TSPG1;
typedef struct _TSConnections* _TSPConnections;
typedef struct _TSSectionBody* _TSPSectionBody;
typedef struct _TSSectionElements* _TSPSectionElements;
typedef struct _TSMeasureParameters* _TSPMeasureParameters;
typedef struct _TSMeasures* _TSPMeasures;
typedef struct _TSRewards* _TSPRewards;
typedef struct _TSArcs* _TSPArcs;
typedef struct _TSTransitionAttributes* _TSPTransitionAttributes;
typedef struct _TSTransitions* _TSPTransitions;
typedef struct _TSPlaces* _TSPPlaces;
typedef struct _TSParameters* _TSPParameters;
typedef struct _TSG2* _TSPG2;
typedef struct _TSConnection* _TSPConnection;
typedef struct _TSG3* _TSPG3;
typedef struct _TSParameter* _TSPParameter;
typedef struct _TSGlobalId* _TSPGlobalId;
typedef struct _TSParameterExpression* _TSPParameterExpression;
typedef struct _TSSign* _TSPSign;
typedef struct _TSParameterSum* _TSPParameterSum;
typedef struct _TSAddOp* _TSPAddOp;
typedef struct _TSParameterTerm* _TSPParameterTerm;
typedef struct _TSMulOp* _TSPMulOp;
typedef struct _TSParameterFactor* _TSPParameterFactor;
typedef struct _TSExpOp* _TSPExpOp;
typedef struct _TSParameterPrimary* _TSPParameterPrimary;
typedef struct _TSNumber* _TSPNumber;
typedef struct _TSG4* _TSPG4;
typedef struct _TSPlace* _TSPPlace;
typedef struct _TSG5* _TSPG5;
typedef struct _TSTransition* _TSPTransition;
typedef struct _TSTransitionType* _TSPTransitionType;
typedef struct _TSG6* _TSPG6;
typedef struct _TSTransitionAttributeDefItem* _TSPTransitionAttributeDefItem;
typedef struct _TSG9* _TSPG9;
typedef struct _TSG7* _TSPG7;
typedef struct _TSG8* _TSPG8;
typedef struct _TSTransitionAttribute* _TSPTransitionAttribute;
typedef struct _TSPriorityAttribute* _TSPPriorityAttribute;
typedef struct _TSDistributionAttribute* _TSPDistributionAttribute;
typedef struct _TSWeightAttribute* _TSPWeightAttribute;
typedef struct _TSMarkingDependencyAttribute* _TSPMarkingDependencyAttribute;
typedef struct _TSPolicyAttribute* _TSPPolicyAttribute;
typedef struct _TSConcurrencyAttribute* _TSPConcurrencyAttribute;
typedef struct _TSGuardAttribute* _TSPGuardAttribute;
typedef struct _TSRewardExpression* _TSPRewardExpression;
typedef struct _TSDistributionExpression* _TSPDistributionExpression;
typedef struct _TSMarkingDependencyType* _TSPMarkingDependencyType;
typedef struct _TSPolicyType* _TSPPolicyType;
typedef struct _TSConcurrencyDegree* _TSPConcurrencyDegree;
typedef struct _TSPredicate* _TSPPredicate;
typedef struct _TSG10* _TSPG10;
typedef struct _TSArc* _TSPArc;
typedef struct _TSG12* _TSPG12;
typedef struct _TSG11* _TSPG11;
typedef struct _TSArcAttribute* _TSPArcAttribute;
typedef struct _TSArcTypeAttribute* _TSPArcTypeAttribute;
typedef struct _TSMultiplicityAttribute* _TSPMultiplicityAttribute;
typedef struct _TSArcType* _TSPArcType;
typedef struct _TSG13* _TSPG13;
typedef struct _TSReward* _TSPReward;
typedef struct _TSRewardSign* _TSPRewardSign;
typedef struct _TSG15* _TSPG15;
typedef struct _TSG14* _TSPG14;
typedef struct _TSRewardSum* _TSPRewardSum;
typedef struct _TSRewardTerm* _TSPRewardTerm;
typedef struct _TSRewardFactor* _TSPRewardFactor;
typedef struct _TSRewardPrimary* _TSPRewardPrimary;
typedef struct _TSPredicateSum* _TSPPredicateSum;
typedef struct _TSOrOp* _TSPOrOp;
typedef struct _TSPredicateTerm* _TSPPredicateTerm;
typedef struct _TSAndOp* _TSPAndOp;
typedef struct _TSPredicateFactor* _TSPPredicateFactor;
typedef struct _TSNotOp* _TSPNotOp;
typedef struct _TSPredicatePrimary* _TSPPredicatePrimary;
typedef struct _TSPredicateComp* _TSPPredicateComp;
typedef struct _TSCompOp* _TSPCompOp;
typedef struct _TSG16* _TSPG16;
typedef struct _TSMeasure* _TSPMeasure;
typedef struct _TSMeasureExpression* _TSPMeasureExpression;
typedef struct _TSSingleMeasureExpr* _TSPSingleMeasureExpr;
typedef struct _TSMultMeasureExpr* _TSPMultMeasureExpr;
typedef struct _TSMeasureSum* _TSPMeasureSum;
typedef struct _TSMeasureTerm* _TSPMeasureTerm;
typedef struct _TSMeasureFactor* _TSPMeasureFactor;
typedef struct _TSMeasurePrimary* _TSPMeasurePrimary;
typedef struct _TSG17* _TSPG17;
typedef struct _TSMeasureParameter* _TSPMeasureParameter;
typedef struct _TSExponentialDistribution* _TSPExponentialDistribution;
typedef struct _TSUniformDistribution* _TSPUniformDistribution;
typedef struct _TSTruncNormalDistribution* _TSPTruncNormalDistribution;
typedef struct _TSErlangDistribution* _TSPErlangDistribution;
typedef struct _TSWeibullDistribution* _TSPWeibullDistribution;
typedef struct _TSPhaseTypeDistribution* _TSPPhaseTypeDistribution;
typedef struct _TSDeterministicDistribution* _TSPDeterministicDistribution;
typedef struct _TSBernoulliDistribution* _TSPBernoulliDistribution;
typedef struct _TSDiscreteUniDistribution* _TSPDiscreteUniDistribution;
typedef struct _TSGeometricDistribution* _TSPGeometricDistribution;
typedef struct _TSModGeometricDistribution* _TSPModGeometricDistribution;
typedef struct _TSBinomialDistribution* _TSPBinomialDistribution;
typedef struct _TSPoissonDistribution* _TSPPoissonDistribution;
typedef struct _TSExpolyDistribution* _TSPExpolyDistribution;
typedef struct _TSMatrix* _TSPMatrix;
typedef struct _TSVektor* _TSPVektor;
typedef struct _TSG20* _TSPG20;
typedef struct _TSG18* _TSPG18;
typedef struct _TSG19* _TSPG19;
typedef struct _TSG23* _TSPG23;
typedef struct _TSG21* _TSPG21;
typedef struct _TSG22* _TSPG22;
typedef struct _TSExpolyDistributionSum* _TSPExpolyDistributionSum;
typedef struct _TSExpolyDistributionPrimary* _TSPExpolyDistributionPrimary;
typedef struct _TSImpulseExpression* _TSPImpulseExpression;
typedef struct _TSContinuousExpression* _TSPContinuousExpression;
typedef struct _TSExpolynomial* _TSPExpolynomial;
typedef struct _TSExpolinomialSum* _TSPExpolinomialSum;
typedef struct _TSExpolinomialPrimary* _TSPExpolinomialPrimary;
typedef struct _TSG25* _TSPG25;
typedef struct _TSG24* _TSPG24;
typedef struct _TPrule_000* _TPPrule_000;
typedef struct _TPrule_001* _TPPrule_001;
typedef struct _TPrule_002* _TPPrule_002;
typedef struct _TPrule_003* _TPPrule_003;
typedef struct _TPrule_004* _TPPrule_004;
typedef struct _TPrule_005* _TPPrule_005;
typedef struct _TPrule_006* _TPPrule_006;
typedef struct _TPrule_007* _TPPrule_007;
typedef struct _TPrule_008* _TPPrule_008;
typedef struct _TPrule_009* _TPPrule_009;
typedef struct _TPrule_010* _TPPrule_010;
typedef struct _TPrule_011* _TPPrule_011;
typedef struct _TPrule_012* _TPPrule_012;
typedef struct _TPrule_013* _TPPrule_013;
typedef struct _TPrule_014* _TPPrule_014;
typedef struct _TPrule_015* _TPPrule_015;
typedef struct _TPrule_016* _TPPrule_016;
typedef struct _TPrule_017* _TPPrule_017;
typedef struct _TPrule_018* _TPPrule_018;
typedef struct _TPrule_019* _TPPrule_019;
typedef struct _TPrule_020* _TPPrule_020;
typedef struct _TPrule_021* _TPPrule_021;
typedef struct _TPrule_022* _TPPrule_022;
typedef struct _TPrule_023* _TPPrule_023;
typedef struct _TPrule_024* _TPPrule_024;
typedef struct _TPrule_025* _TPPrule_025;
typedef struct _TPrule_026* _TPPrule_026;
typedef struct _TPrule_027* _TPPrule_027;
typedef struct _TPrule_028* _TPPrule_028;
typedef struct _TPrule_029* _TPPrule_029;
typedef struct _TPrule_030* _TPPrule_030;
typedef struct _TPrule_031* _TPPrule_031;
typedef struct _TPrule_032* _TPPrule_032;
typedef struct _TPrule_033* _TPPrule_033;
typedef struct _TPrule_034* _TPPrule_034;
typedef struct _TPrule_035* _TPPrule_035;
typedef struct _TPrule_036* _TPPrule_036;
typedef struct _TPrule_037* _TPPrule_037;
typedef struct _TPrule_038* _TPPrule_038;
typedef struct _TPrule_039* _TPPrule_039;
typedef struct _TPrule_040* _TPPrule_040;
typedef struct _TPrule_041* _TPPrule_041;
typedef struct _TPrule_042* _TPPrule_042;
typedef struct _TPrule_043* _TPPrule_043;
typedef struct _TPrule_044* _TPPrule_044;
typedef struct _TPrule_045* _TPPrule_045;
typedef struct _TPrule_046* _TPPrule_046;
typedef struct _TPrule_047* _TPPrule_047;
typedef struct _TPrule_048* _TPPrule_048;
typedef struct _TPrule_049* _TPPrule_049;
typedef struct _TPrule_050* _TPPrule_050;
typedef struct _TPrule_051* _TPPrule_051;
typedef struct _TPrule_052* _TPPrule_052;
typedef struct _TPrule_053* _TPPrule_053;
typedef struct _TPrule_054* _TPPrule_054;
typedef struct _TPrule_055* _TPPrule_055;
typedef struct _TPrule_056* _TPPrule_056;
typedef struct _TPrule_057* _TPPrule_057;
typedef struct _TPrule_058* _TPPrule_058;
typedef struct _TPrule_059* _TPPrule_059;
typedef struct _TPrule_060* _TPPrule_060;
typedef struct _TPrule_061* _TPPrule_061;
typedef struct _TPrule_062* _TPPrule_062;
typedef struct _TPrule_063* _TPPrule_063;
typedef struct _TPrule_064* _TPPrule_064;
typedef struct _TPrule_065* _TPPrule_065;
typedef struct _TPrule_066* _TPPrule_066;
typedef struct _TPrule_067* _TPPrule_067;
typedef struct _TPrule_068* _TPPrule_068;
typedef struct _TPrule_069* _TPPrule_069;
typedef struct _TPrule_070* _TPPrule_070;
typedef struct _TPrule_071* _TPPrule_071;
typedef struct _TPrule_072* _TPPrule_072;
typedef struct _TPrule_073* _TPPrule_073;
typedef struct _TPrule_074* _TPPrule_074;
typedef struct _TPrule_075* _TPPrule_075;
typedef struct _TPrule_076* _TPPrule_076;
typedef struct _TPrule_077* _TPPrule_077;
typedef struct _TPrule_078* _TPPrule_078;
typedef struct _TPrule_079* _TPPrule_079;
typedef struct _TPrule_080* _TPPrule_080;
typedef struct _TPrule_081* _TPPrule_081;
typedef struct _TPrule_082* _TPPrule_082;
typedef struct _TPrule_083* _TPPrule_083;
typedef struct _TPrule_084* _TPPrule_084;
typedef struct _TPrule_085* _TPPrule_085;
typedef struct _TPrule_086* _TPPrule_086;
typedef struct _TPrule_087* _TPPrule_087;
typedef struct _TPrule_088* _TPPrule_088;
typedef struct _TPrule_089* _TPPrule_089;
typedef struct _TPrule_090* _TPPrule_090;
typedef struct _TPrule_091* _TPPrule_091;
typedef struct _TPrule_092* _TPPrule_092;
typedef struct _TPrule_093* _TPPrule_093;
typedef struct _TPrule_094* _TPPrule_094;
typedef struct _TPrule_095* _TPPrule_095;
typedef struct _TPrule_096* _TPPrule_096;
typedef struct _TPrule_097* _TPPrule_097;
typedef struct _TPrule_098* _TPPrule_098;
typedef struct _TPrule_099* _TPPrule_099;
typedef struct _TPrule_100* _TPPrule_100;
typedef struct _TPrule_101* _TPPrule_101;
typedef struct _TPrule_102* _TPPrule_102;
typedef struct _TPrule_103* _TPPrule_103;
typedef struct _TPrule_104* _TPPrule_104;
typedef struct _TPrule_105* _TPPrule_105;
typedef struct _TPrule_106* _TPPrule_106;
typedef struct _TPrule_107* _TPPrule_107;
typedef struct _TPrule_108* _TPPrule_108;
typedef struct _TPrule_109* _TPPrule_109;
typedef struct _TPrule_110* _TPPrule_110;
typedef struct _TPrule_111* _TPPrule_111;
typedef struct _TPrule_112* _TPPrule_112;
typedef struct _TPrule_113* _TPPrule_113;
typedef struct _TPrule_114* _TPPrule_114;
typedef struct _TPrule_115* _TPPrule_115;
typedef struct _TPrule_116* _TPPrule_116;
typedef struct _TPrule_117* _TPPrule_117;
typedef struct _TPrule_118* _TPPrule_118;
typedef struct _TPrule_119* _TPPrule_119;
typedef struct _TPrule_120* _TPPrule_120;
typedef struct _TPrule_121* _TPPrule_121;
typedef struct _TPrule_122* _TPPrule_122;
typedef struct _TPrule_123* _TPPrule_123;
typedef struct _TPrule_124* _TPPrule_124;
typedef struct _TPrule_125* _TPPrule_125;
typedef struct _TPrule_126* _TPPrule_126;
typedef struct _TPrule_127* _TPPrule_127;
typedef struct _TPrule_128* _TPPrule_128;
typedef struct _TPrule_129* _TPPrule_129;
typedef struct _TPrule_130* _TPPrule_130;
typedef struct _TPrule_131* _TPPrule_131;
typedef struct _TPrule_132* _TPPrule_132;
typedef struct _TPrule_133* _TPPrule_133;
typedef struct _TPrule_134* _TPPrule_134;
typedef struct _TPrule_135* _TPPrule_135;
typedef struct _TPrule_136* _TPPrule_136;
typedef struct _TPrule_137* _TPPrule_137;
typedef struct _TPrule_138* _TPPrule_138;
typedef struct _TPrule_139* _TPPrule_139;
typedef struct _TPrule_140* _TPPrule_140;
typedef struct _TPrule_141* _TPPrule_141;
typedef struct _TPrule_142* _TPPrule_142;
typedef struct _TPrule_143* _TPPrule_143;
typedef struct _TPrule_144* _TPPrule_144;
typedef struct _TPrule_145* _TPPrule_145;
typedef struct _TPrule_146* _TPPrule_146;
typedef struct _TPrule_147* _TPPrule_147;
typedef struct _TPrule_148* _TPPrule_148;
typedef struct _TPrule_149* _TPPrule_149;
typedef struct _TPrule_150* _TPPrule_150;
typedef struct _TPrule_151* _TPPrule_151;
typedef struct _TPrule_152* _TPPrule_152;
typedef struct _TPrule_153* _TPPrule_153;
typedef struct _TPrule_154* _TPPrule_154;
typedef struct _TPrule_155* _TPPrule_155;
typedef struct _TPrule_156* _TPPrule_156;
typedef struct _TPrule_157* _TPPrule_157;
typedef struct _TPrule_158* _TPPrule_158;
typedef struct _TPrule_159* _TPPrule_159;
typedef struct _TPrule_160* _TPPrule_160;
typedef struct _TPrule_161* _TPPrule_161;
typedef struct _TPrule_162* _TPPrule_162;
typedef struct _TPrule_163* _TPPrule_163;
typedef struct _TPrule_164* _TPPrule_164;
typedef struct _TPrule_165* _TPPrule_165;
typedef struct _TPrule_166* _TPPrule_166;
typedef struct _TPrule_167* _TPPrule_167;
typedef struct _TPrule_168* _TPPrule_168;
typedef struct _TPrule_169* _TPPrule_169;
typedef struct _TPrule_170* _TPPrule_170;
typedef struct _TPrule_171* _TPPrule_171;
typedef struct _TPrule_172* _TPPrule_172;
typedef struct _TPrule_173* _TPPrule_173;
typedef struct _TPrule_174* _TPPrule_174;
typedef struct _TPrule_175* _TPPrule_175;
typedef struct _TPrule_176* _TPPrule_176;
typedef struct _TPrule_177* _TPPrule_177;
typedef struct _TPrule_178* _TPPrule_178;
typedef struct _TPrule_179* _TPPrule_179;
typedef struct _TPrule_180* _TPPrule_180;
typedef struct _TPrule_181* _TPPrule_181;
typedef struct _TPrule_182* _TPPrule_182;
typedef struct _TPrule_183* _TPPrule_183;
typedef struct _TPrule_184* _TPPrule_184;
typedef struct _TPrule_185* _TPPrule_185;
typedef struct _TPrule_186* _TPPrule_186;
typedef struct _TPrule_187* _TPPrule_187;
typedef struct _TPrule_188* _TPPrule_188;
typedef struct _TPrule_189* _TPPrule_189;
typedef struct _TPrule_190* _TPPrule_190;
typedef struct _TPrule_191* _TPPrule_191;
typedef struct _TPrule_192* _TPPrule_192;
typedef struct _TPrule_193* _TPPrule_193;
typedef struct _TPrule_194* _TPPrule_194;
typedef struct _TPrule_195* _TPPrule_195;
typedef struct _TPrule_196* _TPPrule_196;
typedef struct _TPrule_197* _TPPrule_197;
typedef struct _TPrule_198* _TPPrule_198;
typedef struct _TPrule_199* _TPPrule_199;
typedef struct _TPrule_200* _TPPrule_200;
typedef struct _TPrule_201* _TPPrule_201;
typedef struct _TPrule_202* _TPPrule_202;
typedef struct _TPrule_203* _TPPrule_203;
typedef struct _TPrule_204* _TPPrule_204;
typedef struct _TPrule_205* _TPPrule_205;
typedef struct _TPrule_206* _TPPrule_206;
typedef struct _TPrule_207* _TPPrule_207;
typedef struct _TPrule_208* _TPPrule_208;
typedef struct _TPrule_209* _TPPrule_209;
typedef struct _TPrule_210* _TPPrule_210;
typedef struct _TPrule_211* _TPPrule_211;
typedef struct _TPrule_212* _TPPrule_212;
typedef struct _TPrule_213* _TPPrule_213;
typedef struct _TPrule_214* _TPPrule_214;
typedef struct _TPrule_215* _TPPrule_215;
typedef struct _TPrule_216* _TPPrule_216;
typedef struct _TPrule_217* _TPPrule_217;
typedef struct _TPrule_218* _TPPrule_218;
typedef struct _TPrule_219* _TPPrule_219;
typedef struct _TPrule_220* _TPPrule_220;
typedef struct _TPrule_221* _TPPrule_221;
typedef struct _TPrule_222* _TPPrule_222;
typedef struct _TPrule_223* _TPPrule_223;
typedef struct _TPrule_224* _TPPrule_224;
typedef struct _TPrule_225* _TPPrule_225;
typedef struct _TPrule_226* _TPPrule_226;
typedef struct _TPrule_227* _TPPrule_227;
typedef struct _TPrule_228* _TPPrule_228;
typedef struct _TPrule_229* _TPPrule_229;
typedef struct _TPrule_230* _TPPrule_230;
typedef struct _TPrule_231* _TPPrule_231;
typedef struct _TPrule_232* _TPPrule_232;
typedef struct _TPrule_233* _TPPrule_233;
typedef struct _TPrule_234* _TPPrule_234;
typedef struct _TPrule_235* _TPPrule_235;
typedef struct _TPrule_236* _TPPrule_236;
typedef struct _TPrule_237* _TPPrule_237;
typedef struct _TPrule_238* _TPPrule_238;
typedef struct _TPrule_239* _TPPrule_239;
typedef struct _TPrule_240* _TPPrule_240;
typedef struct _TPrule_241* _TPPrule_241;
typedef struct _TPrule_242* _TPPrule_242;
typedef struct _TPrule_243* _TPPrule_243;
typedef struct _TPrule_244* _TPPrule_244;
typedef struct _TPrule_245* _TPPrule_245;
typedef struct _TPrule_246* _TPPrule_246;
typedef struct _TPrule_247* _TPPrule_247;
typedef struct _TPrule_248* _TPPrule_248;
typedef struct _TPrule_249* _TPPrule_249;
typedef struct _TPrule_250* _TPPrule_250;
typedef struct _TPrule_251* _TPPrule_251;
typedef struct _TPrule_252* _TPPrule_252;
typedef struct _TPrule_253* _TPPrule_253;
typedef struct _TPrule_254* _TPPrule_254;
typedef struct _TPrule_255* _TPPrule_255;
typedef struct _TPrule_256* _TPPrule_256;
typedef struct _TPrule_257* _TPPrule_257;
typedef struct _TPrule_258* _TPPrule_258;
typedef struct _TPrule_259* _TPPrule_259;
typedef struct _TPrule_260* _TPPrule_260;
typedef struct _TPrule_261* _TPPrule_261;
typedef struct _TPrule_262* _TPPrule_262;
typedef struct _TPrule_263* _TPPrule_263;
typedef struct _TPrule_264* _TPPrule_264;
typedef struct _TPrule_265* _TPPrule_265;
typedef struct _TPrule_266* _TPPrule_266;
typedef struct _TPrule_267* _TPPrule_267;
typedef struct _TPrule_268* _TPPrule_268;
typedef struct _TPrule_269* _TPPrule_269;
typedef struct _TPrule_270* _TPPrule_270;
typedef struct _TPrule_271* _TPPrule_271;
typedef struct _TPrule_272* _TPPrule_272;
typedef struct _TPrule_273* _TPPrule_273;
typedef struct _TPrule_274* _TPPrule_274;
typedef struct _TPrule_275* _TPPrule_275;
typedef struct _TPrule_276* _TPPrule_276;
typedef struct _TPrule_277* _TPPrule_277;
typedef struct _TPrule_278* _TPPrule_278;
typedef struct _TPrule_279* _TPPrule_279;
typedef struct _TPrule_280* _TPPrule_280;
typedef struct _TPrule_281* _TPPrule_281;
typedef struct _TPrule_282* _TPPrule_282;
typedef struct _TPrule_283* _TPPrule_283;
typedef struct _TPrule_284* _TPPrule_284;
typedef struct _TPrule_285* _TPPrule_285;
typedef struct _TPrule_286* _TPPrule_286;
typedef struct _TPrule_287* _TPPrule_287;
typedef struct _TPrule_288* _TPPrule_288;
typedef struct _TPrule_289* _TPPrule_289;
typedef struct _TPrule_290* _TPPrule_290;
typedef struct _TPrule_291* _TPPrule_291;
typedef struct _TPrule_292* _TPPrule_292;
typedef struct _TPrule_293* _TPPrule_293;
typedef struct _TPrule_294* _TPPrule_294;
typedef struct _TPrule_295* _TPPrule_295;
typedef struct _TPrule_296* _TPPrule_296;
typedef struct _TPrule_297* _TPPrule_297;
typedef struct _TPrule_298* _TPPrule_298;
typedef struct _TPrule_299* _TPPrule_299;
typedef struct _TPrule_300* _TPPrule_300;
typedef struct _TPrule_301* _TPPrule_301;
typedef struct _TPrule_302* _TPPrule_302;
typedef struct _TPrule_303* _TPPrule_303;
typedef struct _TPrule_304* _TPPrule_304;
typedef struct _TPrule_305* _TPPrule_305;
typedef struct _TPrule_306* _TPPrule_306;
typedef struct _TPrule_307* _TPPrule_307;
typedef struct _TPrule_308* _TPPrule_308;
typedef struct _TPrule_309* _TPPrule_309;
typedef struct _TPrule_310* _TPPrule_310;
typedef struct _TPrule_311* _TPPrule_311;
typedef struct _TPrule_312* _TPPrule_312;
typedef struct _TPrule_313* _TPPrule_313;
typedef struct _TPrule_314* _TPPrule_314;
typedef struct _TPrule_315* _TPPrule_315;
typedef struct _TPrule_316* _TPPrule_316;
typedef struct _TPrule_317* _TPPrule_317;
typedef struct _TPrule_318* _TPPrule_318;
typedef struct _TPrule_319* _TPPrule_319;
typedef struct _TPrule_320* _TPPrule_320;
typedef struct _TPrule_321* _TPPrule_321;
typedef struct _TPrule_322* _TPPrule_322;
typedef struct _TPrule_323* _TPPrule_323;
typedef struct _TPrule_324* _TPPrule_324;
typedef struct _TPrule_325* _TPPrule_325;
typedef struct _TPrule_326* _TPPrule_326;
typedef struct _TPrule_327* _TPPrule_327;
typedef struct _TPrule_328* _TPPrule_328;
typedef struct _TPrule_329* _TPPrule_329;
typedef struct _TPrule_330* _TPPrule_330;
typedef struct _TPrule_331* _TPPrule_331;
typedef struct _TPrule_332* _TPPrule_332;
typedef struct _TPrule_333* _TPPrule_333;
typedef struct _TPrule_334* _TPPrule_334;
typedef struct _TPrule_335* _TPPrule_335;
typedef struct _TPrule_336* _TPPrule_336;
typedef struct _TPrule_337* _TPPrule_337;
typedef struct _TPrule_338* _TPPrule_338;
typedef struct _TPrule_339* _TPPrule_339;
typedef struct _TPrule_340* _TPPrule_340;
typedef struct _TPrule_341* _TPPrule_341;
typedef struct _TPrule_342* _TPPrule_342;
typedef struct _TPrule_343* _TPPrule_343;
typedef struct _TPrule_344* _TPPrule_344;
typedef struct _TPrule_345* _TPPrule_345;
typedef struct _TPrule_346* _TPPrule_346;
typedef struct _TPrule_347* _TPPrule_347;
typedef struct _TPrule_348* _TPPrule_348;
typedef struct _TPrule_349* _TPPrule_349;
typedef struct _TPrule_350* _TPPrule_350;
typedef struct _TPrule_351* _TPPrule_351;
typedef struct _TPrule_352* _TPPrule_352;
typedef struct _TPrule_353* _TPPrule_353;
typedef struct _TPrule_354* _TPPrule_354;
typedef struct _TPrule_355* _TPPrule_355;
typedef struct _TPrule_356* _TPPrule_356;
typedef struct _TPrule_357* _TPPrule_357;
typedef struct _TPrule_358* _TPPrule_358;
typedef struct _TPrule_359* _TPPrule_359;
typedef struct _TPrule_360* _TPPrule_360;
typedef struct _TPrule_361* _TPPrule_361;
typedef struct _TPrule_362* _TPPrule_362;
typedef struct _TPrule_363* _TPPrule_363;
typedef struct _TPrule_364* _TPPrule_364;
typedef struct _TPrule_365* _TPPrule_365;
typedef struct _TPrule_366* _TPPrule_366;
typedef struct _TPrule_367* _TPPrule_367;
typedef struct _TPrule_368* _TPPrule_368;
typedef struct _TPrule_369* _TPPrule_369;
typedef struct _TPrule_370* _TPPrule_370;
typedef struct _TPrule_371* _TPPrule_371;
typedef struct _TPrule_372* _TPPrule_372;
typedef struct _TPrule_373* _TPPrule_373;
typedef struct _TPrule_374* _TPPrule_374;
typedef struct _TPrule_375* _TPPrule_375;
typedef struct _TPrule_376* _TPPrule_376;
typedef struct _TPrule_377* _TPPrule_377;
typedef struct _TPrule_378* _TPPrule_378;
typedef struct _TPrule_379* _TPPrule_379;
typedef struct _TPrule_380* _TPPrule_380;
typedef struct _TPrule_381* _TPPrule_381;
typedef struct _TPrule_382* _TPPrule_382;
typedef struct _TPrule_383* _TPPrule_383;
typedef struct _TPrule_384* _TPPrule_384;
typedef struct _TPrule_385* _TPPrule_385;
typedef struct _TPrule_386* _TPPrule_386;
typedef struct _TPrule_387* _TPPrule_387;
typedef struct _TPrule_388* _TPPrule_388;
typedef struct _TPrule_389* _TPPrule_389;
typedef struct _TPrule_390* _TPPrule_390;
typedef struct _TPrule_391* _TPPrule_391;
typedef struct _TPrule_392* _TPPrule_392;
typedef struct _TPrule_393* _TPPrule_393;
typedef struct _TPrule_394* _TPPrule_394;
typedef struct _TPrule_395* _TPPrule_395;
typedef struct _TPrule_396* _TPPrule_396;
typedef struct _TPrule_397* _TPPrule_397;
typedef struct _TPrule_398* _TPPrule_398;
typedef struct _TPrule_399* _TPPrule_399;
typedef struct _TPrule_400* _TPPrule_400;
typedef struct _TPrule_401* _TPPrule_401;
typedef struct _TPrule_402* _TPPrule_402;
typedef struct _TPrule_403* _TPPrule_403;
typedef struct _TPrule_404* _TPPrule_404;
typedef struct _TPrule_405* _TPPrule_405;
typedef struct _TPrule_406* _TPPrule_406;
typedef struct _TPrule_407* _TPPrule_407;
typedef struct _TPrule_408* _TPPrule_408;
typedef struct _TPrule_409* _TPPrule_409;
typedef struct _TPrule_410* _TPPrule_410;
typedef struct _TPrule_411* _TPPrule_411;
typedef struct _TPrule_412* _TPPrule_412;
typedef struct _TPrule_413* _TPPrule_413;
typedef struct _TPrule_414* _TPPrule_414;
typedef struct _TPrule_415* _TPPrule_415;
typedef struct _TPrule_416* _TPPrule_416;
typedef struct _TPrule_417* _TPPrule_417;
typedef struct _TPrule_418* _TPPrule_418;
typedef struct _TPrule_419* _TPPrule_419;
typedef struct _TPrule_420* _TPPrule_420;
typedef struct _TPrule_421* _TPPrule_421;
typedef struct _TPrule_422* _TPPrule_422;
typedef struct _TPrule_423* _TPPrule_423;
typedef struct _TPrule_424* _TPPrule_424;
typedef struct _TPrule_425* _TPPrule_425;
typedef struct _TPrule_426* _TPPrule_426;
typedef struct _TPrule_427* _TPPrule_427;
typedef struct _TPrule_428* _TPPrule_428;
typedef struct _TPrule_429* _TPPrule_429;
typedef struct _TPrule_430* _TPPrule_430;
typedef struct _TPrule_431* _TPPrule_431;
typedef struct _TPrule_432* _TPPrule_432;
typedef struct _TPrule_433* _TPPrule_433;
typedef struct _TPrule_434* _TPPrule_434;
typedef struct _TPrule_435* _TPPrule_435;
typedef struct _TPrule_436* _TPPrule_436;
typedef struct _TPrule_437* _TPPrule_437;
typedef struct _TPrule_438* _TPPrule_438;
typedef struct _TPrule_439* _TPPrule_439;
typedef struct _TPrule_440* _TPPrule_440;
typedef struct _TPrule_441* _TPPrule_441;
typedef struct _TPrule_442* _TPPrule_442;
typedef struct _TPrule_443* _TPPrule_443;
typedef struct _TPrule_444* _TPPrule_444;
typedef struct _TPrule_445* _TPPrule_445;
typedef struct _TPrule_446* _TPPrule_446;
typedef struct _TPrule_447* _TPPrule_447;
typedef struct _TPrule_448* _TPPrule_448;
typedef struct _TPrule_449* _TPPrule_449;
typedef struct _TPrule_450* _TPPrule_450;
typedef struct _TPrule_451* _TPPrule_451;
typedef struct _TPrule_452* _TPPrule_452;
typedef struct _TPrule_453* _TPPrule_453;
typedef struct _TPrule_454* _TPPrule_454;
typedef struct _TPrule_455* _TPPrule_455;
typedef struct _TPrule_456* _TPPrule_456;
typedef struct _TPrule_457* _TPPrule_457;
typedef struct _TPrule_458* _TPPrule_458;
typedef struct _TPrule_459* _TPPrule_459;
typedef struct _TPrule_460* _TPPrule_460;
typedef struct _TPrule_461* _TPPrule_461;
typedef struct _TPrule_462* _TPPrule_462;
typedef struct _TPrule_463* _TPPrule_463;
typedef struct _TPrule_464* _TPPrule_464;
typedef struct _TPrule_465* _TPPrule_465;
typedef struct _TPrule_466* _TPPrule_466;
typedef struct _TPrule_467* _TPPrule_467;
typedef struct _TPrule_468* _TPPrule_468;
typedef struct _TPrule_469* _TPPrule_469;
typedef struct _TPrule_470* _TPPrule_470;

struct _TSCompiledSPNL
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSConnections
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSectionBody
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSectionElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasureParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasures
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRewards
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSArcs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTransitionAttributes
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTransitions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPlaces
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParameters
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSConnection
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSGlobalId
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParameterExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSign
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParameterSum
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAddOp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParameterTerm
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMulOp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParameterFactor
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpOp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParameterPrimary
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSNumber
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPlace
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTransition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTransitionType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG6
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTransitionAttributeDefItem
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG8
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTransitionAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPriorityAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDistributionAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSWeightAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMarkingDependencyAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPolicyAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSConcurrencyAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSGuardAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRewardExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDistributionExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMarkingDependencyType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPolicyType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSConcurrencyDegree
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPredicate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG10
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSArc
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSArcAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSArcTypeAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMultiplicityAttribute
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSArcType
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG13
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSReward
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRewardSign
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG15
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG14
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRewardSum
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRewardTerm
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRewardFactor
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRewardPrimary
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPredicateSum
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSOrOp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPredicateTerm
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAndOp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPredicateFactor
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSNotOp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPredicatePrimary
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPredicateComp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSCompOp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG16
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasure
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasureExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSingleMeasureExpr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMultMeasureExpr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasureSum
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasureTerm
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasureFactor
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasurePrimary
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG17
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMeasureParameter
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExponentialDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSUniformDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTruncNormalDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSErlangDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSWeibullDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPhaseTypeDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDeterministicDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSBernoulliDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDiscreteUniDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSGeometricDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSModGeometricDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSBinomialDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSPoissonDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpolyDistribution
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMatrix
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSVektor
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG20
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG18
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG19
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG23
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG21
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG22
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpolyDistributionSum
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpolyDistributionPrimary
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSImpulseExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSContinuousExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpolynomial
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpolinomialSum
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpolinomialPrimary
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG25
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG24
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_000
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG1 _desc1;
};

struct _TPrule_001
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG1 _desc1;
_TSPConnections _desc2;
};

struct _TPrule_002
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_003
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG1 _desc1;
_TSPSectionBody _desc2;
};

struct _TPrule_004
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSectionElements _desc1;
};

struct _TPrule_005
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_006
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureParameters _desc1;
};

struct _TPrule_007
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasures _desc1;
};

struct _TPrule_008
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasures _desc1;
_TSPMeasureParameters _desc2;
};

struct _TPrule_009
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewards _desc1;
};

struct _TPrule_010
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewards _desc1;
_TSPMeasureParameters _desc2;
};

struct _TPrule_011
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewards _desc1;
_TSPMeasures _desc2;
};

struct _TPrule_012
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewards _desc1;
_TSPMeasures _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_013
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
};

struct _TPrule_014
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
_TSPMeasureParameters _desc2;
};

struct _TPrule_015
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
_TSPMeasures _desc2;
};

struct _TPrule_016
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
_TSPMeasures _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_017
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
_TSPRewards _desc2;
};

struct _TPrule_018
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
_TSPRewards _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_019
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_020
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcs _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_021
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
};

struct _TPrule_022
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPMeasureParameters _desc2;
};

struct _TPrule_023
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPMeasures _desc2;
};

struct _TPrule_024
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPMeasures _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_025
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPRewards _desc2;
};

struct _TPrule_026
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPRewards _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_027
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_028
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_029
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
};

struct _TPrule_030
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_031
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_032
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_033
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
};

struct _TPrule_034
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_035
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_036
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributes _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_037
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
};

struct _TPrule_038
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPMeasureParameters _desc2;
};

struct _TPrule_039
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPMeasures _desc2;
};

struct _TPrule_040
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPMeasures _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_041
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPRewards _desc2;
};

struct _TPrule_042
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPRewards _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_043
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_044
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_045
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
};

struct _TPrule_046
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_047
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_048
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_049
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
};

struct _TPrule_050
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_051
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_052
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_053
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
};

struct _TPrule_054
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_055
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_056
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_057
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
};

struct _TPrule_058
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_059
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_060
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_061
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
};

struct _TPrule_062
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_063
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_064
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_065
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
};

struct _TPrule_066
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_067
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_068
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitions _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_069
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
};

struct _TPrule_070
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPMeasureParameters _desc2;
};

struct _TPrule_071
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPMeasures _desc2;
};

struct _TPrule_072
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPMeasures _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_073
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPRewards _desc2;
};

struct _TPrule_074
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPRewards _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_075
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_076
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_077
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
};

struct _TPrule_078
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_079
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_080
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_081
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
};

struct _TPrule_082
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_083
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_084
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_085
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
};

struct _TPrule_086
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_087
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_088
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_089
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
};

struct _TPrule_090
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_091
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_092
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_093
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
};

struct _TPrule_094
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_095
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_096
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_097
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
};

struct _TPrule_098
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_099
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_100
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_101
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
};

struct _TPrule_102
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_103
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_104
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_105
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
};

struct _TPrule_106
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_107
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_108
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_109
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
};

struct _TPrule_110
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_111
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_112
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_113
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
};

struct _TPrule_114
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_115
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_116
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_117
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
};

struct _TPrule_118
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_119
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_120
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_121
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
};

struct _TPrule_122
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_123
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_124
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_125
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
};

struct _TPrule_126
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_127
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_128
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_129
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
};

struct _TPrule_130
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_131
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
};

struct _TPrule_132
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlaces _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
_TSPMeasureParameters _desc7;
};

struct _TPrule_133
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
};

struct _TPrule_134
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPMeasureParameters _desc2;
};

struct _TPrule_135
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPMeasures _desc2;
};

struct _TPrule_136
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPMeasures _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_137
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPRewards _desc2;
};

struct _TPrule_138
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPRewards _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_139
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_140
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPRewards _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_141
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
};

struct _TPrule_142
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_143
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_144
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_145
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
};

struct _TPrule_146
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_147
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_148
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPArcs _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_149
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
};

struct _TPrule_150
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_151
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_152
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_153
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
};

struct _TPrule_154
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_155
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_156
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_157
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
};

struct _TPrule_158
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_159
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_160
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_161
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
};

struct _TPrule_162
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_163
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_164
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitionAttributes _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_165
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
};

struct _TPrule_166
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_167
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_168
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_169
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
};

struct _TPrule_170
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_171
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_172
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_173
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
};

struct _TPrule_174
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_175
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_176
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_177
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
};

struct _TPrule_178
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_179
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_180
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_181
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
};

struct _TPrule_182
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_183
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_184
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_185
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
};

struct _TPrule_186
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_187
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_188
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_189
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
};

struct _TPrule_190
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_191
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_192
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_193
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
};

struct _TPrule_194
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_195
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
};

struct _TPrule_196
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPTransitions _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
_TSPMeasureParameters _desc7;
};

struct _TPrule_197
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
};

struct _TPrule_198
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPMeasureParameters _desc3;
};

struct _TPrule_199
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPMeasures _desc3;
};

struct _TPrule_200
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPMeasures _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_201
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPRewards _desc3;
};

struct _TPrule_202
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPRewards _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_203
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_204
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPRewards _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_205
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
};

struct _TPrule_206
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_207
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_208
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_209
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
};

struct _TPrule_210
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_211
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_212
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPArcs _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_213
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
};

struct _TPrule_214
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_215
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_216
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_217
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
};

struct _TPrule_218
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_219
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_220
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_221
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
};

struct _TPrule_222
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_223
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_224
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_225
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
};

struct _TPrule_226
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_227
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
};

struct _TPrule_228
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitionAttributes _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
_TSPMeasureParameters _desc7;
};

struct _TPrule_229
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
};

struct _TPrule_230
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPMeasureParameters _desc4;
};

struct _TPrule_231
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPMeasures _desc4;
};

struct _TPrule_232
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPMeasures _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_233
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPRewards _desc4;
};

struct _TPrule_234
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPRewards _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_235
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_236
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPRewards _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_237
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
};

struct _TPrule_238
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_239
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_240
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_241
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
};

struct _TPrule_242
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_243
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
};

struct _TPrule_244
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPArcs _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
_TSPMeasureParameters _desc7;
};

struct _TPrule_245
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
};

struct _TPrule_246
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPMeasureParameters _desc5;
};

struct _TPrule_247
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPMeasures _desc5;
};

struct _TPrule_248
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPMeasures _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_249
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPRewards _desc5;
};

struct _TPrule_250
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPRewards _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_251
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
};

struct _TPrule_252
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPRewards _desc5;
_TSPMeasures _desc6;
_TSPMeasureParameters _desc7;
};

struct _TPrule_253
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
};

struct _TPrule_254
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
_TSPMeasureParameters _desc6;
};

struct _TPrule_255
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
_TSPMeasures _desc6;
};

struct _TPrule_256
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
_TSPMeasures _desc6;
_TSPMeasureParameters _desc7;
};

struct _TPrule_257
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
_TSPRewards _desc6;
};

struct _TPrule_258
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
_TSPRewards _desc6;
_TSPMeasureParameters _desc7;
};

struct _TPrule_259
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
_TSPRewards _desc6;
_TSPMeasures _desc7;
};

struct _TPrule_260
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameters _desc1;
_TSPPlaces _desc2;
_TSPTransitions _desc3;
_TSPTransitionAttributes _desc4;
_TSPArcs _desc5;
_TSPRewards _desc6;
_TSPMeasures _desc7;
_TSPMeasureParameters _desc8;
};

struct _TPrule_261
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG2 _desc1;
};

struct _TPrule_262
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPConnection _desc1;
};

struct _TPrule_263
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG2 _desc1;
_TSPConnection _desc2;
};

struct _TPrule_264
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_265
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG3 _desc1;
};

struct _TPrule_266
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameter _desc1;
};

struct _TPrule_267
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG3 _desc1;
_TSPParameter _desc2;
};

struct _TPrule_268
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPParameterExpression _desc2;
};

struct _TPrule_269
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterExpression _desc1;
};

struct _TPrule_270
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSign _desc1;
_TSPParameterSum _desc2;
};

struct _TPrule_271
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterSum _desc1;
};

struct _TPrule_272
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterSum _desc1;
_TSPAddOp _desc2;
_TSPParameterTerm _desc3;
};

struct _TPrule_273
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterTerm _desc1;
};

struct _TPrule_274
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterTerm _desc1;
_TSPMulOp _desc2;
_TSPParameterFactor _desc3;
};

struct _TPrule_275
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterFactor _desc1;
};

struct _TPrule_276
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterFactor _desc1;
_TSPExpOp _desc2;
_TSPParameterPrimary _desc3;
};

struct _TPrule_277
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterPrimary _desc1;
};

struct _TPrule_278
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPNumber _desc1;
};

struct _TPrule_279
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_280
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParameterExpression _desc1;
};

struct _TPrule_281
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG4 _desc1;
};

struct _TPrule_282
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPlace _desc1;
};

struct _TPrule_283
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG4 _desc1;
_TSPPlace _desc2;
};

struct _TPrule_284
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
};

struct _TPrule_285
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPParameterExpression _desc2;
};

struct _TPrule_286
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG5 _desc1;
};

struct _TPrule_287
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransition _desc1;
};

struct _TPrule_288
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG5 _desc1;
_TSPTransition _desc2;
};

struct _TPrule_289
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
};

struct _TPrule_290
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPTransitionType _desc2;
};

struct _TPrule_291
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_292
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_293
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG6 _desc1;
};

struct _TPrule_294
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttributeDefItem _desc1;
};

struct _TPrule_295
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG6 _desc1;
_TSPTransitionAttributeDefItem _desc2;
};

struct _TPrule_296
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG9 _desc1;
};

struct _TPrule_297
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG8 _desc1;
};

struct _TPrule_298
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG7 _desc1;
_TSPG8 _desc2;
};

struct _TPrule_299
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransitionAttribute _desc1;
};

struct _TPrule_300
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG7 _desc1;
};

struct _TPrule_301
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPriorityAttribute _desc1;
};

struct _TPrule_302
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDistributionAttribute _desc1;
};

struct _TPrule_303
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPWeightAttribute _desc1;
};

struct _TPrule_304
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMarkingDependencyAttribute _desc1;
};

struct _TPrule_305
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPolicyAttribute _desc1;
};

struct _TPrule_306
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPConcurrencyAttribute _desc1;
};

struct _TPrule_307
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGuardAttribute _desc1;
};

struct _TPrule_308
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_309
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDistributionExpression _desc1;
};

struct _TPrule_310
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_311
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMarkingDependencyType _desc1;
};

struct _TPrule_312
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_313
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_314
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_315
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPolicyType _desc1;
};

struct _TPrule_316
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_317
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_318
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_319
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPConcurrencyDegree _desc1;
};

struct _TPrule_320
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_321
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_322
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicate _desc1;
};

struct _TPrule_323
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG10 _desc1;
};

struct _TPrule_324
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArc _desc1;
};

struct _TPrule_325
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG10 _desc1;
_TSPArc _desc2;
};

struct _TPrule_326
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPG12 _desc2;
};

struct _TPrule_327
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcAttribute _desc1;
};

struct _TPrule_328
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_329
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG12 _desc1;
_TSPG11 _desc2;
};

struct _TPrule_330
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcTypeAttribute _desc1;
};

struct _TPrule_331
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMultiplicityAttribute _desc1;
};

struct _TPrule_332
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPArcType _desc1;
};

struct _TPrule_333
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_334
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_335
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_336
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG13 _desc1;
};

struct _TPrule_337
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPReward _desc1;
};

struct _TPrule_338
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG13 _desc1;
_TSPReward _desc2;
};

struct _TPrule_339
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_340
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicate _desc1;
_TSPRewardSign _desc2;
_TSPG15 _desc3;
};

struct _TPrule_341
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicate _desc1;
_TSPRewardSign _desc2;
_TSPG15 _desc3;
_TSPRewardSign _desc4;
};

struct _TPrule_342
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardSign _desc1;
};

struct _TPrule_343
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicate _desc1;
_TSPRewardSign _desc2;
};

struct _TPrule_344
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_345
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG15 _desc1;
_TSPG14 _desc2;
};

struct _TPrule_346
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSign _desc1;
_TSPRewardSum _desc2;
};

struct _TPrule_347
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardSum _desc1;
};

struct _TPrule_348
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardSum _desc1;
_TSPAddOp _desc2;
_TSPRewardTerm _desc3;
};

struct _TPrule_349
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardTerm _desc1;
};

struct _TPrule_350
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardTerm _desc1;
_TSPMulOp _desc2;
_TSPRewardFactor _desc3;
};

struct _TPrule_351
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardFactor _desc1;
};

struct _TPrule_352
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardFactor _desc1;
_TSPExpOp _desc2;
_TSPRewardPrimary _desc3;
};

struct _TPrule_353
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardPrimary _desc1;
};

struct _TPrule_354
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_355
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_356
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPNumber _desc1;
};

struct _TPrule_357
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_358
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicateSum _desc1;
};

struct _TPrule_359
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicateSum _desc1;
_TSPOrOp _desc2;
_TSPPredicateTerm _desc3;
};

struct _TPrule_360
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicateTerm _desc1;
};

struct _TPrule_361
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicateTerm _desc1;
_TSPAndOp _desc2;
_TSPPredicateFactor _desc3;
};

struct _TPrule_362
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicateFactor _desc1;
};

struct _TPrule_363
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPNotOp _desc1;
_TSPPredicateFactor _desc2;
};

struct _TPrule_364
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicatePrimary _desc1;
};

struct _TPrule_365
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_366
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_367
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicateComp _desc1;
};

struct _TPrule_368
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPredicate _desc1;
};

struct _TPrule_369
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPCompOp _desc2;
_TSPRewardExpression _desc3;
};

struct _TPrule_370
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG16 _desc1;
};

struct _TPrule_371
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasure _desc1;
};

struct _TPrule_372
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG16 _desc1;
_TSPMeasure _desc2;
};

struct _TPrule_373
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPMeasureExpression _desc2;
};

struct _TPrule_374
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSingleMeasureExpr _desc1;
};

struct _TPrule_375
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMultMeasureExpr _desc1;
};

struct _TPrule_376
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSign _desc1;
_TSPMeasureSum _desc2;
};

struct _TPrule_377
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureSum _desc1;
};

struct _TPrule_378
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureSum _desc1;
_TSPAddOp _desc2;
_TSPMeasureTerm _desc3;
};

struct _TPrule_379
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureTerm _desc1;
};

struct _TPrule_380
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureTerm _desc1;
_TSPMulOp _desc2;
_TSPMeasureFactor _desc3;
};

struct _TPrule_381
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureFactor _desc1;
};

struct _TPrule_382
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureFactor _desc1;
_TSPExpOp _desc2;
_TSPMeasurePrimary _desc3;
};

struct _TPrule_383
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasurePrimary _desc1;
};

struct _TPrule_384
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPNumber _desc1;
};

struct _TPrule_385
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_386
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_387
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPPredicate _desc2;
};

struct _TPrule_388
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureExpression _desc1;
};

struct _TPrule_389
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_390
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPPredicate _desc2;
};

struct _TPrule_391
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG17 _desc1;
};

struct _TPrule_392
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMeasureParameter _desc1;
};

struct _TPrule_393
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG17 _desc1;
_TSPMeasureParameter _desc2;
};

struct _TPrule_394
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPMeasureExpression _desc2;
};

struct _TPrule_395
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGlobalId _desc1;
_TSPMeasureExpression _desc2;
_TSPParameterExpression _desc3;
};

struct _TPrule_396
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExponentialDistribution _desc1;
};

struct _TPrule_397
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPUniformDistribution _desc1;
};

struct _TPrule_398
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTruncNormalDistribution _desc1;
};

struct _TPrule_399
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPErlangDistribution _desc1;
};

struct _TPrule_400
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPWeibullDistribution _desc1;
};

struct _TPrule_401
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPhaseTypeDistribution _desc1;
};

struct _TPrule_402
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDeterministicDistribution _desc1;
};

struct _TPrule_403
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPBernoulliDistribution _desc1;
};

struct _TPrule_404
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDiscreteUniDistribution _desc1;
};

struct _TPrule_405
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPGeometricDistribution _desc1;
};

struct _TPrule_406
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPModGeometricDistribution _desc1;
};

struct _TPrule_407
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPBinomialDistribution _desc1;
};

struct _TPrule_408
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPPoissonDistribution _desc1;
};

struct _TPrule_409
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolyDistribution _desc1;
};

struct _TPrule_410
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_411
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_412
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_413
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_414
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_415
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMatrix _desc1;
_TSPVektor _desc2;
};

struct _TPrule_416
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG20 _desc1;
};

struct _TPrule_417
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG19 _desc1;
};

struct _TPrule_418
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG18 _desc1;
_TSPG19 _desc2;
};

struct _TPrule_419
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPVektor _desc1;
};

struct _TPrule_420
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG18 _desc1;
};

struct _TPrule_421
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG23 _desc1;
};

struct _TPrule_422
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG22 _desc1;
};

struct _TPrule_423
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG21 _desc1;
_TSPG22 _desc2;
};

struct _TPrule_424
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_425
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG21 _desc1;
};

struct _TPrule_426
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_427
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_428
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
_TSPRewardExpression _desc3;
};

struct _TPrule_429
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_430
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_431
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
_TSPRewardExpression _desc3;
};

struct _TPrule_432
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
_TSPRewardExpression _desc3;
};

struct _TPrule_433
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolyDistributionSum _desc1;
};

struct _TPrule_434
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolyDistributionSum _desc1;
_TSPAddOp _desc2;
_TSPExpolyDistributionPrimary _desc3;
};

struct _TPrule_435
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolyDistributionPrimary _desc1;
};

struct _TPrule_436
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPImpulseExpression _desc1;
};

struct _TPrule_437
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPContinuousExpression _desc1;
};

struct _TPrule_438
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
};

struct _TPrule_439
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_440
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
};

struct _TPrule_441
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolynomial _desc1;
_TSPRewardExpression _desc2;
_TSPRewardExpression _desc3;
};

struct _TPrule_442
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolinomialSum _desc1;
};

struct _TPrule_443
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolinomialSum _desc1;
_TSPAddOp _desc2;
_TSPExpolinomialPrimary _desc3;
};

struct _TPrule_444
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolinomialPrimary _desc1;
};

struct _TPrule_445
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRewardExpression _desc1;
_TSPRewardExpression _desc2;
_TSPRewardExpression _desc3;
};

struct _TPrule_446
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpolynomial _desc1;
};

struct _TPrule_447
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_448
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_449
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_450
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_451
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_452
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_453
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_454
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_455
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_456
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_457
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_458
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_459
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_460
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_461
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_462
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_463
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_464
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_465
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG25 _desc1;
};

struct _TPrule_466
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG25 _desc1;
};

struct _TPrule_467
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_468
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_469
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_470
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG25 _desc1;
_TSPG24 _desc2;
};

#undef _NODECOMMON
#endif
