#define __main_c__
#include <string.h>
#include "types.h"		/* t_sub subnet */

extern eperror();

/*
 * Global Variables:
 */
char *progname;
FILE *frrg;
FILE *ftmark;

int trans_solve_solution = FALSE;

int no_det_trans;
int no_neis_trans; /* number of non-exponential infinite transitions */
int no_trans;
int no_places;
int no_tang_markings = 0;
int no_edges = 0;

int no_subnets;
subnet        *subnets;

int no_absorb_states;

t_sub	         timed;
tang_marking  *new_markings;
tang_node     *graph;

int main(ac,av)
int ac;
char **av;
{
	FILE *fstruct;
	int  i;
	char nstruct[MAXPATHLEN];
	char nrrg   [MAXPATHLEN];
	char ntmark [MAXPATHLEN];

	for(i=strlen(av[0]); i--; )
		if (av[0][i]=='/') break;
	progname = &(av[0][i+1]);
	for (i=ac; --i;) {
		if (!strcmp(av[i],"-t")){
			trans_solve_solution = TRUE;
			break;
		}
	}
	while (--ac) {
		if (!strcmp(av[ac],"-t")) continue;
		/*
		 * Generate Reduced Reachability Graph of av[ac]:
		 */
		strcpy(nstruct,av[ac]);
		strcat(nstruct,".STRUCT");
		if (!(fstruct=fopen(nstruct,"r"))) {
			eperror(nstruct);
		}
		strcpy(nrrg,av[ac]);
		strcat(nrrg,".rrg");
		if (!(frrg=fopen(nrrg,"w"))) {
			eperror(nrrg);
		}
		strcpy(ntmark,av[ac]);
		strcat(ntmark,".tmark");
		if (!(ftmark=fopen(ntmark,"w"))) {
			eperror(ntmark);
		}
		/*
		 * Now all files are opened, do someting with them:
		 */
		read_struct(fstruct);
		graph        = NULL;
		new_markings = NULL;

#ifdef DEBUG				
		printf("GENERATING REDUCED REACHABILITY GRAPH FOR %s\n",av[ac]);
#endif		
		generate_rg( subnets, &timed );

#ifdef DEBUG	     
		show_graph_tree( subnets, &timed );
#endif			

		file_graph_tree( subnets, &timed, nrrg, ntmark );

		if (fclose(ftmark)) {
			eperror(ntmark);
		}
		if (fclose(frrg)) {
			eperror(nrrg);
		}
		if (fclose(fstruct)) perror(nstruct);
	}
	return (0);
}
