/*****************************************************************************

  	Filename	:	pars_service.c

       	Funktionen	:	verschiedene Teilfunktionen fuer parser

	Aufgabe		:	

	Programmierer	:	Joerg Mitzlaff, Ch. Kelling

	Datum		:	Mai 1994

******************************************************************************/

#include <stdio.h>
#include "expoly.h"
#include "pars_TN.h"
#include <math.h>


#define True 1
#define False 0

extern char *emalloc();

/* avoid 0^0 problem */
double my_pow(a,b)
        double a,b;
{
        if ((a==0.0) && (b==0.0))
                return (1.0);
        return pow(a,b);
}

time_l *free_whole_stru(p)
     time_l *p;
{
   time_l *i;
   time_l *iold;      
   power_m *j;
   power_m *jold;
   expo_n *k;
   expo_n *kold;

   i = p;
   while(i!=NULL)
   {
      j = i->power;
      while(j!=NULL)
      {
	 k = j->expo;
	 while(k!=NULL)
	 {
	    kold = k;
	    k = k->next;
	    free(kold);
	 }
	 jold = j;
	 j = j->next;
	 free(jold);
      }
      iold = i;
      i = i->next;
      free(iold);
   }
   return(NULL);
}

power_m *zero_tail()
{

    return(make_m_stru(0,
		       make_n_stru(0.0, (double)UNDEF, 0.0, NULL),
		       NULL));
}

time_l *copy_all_intervall(p1)
     time_l *p1;
{
     time_l *basis;
     time_l *neubas;
     time_l *retu;
    
    neubas = make_l_stru(0.0, 0.0, 0.0, NULL, NULL);    
    basis = p1;
    retu = neubas;

    neubas->x1    = basis->x1;
    neubas->x2    = basis->x2;
    neubas->p     = basis->p;
    neubas->power = copy_all_power(basis->power);
    
    while(basis->next!=NULL)
    {
	basis  = basis->next;         /* erhoehen */
	neubas->next = make_l_stru(0.0, 0.0, 0.0, NULL,NULL);
        neubas = neubas->next;
	neubas->x1    = basis->x1;
	neubas->x2    = basis->x2;
	neubas->p     = basis->p;
	neubas->power = copy_all_power(basis->power);
    }
    return(retu);
}


power_m *copy_all_power(p1)
     power_m *p1;
{
    power_m *basis;
    power_m *neubas;
    power_m *retu;
    
    neubas = make_m_stru(0,NULL,NULL);    
    basis = p1;
    retu = neubas;

    neubas->m    = basis->m;
    neubas->expo = copy_all_expo(basis->expo);
    
    while(basis->next!=NULL)
    {
	basis  = basis->next;         /* erhoehen */
	neubas->next = make_m_stru(0,NULL,NULL);
        neubas = neubas->next;
	neubas->m    = basis->m;
	neubas->expo = copy_all_expo(basis->expo);
    }
    return(retu);
}

expo_n *copy_all_expo(p1)
     expo_n *p1;
{
    expo_n *basis;
    expo_n *neubas;
    expo_n *retu;
    
    neubas = make_n_stru(0.0, 0.0, 0.0, NULL);
    
    basis = p1;
    retu = neubas;

    neubas->lambda = basis->lambda;    /* expo kopieren von basis nach retu */
    neubas->b      = basis->b;
    neubas->c      = basis->c;

    while(basis->next!=NULL)
    {
	basis  = basis->next;         /* erhoehen */
	neubas = neubas->next;
	
	neubas = make_n_stru(0.0, 0.0, 0.0, NULL);
	neubas->lambda = basis->lambda; /*  kopieren von basis nach neubas */
	neubas->b      = basis->b;
	neubas->c      = basis->c;
    }
    return(retu);
}

time_l *melt_intervall(p1, p2)
     time_l *p1;
     time_l *p2;   /* p2 wird in p1 reingesteckt */
{
    time_l *i;      /* geht ueber alle time-stru's von p2 */
    time_l *j;      /* geht ueber alle time-stru's von p1 dessen 
		       Intervall <= als jeweiliges p2 ist*/
    time_l *lastj;
    time_l *pneu;
    int    int_eingeordnet;
     
    i = p2;
    do{
      int_eingeordnet = False;
      while(!int_eingeordnet)
	{
	  j = p1;
	  lastj = NULL;
	  /* p2-Intervalle fangen immer am Anfang eine p1-Intervalls an!!! */
	  /* Einstiegspunkt in p1-Intervall finden */
	  while((i->x1 != j->x1) && (j->next!=NULL))
	    {
	      lastj = j;
	      j = j->next;
	    }
	  
	  if(j->next==NULL)
	    {             /* Sonderfall j->x2=UNENDLICH 
			     (p2-Int.-anf. gesucht, wo p1 keine Int.mehr hat */
	      if(lastj==NULL)
		p1 = i;
	      else
		lastj->next = i;
	      i->p = j->p;
	      return(p1);   /* >>>>>>>>>>>>>>>>>>>>>>>> 
			       sofort zurueck (Ziel erreicht) */
	    }
	  if(i->next==NULL)
	    {  				    /* Sonderfall i->x2=UNENDLICH */
	      break; /* patch:das erste war auch schon das letzte */
	    }
	  else
	    if(i->x2 == j->x2)
	      {                           /* Fall 1 (identisch)*/
		j->p = j->p + i->p;
		melt_power(j->power,copy_all_power(i->power));
		int_eingeordnet = True;
	      } 
	    else
	      if(i->x2 < j->x2)
		{                       /* Fall 2 (j spaltet sich)*/
		  pneu = make_l_stru(i->x2, j->x2, j->p, copy_all_power(j->power), NULL); /* neuer 2. Teil */
		  j->x2 = i->x2;								/* neuer 1. Teil */
		  melt_power(j->power,copy_all_power(i->power));
		  pneu->next = j->next;
		  j->next = pneu;  /* verkettung */
		  int_eingeordnet = True;
		}
	      else /*  i->x2 > j->x2 */
		{   	                    /* Fall 3 (mit go back)*/
		  
		  melt_power(j->power,copy_all_power(i->power));
		  i->x1 = j->x2;    /* verkleinerung von i-Intervall */
		  int_eingeordnet = False;
		}
	}
      if(i->next==NULL)
	break;  /* patch:das erste war auch schon das letzte */
      else
	i = i->next;
    }while(i->next!=NULL); /* das letzte "dummy"-intervall 
			      von i (p2) wird weggelassen... */
    if(i->p!=0)		   /* ...ausser es gibt eine Punktmasse am Ende */
    {
      j = p1;
      /* p2-Intervalle fangen immer am Anfang eine p1-Intervalls an!!! */
      /* Einstiegspunkt in p1-Intervall finden */
      while(i->x1 != j->x1) 
	j = j->next;
      j->p =  j->p + i->p;
    }
    return(p1);  
  }

void append_one_power(p1, p2)
     power_m *p1;
     power_m *p2; /* ein p2 an p1 angehaengt */
{						    
  power_m *append;
  
  append = p1;
  while(append->next != NULL)
    append = append->next;
  append->next = p2;
  p2->next = NULL;
}

power_m *melt_power(p1, p2)
     power_m *p1;
     power_m *p2;          /* p2 in p1 rein */
{
    power_m *i;   /* geht ueber alle powerstru's von p1 */
    power_m *j;   /* geht ueber alle powerstru's von p2 */
    power_m *nextj;
    
    j       = p2;              /* j ist ausserer zaehler */
    do{
      nextj = j->next;         /* muss man sich merken, da j verloren geht. */
      
      i       = p1;            /* i ist innerer zahler */
      while( !((i->next == NULL) || (i->m == j->m)))
	i = i->next;
      
      if(i->m == j->m)   /* gleicher exponent p2->m in p1-stru's */
	
	add_or_append_all_expos(i->expo,copy_all_expo(j->expo));
      else
	append_one_power(i,j);    /* ganz neuer exponent in p2, 
				     der in p1 noch nicht vorkam */
      
      j = nextj;		      /* weiterzaehlen */
    }while( j != NULL);
    return(p1);
  }

void append_one_expo(p1, p2)
     expo_n *p1;
     expo_n *p2; /* ein p2 an p1 angehaengt */
{						    
  expo_n *append;
  
  append = p1;
  while(append->next != NULL)
    append = append->next;
  append->next = p2;
  p2->next = NULL;
}

void add_or_append_all_expos(p1, p2)
     expo_n *p1;
     expo_n *p2; /* alle expos von p2 an p1-expos angehaengt */
{						    /* p2 freigeben */
    expo_n *i;
    expo_n *j;
    expo_n *weiter;
    
    i = p2;
    do{                            /* fuer alle expos in p2 */
      j = p1;
      while((j->lambda!=i->lambda) && (j->next!=NULL))
	{
	  j = j->next;           /* stimmt ein lambda aus p1 ueberein? */
	}
      if(j->lambda == i->lambda) /* ja */
	{
	  j->c += i->c;
	  j->b += i->b;
	  i = i->next;           /* hochzaehlen */
	}
      else                       /* nein: neues lambda anhaengen */
	{
	  weiter = i->next;
	  i->next = NULL;        /* ist letztes in Schlange */
	  j->next = i;	   /* anhaengen an p1-expos */
	  
	  i = weiter;             /* hochzaehlen */
	}
    }while(i != NULL);
    
    /* free all p2 expos */
}

power_m *negate_all_c(p1)
     power_m *p1;    /* Arg. p1 wird durchgereicht */
  {
    power_m *i;   /* geht ueber alle powerstru's */
    expo_n  *j;   /* geht ueber alle expostru's */

    i = p1;
    do{	
      j = i->expo;
      do{
	j->c = j->c * (-1);  /* faktor negieren */
	j = j->next;
      }while(j != NULL);
      i = i->next;
    }while(i != NULL);
    
    return(p1);
  }

time_l  *make_l_stru(x1, x2, p, p1, p2)
     double x1;
     double x2;
     double p;
     power_m *p1;
     time_l *p2;
{
  time_l *ret;
  
  ret=(time_l *) emalloc(sizeof(time_l));
  
  ret->x1 = x1;
  ret->x2 = x2;
  ret->p  = p;
  ret->power = p1;
  ret->next  = p2;
  ret->type = EXPOLY;

  return ret;
}
 
power_m *make_m_stru(m, p1, p2)
     unsigned int m;
     expo_n *p1;
     power_m *p2;
{	
  power_m *ret;

  ret=(power_m *) emalloc(sizeof(time_l));
  
  ret->m = m;
  ret->expo = p1;
  ret->next = p2;
  
  return ret;
}

expo_n  *make_n_stru(l, b, c, p1)
     double l;
     double b;
     double c;
     expo_n *p1;
{
  expo_n *ret;
  
  ret=(expo_n *) emalloc(sizeof(time_l));
  
  ret->lambda = l;
  ret->b  = b;
  ret->c  = c;
  ret->next = p1;
  
  return ret;
}


/************************* count ()   ****************************************/
/* Liefert Anzahl der Eintraege in der Struktur time_l zurueck               */
/*****************************************************************************/
int count(tp)
time_l *tp;
{
  int num = 0;
  while (tp){
    num++;
    tp = tp->next;
  }
  return num;
}

/*****************************************************************************/
/* Mit Hilfe der gegebene pdf-Funktion wird fuer den Punkt x  f(x)      */
/* bestimmt.                                                                 */
/*****************************************************************************/

double func(point,x)
time_l *point;
double x;
{
  power_m  *power_p;
  expo_n   *expo_p;
  double   temp;
  double   fx;

  power_p = point->power;
  fx   = 0.0;
  while (power_p){
      expo_p = power_p->expo;
      temp = 0.0;
      while(expo_p){
/* debug 
   printf("exp b : %f\t exp lambda: %f\t x: %f\n", expo_p->b, expo_p->lambda, x);
   printf("c waere : %f\n", expo_p->c); */
	
	temp += (expo_p->b) * (exp((-1.0)*expo_p->lambda * x));
/* debug 
   printf("erg temp: %f\n", temp); */

	expo_p = expo_p->next;
      }
/* debug 
   printf("erg pow: %f\n",my_pow(x, (double)(power_p->m)));*/
      
      fx += my_pow(x, (double)(power_p->m)) * temp;
/* debug 
   printf("erg fx: %f\n", fx);*/
      
      power_p = power_p->next;
    }
    return (fx);
}

