/*######################################################################

	Komponente		:	portab.h

	Project Director:	Christoph Lindemann TU Berlin
						
	Programmierer	:	Kolja Koischwitz

	Datum			:	Juni 1993

########################################################################*/

#include <math.h>

#if defined(sun) && defined(__svr4__)
#define SOL2
#endif

#ifdef __hpux
/* for HP-UX compatibility: */
#include <syscall.h>
#include <unistd.h>
/* Systemcalls */
#define getpagesize()                           sysconf(_SC_PAGE_SIZE)
/* Der Systemcall SYS_getrusage liefert leider 0 fuer rusage.ru_maxrss */
#define getrusage(who,rusage)           syscall(SYS_getrusage,who,rusage)

/* setbuffer/setlinebuf-Ersatz */
#define setbuffer(stream,buf,size)      setvbuf(stream,buf,_IOFBF,size)

/* Wird verwendet, um stdout und stderr auf LineBuffering zu setzen */
#define setlinebuf(stream)                      setvbuf(stream,NULL,_IOLBF,BUFSI
Z)

/* ioctl-Flag heisst bei HP-UX anders! */
#define FIOSETOWN                                       SIOCSPGRP

#endif
#ifdef __hpux
#define RSH_CMD_PATH "/usr/bin/remsh"
#define RSH_CMD      "remsh"
#else
#define RSH_CMD_PATH "/usr/ucb/rsh"
#define RSH_CMD      "rsh"
#endif

#ifdef ultrix
/* for Ultrix compatibility: */
extern char *malloc();
static char *strdup (string)
char *string;
{
  register char *new_string = (char *)malloc (strlen (string) + 1);
  if (new_string)
    strcpy (new_string, string);
  return new_string;
}
#endif

#if defined(ultrix) || defined(__hpux) || defined(SOL2) || defined(__osf__) || defined(linux)
/*	for Ultrix, HP-UX, OSF, Linux and Solaris 2 compatibility */
static int isinf(x)
double x;
{
  return x == HUGE_VAL || x == -HUGE_VAL;
}

#define infinity() HUGE_VAL
#define issubnormal(x) false
#define log2(x) (log(x)/log(2.0))
#endif

#if defined(SOL2) || defined(linux)
static double nint(x)
double x;
{
  return (x)-floor(x) < 0.5 ? floor(x) : ceil(x);
}
#endif

#ifndef __svr4__
#  define memmove(dest,src,length) bcopy((char*)(src),(char*)(dest),length)
#endif
