/******************************************************************************
File:              showStatSimCurves.h
 
Project Director:  Christian Kelling
 

Programmer:        Henning Ziegler [Joerg Mitzlaff (showTransCurves.h)]

History:           10.96 (Dipl.Arbeit)

*******************************************************************************/

#define COMMENT     '#'
#define BUF_SIZE    1000

typedef enum {Adaptive,Absolute,Logarithmic} Scale_Type;      /* y-axis */
typedef enum {Adaptive_x,Absolute_x} Scale_x_Type;            /* x-axis */

typedef enum {Lines, Dashes,Off} Conf_Type;
typedef enum {false=0, true=1} bool;

typedef struct
{
      char *name;       /* reward measure name */
      int   stopped;
                              /* gegebene Groessen */
      double minX; 
      double maxX;      
      double maxY;
      double minY;
      Scale_Type scale;
      Scale_x_Type scale_x;
      int visible;

      int kachel_breite; /* Bildausschnittsdimension */
      int kachel_hoehe;
      int kachel_x;
      int kachel_y;
                          /* Berechnete Groessen */
      double rminX;       /* abgerundetes maxX ist aber groesser  minX-rticstepy */
      double rmaxX;
      double udiffX;      /* realer X-Achsen-Bereich */
      double rminY;       /* abgerundetes maxY ist aber groesser  minY-rticstepy */
      double rmaxY; 
      double udiffY;      /* realer Y-Achse-Bereich */
      double lrminY;      /* log10(rminY); */

      int    startx;      /* zum schnellen unrealx berechnen */
      int    starty;      /* zum schnellen unrealy berechnen */

      int aktData;        /* naechstes zu lesendes Datum */
      double *Datas;      /* numDatas Werte */
      double *time;       /*zugehoerige Zeit */
      double *conf_datas; /* numDatas Konfidenz-Werte */

} Measure_Datas;

typedef struct
{
      int numDatas;
      int numMeasures;
      Measure_Datas *mdata;
      char *buffer;
} Drawing_Basis;
