/*******************************************************************/
/* Patrick Drescher                        Matr.: 136106           */
/* Illigstr. 56a                                                   */
/* 12307 Berlin                                                    */
/* Tel.: 7452384                                                   */
/*******************************************************************/
/*                                                                 */
/*                         RESTART MODUL                           */
/*                                                                 */
/*******************************************************************/

/**************/
/* prep_rst.c */
/**************/

#include <stdio.h>
#include <ctype.h>

#define MAX_PRE_PROBS 50

int        border,
           max_poss_t,
           z_max,
           direction,
           event,
           z[MAX_PRE_PROBS+1],
           i,
           l,
           h,
           j;
float      k;
char       measure_place[100],
           string[100],
           *pointer,
           file[4][256]={"","","",""},
           *mode[]={"r","r","w","w","w"},
           *fgets(),
           *strcpy(),
           *strrchr();
FILE       *filepointer[5],
           *fopen();

main(argc, argv)
int argc;
char *argv[];

{
/* extract values */

if (argc!=2)
   {
   fprintf(stderr,"wrong number of parameters\n");
   exit(1);
   }

sprintf(file[0],"%s.INV",argv[1]);
sprintf(file[1],"%s.TN",argv[1]);
sprintf(file[2],"%s_RST.TN",argv[1]);
sprintf(file[3],"%s.PARAM",argv[1]);

for (i=0;i<4;++i)
    if ((filepointer[i]=fopen(file[i],mode[i]))==NULL)
       {
       fprintf(stderr,"cannot open %s\n",file[i]);
       exit(1);
       }

if (!search(filepointer[1],string,&pointer,"MEASURE ",1))
   {
   fprintf(stderr,"cannot find MEASURE\n");
   exit(1);
   }
if (!search(filepointer[1],string,&pointer,"#",1))
   {
   fprintf(stderr,"cannot find #\n");
   exit(1);
   }
if (!fetch(&pointer,measure_place,'>','<'))
   {
   fprintf(stderr,"cannot find >,<\n");
   exit(1);
   }
direction=(*pointer=='>') ? 1 : -1;
if (!search(filepointer[1],string,&pointer,"=",0))
   {
   fprintf(stderr,"cannot find =\n");
   exit(1);
   }
event=atoi(pointer);
if (search(filepointer[1],string,&pointer,"MEASURE ",1))
   {
   fprintf(stderr,"more than one MEASURE\n");
   exit(1);
   }
if (direction==1)
   border=0;
else
   if ((border=s_invariant())==-1)
      {
      fprintf(stderr,"failure in getting s_invariant\n");
      exit(1);
      }

/* compute numbers of token */

if (abs(event-border)<2)
   {
   fprintf(stderr,"no place for thresholds\n");
   exit(1);
   }
else
   max_poss_t=abs(event-border)-1;
if (max_poss_t<=MAX_PRE_PROBS)
   z_max=max_poss_t, k=1.0;
else
   z_max=MAX_PRE_PROBS, k=(float)max_poss_t/(float)MAX_PRE_PROBS;
for (l=1, j=0, h=0; j<z_max; ++l)
    if (((float)l/k-h)>0.0)
       ++j, ++h, z[j]=border+direction*l;

/* write file _RST.TN */

rewind(filepointer[1]);

do {
   if (fgets(string,100,filepointer[1])==NULL)
      {
      fprintf(stderr,"cannot find REWARD_MEASURES:\n");
      exit(1);
      }
   if (strncmp(string,"REWARD_MEASURES:",16))
      fputs(string,filepointer[2]);
   } while (strncmp(string,"REWARD_MEASURES:",16));
fprintf(filepointer[2],"REWARD_MEASURES:%9d\n",z_max);
do {
   if (fgets(string,100,filepointer[1])==NULL)
      {
      fprintf(stderr,"cannot find MEASURE\n");
      exit(1);
      }
   if (strncmp(string,"MEASURE ",8))
      fputs(string,filepointer[2]);
   } while (strncmp(string,"MEASURE ",8));
for (i=1; i<=z_max; ++i)
    {
    fprintf(filepointer[2],"MEASURE z%-d\n",z[i]);
    if (direction==1)
       fprintf(filepointer[2],"P{#%s>=%-d};\n\n",measure_place,z[i]);
    else
       fprintf(filepointer[2],"P{#%s<=%-d};\n\n",measure_place,z[i]);
    }
fprintf(filepointer[2],"-- END OF SPECIFICATION FILE\n");

/* write file .PARAM */

fprintf(filepointer[3],"measure_place = %s\n",measure_place);
fprintf(filepointer[3],"direction = %-d\n",direction);
fprintf(filepointer[3],"event = %-d\n",event);
fprintf(filepointer[3],"z_max = %-d\n",z_max);
fprintf(filepointer[3],"border = %-d\n",border);

/* close all files */

for (i=0;i<4;++i)
     fclose(filepointer[i]);
exit(0);
}


s_invariant()

{
char *inv_pointer,
     *tn_pointer,
     markpar[100],
     string_inv[100],
     string_tn[100],
     dummy[100],
     compare[100];
int  max_inv=0,
     inv_value,
     need_it=1;

do {
   inv_value=0;
   if (!search(filepointer[0],string_inv,&inv_pointer,measure_place,1))
      if (need_it)
         return(-1);
      else
         return(max_inv);
   else
      need_it=0;
   if (!search(filepointer[0],string_inv,&inv_pointer,"=",0))
      return(event+50); /* uncovered place */
   do {
      if (*inv_pointer=='+')
         ++inv_pointer;
      if ((atoi(inv_pointer))!=0)
         {
         inv_value+=atoi(inv_pointer);
         fetch(&inv_pointer,dummy,' ',' '); 
         }
      else
         {
         fetch(&inv_pointer,markpar,' ',' ');
         rewind(filepointer[1]);
         do {
            if (!search(filepointer[1],string_tn,&tn_pointer,"MARKPAR ",1))
               return(-1);
            fetch(&tn_pointer,compare,' ',' ');
            } while (strcmp(compare,markpar));
         inv_value+=atoi(tn_pointer);
         }
      } while (!fetch(&inv_pointer,dummy,'+','+'));
   if (inv_value>=max_inv)
      max_inv=inv_value;
   } while (1);   
}


/*************************************************************************/
/* The function "search(text,line,pointer,string,n_l)"                   */
/* searches for a "string" in the opened file "text" and places the      */
/* "pointer" behind it. The returned value informs wether the operation  */
/* was succesfull or not. Depending on the parameter "n_l" the function  */
/* first reads a new line of "text" or starts to search behind "pointer".*/ 
/*************************************************************************/

search(text,line,pointer,string,n_l)

int  n_l;
char line[100],
     *string,
     **pointer;
FILE *text;

{
char *sign;
int  found=0;

do {
   if (n_l)
      {
      if (fgets(line,100,text)==0)
         return(0);
      *pointer=line; 
      }
   else
      n_l=1;   
   sign=string;
   while (*sign!='\0')
      {
      if (**pointer==*sign)
         {
	 found=1;
	 ++*pointer, ++sign;
         }
      else
         {
         found=0;
      	 if (sign==string)
            ++*pointer;
         else
	    sign=string;
         }
      if ((**pointer=='\0')&&(*sign!='\0'))
         {
	 found=0;
	 break;
         }
      }
   } while(!found);
return(1);
}

/**********************************************************************/
/* The function "char *fetch(pointer,string,sign_1,sign_2)"           */
/* extracts a "string" starting at the "pointer" until "sign_1"       */
/* or "sign_2" is reached or one of the specific signs below occurs.  */
/* The returned value informs wether "sign_1" or "sign_2" was reached */
/* or not.                                                            */
/**********************************************************************/ 


fetch(pointer,string,sign_1,sign_2)

char **pointer,
     string[100],
     sign_1,
     sign_2;

{
char *sign;

sign=string;
while (isspace(**pointer))
   ++*pointer;
while ((**pointer!=' ')&&(**pointer!='\0')&&(**pointer!='\n')&&
       (**pointer!=sign_1)&&(**pointer!=sign_2))
   { 
   *sign=**pointer;        
   ++sign, ++*pointer;
   }
*sign='\0';
if ((**pointer!=sign_1)||(**pointer!=sign_2))
   return(1);
else
   return(0);
}

