/******************************************************************************

Programm	:	graph

Komponente	:	exec_types.h

Aufgabe		:	Typdefinitionen fuer exec_rand.c

Projektleiter	:	Christoph Lindemann TU Berlin

Programmierer	:	Tobias Bading

Datum		:	Oktober 1992

Aenderung	:	Armin Zimmermann, Juni 1993:
			Anpassung an Verarbeitung von Isomorphieklassen
			von Komponenten der zugeordneten Markov-Ketten
			durch den rand - Prozess

******************************************************************************/

typedef char bool;

/* Informationen ueber die Rechner aus dem Environmentfile: */
typedef struct hostinfo
{	struct hostinfo	*next;			/* naechster Eintrag */
	char		*hostname;		/* Rechnername */
	unsigned short	running_processes;	/* Anzahl laufender Rand-Prozesse */
	long		load;			/* Auslastung des Rechners */
	unsigned	priority;		/* Prioritaet zur Benutzung dieses Rechners */
	bool		no_rusers;		/* rusers-Aufruf absetzen ? (Auf DECs ist
						   kein rusers-daemon vorhanden) */
	bool		free;			/* Rechner unbenutzt ? */
}  hostinfo;

/* Daten einer zugeordneten Markoff-Kette: */
typedef struct randinfo
{	double		tau;			/* Deterministische Schaltzeit tau */
	double		max_qii;		/* Absolutwert des kleinsten Diagonal-
					   	   elements der Generatormatrix */
	double		effort;			/* Geschaetzter Aufwand fuer die
					   	   Berechnungen von rand.c */
	unsigned	kb_per_sec;		/* Geschaetzte Geschwindigkeit der Berechnung der
					   	   P- und C-Matrix- eintraege in KB pro Sekunde */
	unsigned	eta;			/* Anzahl Nicht-Null-Eintraege der Generator-
						   matrix ohne die Diagonalelemente */
	Iso_Class	*class;			/* zugeordnete Isomorphie - Klasse */
	hostinfo	*host;			/* Rechner, auf welchem der zugehoerige
					   	   rand-Prozess laeuft */
	int		connection_fd;		/* Filedescriptor fuer die Socket-
					   	   Verbindung zum rand-Prozess */
	FILE		*connection_fp;		/* Filepointer zu socket_fd */
	enum
	{	no_process, waiting_for_connection, connected, running, terminated
	} status;				/* Status des zugehoerigen rand-
					   	   Prozesses */
}  randinfo;

extern void my_fwrite();
