/*****************************************************************************

	Programm	:	graph

	Komponente	:	graph_extern.h
				externe Deklaration globaler Variablen

	Programmierer	:	Armin Zimmermann

	Datum		:	Juni 1992

        Aenderung       :       Juni 1995 (Patrick Drescher)

*****************************************************************************/

extern int no_places;			/* number of places in the net */
extern int no_trans;			/* number of transitions in the net */
extern int no_subnets;			/* number of immediate transition subnets */
extern int no_det_trans;		/* number of deterministic transitions */
extern int no_tang_markings;		/* number of tangible markings */
extern int no_exp_markings;		/* number of exponential tangible markings */
extern int no_absorb_states;		/* number of absorbing markings */
extern int *no_van_submarks;		/* number of vanishing submarkings */

extern t_sub		timed;		/* timed transitions and disconnected places */
extern subnet		*subnets;	/* immediate transition subnets */
extern tang_node 	*r_graph;	/* reduced reachability graph */
extern tang_marking 	*new_markings;	/* list of all new markings */
extern tang_marking 	**det_markings;	/* lists of markings with fireable det. trans */
extern tang_marking 	*exp_markings;	/* list of exponential markings */
extern byte		*cyclic;	/* the corresponding EMC is cyclic */
extern int		*no_nodes;	/* number of markings of the corresponding EMC */

extern FILE	*mexp_file;		/* MEXP - file (firing of exponential transitions) */
extern FILE	*rates_file;		/* RATES - file (firing rates of timed trans. in markings) */
extern FILE	*mdet_file;		/* MDET - files (markoff chains of det. trans.) */
extern FILE	*delta_file;		/* DELTA - files (imm. trans. firing probabilities) */
extern int	out_bit;		/* output option */
extern int	mem_bit;		/* memory optimization option */

