/******************************************************************************
 Program:           get_rrg.h

 Purpose:           Datenstrukturen wie sie im .rrg-File abgelegt sind def.

 Project Director:  Reinhard German

 Programmer:        Joerg W. Mitzlaff

 History:           10.94 (Dipl.Arbeit)
                    angelehnt an EDSPNAnalysis/parse_rrg.h 
*******************************************************************************/

/* .rrg file line buffer */
#define BUF_SIZE    1000

/* comment */
#define COMMENT     '#'

/* transition types */
#define EXP_TYPE    'e'
#define DET_TYPE    'd'
#define GEN_TYPE    'g'


/* transition names struct aus .rrg file */
typedef struct
{
   unsigned number;           /* transition number {4} index von 0 bis nnames-1 */
   char *name;                /* transition name   {4} */
   int typeNr;                /* wie ndetT */
   char type;                 /* transition type   {1} */
   char *sType;               /* server type       {4} */
   char *semant;              /* semantics         {4} */
} name_t;                     /* SIZEOF:          {17} */


/* Kanten struct enthaelt, was ich von ihr alles wissen muss */
typedef struct
{
   char type;                 /* entspricht names.type wird von ndetT im Moment vollstaendig ersetzt */
   int      typeNr;           /* entspricht names.typeNr ist nur bei detT immer gleich fromtypeNr ! */ 
   char *name;                /* entspricht names.name */
   unsigned fromMark;         /* index in look-up-table mark_t von 0 bis nmarking-1*/
   unsigned toMark;           /* --||-- */
   int      fromtypeNr;       /* wie ndetT */
   int      totypeNr;         /* wie ndetT */
   double delay;              /* time */                                 
   double prob;               /* probability */
   unsigned sMult;            /* server multiplicity ? */
} edge_t;

typedef struct
{
   int typeNr;                /* wie ndetT */
} mark_t;                     
