/*******************************************************************************
 Modul:              shared.h

 Purpose:            datenstrukturen fuer loesungskomponenten

 Project Director:   Reinhard German

 Programmer:         Joerg W. Mitzlaff

 History:            10.94 (Dipl.Arbeit)
 ******************************************************************************/
typedef struct
{
      double *maxY;
      double *minY;
} Result_Basis;

typedef struct
{
      double qmax_ii;
      double **Betas;            /* erste Index ist k (k. Summand) */
      int *L;                    /* beta, L und R sind in jedem Cluster gleich */
      int *R;                    /* darum merken wir sie uns */
      sp_vectors *pi_summand;    /* pi'k sind nur fuer einen Cluster gleich */
} Randomisation_Over_Time_Line;  /* fuer case i und ii */
 
typedef struct
{
      sp_matrix *A;
      double *Betas;            /* erste Index ist k (k. Summand) */
      int L;                    /* beta, L und R sind in jedem Cluster gleich */
      int R;                    /* darum merken wir sie uns */
} PrepeareRandomisation;        /* fuer case iii */
 
typedef struct
{
      sp_matrix *A;
      double qmax_ii;          
      double *Betas;           /* Betas, L und R aendern sich bei jedem Schritt */
      int L;
      int R;
} ConcernsRandomisation;       /* fuer adaptive_stepcontrol-case */

typedef struct               
{
      double tau;
      double startline;
      double finishline;
      double (*density)();
      double (*reliability)();
} ConcernsGenDistribution;    /* fuer den (eingeschraenkten) Fall allgemeiner Verteilungen */







